//  File: font_support.js, 6/25/03
//
//  This file contains jscipt code to manage fonts and to bring in
//  sytle sheets and change their font size tokens (below) to numbers
//  that look good for the browser and the screen size.
//  
//   VERDANA SMALL 	   Token:    %bodyVerdanaSmall% 
//                         Strategy  (%bodyVerdanaFontSize% - 2pt)
//
//   VERDANA BODY FONT     Token:    %bodyVerdanaFontSize% 
//                         Strategy  8pt (IE) for small screens, larger for larger screens
//
//   SUB HEAD ARIAL FONT   Token:    %subheadArialFontSize% 
//                         Strategy  10pt (IE) for small screens, larger for larger screens
//
//   DOC HEAD ARIAL FONT   Token:    %docheadArialFontSize% 
//                         Strategy  12pt (IE) for small screens, larger for larger screens

// --------------------------------------------------------
// global vars that are loaded with calculated font sizes

var bodyVerdanaSmallSize = "";
var bodyVerdanaFontSize  = "";
var subheadArialFontSize = "";
var docheadArialFontSize = "";
var styleText_c          = "";

// --------------------------------------------------------
// write font adjusted style sheet to window
//
function Load_FontAdjusted_StyleSheet(doc)
{
   doc.writeln('<STYLE TYPE=\'text/css\'>' + GetFonts() + '<\/STYLE>');
}

// --------------------------------------------------------
// Print Updated Stylesheet to window.  This routine will load a stylesheet,
// convert the tokens (i.e. %bodyVerdanaFontSize%, %subheadArialFontSize%,
// %docheadArialFontSize%) to numbers, and then print the style sheet to the
// window.
//
function GetFonts()
{ 
  // calculate the font sizes
  Calculate_Font_Sizes();

  // if we have not yet calculated the style sheet
  if (styleText_c == "")  {

     // get the style sheet text (from file "style/sytle.js")
     styleText = Get_StyleSheet_Text();

    // splice in the new calculated font sizes
 

    styleText_a = styleText.replace(  /%bodyVerdanaFontSize%/g,   bodyVerdanaFontSize.toString(10));
    styleText_b = styleText_a.replace(/%subheadArialFontSize%/g,  subheadArialFontSize.toString(10));
    styleText_c = styleText_b.replace(/%docheadArialFontSize%/g,  docheadArialFontSize.toString(10));
    styleText_d = styleText_c.replace(/%bodyVerdanaSmall%/g,      bodyVerdanaSmallSize.toString(10));
  }

  return styleText_d;
}

// --------------------------------------------------------
// This will calculate the font sizes

function Calculate_Font_Sizes() { 

   // we only need to hit this routine onece
   if (bodyVerdanaFontSize != "") return;
   
   // -----------------
   // SMALL DISPLAY

   if (screen.width < 1095) {

      if (navigator.appName == 'Netscape') {

          bodyVerdanaSmallSize = 6;
          bodyVerdanaFontSize  = 8;
          subheadArialFontSize = 10;
          docheadArialFontSize = 14;
      }
      else {  // Internet Explorer

          bodyVerdanaSmallSize = 6;
          bodyVerdanaFontSize  = 8;
          subheadArialFontSize = 10;
          docheadArialFontSize = 14;
      }
       
      return;
  }

   // -----------------
   // MEDIUM DISPLAY

   if (screen.width < 1395) {

      if (navigator.appName == 'Netscape') {

          bodyVerdanaSmallSize = 8;
          bodyVerdanaFontSize = 10;
          subheadArialFontSize = 11;
          docheadArialFontSize = 16;
      }
      else {  // Internet Explorer

          bodyVerdanaSmallSize = 8;
          bodyVerdanaFontSize = 10;
          subheadArialFontSize = 11;
          docheadArialFontSize = 16;
      }
       
      return;
   }

   // -----------------
   // LARGE DISPLAY (width > 1395)

      if (navigator.appName == 'Netscape') {

          bodyVerdanaSmallSize = 9;
          bodyVerdanaFontSize = 11;
          subheadArialFontSize = 12;
          docheadArialFontSize = 18;
      }
      else {  // Internet Explorer

          bodyVerdanaSmallSize = 9;
          bodyVerdanaFontSize = 11;
          subheadArialFontSize = 12;
          docheadArialFontSize = 18;
      }
       
      return;
}

// -------------------------------------------------
// shows a simple alert; used for testing purposes
//
function ShowHelloAlert() { 
   alert("Hello!"); 
   return;
}



