// Style sheet, left navigation frame
//
// light blue (nstruNet Logo): #aaaaff
// lighter blue (background on tables): #f0f0ff  (#ececff is slightly darker)
// Selected Button Background: #fa40ff
// Light Red: #FF9F9F 
//

// --------------------------------------------------------
// FONT SIZE STRATEGY
// 
// javascript /jscript/font_support.js routines will take this file
// and convert the following labels to numbers:
// 
//   VERDANA BODY FONT     Token:    %bodyVerdanaFontSize% 
//                         Strategy  8pt (IE) for small screens, larger for larger screens
//
//   SUB HEAD ARIAL FONT   Token:    %subheadArialFontSize% 
//                         Strategy  10pt (IE) for small screens, larger for larger screens
//
//   DOC HEAD ARIAL FONT   Token:    %docheadArialFontSize% 
//                         Strategy  12pt (IE) for small screens, larger for larger screens

// --------------------------------------------------------
// Return style sheet text
//
function Get_StyleSheet_Text() {

var s = "";

// TD/TR is used for the left Navigation options.  We place a 5px white vertical
// border against the left edge, and then we offset the text 5px to the right
// with a left-margin to give it some space between it and the background
s += "TD, TR  ";
s += "  /* 'color' seems to be ignored */  ";
s += "  {font-family: Verdana, Helvetica, Sans-Serif;  ";  
s += "   background-color: #ececff;  color: #3366cc;  ";   
s += "   padding-left: 5;   ";
s += "   border-left-width: 5;  border-left-style: solid;  border-left-color: 'white'; ";
s += "   font-size: %bodyVerdanaFontSize%pt;}   ";

s += ".SubTitle  ";
s += "  {font-family: Arial, Helvetica, Sans-Serif;  ";   
s += "   color: #fa40ff; background-color: #ececff; font-weight: bold; }  ";
s += "   font-size: %subheadArialFontSize%pt}  ";

s += "a  ";
s += "  /* note we are moving from Verdana to Arial here */  ";
s += "  {font-family: Arial, Helvetica, Sans-Serif;  ";
s += "   text-decoration: none;  ";
s += "   font-size: %bodyVerdanaFontSize%pt}  ";

// this sets the color of the navigation links on the left 
// #7575b0 - dark blue
// #a07575 - brown, gray
// #7050c0 - dark blue, purple - this is nice

s += "a:link, a:visited, a:active  "; 
s += "  { color: #7050c0}  ";

s += "a:hover  ";
s += "  {color: red}  ";

     return s;
}


