// --------------------------------------------------------
// style sheet, mainbody frame
// 
//    light blue (instruNet Logo): #aaaaff
//    lighter blue (background on tables): #f0f0ff  (#ececff is slightly darker)
//    Selected Button Background: #fa40ff
//    Dark Blue (left nav text): #3366cc
//    Light Red: #FF9F9F 
//    Dark Gray: #505050 (for body text)

// --------------------------------------------------------
// FONT SIZE STRATEGY
// 
// javascript /jscript/font_support.js routines will take this file
// and convert the following labels to numbers:
// 
//   VERDANA SMALL 	   Token:    %bodyVerdanaSmall% 
//                         Strategy  (%bodyVerdanaFontSize% - 2pt)
//
//   VERDANA BODY FONT     Token:    %bodyVerdanaFontSize% 
//                         Strategy  8pt (IE) for small screens, larger for larger crt
//
//   SUB HEAD ARIAL FONT   Token:    %subheadArialFontSize% 
//                         Strategy  10pt (IE) for small screens, larger for larger crt
//
//   DOC HEAD ARIAL FONT   Token:    %docheadArialFontSize% 
//                         Strategy  12pt (IE) for small screens, larger for larger crt

// --------------------------------------------------------
// Return style sheet text
//
function Get_StyleSheet_Text() {

var s = "";

s += "TD, TR  ";
s += "     {font-family: Verdana, Helvetica, Sans-Serif; color: #505050;  ";
s += "      line-height: 1.4;  ";
s += "      font-size: %bodyVerdanaFontSize%pt;}  ";

s += "BODY, P  ";
s += "     {font-family: Verdana, Helvetica, Sans-Serif;  ";
s += "      margin-top: 0pt; margin-bottom: 0pt; padding-top: 0pt; padding-bottom: 0pt;  ";
s += "      width: 550px;   line-height: 1.4;   color: #505050;  ";
s += "      font-size: %bodyVerdanaFontSize%pt}  ";

s += "UL  ";

s += "     /* width, and margin-right does not seem to work with UL and LI on IE 7.x ?? */  ";
s += "     /* width, and margin-right does not seem to work with UL and LI on IE 7.x ?? */  ";

s += "     {font-family: Verdana, Helvetica, Sans-Serif;  ";
s += "      left: 0px; margin-left: 0px; padding-left: 0.20in; margin-top: 0px;  ";
s += "      margin-bottom: 0pt; padding-top: 0pt; padding-bottom: 0pt;  ";
s += "      line-height: 1.4;  color: #505050;  ";
s += "      font-size: %bodyVerdanaFontSize%pt}  ";

// ----------------------------------------
// These are used with <A> links.

s += "a  ";        
s += "     {text-decoration: none; }  ";

s += "a:visited  ";
s += "     {color: blue; }  ";

s += "a:hover  ";
s += "     {color: red;  text-decoration: underline; }  ";

// ----------------------------------------
// These are used with table of contents (e.g. plus_summary.html)

s += ".Cat  { text-decoration: underline; line-height: 1.6  }"

s += ".Sub  { font-size: %bodyVerdanaSmall%pt; color: blue; line-height: 1.4 }"

// ----------------------------------------
// These are used to make tables. Example: www.instrunet.com/html/plus_code.html

s += ".TableStyle  ";
s += "     {margin-left: 5px; margin-right: 20px; } ";

s += ".TableHeader, .TableHeaderR  ";
s += "     {padding-left: 10px; text-align: left; "; 
s += "      background-color: #f2f2ff; font-weight: bold;}  ";

s += ".TableCell, .TableCellR ";
s += "     {padding-left: 10px;  } ";

s += ".TableCell, .TableHeader  ";
s += "     {border-bottom: '1px solid gray'; border-right: '1px solid gray' } ";

s += ".TableCellR, .TableHeaderR  ";
s += "     {border-bottom: '1px solid gray'; } ";

// ----------------------------------------
// These are used to show script code. Example: www.instrunet.com/html/plus_code.html

s += ".CodeFont, .CodeColA, .CodeColB, .CodeColC, .CodeCom  ";
s += "     {font-family: Courier New, Courier, Arial, Helvetica, Sans-Serif;  ";
s += "      color: brown;  font-size: %bodyVerdanaFontSize%pt}  ";

s += ".CodeFontT  ";
s += "     {font-family:  Arial, Helvetica, Sans-Serif;  ";
s += "      width: 550px; color: brown; font-weight: bold; font-size: %subheadArialFontSize%pt }  ";

s += ".CodeColA { padding-left: 30px; width: 750px;}  ";

s += ".CodeColB { padding-left: 50px; width: 750px;}  ";

s += ".CodeColC { padding-left: 70px; width: 750px;}  ";

s += ".CodeCom {  padding-left: 275px; width: 750px;}  ";

// ----------------------------------------
// Standard titles

s += ".SubSubTitle  ";
s += "     {font-family: Arial, Helvetica, Sans-Serif;  ";
s += "      color: #6260A1;  font-weight: bold;   ";
s += "      font-size: %bodyVerdanaFontSize%pt}  ";

s += ".MenuCmd  ";
s += "     {font-family: Arial, Helvetica, Sans-Serif;  ";
s += "      color: green;  font-weight: bold;   ";
s += "      font-size: %bodyVerdanaFontSize%pt}  ";

// background-color: #f8f8ff;    border-style:solid;  border-width: 1;   
// border-color: green;  padding-left: 6px;  padding-right: 6px;

s += ".SubTitle  ";
s += "     {font-family: Arial, Helvetica, Sans-Serif;    padding-left: 2; ";
s += "      color: #fa40ff; background-color: #ececff; font-weight: bold;  ";
s += "      width: 550px;   font-size: %subheadArialFontSize%pt}  ";

s += ".BoldArialLink  ";      // shows up Blue when used in an <A> link
s += "     {font-family: Arial, Helvetica, Sans-Serif;  ";
s += "      font-weight: bold;   ";
s += "      font-size: %bodyVerdanaFontSize%pt}  ";

s += ".MainDocTitle   ";
s += "     {font-family: Arial, Helvetica; font-size: %docheadArialFontSize%pt;    ";
s += "      color: #6260A1; font-weight: bold;   ";
s += "      margin-bottom: 0pt; margin-top: 0pt; padding-top: 0pt; padding-bottom: 0pt}  ";

// ----------------------------------------
// Menubar at top of window

s += ".Menubar  ";
s += "     {font-family: Arial, Helvetica, Sans-Serif; background-color='#ececff'; ";
s += "      color: #3366cc;   text-align = 'center';   text-decoration: none; ";
s += "      border-style:solid;  border-width: 2;   border-color: white;  ";
s += "      font-size: %bodyVerdanaFontSize%pt;   }  ";

s += ".Menubar:visited  ";
s += "     {color: #3366cc;   }  ";

// ----------------------------------------
// Footer

s += ".TagLine  ";
s += "     {font-family: Verdana, Helvetica, Sans-Serif; color: gray;   ";
s += "     font-size: %subheadArialFontSize%pt}  ";

s += ".IccHorizontalRule  ";
s += "   {font-family: Arial; font-size: 1pt;  border-color: #aaaaff;  ";
s += "    text-align: left; border-width: 2px; border-style: solid; margin-left: 0px}  ";

s += ".IccHorizontalRuleRED  ";
s += "   {font-family: Arial; font-size: 1pt;  border-color: #FF9F9F;  ";
s += "    text-align: left; border-width: 2px; border-style: solid; margin-left: 0px}  ";

return s;
}

    // ========================================================================
    // IMPORTANT NOTES REGARDING SCRIPTING <A> ANCHOR OBJECTS
    //
    // 1) IE does not like to go to a named anchor using the anchors
    //    array so either use document.all.home_button or document.anchors[0]
    //
    // 2) When you reference a style such as border-width in jScript,
    //    you must say "borderWidth", and the "W" MUST be capitalized.
    //
    // This works:    alert(document.links[0].id);   .href should work too
    //                alert(document.all.home_button.id);
    //                document.all.home_button.runtimeStyle.borderStyle = 'solid';
    //                document.all.home_button.runtimeStyle.borderColor = '#fa40ff';
    //                document.all.home_button.runtimeStyle.borderWidth = '1';

// ============================== RESEARCH ==============================
// 
// + Netscape shows Rules set up as 2px as 3 or 4px (bug?) 
// 
// + Netscape does not like underscores (_) in class names 
// 
// + Documentation:
// 
// margin-top: 0px; margin-bottom: 0px; padding-top: 0px; padding-bottom: 0px
// 
// TD,TR - Tables
// 
// INPUT, SELECT - Style for Lotus Edit Field (INPUT, SELECT). All INPUT's 
// automatically pick this up.
// 
// .IccInput - HTML Class for Lotus Edit Field (INPUT). Use this when you want
// the width of the INPUT field to // span the column.
// 
// .IccTextArea - This sets the width and font. Use the HTML area to separately
// set the # of ROWS and MAXLENGHT.
// 
// .IccTable - HTML Class for Lotus Table Field (TABLE)
// 
// .IccTableCell - HTML Class for Lotus Table Cell Field (TD) 

