Option Strict Off
Option Explicit On 
Imports System.Runtime.InteropServices

Module Declaration_Utilities

    ' =========================================================================
    ' =========================================================================
    ' FILE: INET_Declarations.vb    
    '
    ' ------------------ D O C U  M E N T A T I O N ---------------------------
    '
    ' This iNet Interface file contains many Global Constants
    ' and must be included in every Visual Basic program that
    ' accesses iNet hardware
    '
    ' -------------------------  H I S T O R Y --------------------------------
    ' HISTORY  Copyright c 1994-96 GWI.  All rights reserved.
    ' 4/16/94  created - gsw
    ' 6/6/02   updated to be compatible with Visual Studio (Visual Basic) .Net v7
    '
    ' =========================================================================
    ' =========================================================================

    ' ============================ iNetTrue/iNetFalse =========================

    Public Const iNetTrue As Short = 1      ' instruNet DLL uses non-zero for TRUE
    Public Const iNetFalse As Short = 0     ' instruNet DLL uses 0 for FALSE
    '                                         (VB true/false is similar at -1/0)

    ' ============================ SettingsTypes ==============================
    ' Types of Settings for each channel.

    Public Const sgt_noneFound As Short = -1
    Public Const sgt_UnRecognizedType As Short = -2

    'Vin "Hardware" settingGroupType {sensorType, a/d range, analog lp, function}
    Public Const sgt_VinHardware As Short = -3

    'Vin "Constants" settingGroupType {Ro,Rshunt,Vexcit,GF,alpha,delta}
    Public Const sgt_VinConstants As Short = -4

    '8bit Mod 100 Digital I/O settingGroup = {din, dout, direction}
    Public Const sgt_Mod100DinDout As Short = -5

    'General settingGroupType struct {valueEU, chanName, unitsLabel, userName...}
    Public Const sgt_General As Short = -6

    'DISPLAY settingGroup = {dispOnOff, dispMaxEU, dispMinEU}
    Public Const sgt_Display As Short = -7

    'Mapping settingGroup = {Internal1, External1, Internal2, External2}
    Public Const sgt_Mapping As Short = -20

    'LOW PASS filter settingGroup type
    Public Const sgt_LowPass As Short = -8

    'HIGH PASS filter settingGroup type
    Public Const sgt_HighPass As Short = -9

    'BAND PASS filter settingGroup type
    Public Const sgt_BandPass As Short = -10

    'BAND STOP filter settingGroup type
    Public Const sgt_BandStop As Short = -11

    'Timing = {DigitizeOnOff, PtsPerScan, NoOfScans,ContinuousOnOff, SampleRate}
    Public Const sgt_Timing As Short = -12

    'Trigger = {TriggerMode, ThresholdEu, Slope, PreTrigSec, SrcNet, SrcModule, SrcDevice, SrcChannel}
    Public Const sgt_Trigger As Short = -13

    'TIMER settingGroup = {functionPop, clkTotalSecs, clkHiSecs,
    'measHiOrCyclePop, measResolution, measNumPeriods}
    Public Const sgt_Timer As Short = -14

    'Driver Ram Buffer = {DigitizeOnOff, ScanNumIn, PtNumIn..}
    Public Const sgt_DriverRamBuffer As Short = -15

    'User Ram Buffer = {DigitizeOnOff, userBufferAddr, ptrSize, ScanNumIn, PtNumIn..}
    Public Const sgt_UserRamBuffer As Short = -16

    'File = {FileName, Command, ScanNumIn, PtNumIn, ScanNumIn ..}
    Public Const sgt_File As Short = -17

    'RECORD OPTIONS settingGroup = {}
    Public Const sgt_RecordOptions As Short = -18

    'MASTER DIRECTORY settingGroup = {pathname, command, save/load settings}
    Public Const sgt_MasterDirectory As Short = -19

    'CAL OPTIONS = {CalBtn, CalOnStart, CalOnWarm, AutoCalRate}
    Public Const sgt_CalOptions As Short = -21

    '======================== Field Access Intentions ========================

    Public Const intention_getValue As Short = 1            'get the value of the field
    Public Const intention_setValue As Short = 2            'set the value of the field
    Public Const intention_getNameStr As Short = 3          'get name of field (i.e. string)
    Public Const intention_getMaxValue As Short = 4         'get maximum value of the field
    Public Const intention_getMinValue As Short = 5         'get minimum value of the field
    Public Const intention_getUserInterfaceType As Short = 6 'get user interface type {e.g. }
    Public Const intention_getDefaultValue As Short = 7     'get the defaultValue of the field
    Public Const intention_nativeStorageType As Short = 8   'get the native storageType of the field
    Public Const intention_getValueAndPullData As Short = 9 'get the value of the field (USER RAM BUFFER userBufferAddr
    'field or DRIVER RAM BUFFER bufferPtr field) and
    'also pull data out of the buffer and place
    'pointToPullindex'into A, 'numPointsToPull'into B,
    'and 'scanNumIn'into C. gsw 11/25/95

    'ADMINISTRATIVE
    Public Const intention_doNothing As Short = 4000
    Public Const intention_DisableAllChannelDigitizing As Short = 4005

    'SHOW ALERT UPON ERROR CONTROL
    Public Const intention_ShowAlertOnError As Short = 8000
    Public Const intention_NoShowAlertOnError As Short = 8001
    Public Const intention_GetShowAlertOnErrorStatus As Short = 8002

    'DETERMINE IF NETWORK ELEMENT EXISTS
    Public Const intention_ThisExists_Network As Short = 8003
    Public Const intention_ThisExists_Device As Short = 8004
    Public Const intention_ThisExists_Module As Short = 8005
    Public Const intention_ThisExists_Channel As Short = 8006
    Public Const intention_ThisExists_Setting As Short = 8007
    Public Const intention_ThisExists_Field As Short = 8008

    'INTERROGATE NETWORK
    Public Const intention_GetNumNetworks As Short = 8009
    Public Const intention_GetNumDevices As Short = 8010
    Public Const intention_GetNumModules As Short = 8011
    Public Const intention_GetNumChannels As Short = 8012
    Public Const intention_GetNumSettings As Short = 8013
    Public Const intention_GetNumFields As Short = 8014

    'USER INTERFACE
    Public Const intention_Get_UI_Catagory As Short = 8017
    Public Const intention_Get_NumPopupItems As Short = 8018
    Public Const intention_Get_PopupStringArray As Short = 8019
    Public Const intention_Get_AddrNamesStringArray As Short = 8020
    Public Const intention_GetChannelDirection As Short = 8021

    'GET/SET NETWORK STATE
    Public Const intention_getHandleToNetworkState As Short = 8022
    Public Const intention_setNetworkStateWithHandle As Short = 8023
    Public Const intention_disposeOfNetworkState As Short = 8024

    'SERVICE THE DIGITIZATON PROCESS
    Public Const intention_serviceAllDigitizeBuffers As Short = 8028
    Public Const intention_SetUpDigitization As Short = 8044

    'SHOW PROBE DIALOG
    Public Const intention_showProbeDialog_Full As Short = 8031
    Public Const intention_showProbeDialog_ChannelAddrOnl As Short = 8032
    Public Const intention_showProbeDialog_FieldAddrOnl As Short = 8033
    Public Const intention_showProbeDialog_FieldAddrOnly As Short = 8033
    Public Const intention_showProbeDialog_fixedChanAddr As Short = 8034
    Public Const intention_showProbeDialog_fixedChanAddrAndSettingGp As Short = 8035

    ' MANAGEMENT
    Public Const intention_Set_gClickOnThisWindowToQuitiNet As Short = 8040
    Public Const intention_lockInternalMemory As Short = 8041
    Public Const intention_unlockInternalMemory As Short = 8042
    Public Const intention_SetDemoMode As Short = 8037

    '================================== Data Types ===================================

    Public Const iNetDT_INT16 As Short = 0          ' 16bit integer, signed
    Public Const iNetDT_INT16bus As Short = 1       ' 16bit integer, signed; yet data is on a card and
    Public Const iNetDT_UINT16 As Short = 2         ' 16bit integer, unsigned
    '                                                 must be transferred to with 16bit transfers.

    Public Const iNetDT_INT32 As Short = 3          ' 32bit integer, signed
    Public Const iNetDT_UINT32 As Short = 4         ' 32bit integer, unsigned

    Public Const iNetDT_FLT32 As Short = 5          ' 32bit float (ieee Macintosh format)
    Public Const iNetDT_Double As Short = 6         ' 'double', as determined by the compiler (e.g. flt64, flt80, flt96, flt128)
    Public Const iNetDT_INT16comp As Short = 7      ' 16bit integer, signed; yet compressed in the standard iNet
    '                                                 iNetDT_INT16comp" manner.
    Public Const iNetDT_P_Str15 As Short = 8        ' PASCAL Str15 string (15 chars, 0th char is length)
    Public Const iNetDT_P_Str255 As Short = 9       ' PASCAL Str255 string (255 chars, 0th char is length)
    Public Const iNetDT_C_Str15 As Short = 10       ' C Str15 string (15 chars, 0x00 terminate)
    Public Const iNetDT_C_Str255 As Short = 11      ' C Str255 string (255 chars, 0x00 terminate)

    Public Const iNetDT_READ_ONLY_BIT As Short = 128 'this is ADDED to the iNetDataType value if the
    'field is read only.

    Public Const iNetDataType_MIN As Short = iNetDT_INT16
    Public Const iNetDataType_MAX As Short = iNetDT_C_Str255

    Public Const iNetDataType_MASK As Short = &H7FS 'mask to strip off special on/off bits
    '                                               (e.g. iNetDT_READ_ONLY_BIT)

    '============================= iNetError error codes =============================

    Public Const iNetErr_None As Short = 0 'no error
    Public Const iNetErr_General As Short = 1 'general error
    Public Const iNetErr_ControllerNotInitialized As Short = 2 'InitializeDriverAndControllers_iNet() has not been called
    Public Const iNetErr_InitializationFailed As Short = 3 'InitializeDriverAndControllers_iNet was called, yet failed
    Public Const iNetErr_DeviceNumOutOfRange As Short = 4 'Device number is out of range (is it connected & powered on?)
    Public Const iNetErr_ChannelNumOutOfRange As Short = 5 'Channel number is out of range
    Public Const iNetErr_FieldNumOutOfRange As Short = 6 'Field number is out of range
    Public Const iNetErr_ControllerNotFound As Short = 7 'iNet Controller not found
    Public Const iNetErr_FieldDoesNotExist As Short = 8 '(deviceNum, chanNum, fieldNum) refer to field that
    Public Const iNetErr_BadfieldNativeDataType As Short = 9 'bad iNetFieldDataType value
    Public Const iNetErr_BadFieldReadType As Short = 10 'bad iNetFieldReadType value
    Public Const iNetErr_TimeoutAtReadBegin As Short = 11 'time out at read begin
    Public Const iNetErr_TimeoutAtWaitForReadDone As Short = 12 'timeout at wait for read done
    Public Const iNetErr_ControllerIsInWeeds As Short = 13 'controller is in the weeds
    Public Const iNetErr_illegalDataType As Short = 14 'illegal data type
    Public Const iNetErr_FailedCopyDataTest As Short = 15 'failed the CopyWaveData() test
    Public Const iNetErr_CompressorHitError As Short = 16 'compressor hit error
    Public Const iNetErr_FailedRamTest As Short = 17 'failed board ram test
    Public Const iNetErr_RanOutOfMemory As Short = 18 'ran out of memory
    Public Const iNetErr_AlertFailed As Short = 19 'the routine that shows an alert failed

    'Controller Errors
    Public Const iNetErr_CtrlrRomNotBooting As Short = 20
    Public Const iNetErr_CtrlrRamNotBooting As Short = 21
    Public Const iNetErr_DriverDownloadFailed As Short = 22
    Public Const iNetErr_CtrlrRWTestFailed As Short = 23
    Public Const iNetErr_InterfaceBlockTestFailed As Short = 24
    Public Const iNetErr_IncCounterTestFailed As Short = 25
    Public Const iNetErr_EchoCmdToStatusTestFailed As Short = 26
    Public Const iNetErr_ControllerBootTestFailed As Short = 27
    Public Const iNetErr_ControlleFailedToBoot As Short = 28
    Public Const iNetErr_ControllerCmdFailed As Short = 29

    Public Const iNetErr_GUI As Short = 30

    Public Const iNetErr_QSPI_Busy As Short = 31
    Public Const iNetErr_QSPI_Halted As Short = 32
    Public Const iNetErr_QSPI_ArgOutOfRange As Short = 33
    Public Const iNetErr_QSPI_TimeOutErr As Short = 34
    Public Const iNetErr_FlakyNetwork As Short = 35

    'Driver Errors
    Public Const iNetErr_CouldNotLocateDriverFile As Short = 36
    Public Const iNetErr_netNumOutOfRange As Short = 37
    Public Const iNetErr_SettingGroupNumOutOfRange As Short = 38
    Public Const iNetErr_UnitTypeOutOfRange As Short = 39
    Public Const iNetErr_DriverDidNotSetErrCode As Short = 40

    Public Const iNetErr_SettingGroupTypeOutOfRange As Short = 41

    'Etc Codes
    Public Const iNetErr_ModuleNumOutOfRange As Short = 42
    Public Const iNetErr_IntentionNumOutOfRange As Short = 43
    Public Const iNetErr_ReadOnlyField As Short = 44
    Public Const iNetErr_WriteOnlyField As Short = 45
    Public Const iNetErr_FieldValueOutOfRange As Short = 46
    Public Const iNetErr_ArgTypeOutOfRange As Short = 47
    Public Const iNetErr_BadKeyInFieldHierarchy As Short = 48
    Public Const iNetErr_Max_LT_MinInFieldHierarchy As Short = 49
    Public Const iNetErr_HierarchyFieldDataInTrouble As Short = 50
    Public Const iNetErr_ChannelNameInvalid As Short = 51
    Public Const iNetErr_tempUnits_outOfRange As Short = 52
    Public Const iNetErr_sensorType_outOfRange As Short = 53

    'Digitize Errors.
    Public Const iNetErr_CircBufErr As Short = 54
    Public Const iNetErr_DataBufferOverflow As Short = 55
    Public Const iNetErr_PulledTooMuchOnLastPull As Short = 56

    'Filter Error Codes
    Public Const ERequired_fbx_DCIIR As Short = 57
    Public Const EFreqTooLarge_fx_DCIIR As Short = 58
    Public Const EFreqsNotAscending_DCIIR As Short = 59
    Public Const ERequired_fx_DCIIR As Short = 60
    Public Const ERequired_adelx_DCIIR As Short = 61
    Public Const EInvalidArg_DCIIR As Short = 62
    Public Const EOrderTooHigh_DCIIR As Short = 63
    Public Const EEven_ndeg_DCIIR As Short = 64
    Public Const EOrderTooLow_DCIIR As Short = 65
    Public Const EActualOrder_DCIIR As Short = 66

    'New Error Codes
    Public Const iNetErr_InterfaceCompiledBadly As Short = 67
    Public Const iNetErr_BadInterfaceKey As Short = 68
    Public Const iNetErr_BadAddrPassedToDriver As Short = 69
    Public Const iNetErr_BadStaticVarInDriver As Short = 70
    Public Const iNetErr_BadIntegerMathInDriver As Short = 71

    Public Const iNetErr_BadChannelType As Short = 72
    Public Const iNetErr_CppCompilerDidBad As Short = 73
    Public Const iNetErr_MemMngr_Failed As Short = 74
    Public Const iNetErr_Toolbox_Failed As Short = 75
    Public Const iNetErr_CrtRect_Failed As Short = 76
    Public Const iNetErr_DlogCode_Failed As Short = 77
    Public Const iNetErr_DrvrNeedsFpu_Failed As Short = 78
    Public Const iNetErr_iirCode_Failed As Short = 79
    Public Const iNetErr_sprintf_Failed As Short = 80

    Public Const iNetErr_DigitizeInit As Short = 81
    Public Const iNetErr_SPE_off As Short = 82
    Public Const iNetErr_Halt_on As Short = 83
    Public Const iNetErr_CPTQP_failed_to_clr As Short = 84
    Public Const iNetErr_qspiBusyBeforeDigitize As Short = 85
    Public Const iNetErr_weAbortedEarly As Short = 86
    Public Const iNetErr_CtlrIsBusyDoingSomething As Short = 87
    Public Const iNetErr_CtrlDidNotFinishCmd As Short = 88
    Public Const iNetErr_CodeGenSegmentError As Short = 89
    Public Const iNetErr_CPTQP_is_Bad As Short = 90
    Public Const iNetErr_CompilerErr As Short = 91
    Public Const iNetErr_DrvrOrUserBufferOverflow As Short = 92
    Public Const iNetErr_NonCompatible_OS As Short = 93
    Public Const iNetErr_badChanPtsPerScan As Short = 94

    'STATUS register error codes.
    Public Const iNetErr_StatusRegBase As Short = 10000
    Public Const iNetErr_StatusRegEnd As Short = 10255

    'Operating System Error (Macintosh or Windows Error)
    'iNetError = (OSErr + iNetErr_OsBase)
    Public Const iNetErr_OsRegMin As Short = -32000 'min Operating System Error
    Public Const iNetErr_OsBase As Short = -16000 'max Operating System Error
    Public Const iNetErr_OsRegMax As Short = -1 'max Operating System Error

    'SubErrors
    Public Const ioSubNetErr_None As Short = 0
    Public Const ioSubNetErr_BadLastRAMAddr As Short = 1
    Public Const ioSubNetErr_BadBaseAddr As Short = 2
    Public Const ioSubNetErr_FirstRamAddrBad As Short = 3
    Public Const ioSubNetErr_FailedFloatTest As Short = 4
    Public Const ioSubNetErr_DataLinesBad As Short = 5
    Public Const ioSubNetErr_AddrLinesBad As Short = 6
    Public Const ioSubNetErr_QuickIOtestFailed As Short = 7

    '================================== beep signal ====================================

    Public Const beepSignal_OS_Version_too_old As Short = 3
    Public Const beepSignal_NUM_BEEPS_IF_NO_DRIVER_FILE As Short = 4
    Public Const beepSignal_CouldNotShowAn_Alert As Short = 5
    Public Const beepSignal_PopupTrouble As Short = 6
    Public Const beepSignal_CouldNotLoadRsrc As Short = 7

    '======================== Types of Controllers ====================================

    Public Const ctlr_NotIdentified As Short = &H0S 'Not yet identified
    Public Const ctlr_Nubus As Short = &H1234S 'Nubus (Macintosh only)
    Public Const ctlr_PCI As Short = &H1235S 'PCI (Windows or Mac)
    Public Const ctlr_Ext_ISA As Short = &H1236S 'Extended ISA
    Public Const ctlr_PCMCIA As Short = &H1237S 'PCMCIA (Windows or Mac)

    '============================= Field Hierarchy Limits =============================

    Public Const MAX_NUM_settinggroup_PER_CHANNEL As Short = 32 'max  of settinggroups per CHANNEL
    Public Const MIN_NUM_settinggroup_PER_CHANNEL As Short = 1 'min  of settinggroups per CHANNEL

    Public Const MAX_NUM_CHANNELS_PER_MODULE As Short = 32 'max  of CHANNELS per MODULE
    Public Const MIN_NUM_CHANNELS_PER_MODULE As Short = 1 'min  of CHANNELS per MODULE

    Public Const MAX_NUM_MODULES_PER_DEVICE As Short = 16 'max  of MODULES per hardware DEVICE
    Public Const MIN_NUM_MODULES_PER_DEVICE As Short = 1 'min  of MODULES per hardware DEVICE

    Public Const MAX_NUM_DEVICES_PER_NETWORK As Short = 32 'max  of hardware DEVICES per NETWORK (doesn't include CONTROLLER)
    Public Const MIN_NUM_DEVICES_PER_NETWORK As Short = 1 'min  of hardware DEVICES per NETWORK

    Public Const cltrNum_DRIVER As Short = 0        ' 'cltrNum'= driver
    Public Const cltrNum_NONE As Short = -1         ' 'cltrNum'= no controller, or driver
    Public Const FIRST_NETWORK As Short = 1         ' netNum of first network

    Public Const MAX_NUM_NETWORKS As Short = 16     ' maximum of hardware controllers/networks (does not include DRIVER)

    Public Const netNum_DRIVER As Short = 0         ' netNum'of 0 means "driver"
    Public Const netNum_1stController As Short = 1  ' netNum'of the 1st controller
    Public Const cltrNum_AllControllers As Short = -1 '-1 means all network controllers

    Public Const deviceNum_CONTROLLER As Short = 0  ' deviceNum'of 0 means iNet Controller"
    Public Const deviceNum_1stDevice As Short = 1   ' deviceNum'of the 1st DEVICE on network

    Public Const moduleNum_1stModule As Short = 1   ' moduleNum'of the 1st MODULE in DEVICE

    Public Const chanNum_1stChannel As Short = 1    ' channelNum'of the 1st CHANNEL in MODULE

    Public Const settingNum_1stSetting As Short = 1 ' settingNum'of the 1st SETTING Group in CHANNEL

    Public Const fieldNum_1stField As Short = 1     ' fieldNum'of the 1st FIELD in SETTING Group

    '============================ little/big Endian ==================================

    Public Const bigEndian_ion As Short = 0 'big endian, e.g. Motorola 68K, 68332
    Public Const littleEndian_ion As Short = 1 'ittle endian, e.g. Intel x86

    Public Const THIS_COMPILERS_ENDIAN_MODE As Short = littleEndian_ion 'Intel x86 used by Microsoft Windows

    '========================= Open Window Commands ===================================

    Public Const iNetCM_OpenWindow_Record As Short = 1 'open the RECORD page
    Public Const iNetCM_OpenWindow_Network As Short = 2 'open the NETWORK page
    Public Const iNetCM_OpenWindow_Test As Short = 3 'open the TEST page
    Public Const iNetCM_OpenWindow_Service As Short = 4 'open the SERVICE page
    Public Const iNetCM_OpenWindow_ChanSelection As Short = 5 'open channel selection dialog
    Public Const iNetCM_OpenWindow_FieldSelection As Short = 6 'open field selection dialog
    Public Const iNetCM_OpenWindow_OneFieldSet As Short = 7 'open Probe dialog with fixed channel address & setting group
    Public Const iNetCM_OpenWindow_AllFieldSets As Short = 8 'open Probe dialog with fixed channel address
    Public Const iNetCM_OpenWindow_RecTiming As Short = 9 'open Timing dialog
    Public Const iNetCM_OpenWindow_RecTrigger As Short = 10 'open Trigger dialog
    Public Const iNetCM_OpenWindow_RecOptions As Short = 11 'open the Record Options dialog
    Public Const iNetCM_OpenWindow_RecFile As Short = 12 'open the Record File dialog
    Public Const iNetCM_OpenWindow_SimpleTiming As Short = 13 'open the SimpleTiming dlog (pts -per-scan and sample-rate)
    Public Const iNetCM_OpenWindow_CalOptions As Short = 14 'open the Calibration Options dlog

    '========================= Button Press Commands ===================================

    'RECORD page
    Public Const iNetCM_BtnPress_Record_Start As Short = 1      'press 'Start'button in RECORD page
    Public Const iNetCM_BtnPress_Record_Stop As Short = 2       'press 'Stop'button in RECORD page
    Public Const iNetCM_BtnPress_Record_Open As Short = 3       'press 'Open'button in RECORD page
    Public Const iNetCM_BtnPress_Record_Save As Short = 4       'press 'Save'button in RECORD page
    Public Const iNetCM_BtnPress_Record_Options As Short = 5    'press 'Options'button in RECORD page
    Public Const iNetCM_BtnPress_Record_Timing As Short = 6     'press 'Timing'button in RECORD page
    Public Const iNetCM_BtnPress_Record_Trigger As Short = 7    'press 'Trigger'button in RECORD page
    Public Const iNetCM_BtnPress_Record_Probe As Short = 8      'press 'Probe'button in RECORD page

    'NETWORK page
    Public Const iNetCM_BtnPress_Network_Restore As Short = 9   'press 'Restore'button in NETWORK page
    Public Const iNetCM_BtnPress_Network_Store As Short = 10    'press 'Store'button in NETWORK page
    Public Const iNetCM_BtnPress_Network_Open As Short = 11     'press 'Open'button in NETWORK page
    Public Const iNetCM_BtnPress_Network_Save As Short = 12     'press 'Start'button in NETWORK page
    Public Const iNetCM_BtnPress_Network_Clear As Short = 13    'press 'Clear'button in NETWORK page
    Public Const iNetCM_BtnPress_Network_Reset As Short = 14    'press 'Reset'button in NETWORK page

    'TEST page
    Public Const iNetCM_BtnPress_Test_Search As Short = 15      'press 'Search'button in TEST page
    Public Const iNetCM_BtnPress_Test_Test As Short = 16        'press 'Test'button in TEST page
    Public Const iNetCM_BtnPress_Test_BigTest As Short = 17     'press 'Big Test'button in TEST page
    Public Const iNetCM_BtnPress_Test_Open As Short = 18        'press 'Open'button in TEST page
    Public Const iNetCM_BtnPress_Test_SaveAs As Short = 19      'press 'Save As'button in TEST page
    Public Const iNetCM_BtnPress_Test_Clear As Short = 20       'press 'Clear'button in TEST page

    ' RECENT ADDITIONS
    Public Const iNetCM_BtnPress_Record_Directory As Short = 21 'press 'Directory' button in RECORD page
    Public Const iNetCM_BtnPress_Network_Recal As Short = 22    'press 'Recal' button in NETWORK page, 4/21/97
    Public Const iNetCM_BtnPress_Record_Setup As Short = 23     'press 'Setup' button in RECORD page
    Public Const iNetCM_BtnPress_Record_Print As Short = 32     'press 'Print' button in RECORD page, gsw 8/22/98

    Public Const iNetCM_BtnPress_Test_Print As Short = 33       'press 'Print' button in TEST page, gsw 8/22/98
    Public Const iNetCM_BtnPress_Basic_Print As Short = 34      'press 'Print' button in BASIC page, gsw 8/22/98

    ' BASIC page
    Public Const iNetCM_BtnPress_Basic_Execute As Short = 24    'press 'Execute' button in BASIC page
    Public Const iNetCM_BtnPress_Basic_Stop As Short = 25       'press 'Stop' button in BASIC page
    Public Const iNetCM_BtnPress_Basic_Open As Short = 26       'press 'Open' button in BASIC page
    Public Const iNetCM_BtnPress_Basic_Save As Short = 27       'press 'Save' button in BASIC page
    Public Const iNetCM_BtnPress_Basic_SaveAs As Short = 28     'press 'Save As' button in BASIC page
    Public Const iNetCM_BtnPress_Basic_Clear As Short = 29      'press 'Clear' button in BASIC page

    ' RECENT ADDITIONS
    Public Const iNetCM_BtnPress_Record_CalOptions As Short = 30 'press 'Calibrate Options' button in RECORD page
    Public Const iNetCM_BtnPress_Test_Report As Short = 31 'press 'Report' button in TEST page

    '=========================== DRIVER CHANNEL NUMBERS ==============================

    Public Const driver_ChanNum_OpenWindow As Short = 1 'Open Window Command (DRIVER channel type)
    Public Const driver_ChanNum_PushButton As Short = 2 'Push Button Command (DRIVER channel type)
    Public Const driver_ChanNum_RecordOptions As Short = 3 'RECORD OPTIONS = {hScale, hPosition, maxPtsPerPix, gridOnOff, plotLinesDots}

    '================================= HARDWARE Settings ===============================

    'FIELD NUMBERS for HARDWARE settingGroup
    Public Const fldNum_Vin_sensorType As Short = 1 'sensorType
    Public Const fldNum_Vin_wiring As Short = 2 'wiring options
    Public Const fldNum_Vin_AnaLpFltr_Hz As Short = 3 'analog lp filter hz value (e.g. 0, 40, 16000 for Model 100)
    Public Const fldNum_Vin_ad_IntegrateSecs As Short = 4 ' of seconds that a/d integrates via multiple readings. 1/19/96
    Public Const fldNum_Vin_ad_VmaxRange As Short = 5 'voltage range (max voltage) (i.e. a/d gain) {e.g. 5, 1.25, 0.3175, 0.078125}

    ' SENSOR TYPES
    Public Const ion_SensorType_Voltage As Short = 1
    Public Const ion_SensorType_Current As Short = 2
    Public Const ion_SensorType_Resistance As Short = 3
    Public Const ion_SensorType_StrainGauge As Short = 4
    Public Const ion_SensorType_RTD As Short = 5
    Public Const ion_SensorType_TC_J As Short = 6
    Public Const ion_SensorType_TC_K As Short = 7
    Public Const ion_SensorType_TC_T As Short = 8
    Public Const ion_SensorType_TC_E As Short = 9
    Public Const ion_SensorType_TC_R As Short = 10
    Public Const ion_SensorType_TC_S As Short = 11
    Public Const ion_SensorType_TC_B As Short = 12
    Public Const ion_SensorType_TC_N As Short = 13
    Public Const ion_SensorType_Thermister As Short = 14
    Public Const ion_SensorType_Digital As Short = 15

    'WIRING OPTIONS
    Public Const ion_Wiring_Differential As Short = 1
    Public Const ion_Wiring_SingleEnded As Short = 2
    Public Const ion_Wiring_Shunt_Resistor As Short = 3
    Public Const ion_Wiring_Voltage_Divider As Short = 4
    Public Const ion_Wiring_Bridge As Short = 5
    Public Const ion_Wiring_Q_Bridge_Bend As Short = 6
    Public Const ion_Wiring_H_Bridge_Bend As Short = 7
    Public Const ion_Wiring_H_Bridge_Axial As Short = 8
    Public Const ion_Wiring_F_Bridge_Bend_I As Short = 9
    Public Const ion_Wiring_F_Bridge_Axial_I As Short = 10
    Public Const ion_Wiring_F_Bridge_Axial_II As Short = 11

    'Analog Low Pass Filter Options (e.g. Model 100)
    Public Const ion_AD_AnaLpFltr_Pop_Off As Short = 1 'off
    Public Const ion_AD_AnaLpFltr_Pop_40Hz As Short = 2 '40Hz
    Public Const ion_AD_AnaLpFltr_Pop_4KHz As Short = 3 '4KHz

    ' ion_AD_AnaLpFltr_Pop
    Public Const ion_AD_AnaLpFltr_Pop_MIN As Short = ion_AD_AnaLpFltr_Pop_Off
    Public Const ion_AD_AnaLpFltr_Pop_MAX As Short = ion_AD_AnaLpFltr_Pop_4KHz
    Public Const ion_AD_AnaLpFltr_Pop_DEF As Short = ion_AD_AnaLpFltr_Pop_Off

    ' A/D Range Options (e.g. popup)
    Public Const ion_AD_RangePop_5V As Short = 1 '+/- 5.0V
    Public Const ion_AD_RangePop_0_625V As Short = 2 '+/- .625V
    Public Const ion_AD_RangePop_0_078V As Short = 3 '+/- 0.078V
    Public Const ion_AD_RangePop_0_010V As Short = 4 '+/- 0.010V

    '  ion_AD_RangePop
    Public Const ion_AD_RangePop_MIN As Short = ion_AD_RangePop_5V
    Public Const ion_AD_RangePop_MAX As Short = ion_AD_RangePop_0_010V
    Public Const ion_AD_RangePop_DEF As Short = ion_AD_RangePop_5V

    '=========================== Vin CONSTANTS Settings =======================

    ' FIELD NUMBERS for Vin CONSTANTS settingGroup
    Public Const fldNum_VinCon_Ro As Short = 1 'Ro constant
    Public Const fldNum_VinCon_Rshunt As Short = 2 'Rshunt constant
    Public Const fldNum_VinCon_Vexcitation As Short = 3 'Vexcitation constant
    Public Const fldNum_VinCon_Vinit As Short = 4 'Vinit constant
    Public Const fldNum_VinCon_alpha As Short = 5 'alpha constant
    Public Const fldNum_VinCon_delta As Short = 6 'delta constant
    Public Const fldNum_VinCon_GF As Short = 7 'GF constant
    Public Const fldNum_VinCon_v_Poisson As Short = 8 'v_Poisson constant

    '===================== CONTROLLER CHANNEL NUMBERS =========================

    'Channels numbers for the NETWORK's Controller (counter/timer/digital in/digitial out)
    Public Const controller_ChanNum_Ch1_Dio As Short = 1 'Ch1 Dio
    Public Const controller_ChanNum_Ch2_Dio As Short = 2 'Ch2 Dio
    Public Const controller_ChanNum_Ch3_Dio As Short = 3 'Ch3 Dio
    Public Const controller_ChanNum_Ch4_Dio As Short = 4 'Ch4 Dio
    Public Const controller_ChanNum_Ch5_Dio As Short = 5 'Ch5 Dio
    Public Const controller_ChanNum_Ch6_Dio As Short = 6 'Ch6 Dio
    Public Const controller_ChanNum_Ch7_Dio As Short = 7 'Ch7 Dio
    Public Const controller_ChanNum_Ch8_Dio As Short = 8 'Ch8 Dio
    Public Const controller_ChanNum_Ch9_Dio As Short = 9 'Ch9 Dio
    Public Const controller_ChanNum_C10_Dio As Short = 10 'Ch10 Dio

    Public Const controller_ChanNum_C11_Time As Short = 11 'Ch11 Time (get time in seconds since reset, accurate to .25us)
    Public Const controller_ChanNum_C12_Digitizer As Short = 12 'Ch12 Digitizer {control timebase and trigger while digitizing on network}

    Public Const controller_Channels_Numbers_MIN As Short = controller_ChanNum_Ch1_Dio
    Public Const controller_Channels_Numbers_MAX As Short = controller_ChanNum_C12_Digitizer

    '================================ GENERAL Settings =================================

    'FIELD NUMBERS for GENERAL settingGroup
    Public Const fldNum_General_valueEU As Short = 1 'inputValue (engineering units)
    Public Const fldNum_General_unitsLabel As Short = 2 'units label (editable); e.g. "Volts", "C", "F", "mmHg".
    Public Const fldNum_General_userName As Short = 3 'user name (editable)
    Public Const fldNum_General_ad_sampleRateMult As Short = 4 'sampleRateMult (0.001x to 1.0x of master sample rate)
    Public Const fldNum_General_chanName As Short = 5 'channel name (non-editable)

    '================================ DISPLAY Settings =================================

    'DISPLAY settingGroup = {dispOnOff, dispMaxEU, dispMinEU}
    Public Const fldNum_Display_dispOnOff As Short = 1 '1 = display is turned on (in RECORD window); or off (2)
    Public Const fldNum_Display_dispMaxEU As Short = 2 'EU value of top line of display (RECORD window, and PROBE dialog)
    Public Const fldNum_Display_dispMinEU As Short = 3 'EU value of bottom line of display (RECORD window, and PROBE dialog)

    '================================ MAPPING Settings =================================

    'MAPPING settingGroup = {Internal1, External1, Internal2, External2}
    Public Const fldNum_Mapping_internal1 As Short = 1 'Mapping point 1, coordinate system inside driver
    Public Const fldNum_Mapping_external1 As Short = 2 'Mapping point 1, coordinate system outside driver
    Public Const fldNum_Mapping_internal2 As Short = 3 'Mapping point 2, coordinate system inside driver
    Public Const fldNum_Mapping_external2 As Short = 4 'Mapping point 2, coordinate system outside driver
    Public Const fldNum_Mapping_scale As Short = 5 'Mapping scale, "y=scale*x + offset"
    Public Const fldNum_Mapping_offset As Short = 6 'Mapping offset, "y=scale*x + offset"

    '=========================== DIGITAL FILTER Settings ===============================

    'FIELD NUMBERS for DIGITAL FILTER settingGroup (1 for each
    'filter in each channel = {passband1_Hz, passBand_Ripple_dB,...}
    Public Const fldNum_DigitalFilter_filterMethod As Short = 1
    Public Const fldNum_DigitalFilter_passBand_Ripple_dB As Short = 2 'passband ripple (dB)
    Public Const fldNum_DigitalFilter_stopBand_Attn_dB As Short = 3 'stopband attenuation (dB)
    Public Const fldNum_DigitalFilter_filterOrder As Short = 4
    Public Const fldNum_DigitalFilter_passband1_Hz As Short = 5 '(lower) passband cutoff frequency
    Public Const fldNum_DigitalFilter_stopband1_Hz As Short = 6 '(lower) stopband cutoff frequency
    Public Const fldNum_DigitalFilter_passband2_Hz As Short = 7 'upper passband cutoff (BANDPASS_DCIIR/BANDSTOP_DCIIR only)
    Public Const fldNum_DigitalFilter_stopband2_Hz As Short = 8 'upper stopband cutoff (BANDPASS_DCIIR/BANDSTOP_DCIIR only)

    'Filter Method (this is a popup menu)
    Public Const FILTEROFF_DCIIR As Short = 1
    Public Const ELLIPTIC_DCIIR As Short = 2
    Public Const CHEBYSHEV_P_DCIIR As Short = 3
    Public Const CHEBYSHEV_S_DCIIR As Short = 4
    Public Const BUTTERWORTH_DCIIR As Short = 5

    '=========================== RECORD OPTIONS Settings ===============================

    'FIELD NUMBERS for RECORD OPTIONS settingGroup (1 for each driver)
    ' = {hScale, hPosition, maxPtsPerPix, gridOnOff, plotLinesDots}
    Public Const fldNum_RecordOptions_hScale As Short = 1 'horiz scale (e.g. 0.1 Seconds per horiz division)
    'if == 0, we do an auto-scale and set ~5 digitized points per pixel
    Public Const fldNum_RecordOptions_hPosition As Short = 2 'horiz position (i.e time of left edge, e.g. 0 Seconds)
    Public Const fldNum_RecordOptions_plotLinesDots As Short = 3 'plot dots or connect dots with lines
    Public Const fldNum_RecordOptions_gridOnOff As Short = 4 'grid is on or off
    Public Const fldNum_RecordOptions_maxPtsPerPix As Short = 5 'maximum points per vertical pixel column when plotting
    Public Const fldNum_RecordOptions_saveData As Short = 6 'save data {off / To Ram Buffer / To Disk / User Control}
    Public Const fldNum_RecordOptions_overflowAlert As Short = 7 'show alert on buffer overflow ON/OFF, gsw 11/25/95

    'Off/To Ram Buffer/To Disk Popup
    Public Const ion_gSaveDataPopup_Off As Short = 1
    Public Const ion_gSaveDataPopup_ToRamBuffer As Short = 2
    Public Const ion_gSaveDataPopup_ToDisk As Short = 3
    Public Const ion_gSaveDataPopup_UserControl As Short = 4

    '================================ FILE Settings ===================================

    'FIELD NUMBERS for FILE settingGroup

    Public Const fldNum_File_FileOnOff As Short = 1
    Public Const fldNum_File_DigitizeOnOff As Short = 2
    Public Const fldNum_File_FileName As Short = 3
    Public Const fldNum_File_fileCmd As Short = 4 ' command = fileCmd_FileToRamBuffer (ScanNum)
    ' fileCmd_RamBufferToFile (ScanNum),
    ' fileCmd_FileToUserBuffer (ScanNum)
    Public Const fldNum_File_ScanNum As Short = 5
    Public Const fldNum_File_FirstPointNum As Short = 6
    Public Const fldNum_File_NumPts As Short = 7

    'File Command Options (e.g. popup)
    Public Const fileCmd_Off As Short = 1 ' minimum
    Public Const fileCmd_FileToRamBuffer As Short = 2 ' Transfer data from FILE @ 'ScanNum'to DRIVER RAM BUFFER
    Public Const fileCmd_RamBufferToFile As Short = 3 ' Transfer data from DRIVER RAM BUFFER to FILE @ 'ScanNum'
    Public Const fileCmd_FileToUserBuffer As Short = 4 ' Transfer data from FILE @ 'ScanNum'to USER RAM BUFFER
    Public Const fileCmd_UserBufferToFile As Short = 5 ' Transfer data from USER RAM BUFFER to File @ 'ScanNum'
    Public Const fileCmd_Get_File_Info As Short = 6 ' Get info on FILE (ScanNum =  of scans; NumPts = pts per scan)

    '============================= MASTER DIRECTORY Settings ============================

    'FIELD NUMBERS for MASTER DIRECTORY settingGroup
    Public Const fldNum_Directory_PathName As Short = 1 'Path Name (for directory that contains a file)
    Public Const fldNum_Directory_NewDirectoryName As Short = 2 'New Directory Name = { ndn_PromptUser, ndn_AutoGenerate }
    Public Const fldNum_Directory_SaveSettingsOnOff As Short = 3 'When we create a new directory we can save network
    Public Const fldNum_Directory_LoadSettingsOnOff As Short = 4 'When we are asked to redirect our directory, then if
    Public Const fldNum_Directory_FileType As Short = 5 'FileType = {ft_Text, ft_iNet_Binary}
    Public Const fldNum_Directory_dirCmd As Short = 6 'dirCmd = {dirCmd_CreateNewDirectory, dirCmd_ShowDirectoryDlog}

    ' New Name = {Prompt User/Auto Generate} options (e.g. popup)
    Public Const ndn_PromptUser As Short = 1
    Public Const ndn_AutoGenerate As Short = 2

    'FileType Options.
    Public Const ft_iNet_Binary As Short = 1
    Public Const ft_Text As Short = 2
    Public Const ft_TextMerge As Short = 3
    Public Const ft_BinaryMerge As Short = 4

    'MASTER DIRECTORY Command Options
    Public Const dirCmd_CreateNewDirectory As Short = 1
    Public Const dirCmd_ShowDirectoryDlog As Short = 2

    ' ============================== CALIBRATION Settings ===============================

    ' FIELD NUMBERS for CALIBRATION settingGroup
    Public Const fldNum_CalOptions_CalBtn As Short = 1 'Cal Btn = { measure, bal gages }
    Public Const fldNum_CalOptions_CalOnStart As Short = 2 'Cal On Start = on/off
    Public Const fldNum_CalOptions_CalOnWarm As Short = 3 'Cal On Warm (10min,25min after launch) = on/off
    Public Const fldNum_CalOptions_AutoCalRate As Short = 4 'Auto Cal Rate (minutes), 0=never

    'CalBtn = {Measure/Bal Gages} determines what happens when the Calibrate button is pressed.
    Public Const ion_gCalBtnPop_Measure As Short = 1 'calibrate the instruNet hardware for measurement
    Public Const ion_gCalBtnPop_BalGages As Short = 2 'Balance strain gages
    Public Const ion_gCalBtnPop_BalBridges As Short = 3 'Balance Bridges
    Public Const ion_gCalBtnPop_BalVdividers As Short = 4 'Balance voltage dividers


    '============================= USER RAM BUFFER Settings ============================

    'FIELD NUMBERS for USER RAM BUFFER settingGroup
    Public Const fldNum_UserBuffer_DigitizeOnOff As Short = 1 'on/off for Moving Digitized Data to buffer at Digitize Time
    Public Const fldNum_UserBuffer_UserBufferAddr As Short = 2
    Public Const fldNum_UserBuffer_UserPtrSizeInBytes As Short = 3 'This is the size of the user's buffer in Bytes.
    Public Const fldNum_UserBuffer_ScanNumIn As Short = 4 'Scan  of last point pushed into buffer = {1...numScans}
    Public Const fldNum_UserBuffer_PtNumIn As Short = 5 'Point  of last point pushed into buffer = {1...PtsPerScan}
    Public Const fldNum_UserBuffer_ScanNumOut As Short = 6 'Scan  of last point pulled out of buffer = {1...umScans}
    Public Const fldNum_UserBuffer_PtNumOut As Short = 7 'Point  of last point pulled out of buffer = {1...PtsPerScan}

    '=========================== DRIVER RAM BUFFER Settings ============================

    'FIELD NUMBERS for DRIVER RAM BUFFER settingGroup
    Public Const fldNum_DvrBuffer_DigitizeOnOff As Short = 1 'on/off for Moving Digitized Data to buffer at Digitize Time
    Public Const fldNum_DvrBuffer_BufferAddr As Short = 2 'driver's addr to a buffer in RAM; 0 if not used (off)
    Public Const fldNum_DvrBuffer_BufferAddrSizeInBytes As Short = 3
    Public Const fldNum_DvrBuffer_ScanNumIn As Short = 4 'Scan  of last point pushed into buffer = {1...numScans}
    Public Const fldNum_DvrBuffer_PtNumIn As Short = 5 'Point  of last point pushed into buffer = {1...PtsPerScan}
    Public Const fldNum_DvrBuffer_ScanNumOut As Short = 6 'Scan  of last point pulled out of buffer = {1...numScans}
    Public Const fldNum_DvrBuffer_PtNumOut As Short = 7 'Point  of last point pulled out of buffer = {1...PtsPerScan}

    '=============================== TIMING Settings ===================================

    'FIELD NUMBERS for TIMING settingGroup
    Public Const fldNum_Timing_digitizeOnOff As Short = 1 '1 = digitizer turned on; 2 = off
    Public Const fldNum_Timing_ptsPerScan As Short = 2 'points per scan (i.e. pts/trace)
    Public Const fldNum_Timing_noOfScans As Short = 3 ' of scans
    Public Const fldNum_Timing_scanMode As Short = 4 'space between scans = {ion_gScanModePopup_StripChart  '
    ' ion_gScanModePopup_OscilloQueued  'ion_gScanModePopup_Oscilloscope}
    Public Const fldNum_Timing_sampleRate As Short = 5 'master sample rate (pts/second)
    Public Const fldNum_Timing_minSecsBetweenTsfrs As Short = 6 'minimum secs between 16bit tsfrs.
    '(It gives the analog electronics time to adjust from
    '1 channel to the other. gsw 2/22/96)
    Public Const fldNum_Timing_network_bps As Short = 7 'network data clock rate (bits per second)  'gsw 11/25/95
    Public Const fldNum_Timing_switching As Short = 8 'switch channels quickly or with more accuracy

    'ON/OFF Options (e.g. popup)
    Public Const ion_gOnOffPopup_On As Short = 1 'on
    Public Const ion_gOnOffPopup_Off As Short = 2 'off

    'LINES/DOTS Options (e.g. popup)
    Public Const ion_gLinesDots_Lines As Short = 1 'Lines
    Public Const ion_gLinesDots_Dots As Short = 2 'Dots

    'OSC/OSC_QUEUED/STRIP-CHART Options (e.g. popup)
    Public Const ion_gScanModePopup_StripChart As Short = 1 'STRIP CHART  continuous scans
    Public Const ion_gScanModePopup_Oscilloscope As Short = 2 'OSCILLOSCOPE non-continuous scans
    'pulled out of controllers buffer
    'in a filo method (first in, last out)
    Public Const ion_gScanModePopup_OscilloQueued As Short = 3 'OSCILLO QUEUED non-continuous scans
    'pulled out of a controllers buffer
    'in a fifo method (first in, first out)

    'switch channels quickly or with more accuracy
    Public Const ion_gSwitchingPopup_Accurate As Short = 1 'switch slower, yet more accurate
    Public Const ion_gSwitchingPopup_Fast As Short = 2 'switch faster, yet more accurate

    '========================= TRIGGER Settings  =============================

    Public Const fldNum_Trigger_triggerModePop As Short = 1 'trigger mode popup {1=off  '2=auto  '3=normal}
    Public Const fldNum_Trigger_thresholdEu As Short = 2 'trigger threshold engineering units
    Public Const fldNum_Trigger_slopeRisFalPop As Short = 3 'slope {1=rising edge, 2=falling edge}
    Public Const fldNum_Trigger_preTrigSec As Short = 4 'pretrigger (seconds)
    Public Const fldNum_Trigger_srcNet As Short = 5 'trigger source netNum
    Public Const fldNum_Trigger_srcModule As Short = 6 'trigger source moduleNum
    Public Const fldNum_Trigger_srcDevice As Short = 7 'trigger source deviceNum
    Public Const fldNum_Trigger_srcChannel As Short = 8 'trigger source channeNum

    'MODE options in TRIGGER Settings Group
    Public Const ion_TriggerMode_Off As Short = 1
    Public Const ion_TriggerMode_Auto As Short = 2
    Public Const ion_TriggerMode_Norm As Short = 3

    Public Const ion_TriggerModePopup_MIN As Short = ion_TriggerMode_Off
    Public Const ion_TriggerModePopup_MAX As Short = ion_TriggerMode_Norm
    Public Const ion_TriggerModePopup_DEF As Short = ion_TriggerMode_Off

    'SLOPE options in TRIGGER Settings Group
    Public Const ion_Rising As Short = 1 'trigger on rising edge
    Public Const ion_Falling As Short = 2 'trigger on falling edge

    Public Const ion_RiseFallPopup_MIN As Short = ion_Rising
    Public Const ion_RiseFallPopup_MAX As Short = ion_Falling
    Public Const ion_RiseFallPopup_DEF As Short = ion_Rising

    '=============================== TIMER Settings  ==================================

    'FIELD NUMBERS for TIMER settingGroup
    Public Const fldNum_Timer_functionPop As Short = 1

    Public Const fldNum_Timer_clkTotalSecs As Short = 2
    Public Const fldNum_Timer_clkHiSecs As Short = 3
    Public Const fldNum_Timer_measHiOrCyclePop As Short = 4
    Public Const fldNum_Timer_measResolutionPop As Short = 5
    Public Const fldNum_Timer_measNumPeriods As Short = 6
    Public Const fldNum_Timer_Mode As Short = 7	

    ' uController TPU Channel Timer/Din/Dout Function Options (e.g. popup)
    Public Const ion_TimerFuncPopup_Din As Short = 1 'digital input
    Public Const ion_TimerFuncPopup_Dout As Short = 2 'digital output
    Public Const ion_TimerFuncPopup_ClkOut As Short = 3 'clock output
    Public Const ion_TimerFuncPopup_PerMeas As Short = 4 'period measurement
    Public Const ion_TimerFuncPopup_CountPulses As Short = 5 'count pulses
    Public Const ion_TimerFuncPopup_FreqMeas As Short = 6 'frequency measurement
    Public Const ion_TimerFuncPopup_QuadMeas As Short = 7 'quadrature measurement

    ' Timer Mode
    Public Const ion_TimerModePopup_WaitAndCont As Short = 1 '   Period/Frequency: Wait till measurement completes
    '                                                               and restart a new one after reading result.
    '                                                            EventCt/Quadrature: Read current value and then let
    '                                                               it continue measuring.

    Public Const ion_TimerModePopup_WaitAndReset As Short = 2 '	Period/Frequency: Wait till measurement completes
    '                                                            	and then halt timer after reading result.
    '                                                            	It will be started when you read again.
    '                                                            EventCt/Quadrature: Read current value, and then 
    '                                                            	reset counter.

    Public Const ion_TimerModePopup_NoWaitAndCont As Short = 3 ' Period/Frequency: Read 0 if measurement is not complete
    '                                                            	and restart a new one after reading result.
    '                                                            EventCt/Quadrature: Read current value and then let
    '                                                            	it continue measuring.

    Public Const ion_TimerModePopup_NoWaitAndReset As Short = 4 ' Period/Frequency: Read 0 if measurement is not complete
    '                                                            	and then halt timer after reading result.
    '                                                          	    It will be started when you read again.
    '                                                             EventCt/Quadrature: Read current value, and then 
    '                                                            	reset counter.

    'uController TPU Channel measure CYCLE time
    Public Const ion_measHiOrCyclePop_CycleTime As Short = 1 'measure cycle time (falling edge to falling edge)
    Public Const ion_measHiOrCyclePop_HighTime As Short = 2 'measure high time (rising edge to falling edge)

    '25us/8ms Resolution Popup
    Public Const ion_timeResolutionPop_quarterMicroSec As Short = 1 '.25us resolution
    Public Const ion_timeResolutionPop_eightMilliSec As Short = 2 '8ms resolution

    '====================== DIGITAL I/O Settings Field Numbers  =========================

    'FIELD NUMBERS for 8bit Mod 100 DigitalI/O settingGroup {din, dout, direction}
    Public Const fldNum_Mod100DinDout_dout As Short = 1 'digital output, {0..255}
    Public Const fldNum_Mod100DinDout_direction As Short = 2 'direction, {0..255}

    '========================= User Interface Types For Fields ==========================

    'types of user interfaces for fields
    Public Const fuit_unknown As Short = 0

    Public Const fuit_editField_flt32 As Short = 1 'Edit Field with FLT32 data
    Public Const fuit_editField_double As Short = 2 'Edit Field with double data
    Public Const fuit_editField_int16 As Short = 3 'Edit Field with INT16 data
    Public Const fuit_editField_int32 As Short = 4 'Edit Field with INT32 data
    Public Const fuit_editField_uint32 As Short = 5 'Edit Field with UINT32 data
    Public Const fuit_editField_str15 As Short = 6 'Edit Field with STR15 data
    Public Const fuit_editField_str255 As Short = 7 'Edit Field with STR255 data

    Public Const fuit_staticText_flt32 As Short = 10 'Static Text with FLT32 data
    Public Const fuit_staticText_int16 As Short = 11 'Static Text with INT16 data
    Public Const fuit_staticText_int32 As Short = 12 'Static Text with INT32 data
    Public Const fuit_staticText_uint32 As Short = 13 'Static Text with UINT32 data
    Public Const fuit_staticText_str15 As Short = 14 'Static Text with STR15 data

    Public Const fuit_popup_Mod100analogLpFltrPop As Short = 20 'Model 100 Analog Low Pass Filter Popup {off, 40Hz, 4KHz}
    Public Const fuit_popup_Mod100rangePop As Short = 21 'Model 100 Range Popup {+/-5V, +/-1.25V, +/-.37V, +/-.08V}
    Public Const fuit_popup_Mod100sensorPosTypePop As Short = 22 'Model 100 POS SensorType {voltage, J, K, RTD..}
    Public Const fuit_popup_Mod100sensorNegTypePop As Short = 23 'Model 100 NEG SensorType {diff/se VOLTS}
    Public Const fuit_popup_Mod100WiringPosTypePop As Short = 24 'Model 100 POS Wiring {diff, se, bridge, R shunt, V divider}
    Public Const fuit_popup_Mod100WiringNegTypePop As Short = 25 'Model 100 NEG Wiring {diff, se}

    Public Const fuit_popup_continuousOnOff As Short = 26 'On/Off Popup {1=on 2=off,3=offWithSkip}
    Public Const fuit_popup_saveData As Short = 27 'save data {off / To Ram Buffer / To Disk / User Control}
    Public Const fuit_popup_OnOff As Short = 28 'On/Off Popup {1=on 0=off}
    Public Const fuit_popup_LinesDots As Short = 29 'Lines/Dots Popup {1=lines 2=dots}
    Public Const fuit_popup_triggerMode As Short = 30 'trigger mode popup {1=off, 2=auto, 3=normal}
    Public Const fuit_popup_riseFall As Short = 31 'slope {1=rising edge, 2=falling edge}
    Public Const fuit_popup_timerFunction As Short = 32 'function mode popup {1=digitalIn, 2=digitalOut, 3=clkOut, 4=periodMeas}
    Public Const fuit_popup_measHiOrCycle As Short = 33 'periodMeasureCyclePop {1=measureCycleTime, 2=measureHighTime}
    Public Const fuit_popup_measResolution As Short = 34 'periodMeasureResolutionPop {1 = 0.25us, 2 = 4ms}
    Public Const fuit_popup_filterMethod As Short = 35 'filter method = {FILTEROFF_DCIIR, BUTTERWORTH_DCIIR, etc}
    Public Const fuit_popup_DirCmd As Short = 36 'text to the DirCmd popup
    Public Const fuit_popup_FileType As Short = 37 'text to the FileType popup
    Public Const fuit_popup_NewDirName As Short = 38 'text to the NewDirName popup
    Public Const fuit_popup_FileCmd As Short = 39 'text to the FileCmd popup
    Public Const fuit_popup_PushButton As Short = 40 'DRIVER Push Button Command
    Public Const fuit_popup_OpenWindow As Short = 41 'DRIVER Open Window Command
    Public Const fuit_popup_switching As Short = 42 'channel switching {accurate, fast}

    '=========================== user interface catagory =============================

    'Types of items to add to a dialog.
    Public Const ion_NotDefined As Short = 0 'not defined
    Public Const ion_Button As Short = 1 'button
    Public Const ion_CheckBox As Short = 2 'checkbox
    Public Const ion_RadioBtn As Short = 3 'radio button
    Public Const ion_StaticText As Short = 4 'static text
    Public Const ion_EditText As Short = 5 'edit text
    Public Const ion_UserItem As Short = 6 'user item
    Public Const ion_Icon As Short = 7 'icon item
    Public Const ion_Picture As Short = 8 'picture item
    Public Const ion_Control As Short = 9 'control item

    '=========================== request struct interface =============================
    'These macros are the offset's from the beginning of the iNet_Request struct
    'to the specified field. A pointer to the iNet_Request struct is passed to the driver.

    Public Const netNum_OFFSET As Short = &H0S
    Public Const deviceNum_OFFSET As Short = &H1S
    Public Const moduleNum_OFFSET As Short = &H2S
    Public Const chanNum_OFFSET As Short = &H3S

    Public Const settingGroupNum_OFFSET As Short = &H4S
    Public Const fieldNum_OFFSET As Short = &H6S
    Public Const intention_OFFSET As Short = &H8S
    Public Const argType_OFFSET As Short = &HAS
    Public Const error_OFFSET As Short = &HES
    Public Const ptrToArg_OFFSET As Short = &H10S

    Public Const A_OFFSET As Short = &H14S
    Public Const B_OFFSET As Short = &H18S
    Public Const C_OFFSET As Short = &H1CS
    Public Const D_OFFSET As Short = &H20S
    Public Const E_OFFSET As Short = &H24S
    Public Const F_OFFSET As Short = &H28S

    Public Const netP_OFFSET As Short = &H2CS
    Public Const interfaceBlockP_OFFSET As Short = &H30S
    Public Const deviceGlobalsP_OFFSET As Short = &H34S
    Public Const moduleGlobalsP_OFFSET As Short = &H38S
    Public Const channelGlobalsP_OFFSET As Short = &H3CS
    Public Const settingGroup__P_OFFSET As Short = &H40S
    Public Const settingGroupType_OFFSET As Short = &H44S
    Public Const key_OFFSET As Short = &H46S

    ' chAddrP is used for passing a complete channel address
    ' (i.e. netNum, devNum, modNum, chanNum) to a DLL.  These
    ' 4 params are packed into one 32bit long.
    '
    <StructLayout(LayoutKind.Sequential)> Public Structure chAddrP

        ' The instruNet driver packs this 32bit Integer with
        ' 8bit netNum, 8bit devNum, 8bit modNum, 8bit chanNum.
        Public iNetAddress As Integer

    End Structure

    ' OLD: Public tempArr() As Single 'use this with memcopy and varptr dll's
    ' OLD: PPublic chan0Buff() As Single
    ' OLD: PPublic chan1Buff() As Single
    ' OLD: PPublic chan2Buff() As Single
    ' OLD: PPublic chan3Buff() As Single
    ' OLD: PPublic chan4Buff() As Single
    ' OLD: PPublic message(255, 0) As String
    ' OLD: Public ioArray() As Single

    ' ---------------------------------------------------------------------------
    ' Loaded with address of digitized channels. This is used
    ' by VB and not the iNet DLL, which wants one Long variable.

    <StructLayout(LayoutKind.Sequential)> Public Structure DataArrayType

        ' contains the data, of length 'numValidPts'
        Dim data() As Single

        ' # of valid points contained within data() buffer.
        Dim numValidPts As Integer

        ' # of pts in within the data() buffer.
        Dim numBufferPts As Integer

        ' sample rate of the data, in pts-per-sec
        ' (or pts-per-plotted-xUnit)
        Dim ptsPerXunit As Double

        ' first point (zeroth) time in seconds
        Dim firstPt_Xunits As Double

        ' ------------------------------------
        ' VB has a technique where one can lock an array in memory and get an address
        ' to it's data, to be passed to a DLL. gsw 6/1/02

        Dim gcHandle As GCHandle        ' handle to data() array, after being pinned
        Dim pinnedAddress As Integer    ' address to data() array, after being pinned
        Dim arrayIsPinned As Boolean    ' true if data() has been pinned

    End Structure

    ' ---------------------------------------------------------------------------
    ' Loaded with address of digitized channels. This is used
    ' by VB and not the iNet DLL, which wants one Long variable.

    <StructLayout(LayoutKind.Sequential)> Public Structure chAddr

        ' iNet DLL likes one i32 variable to contain the channel address
        '
        ' THIS MUST BE THE 1st ELEMENT OF THE chAddr STRUCT, SO THE
        ' DLL WILL OPERATE ON THIS ELEMENT WHEN PASSED A ptr TO A
        ' chAddr STRUCT.
        Dim chAddrDLL As chAddrP

        ' VB likes 4 fields to contain the channel address
        Dim netNum As Byte
        Dim deviceNum As Byte
        Dim moduleNum As Byte
        Dim chanNum As Byte

        ' {bNum, dispNum} references the address of a front panel VB display that
        ' contains this channel (if one exists).
        Dim bNum As Short
        Dim dNum As Short

        ' dataArrayY Contains:
        '
        '   .numValidPts = # of valid points contained within the data() buffer
        '   .numBufferPts = buffer size
        '   .data() = data is stored in this array
        '   .ptsPerXunit = sample rate of the data
        '   .firstPt_Xunits = first point time in seconds
        '
        Dim dataArrayY As DataArrayType

        ' massageType (not message, massage) is set to {jNoMassage, jFFTMassage}
        ' and indicates how the data is to be massaged (i.e. analyzed) immediately
        ' after it is digitized.
        Dim massageType As Short

        ' If true, then the digitize code calls EndUser_SegmentProcessor() each
        ' time a little segment of data is digitized.
        Dim runEndUser_SegmentProcessor As Short

    End Structure

End Module