' ============================================================================
' FILE        INET_SetupDialog.vb
'
' PURPOSE     Handles a dialog box that sets the # of scans, the sample rate,
'             and other digitize parameters.
'
' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
' ============================================================================

Option Strict Off
Option Explicit On 

Friend Class instruNet_Setup_Dialog

    Inherits System.Windows.Forms.Form

#Region "Windows Form Designer generated code "

    ' -------------------------------------------------------------------------
    ' FUNCTION    New() - Windows Form Designer generated code
    '
    ' PURPOSE     This is the New() method, which is generated by the windows
    '             Form Designer utility.  This code sets up the dialog and
    '             sets the attributes of the various fields.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Public Sub New()
        MyBase.New()
        If m_vb6FormDefInstance Is Nothing Then
            If m_InitializingDefInstance Then
                m_vb6FormDefInstance = Me
            Else
                Try
                    'For the start-up form, the first instance created is the default instance.
                    If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
                        m_vb6FormDefInstance = Me
                    End If
                Catch
                End Try
            End If
        End If
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    Dispose() - Windows Form Designer generated code
    '
    ' PURPOSE     Form overrides dispose to clean up the component list.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub


    ' -------------------------------------------------------------------------
    ' Required by the Windows Form Designer

    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents TriggerSetup_Button As System.Windows.Forms.Button
    Public WithEvents ProcessSegOrScan As System.Windows.Forms.ComboBox
    Public WithEvents ContScans_Popup As System.Windows.Forms.ComboBox
    Public WithEvents NumOfScans_Field As System.Windows.Forms.TextBox
    Public WithEvents ptsPerScan_field As System.Windows.Forms.TextBox
    Public WithEvents SampleRate_field As System.Windows.Forms.TextBox
    Public WithEvents Cancel_button As System.Windows.Forms.Button
    Public WithEvents OK_button As System.Windows.Forms.Button
    Public WithEvents PointsPerScan_Label As System.Windows.Forms.Label
    Public WithEvents SampleRate_Label As System.Windows.Forms.Label
    Public WithEvents Processing_Label As System.Windows.Forms.Label
    Public WithEvents ContScans_Label As System.Windows.Forms.Label
    Public WithEvents NumOfScans_Label As System.Windows.Forms.Label


    ' -------------------------------------------------------------------------
    ' FUNCTION    InitializeComponent() - Windows Form Designer generated code
    '
    ' PURPOSE     The following procedure is required by the Windows Form Designer
    '             It can be modified using the Windows Form Designer.
    '             Do not modify it using the code editor.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.TriggerSetup_Button = New System.Windows.Forms.Button()
        Me.ProcessSegOrScan = New System.Windows.Forms.ComboBox()
        Me.ContScans_Popup = New System.Windows.Forms.ComboBox()
        Me.NumOfScans_Field = New System.Windows.Forms.TextBox()
        Me.ptsPerScan_field = New System.Windows.Forms.TextBox()
        Me.SampleRate_field = New System.Windows.Forms.TextBox()
        Me.Cancel_button = New System.Windows.Forms.Button()
        Me.OK_button = New System.Windows.Forms.Button()
        Me.PointsPerScan_Label = New System.Windows.Forms.Label()
        Me.SampleRate_Label = New System.Windows.Forms.Label()
        Me.Processing_Label = New System.Windows.Forms.Label()
        Me.ContScans_Label = New System.Windows.Forms.Label()
        Me.NumOfScans_Label = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'TriggerSetup_Button
        '
        Me.TriggerSetup_Button.BackColor = System.Drawing.SystemColors.Control
        Me.TriggerSetup_Button.Cursor = System.Windows.Forms.Cursors.Default
        Me.TriggerSetup_Button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TriggerSetup_Button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.TriggerSetup_Button.Location = New System.Drawing.Point(24, 184)
        Me.TriggerSetup_Button.Name = "TriggerSetup_Button"
        Me.TriggerSetup_Button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.TriggerSetup_Button.Size = New System.Drawing.Size(201, 25)
        Me.TriggerSetup_Button.TabIndex = 12
        Me.TriggerSetup_Button.Text = "Trigger Setup"
        '
        'ProcessSegOrScan
        '
        Me.ProcessSegOrScan.BackColor = System.Drawing.SystemColors.Window
        Me.ProcessSegOrScan.Cursor = System.Windows.Forms.Cursors.Default
        Me.ProcessSegOrScan.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.ProcessSegOrScan.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ProcessSegOrScan.ForeColor = System.Drawing.SystemColors.WindowText
        Me.ProcessSegOrScan.Items.AddRange(New Object() {"Complete Scans", "Little Segments"})
        Me.ProcessSegOrScan.Location = New System.Drawing.Point(128, 144)
        Me.ProcessSegOrScan.Name = "ProcessSegOrScan"
        Me.ProcessSegOrScan.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.ProcessSegOrScan.Size = New System.Drawing.Size(97, 22)
        Me.ProcessSegOrScan.TabIndex = 6
        '
        'ContScans_Popup
        '
        Me.ContScans_Popup.BackColor = System.Drawing.SystemColors.Window
        Me.ContScans_Popup.Cursor = System.Windows.Forms.Cursors.Default
        Me.ContScans_Popup.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.ContScans_Popup.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ContScans_Popup.ForeColor = System.Drawing.SystemColors.WindowText
        Me.ContScans_Popup.Items.AddRange(New Object() {"Yes", "No"})
        Me.ContScans_Popup.Location = New System.Drawing.Point(128, 112)
        Me.ContScans_Popup.Name = "ContScans_Popup"
        Me.ContScans_Popup.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.ContScans_Popup.Size = New System.Drawing.Size(97, 22)
        Me.ContScans_Popup.TabIndex = 5
        '
        'NumOfScans_Field
        '
        Me.NumOfScans_Field.AcceptsReturn = True
        Me.NumOfScans_Field.AutoSize = False
        Me.NumOfScans_Field.BackColor = System.Drawing.SystemColors.Window
        Me.NumOfScans_Field.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.NumOfScans_Field.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.NumOfScans_Field.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.NumOfScans_Field.ForeColor = System.Drawing.SystemColors.WindowText
        Me.NumOfScans_Field.Location = New System.Drawing.Point(128, 80)
        Me.NumOfScans_Field.MaxLength = 0
        Me.NumOfScans_Field.Name = "NumOfScans_Field"
        Me.NumOfScans_Field.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.NumOfScans_Field.Size = New System.Drawing.Size(97, 19)
        Me.NumOfScans_Field.TabIndex = 4
        Me.NumOfScans_Field.Text = "numOfScans"
        '
        'ptsPerScan_field
        '
        Me.ptsPerScan_field.AcceptsReturn = True
        Me.ptsPerScan_field.AutoSize = False
        Me.ptsPerScan_field.BackColor = System.Drawing.SystemColors.Window
        Me.ptsPerScan_field.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.ptsPerScan_field.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.ptsPerScan_field.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ptsPerScan_field.ForeColor = System.Drawing.SystemColors.WindowText
        Me.ptsPerScan_field.Location = New System.Drawing.Point(128, 48)
        Me.ptsPerScan_field.MaxLength = 0
        Me.ptsPerScan_field.Name = "ptsPerScan_field"
        Me.ptsPerScan_field.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.ptsPerScan_field.Size = New System.Drawing.Size(97, 19)
        Me.ptsPerScan_field.TabIndex = 3
        Me.ptsPerScan_field.Text = "ptsPerScan"
        '
        'SampleRate_field
        '
        Me.SampleRate_field.AcceptsReturn = True
        Me.SampleRate_field.AutoSize = False
        Me.SampleRate_field.BackColor = System.Drawing.SystemColors.Window
        Me.SampleRate_field.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.SampleRate_field.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.SampleRate_field.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SampleRate_field.ForeColor = System.Drawing.SystemColors.WindowText
        Me.SampleRate_field.Location = New System.Drawing.Point(128, 16)
        Me.SampleRate_field.MaxLength = 0
        Me.SampleRate_field.Name = "SampleRate_field"
        Me.SampleRate_field.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.SampleRate_field.Size = New System.Drawing.Size(97, 19)
        Me.SampleRate_field.TabIndex = 2
        Me.SampleRate_field.Text = "SampleRate"
        '
        'Cancel_button
        '
        Me.Cancel_button.BackColor = System.Drawing.SystemColors.Control
        Me.Cancel_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Cancel_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Cancel_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Cancel_button.Location = New System.Drawing.Point(24, 224)
        Me.Cancel_button.Name = "Cancel_button"
        Me.Cancel_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Cancel_button.Size = New System.Drawing.Size(89, 25)
        Me.Cancel_button.TabIndex = 1
        Me.Cancel_button.Text = "Cancel"
        '
        'OK_button
        '
        Me.OK_button.BackColor = System.Drawing.SystemColors.Control
        Me.OK_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.OK_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.OK_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.OK_button.Location = New System.Drawing.Point(136, 224)
        Me.OK_button.Name = "OK_button"
        Me.OK_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.OK_button.Size = New System.Drawing.Size(89, 25)
        Me.OK_button.TabIndex = 0
        Me.OK_button.Text = "OK"
        '
        'PointsPerScan_Label
        '
        Me.PointsPerScan_Label.BackColor = System.Drawing.Color.Transparent
        Me.PointsPerScan_Label.Cursor = System.Windows.Forms.Cursors.Default
        Me.PointsPerScan_Label.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.PointsPerScan_Label.ForeColor = System.Drawing.SystemColors.WindowText
        Me.PointsPerScan_Label.Location = New System.Drawing.Point(24, 48)
        Me.PointsPerScan_Label.Name = "PointsPerScan_Label"
        Me.PointsPerScan_Label.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.PointsPerScan_Label.Size = New System.Drawing.Size(88, 17)
        Me.PointsPerScan_Label.TabIndex = 11
        Me.PointsPerScan_Label.Text = "Points Per Scan:"
        '
        'SampleRate_Label
        '
        Me.SampleRate_Label.BackColor = System.Drawing.Color.Transparent
        Me.SampleRate_Label.Cursor = System.Windows.Forms.Cursors.Default
        Me.SampleRate_Label.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SampleRate_Label.ForeColor = System.Drawing.SystemColors.WindowText
        Me.SampleRate_Label.Location = New System.Drawing.Point(24, 16)
        Me.SampleRate_Label.Name = "SampleRate_Label"
        Me.SampleRate_Label.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.SampleRate_Label.Size = New System.Drawing.Size(73, 17)
        Me.SampleRate_Label.TabIndex = 10
        Me.SampleRate_Label.Text = "Sample Rate:"
        '
        'Processing_Label
        '
        Me.Processing_Label.BackColor = System.Drawing.Color.Transparent
        Me.Processing_Label.Cursor = System.Windows.Forms.Cursors.Default
        Me.Processing_Label.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Processing_Label.ForeColor = System.Drawing.SystemColors.WindowText
        Me.Processing_Label.Location = New System.Drawing.Point(24, 144)
        Me.Processing_Label.Name = "Processing_Label"
        Me.Processing_Label.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Processing_Label.Size = New System.Drawing.Size(129, 17)
        Me.Processing_Label.TabIndex = 9
        Me.Processing_Label.Text = "Processing:"
        '
        'ContScans_Label
        '
        Me.ContScans_Label.BackColor = System.Drawing.Color.Transparent
        Me.ContScans_Label.Cursor = System.Windows.Forms.Cursors.Default
        Me.ContScans_Label.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ContScans_Label.ForeColor = System.Drawing.SystemColors.WindowText
        Me.ContScans_Label.Location = New System.Drawing.Point(24, 112)
        Me.ContScans_Label.Name = "ContScans_Label"
        Me.ContScans_Label.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.ContScans_Label.Size = New System.Drawing.Size(97, 17)
        Me.ContScans_Label.TabIndex = 8
        Me.ContScans_Label.Text = "Continuous Scans:"
        '
        'NumOfScans_Label
        '
        Me.NumOfScans_Label.BackColor = System.Drawing.Color.Transparent
        Me.NumOfScans_Label.Cursor = System.Windows.Forms.Cursors.Default
        Me.NumOfScans_Label.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.NumOfScans_Label.ForeColor = System.Drawing.SystemColors.WindowText
        Me.NumOfScans_Label.Location = New System.Drawing.Point(24, 80)
        Me.NumOfScans_Label.Name = "NumOfScans_Label"
        Me.NumOfScans_Label.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.NumOfScans_Label.Size = New System.Drawing.Size(81, 17)
        Me.NumOfScans_Label.TabIndex = 7
        Me.NumOfScans_Label.Text = "Num of Scans:"
        '
        'instruNet_Setup_Dialog
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(252, 262)
        Me.ControlBox = False
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.TriggerSetup_Button, Me.ProcessSegOrScan, Me.ContScans_Popup, Me.NumOfScans_Field, Me.ptsPerScan_field, Me.SampleRate_field, Me.Cancel_button, Me.OK_button, Me.PointsPerScan_Label, Me.SampleRate_Label, Me.Processing_Label, Me.ContScans_Label, Me.NumOfScans_Label})
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ForeColor = System.Drawing.SystemColors.WindowText
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Location = New System.Drawing.Point(240, 206)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "instruNet_Setup_Dialog"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "instruNet Setup Options"
        Me.ResumeLayout(False)

    End Sub
#End Region


    ' -------------------------------------------------------------------------
    ' FUNCTION    Defines several properties to be used with the dialog.
    '
    ' PURPOSE     This was generated by the VS 7 Upgrade Wizard.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
#Region "Upgrade Support "

    Private Shared m_vb6FormDefInstance As instruNet_Setup_Dialog

    Private Shared m_InitializingDefInstance As Boolean

    Public Shared Property DefInstance() As instruNet_Setup_Dialog
        Get
            If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
                m_InitializingDefInstance = True
                m_vb6FormDefInstance = New instruNet_Setup_Dialog()
                m_InitializingDefInstance = False
            End If
            DefInstance = m_vb6FormDefInstance
        End Get
        Set(ByVal Value As instruNet_Setup_Dialog)
            m_vb6FormDefInstance = Value
        End Set
    End Property

#End Region


    ' -------------------------------------------------------------------------
    ' FUNCTION    Cancel_button_Click()
    '
    ' PURPOSE     Handles Clicking the CANCEL button.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Private Sub Cancel_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Cancel_button.Click

        instruNet_Setup_Dialog.DefInstance.Close()

    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    ChannelSetup_Button_Click()
    '
    ' PURPOSE     Handles Clicking the CHANNEL SETUP button.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Private Sub ChannelSetup_Button_Click()

        ' Open the instruNet World network page.
        METHOD_Channels_Button_Click()

    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    instruNet_Setup_Dialog_Load() - DIALOG WINDOW JUST APPEARED
    '
    ' PURPOSE     This loads the fields in the dialog when it is first opened.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Private Sub instruNet_Setup_Dialog_Load(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        ' load the fields with their current values
        ptsPerScan_field.Text = Str(gPtsPerScan_nextDigi)
        SampleRate_field.Text = Str(gSampleRate_nextDigi)
        NumOfScans_Field.Text = Str(gNumScans)
        ContScans_Popup.SelectedIndex = IIf(gContinuousScans <> False, 0, 1)
        ProcessSegOrScan.SelectedIndex = IIf(gProcessSegmentsInsteadOfScans <> False, 1, 0)

    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    OK_button_Click()
    '
    ' PURPOSE     Handles pressing the OK button, which causes the fields to be
    '             read and the dialog to be closed.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Private Sub OK_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles OK_button.Click

        Dim cNum, bNum As Short

        ' read in the edit fields
        gPtsPerScan_nextDigi = Val(ptsPerScan_field.Text)
        gPtsPerScan_currentData = gPtsPerScan_nextDigi

        gNumScans = Val(NumOfScans_Field.Text)

        gContinuousScans = IIf(ContScans_Popup.SelectedIndex = 0, True, False)

        gProcessSegmentsInsteadOfScans = IIf(ProcessSegOrScan.SelectedIndex = 0, False, True)

        ' Measures the actual sample rate, sets the data array sizes to
        ' gPtsPerScan_nextDigi, and updates the dataArrayY ptsPerXunits field.
        gSampleRate_nextDigi = Val(SampleRate_field.Text)
        gSampleRate_currentData = gSampleRate_nextDigi
        gSampleRate_nextDigi = DigitizeProcess_MeasureActualSampleRate()
        gSampleRate_currentData = gSampleRate_nextDigi

        ' Update the data 'numValidPts' and 'ptsPerXunit' field, and the
        ' data.  The reason we do this now, is so that the resetting
        ' of the controls will match the new data.
        For cNum = 0 To (gNumDigiCh - 1)

            ' Resets the data(), numPts, and sRate parameters for a
            ' digitize channel, resizes the data() array, and zeros it.
            DigitizeList_ResetDataArray(cNum)

        Next cNum

        ' Automatically add channels to DisplayBoxes if AutoAddChannels = True
        ' (and clear those displayBoxes of Displays before we begin adding).
        '
        ' This will set the display data() buffers to PtsPerScan_nextDigi size,
        ' which is necessary, since the pts per scan changed in here. gsw 6/1/02
        For bNum = 0 To gNumBoxes - 1

            ' if we are automatically add channels to this box...
            If (gBox(bNum).autoAddPolicy <> hAutoAddNone) Then

                ' Automatically add Digitize Channels to this display box.
                '
                ' This first Deletes all Displays in this DisplayBox before
                ' it adds the channels to the box, one channel per Display
                ' in this one DisplayBox.
                '
                ' This will set the display data() buffers to PtsPerScan_nextDigi size.
                AutoAddChannelsToThisDisplayBox(bNum, gEndUser_GRAPHICS)

            End If

        Next bNum

        ' Reset horiz scale to 0 left edge, 1 scan per display width
        ' (and update the plotted pts-per-xunit params)
        Reset_Controls_AllBoxes( _
            (reset_hPosition_toZero + reset_hScale_toOneScanWideDisplays + reset_ptsPerHscale), _
            gEndUser_GRAPHICS)

        ' Clear all DispBoxes and then redraw them with the new hScales.
        Call Redraw_AllBoxes(gEndUser_GRAPHICS)

        ' close this dialog box
        instruNet_Setup_Dialog.DefInstance.Close()

    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    TriggerSetup_Button_Click()
    '
    ' PURPOSE     Handles pressing the TRIGGER button, which opens the
    '             iNet32.dll's Trigger Setup dialog
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Private Sub TriggerSetup_Button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles TriggerSetup_Button.Click

        ' Open the instruNet World trigger dialog.
        Open_instruNet_Window_VB((iNetCM_OpenWindow_RecTrigger))

    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    Finalize()
    '
    ' PURPOSE     Runs the finalize method when the dialog is closed.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

End Class