' ============================================================================
' FILE        INET_TextWindow.vb
'
' PURPOSE     Handles a window that is used to print text, similar to the 
'             Dos prompt window or a C printf window.
'
' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
' ============================================================================

Option Strict Off
Option Explicit On

Friend Class TextWindow

    Inherits System.Windows.Forms.Form

#Region "Windows Form Designer generated code "

    ' -------------------------------------------------------------------------
    ' FUNCTION    New() - Windows Form Designer generated code
    '
    ' PURPOSE     This is the New() method, which is generated by the windows
    '             Form Designer utility.  This code sets up the dialog and
    '             sets the attributes of the various fields.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Public Sub New()
        MyBase.New()
        If m_vb6FormDefInstance Is Nothing Then
            If m_InitializingDefInstance Then
                m_vb6FormDefInstance = Me
            Else
                Try
                    'For the start-up form, the first instance created is the default instance.
                    If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
                        m_vb6FormDefInstance = Me
                    End If
                Catch
                End Try
            End If
        End If
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    Dispose() - Windows Form Designer generated code
    '
    ' PURPOSE     Form overrides dispose to clean up the component list.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub

    ' -------------------------------------------------------------------------
    'Required by the Windows Form Designer

    Private components As System.ComponentModel.IContainer

    Public ToolTip1 As System.Windows.Forms.ToolTip

    Public WithEvents TextRegion As System.Windows.Forms.TextBox


    ' -------------------------------------------------------------------------
    ' FUNCTION    InitializeComponent() - Windows Form Designer generated code
    '
    ' PURPOSE      The following procedure is required by the Windows Form Designer
    '              It can be modified using the Windows Form Designer.
    '              Do not modify it using the code editor.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.TextRegion = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'TextRegion
        '
        Me.TextRegion.AcceptsReturn = True
        Me.TextRegion.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.TextRegion.AutoSize = False
        Me.TextRegion.BackColor = System.Drawing.SystemColors.Window
        Me.TextRegion.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.TextRegion.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TextRegion.ForeColor = System.Drawing.SystemColors.WindowText
        Me.TextRegion.MaxLength = 0
        Me.TextRegion.Multiline = True
        Me.TextRegion.Name = "TextRegion"
        Me.TextRegion.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.TextRegion.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.TextRegion.Size = New System.Drawing.Size(741, 569)
        Me.TextRegion.TabIndex = 0
        Me.TextRegion.Text = ""
        '
        'TextWindow
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(742, 570)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.TextRegion})
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Location = New System.Drawing.Point(83, 117)
        Me.MaximumSize = New System.Drawing.Size(4000, 4000)
        Me.MinimumSize = New System.Drawing.Size(100, 100)
        Me.Name = "TextWindow"
        Me.ShowInTaskbar = False
        Me.Text = "TextWindow"
        Me.ResumeLayout(False)

    End Sub
#End Region


    ' -------------------------------------------------------------------------
    ' FUNCTION    m_vb6FormDefInstance
    '             m_InitializingDefInstance
    '             DefInstance
    '
    ' PURPOSE     Several properties used with the dialog.
    '
    '             This was generated by the VS 7 Upgrade Wizard.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
#Region "Upgrade Support "

    Private Shared m_vb6FormDefInstance As TextWindow

    Private Shared m_InitializingDefInstance As Boolean

    Public Shared Property DefInstance() As TextWindow
        Get
            If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
                m_InitializingDefInstance = True
                m_vb6FormDefInstance = New TextWindow()
                m_InitializingDefInstance = False
            End If
            DefInstance = m_vb6FormDefInstance
        End Get
        Set(ByVal Value As TextWindow)
            m_vb6FormDefInstance = Value
        End Set
    End Property
#End Region


    ' -------------------------------------------------------------------------
    ' FUNCTION    OpenTextWindow()
    '
    ' PURPOSE     Open the help window, and display the text from the
    '             'filePathName' text file in the dialog.  'caption' is
    '             is shown at the top of the window.  If 'editible' is
    '             true, then the text is editable in the window.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Public Sub OpenTextWindow(ByRef filePathName As String, ByRef caption As String, _
        ByVal editable As Short)

        Dim editible, fileNum, hitError As Integer
        Dim NextLine, LinesFromFile As String

        hitError = False
        On Error GoTo ErrorHandler      ' Add Error Handler Routine

        'ChDir (AppPath)
        NextLine = CurDir()

        ' open the text file
        fileNum = FreeFile()
        FileOpen(fileNum, filePathName, OpenMode.Input)
        If hitError Then Exit Sub ' if we got a file i/o error, bail out

        ' load the text file text into 'LinesFromFile' string
        Do Until EOF(fileNum)
            ' get another line of text from the file
            NextLine = LineInput(fileNum)
            ' chr(13) + chr(10) = Carriage Return + Line Feed
            LinesFromFile = LinesFromFile + NextLine + Chr(13) + Chr(10)
            If hitError Then Exit Sub ' if we got a file i/o error, bail out
        Loop

        FileClose(fileNum)
        If hitError Then Exit Sub ' if we got a file i/o error, bail out

        ' copy the text into the window TextBox
        TextWindow.DefInstance.TextRegion.Text = LinesFromFile

        ' specify if the text is editable or not
        TextWindow.DefInstance.TextRegion.ReadOnly = Not (editible)

        ' Nothing selected
        TextWindow.DefInstance.TextRegion.SelectionStart = 0
        TextWindow.DefInstance.TextRegion.SelectionLength = 0

        ' update the window's caption
        TextWindow.DefInstance.Text = caption

        ' Show the window, as a modal dialog (one does not leave this routine until the
        ' dialog is closed.
        TextWindow.DefInstance.ShowDialog()

        ' --------------------------------------------------------------
        ' End of this subroutine

        Exit Sub

        ' --------------------------------------------------------------
        ' Handle file I/O error case.

ErrorHandler:

        If (hitError = False) Then      ' if this is a vb error...
            MsgBox(Err.Description)     ' show msg about error
        Else
            MsgBox("We hit an error during file I/O.")
        End If

        ' stop saving/loading after error

    End Sub

    ' -------------------------------------------------------------------------
    ' FUNCTION    Finalize()
    '
    ' PURPOSE     Called when window is closed.
    '
    ' HISTORY     6/5/02 created by Visual Basic 7 upgrade wizard, gsw
    ' -------------------------------------------------------------------------
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

End Class