' ====================================================================================
' FORM:     DirectToExcel.vb
'
'           This example Visual Basic program digitizes directly 
'           into an Excel spreadsheet.
'
'           NOTE: IF YOU WANT DETAILED DOCUMENTATION ON HOW TO PROGRAM
'           EXCEL FROM VB, YOU NEED TO GO TO THE MICROSOFT ONLINE
'           LIBRARY (E.G. SEARCH "PersonalViewListSettings" AT wwww.microsoft.com)
'
' HISTORY   6/6/02   updated to be compatible with Visual Studio (Visual Basic) .Net v7
' ====================================================================================

Option Strict Off
Option Explicit On 

' -------------------------------------------------------------------------
' CLASS     EndUser_Window
'
' EndUser_Window is a CLASS created by the end user that contains
' a window (i.e. Visual Basic FORM) and several callback functions:
' EndUser_SegmentProcessor(), EndUser_SaveLoadResults(), EndUser_PostAcqAnalysis()
'
Friend Class EndUser_Window

    ' This class includes a Visual Basic FORM (i.e. window)
    Inherits System.Windows.Forms.Form

    ' -------------------------------------------------------------
    ' Visual Studio generated the following code based on the
    ' dialog box graphical set up.
    '
#Region "Windows Form Designer generated code "

    ' -------------------------------------------------------------------------
    ' FUNCTION    New() - Windows Form Designer generated code
    '
    ' PURPOSE     This is the New() method, which is generated by the windows
    '             Form Designer utility.  This code sets up the dialog and
    '             sets the attributes of the various fields.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Public Sub New()
        MyBase.New()
        If m_vb6FormDefInstance Is Nothing Then
            If m_InitializingDefInstance Then
                m_vb6FormDefInstance = Me
            Else
                Try
                    'For the start-up form, the first instance created is the default instance.
                    If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
                        m_vb6FormDefInstance = Me
                    End If
                Catch
                End Try
            End If
        End If
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public WithEvents SetupHelp As System.Windows.Forms.Button
    Public WithEvents LoadSetup As System.Windows.Forms.Button
    Public WithEvents SaveSetup As System.Windows.Forms.Button
    Public WithEvents SetupButton As System.Windows.Forms.Button
    Public WithEvents SetupChannels As System.Windows.Forms.Button
    Public WithEvents StartStopButton As System.Windows.Forms.Button
    Public WithEvents SetupFrame As System.Windows.Forms.GroupBox
    Public WithEvents Frame1 As System.Windows.Forms.GroupBox
    Public WithEvents Label1 As System.Windows.Forms.Label

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.SetupHelp = New System.Windows.Forms.Button()
        Me.LoadSetup = New System.Windows.Forms.Button()
        Me.SaveSetup = New System.Windows.Forms.Button()
        Me.SetupButton = New System.Windows.Forms.Button()
        Me.SetupChannels = New System.Windows.Forms.Button()
        Me.StartStopButton = New System.Windows.Forms.Button()
        Me.SetupFrame = New System.Windows.Forms.GroupBox()
        Me.Frame1 = New System.Windows.Forms.GroupBox()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'SetupHelp
        '
        Me.SetupHelp.BackColor = System.Drawing.SystemColors.Control
        Me.SetupHelp.Cursor = System.Windows.Forms.Cursors.Default
        Me.SetupHelp.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SetupHelp.ForeColor = System.Drawing.SystemColors.ControlText
        Me.SetupHelp.Location = New System.Drawing.Point(88, 16)
        Me.SetupHelp.Name = "SetupHelp"
        Me.SetupHelp.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.SetupHelp.Size = New System.Drawing.Size(73, 25)
        Me.SetupHelp.TabIndex = 6
        Me.SetupHelp.Text = "Help"
        '
        'LoadSetup
        '
        Me.LoadSetup.BackColor = System.Drawing.SystemColors.Control
        Me.LoadSetup.Cursor = System.Windows.Forms.Cursors.Default
        Me.LoadSetup.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.LoadSetup.ForeColor = System.Drawing.SystemColors.ControlText
        Me.LoadSetup.Location = New System.Drawing.Point(336, 16)
        Me.LoadSetup.Name = "LoadSetup"
        Me.LoadSetup.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.LoadSetup.Size = New System.Drawing.Size(73, 25)
        Me.LoadSetup.TabIndex = 5
        Me.LoadSetup.Text = "Load"
        '
        'SaveSetup
        '
        Me.SaveSetup.BackColor = System.Drawing.SystemColors.Control
        Me.SaveSetup.Cursor = System.Windows.Forms.Cursors.Default
        Me.SaveSetup.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SaveSetup.ForeColor = System.Drawing.SystemColors.ControlText
        Me.SaveSetup.Location = New System.Drawing.Point(408, 16)
        Me.SaveSetup.Name = "SaveSetup"
        Me.SaveSetup.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.SaveSetup.Size = New System.Drawing.Size(73, 25)
        Me.SaveSetup.TabIndex = 4
        Me.SaveSetup.Text = "Save"
        '
        'SetupButton
        '
        Me.SetupButton.BackColor = System.Drawing.SystemColors.Control
        Me.SetupButton.Cursor = System.Windows.Forms.Cursors.Default
        Me.SetupButton.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SetupButton.ForeColor = System.Drawing.SystemColors.ControlText
        Me.SetupButton.Location = New System.Drawing.Point(192, 16)
        Me.SetupButton.Name = "SetupButton"
        Me.SetupButton.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.SetupButton.Size = New System.Drawing.Size(73, 25)
        Me.SetupButton.TabIndex = 3
        Me.SetupButton.Text = "Setup"
        '
        'SetupChannels
        '
        Me.SetupChannels.BackColor = System.Drawing.SystemColors.Control
        Me.SetupChannels.Cursor = System.Windows.Forms.Cursors.Default
        Me.SetupChannels.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SetupChannels.ForeColor = System.Drawing.SystemColors.ControlText
        Me.SetupChannels.Location = New System.Drawing.Point(264, 16)
        Me.SetupChannels.Name = "SetupChannels"
        Me.SetupChannels.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.SetupChannels.Size = New System.Drawing.Size(73, 25)
        Me.SetupChannels.TabIndex = 1
        Me.SetupChannels.Text = "Channels"
        '
        'StartStopButton
        '
        Me.StartStopButton.BackColor = System.Drawing.SystemColors.Control
        Me.StartStopButton.Cursor = System.Windows.Forms.Cursors.Default
        Me.StartStopButton.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.StartStopButton.ForeColor = System.Drawing.SystemColors.ControlText
        Me.StartStopButton.Location = New System.Drawing.Point(16, 16)
        Me.StartStopButton.Name = "StartStopButton"
        Me.StartStopButton.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartStopButton.Size = New System.Drawing.Size(73, 25)
        Me.StartStopButton.TabIndex = 0
        Me.StartStopButton.Text = "Start"
        '
        'SetupFrame
        '
        Me.SetupFrame.BackColor = System.Drawing.SystemColors.Control
        Me.SetupFrame.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SetupFrame.ForeColor = System.Drawing.SystemColors.ControlText
        Me.SetupFrame.Location = New System.Drawing.Point(184, 0)
        Me.SetupFrame.Name = "SetupFrame"
        Me.SetupFrame.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.SetupFrame.Size = New System.Drawing.Size(305, 49)
        Me.SetupFrame.TabIndex = 7
        Me.SetupFrame.TabStop = False
        Me.SetupFrame.Text = "Setup"
        '
        'Frame1
        '
        Me.Frame1.BackColor = System.Drawing.SystemColors.Control
        Me.Frame1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Frame1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Frame1.Location = New System.Drawing.Point(8, 0)
        Me.Frame1.Name = "Frame1"
        Me.Frame1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Frame1.Size = New System.Drawing.Size(161, 49)
        Me.Frame1.TabIndex = 8
        Me.Frame1.TabStop = False
        Me.Frame1.Text = "Control"
        '
        'Label1
        '
        Me.Label1.BackColor = System.Drawing.SystemColors.Control
        Me.Label1.Cursor = System.Windows.Forms.Cursors.Default
        Me.Label1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Label1.Location = New System.Drawing.Point(104, 48)
        Me.Label1.Name = "Label1"
        Me.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Label1.Size = New System.Drawing.Size(1, 1)
        Me.Label1.TabIndex = 2
        Me.Label1.Text = "Label1"
        '
        'EndUser_Window
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(496, 52)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.SetupHelp, Me.LoadSetup, Me.SaveSetup, Me.SetupButton, Me.SetupChannels, Me.StartStopButton, Me.SetupFrame, Me.Frame1, Me.Label1})
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow
        Me.Location = New System.Drawing.Point(74, 376)
        Me.Name = "EndUser_Window"
        Me.Text = "instruNet To Excel Control Panel"
        Me.ResumeLayout(False)

    End Sub
#End Region

    ' -------------------------------------------------------------------------
    ' FUNCTION    Defines several properties to be used with the dialog.
    '
    ' PURPOSE     This was generated by the VS 7 Upgrade Wizard.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
#Region "Upgrade Support "
    Private Shared m_vb6FormDefInstance As EndUser_Window
    Private Shared m_InitializingDefInstance As Boolean
    Public Shared Property DefInstance() As EndUser_Window
        Get
            If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
                m_InitializingDefInstance = True
                m_vb6FormDefInstance = New EndUser_Window()
                m_InitializingDefInstance = False
            End If
            DefInstance = m_vb6FormDefInstance
        End Get
        Set(ByVal Value As EndUser_Window)
            m_vb6FormDefInstance = Value
        End Set
    End Property
#End Region

    ' -------------------------------------------------------------------------------------
    ' Global variables

    Private xlApp As Excel.Application = Nothing
    Private xlBook As Excel.Workbook = Nothing
    Private xlSheet As Excel.Worksheet = Nothing

    ' Header at top that contains "Channel Name" in row #1 and "Channel vUnits" in row #2
    Const Header_Top_rowNum As Integer = 1
    Const Header_numOfRows As Integer = 2

    ' End user can place notes under the top Header
    Const NotesInfo_Top_rowNum As Integer = Header_Top_rowNum + Header_numOfRows
    Const NotesInfo_numOfRows As Integer = 4

    ' We put channel info (e.g. netNum, devNum, hUnits, etc) under the Notes
    Const ChanInfo_Header_Top_rowNum As Integer = NotesInfo_Top_rowNum + NotesInfo_numOfRows + 1
    Const ChanInfo_Top_rowNum As Integer = ChanInfo_Header_Top_rowNum + 2
    Const ChanInfo_numOfRows As Integer = 12

    ' Channel data comes last
    Const chanData_Header_Top_rowNum As Integer = ChanInfo_Top_rowNum + ChanInfo_numOfRows + 1
    Const chanData_Top_rowNum As Integer = chanData_Header_Top_rowNum + 2
    Const gDebug As Integer = False

    ' -------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_StartProgram()
    '
    ' PURPOSE    Called when window is 1st opened. This routine sets up the interface
    '            to the INET_xxx.vb digitize routines.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    ' -------------------------------------------------------------------------------------
    Sub EndUser_StartProgram()

        ' -------------------------------------------------------------
        ' INITIALIZE UTILITY CODE
        '
        ' Load instruNet Driver and Initialize VB interface utilities

        Call Initialize_instruNet_MAIN(Me, EndUser_Window.DefInstance, _
           wJumpIntoDemoModeIfNoDeviceExists)

        ' -------------------------------------------------------------
        ' INITIALIZE DIGITIZING PARAMETERS

        gNumScans = 1                           ' # of scans to digitize

        gPtsPerScan_nextDigi = 100              ' points per scan per channel

        gSampleRate_nextDigi = 1                ' sample rate per channel (pts/sec)

        gContinuousScans = False                ' if true, we run with scans that are continous
        '                                         in time; otherwise, we retrigger for each

        gProcessSegmentsInsteadOfScans = True   ' if false, we process a scan when it has finished
        '                                         digitizing; otherwise, we process little segments
        '                                         as they are recorded.

        gRun_EndUser_PostAcqAnalysis = True     ' if true, then run EndUser_PostAcqAnalysis()
        '                                         at the end of the digitization.  This is an
        '                                         end user routine that processes the resulting data

        gRun_EndUser_SegmentProcessor = True    ' if true, then run EndUser_SegmentProcessor()
        '                                         while data is being digitized.  This is an end
        '                                         user routine that processes little segments of data.

        gCopyChannelsFromNetworkPage = True     ' true if we are to copy the Enabled channels
        '                                         in the Network page to rebuild the Digitize
        '                                         list, after the user closed the Network Window.

        gWaitTillDigitizationCompletes = False  ' If true, then DigitizeProcess_Start() waits for
        '                                         the entire digitization to complete; otherwise,
        '                                         the Timer control triggers the servicing of the
        '                                         digitize buffers, every 200ms or so, while digitizing.

        '                                         Set the digitize parameters
        Call DigitizeProcess_SetTimingParams(gPtsPerScan_nextDigi, gNumScans, _
            gSampleRate_nextDigi, gContinuousScans, gProcessSegmentsInsteadOfScans, _
            gRun_EndUser_PostAcqAnalysis, gRun_EndUser_SegmentProcessor, _
            gCopyChannelsFromNetworkPage, gWaitTillDigitizationCompletes)

        ' Declares "StartStopButton" button and the "DigitizeProcess" Timer. Pass "Nothing"
        ' If there are none
        Call DigitizeProcess_SetControlItems(StartStopButton)

    End Sub


    ' -------------------------------------------------------------------------------------
    ' FUNCTION   DirectToExcel_OpenNewSpreadSheet_And_WriteHeader()
    '
    ' PURPOSE    This opens a new spreadsheet and writes a header based on the
    '            selected channels. We don't start digitizing yet.       
    '
    '            We return FALSE if we hit a error; otherwise, TRUE
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    ' -------------------------------------------------------------------------------------
    Private Function DirectToExcel_OpenNewSpreadSheet_And_WriteHeader() As Boolean

        Dim func, osRoutine As String

        ' -----------------------------------------------------------------------
        ' Start the Digitize To Excel process.

        ' assume we hit an error until we complete what we want to do
        DirectToExcel_OpenNewSpreadSheet_And_WriteHeader = False

        ' set up error handler if we get an error while working w/ Excel
        func = "DirectToExcel_OpenNewSpreadSheet"
        osRoutine = "begin"
        Err().Clear()
        On Error GoTo ErrorHandler

        ' if no Channels have been selected in the Channels dialog, then tell end user
        ' to get it together.
        If gNumDigiCh <= 0 Then
            MsgBox("No channels have been selected to digitize.  To do this, Press the 'Select Channels' button and select channels as desired.")
            Exit Function
        End If

        ' -----------------------------------------------------------------------
        ' Open Excel application, if it is not already open.

        ' Open Excel Application if it is not already open
        Dim openedOk As Boolean = Open_Excel_Application()

        ' if we could not open the Excel app, then bail out
        If Not openedOk Then

            MsgBox("We could not launch Excel.  In order to run this program, you need Excel Version >= 8.x (Microsoft Office >= 97) on your computer.")
            Exit Function

        End If

        ' ----------------------------------------------------------------
        ' Check to make sure you have Excel >= 8.0 on this computer, as opposed to
        ' an older version.

        Dim xl_version_str As String = xlApp.Version
        If IsNothing(xl_version_str) Then GoTo BadExcel
        If Len(xl_version_str) < 1 Then GoTo BadExcel
        Dim positionOfDecimal_base1 As Integer = xl_version_str.IndexOf(".")
        If (positionOfDecimal_base1 >= 1) Then
            xl_version_str = xl_version_str.Substring(0, positionOfDecimal_base1)
        End If

        osRoutine = "System.Convert.ToDouble(xl_versio_str)"
        Dim excelVersion As Double = System.Convert.ToDouble(xl_version_str)

        If (excelVersion < 8) Then
BadExcel:
            MsgBox("We see Excel software on your computer, yet it is too old.  We need Excel Version >= 8.x (Microsoft Office >= 97) to run this program.")

            ' Shut down our Link to Excel, set xlSheet to nothing (disable
            ' segment processor that writes data to spreadsheet).
            ShutDownOurLinkToExcel()

            Exit Function
        End If

        ' -----------------------------------------------------------------------
        ' Create a NEW workbook, and a NEW worksheet file (i.e. a new excel file)

        ' NOTE: IF YOU WANT DETAILED DOCUMENTATION ON HOW TO PROGRAM
        ' EXCEL FROM VB, YOU NEED TO GO TO THE MICROSOFT ONLINE
        ' LIBRARY (E.G. SEARCH "PersonalViewListSettings" AT wwww.microsoft.com)

        ' Create a new workbook (i.e. File)
        osRoutine = "CType(xlApp.Workbooks.Add, Excel.Workbook)"
        If gDebug Then MsgBox(osRoutine)
        xlBook = CType(xlApp.Workbooks.Add, Excel.Workbook)

        ' Get access to the 1st worksheet in the workbook
        osRoutine = "CType(xlBook.Worksheets(1), Excel.Worksheet)"
        If gDebug Then MsgBox(osRoutine)
        xlSheet = CType(xlBook.Worksheets(1), Excel.Worksheet)

        ' Show the sheet.
        osRoutine = "xlSheet.Visible = True"
        If gDebug Then MsgBox(osRoutine)
        xlSheet.Visible = True

        ' -----------------------------------------------------------------------
        ' Testing

        ' Write_Header_to_Spreadsheet(xlSheet)
        ' ShutDownOurLinkToExcel()
        ' End

        ' -----------------------------------------------------------------------
        ' Place Header into Spreadsheet.

        ' Create the Excel header file. The header will vary depending
        ' on the number of channels and the channel settings
        Dim wroteHeaderOk As Boolean = Write_Header_to_Spreadsheet(xlSheet)

        ' Bail out if we hit an error writing the header
        If Not wroteHeaderOk Then Exit Function

        ' ----------------------------------------------------------------
        ' Exit this subroutine

        ' Tell caller we did ok
        DirectToExcel_OpenNewSpreadSheet_And_WriteHeader = True

        ' Exit function w/o entering error handler
        Exit Function

        ' ----------------------------------------------------------------
        ' Handle error case.

ErrorHandler:

        MsgBox("ERROR: Direct To Excel, er = " + Format(Err().Number, "D") + ", func = " + func + ", osRout = " + osRoutine + ", errMsg = " + Err.Description)

        ' Shut down our Link to Excel, set xlSheet to nothing (disable
        ' segment processor that writes data to spreadsheet).
        ShutDownOurLinkToExcel()

    End Function


    ' -------------------------------------------------------------------------------------
    ' FUNCTION   Write_Header_to_Spreadsheet()
    '
    ' PURPOSE    Writes header to spreadsheet.  Returns False if there is a problem.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    ' -------------------------------------------------------------------------------------
    Function Write_Header_to_Spreadsheet(ByRef xlSheet As Excel.Worksheet) As Boolean

        ' ----------------------------------------------------------
        ' LOCAL VARIABLES

        Dim startTime, sampleRate As Double
        Dim ptsPerScan As Integer
        Dim thisFieldExist, e, cNum As Short
        Dim arg_VB_string, channelName, userName, vUnits As String
        Dim netNum, deviceNum, moduleNum, chanNum As Short
        Dim func, osRoutine As String

        ' Assume we hit a problem, until we completed the entire thing w/o an error
        Write_Header_to_Spreadsheet = False

        If IsNothing(xlSheet) Then Exit Function

        ' turn On error handling
        func = "Write_Header_to_Spreadsheet"
        osRoutine = "begin"
        If gDebug Then MsgBox(osRoutine)
        Err().Clear()
        On Error GoTo ErrorHandler

        ' NOTE: IF YOU WANT DETAILED DOCUMENTATION ON HOW TO PROGRAM
        ' EXCEL FROM VB, YOU NEED TO GO TO THE MICROSOFT ONLINE
        ' LIBRARY (E.G. SEARCH "PersonalViewListSettings" AT wwww.microsoft.com)

        ' ----------------------------------------------------------
        ' Write the channel parameter names to the top part of column 1.

        osRoutine = "xlSheet.Cells(Header_Top_rowNum, 1)"
        If gDebug Then MsgBox(osRoutine)
        xlSheet.Cells(Header_Top_rowNum, 1) = "Seconds"

        ' ----------------------------------------------------------
        ' Add Blue bold "Notes" header at top of to of NOTES region

        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 1) = "Notes"
        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 1).font.color = RGB(0, 0, 255)
        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 1).font.bold = True

        ' Active this cell for end user notes
        xlSheet.Cells(NotesInfo_Top_rowNum + 1, 2).activate()

        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 6) = "Date:"
        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 6).font.color = RGB(0, 0, 255)
        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 6).font.bold = True

        ' show date (e.g. "1/2/2003")
        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 7) = Now.Date

        ' show time in 24hr format (e.g. "15:23:20") -- hour/min/sec
        xlSheet.Cells(NotesInfo_Top_rowNum + 0, 8) = _
            Format(Now.Hour, "D") + ":" + Format(Now.Minute, "D") + ":" + Format(Now.Second, "D")

        ' ----------------------------------------------------------
        ' Add Blue bold "Notes" header at top of to of NOTES region

        xlSheet.Cells(ChanInfo_Header_Top_rowNum, 1) = "Channel Information"
        xlSheet.Cells(ChanInfo_Header_Top_rowNum, 1).font.color = RGB(0, 0, 255)
        xlSheet.Cells(ChanInfo_Header_Top_rowNum + 0, 1).font.bold = True

        ' ----------------------------------------------------------
        ' Add Channel Info parameters

        xlSheet.Cells(ChanInfo_Top_rowNum + 0, 1) = "Date & Time"
        xlSheet.Cells(ChanInfo_Top_rowNum + 1, 1) = "ChanName"
        xlSheet.Cells(ChanInfo_Top_rowNum + 2, 1) = "UserName"
        xlSheet.Cells(ChanInfo_Top_rowNum + 3, 1) = "vUnits"
        xlSheet.Cells(ChanInfo_Top_rowNum + 4, 1) = "hUnits"
        xlSheet.Cells(ChanInfo_Top_rowNum + 5, 1) = "PtsPerScan"
        xlSheet.Cells(ChanInfo_Top_rowNum + 6, 1) = "SamplePeriod"
        xlSheet.Cells(ChanInfo_Top_rowNum + 7, 1) = "1stPtTime"
        xlSheet.Cells(ChanInfo_Top_rowNum + 8, 1) = "NetNum"
        xlSheet.Cells(ChanInfo_Top_rowNum + 9, 1) = "DevNum"
        xlSheet.Cells(ChanInfo_Top_rowNum + 10, 1) = "ModuleNum"
        xlSheet.Cells(ChanInfo_Top_rowNum + 11, 1) = "ChanNum"

        ' data comes next

        ' ----------------------------------------------------------
        ' Add Blue bold "Channel Data" header at top of to of DATA region

        xlSheet.Cells(chanData_Header_Top_rowNum + 0, 1) = "Channel Data"
        xlSheet.Cells(chanData_Header_Top_rowNum + 0, 1).font.color = RGB(0, 0, 255)
        xlSheet.Cells(chanData_Header_Top_rowNum + 0, 1).font.bold = True

        ' ----------------------------------------------------------
        ' Scan through all channels selected for digitizing.

        For cNum = 0 To gNumDigiCh - 1

            ' get the channel address
            netNum = gDigiChan(cNum).netNum
            deviceNum = gDigiChan(cNum).deviceNum
            moduleNum = gDigiChan(cNum).moduleNum
            chanNum = gDigiChan(cNum).chanNum

            ' Place ChannelName at very top (in case someone place split bar here)
            thisFieldExist = iNet_VB_GetFieldcStr(gDigiChan(cNum), sgt_General, fldNum_General_chanName, channelName)
            xlSheet.Cells(Header_Top_rowNum + 0, 2 + cNum) = channelName

            ' get the vUnits and write it to Excel
            thisFieldExist = iNet_VB_GetFieldcStr(gDigiChan(cNum), sgt_General, fldNum_General_unitsLabel, vUnits)
            xlSheet.Cells(Header_Top_rowNum + 1, 2 + cNum) = vUnits

            ' get the current Date and Time and write it to Excel
            xlSheet.Cells(ChanInfo_Top_rowNum + 0, 2 + cNum) = Now

            ' get the ChanName for this channel and write it to Excel
            xlSheet.Cells(ChanInfo_Top_rowNum + 1, 2 + cNum) = channelName

            ' get the UserName for this channel and write it to Excel
            thisFieldExist = iNet_VB_GetFieldcStr(gDigiChan(cNum), sgt_General, fldNum_General_userName, userName)
            xlSheet.Cells(ChanInfo_Top_rowNum + 2, 2 + cNum) = userName

            ' get the vUnits and write it to Excel
            xlSheet.Cells(ChanInfo_Top_rowNum + 3, 2 + cNum) = vUnits

            ' set the hUnits to seconds
            xlSheet.Cells(ChanInfo_Top_rowNum + 4, 2 + cNum) = "Seconds"

            ' get the PtsPerScan and write it to Excel
            ptsPerScan = GET_POINTS_PER_SCAN(netNum)
            xlSheet.Cells(ChanInfo_Top_rowNum + 5, 2 + cNum) = ptsPerScan

            ' get the SamplePeriod and write it to Excel
            sampleRate = GET_SAMPLE_RATE_IN_HZ(netNum)
            xlSheet.Cells(ChanInfo_Top_rowNum + 6, 2 + cNum) = sampleRate

            ' get the Starting Time for the first point and write it to Excel
            startTime = GET_START_TIME_IN_SEC(netNum)
            xlSheet.Cells(ChanInfo_Top_rowNum + 7, 2 + cNum) = startTime

            ' write the netnum, devicenum, modulenum and channelnum for this channel to excel
            xlSheet.Cells(ChanInfo_Top_rowNum + 8, 2 + cNum) = netNum
            xlSheet.Cells(ChanInfo_Top_rowNum + 9, 2 + cNum) = moduleNum
            xlSheet.Cells(ChanInfo_Top_rowNum + 10, 2 + cNum) = deviceNum
            xlSheet.Cells(ChanInfo_Top_rowNum + 11, 2 + cNum) = chanNum

            ' data starts after this

        Next cNum

        ' ----------------------------------------------------------------
        ' Place Border lines in several key areas

        Const xlDouble = -4119
        Const xlThick = 4
        Const xlThin = 2

        ' make border at least 8 columns wide
        Dim borderWidth_numColumns As Integer = IIf(gNumDigiCh < 8, 8, gNumDigiCh)

        ' Add thick BLUE border line over NOTES region
        osRoutine = "xlSheet.Range"
        If gDebug Then MsgBox(osRoutine)
        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, NotesInfo_Top_rowNum), _
            Get_Excel_xyCoord_Notation(borderWidth_numColumns, NotesInfo_Top_rowNum) _
            ).Borders(Excel.XlBordersIndex.xlEdgeTop).Weight = 3

        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, NotesInfo_Top_rowNum), _
            Get_Excel_xyCoord_Notation(borderWidth_numColumns, NotesInfo_Top_rowNum) _
            ).Borders(Excel.XlBordersIndex.xlEdgeTop).Color = RGB(0, 0, 255)

        ' Add thick BLUE border line over CHANNEL INFO region
        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, ChanInfo_Header_Top_rowNum), _
            Get_Excel_xyCoord_Notation(borderWidth_numColumns, ChanInfo_Header_Top_rowNum) _
            ).Borders(Excel.XlBordersIndex.xlEdgeTop).Weight = 3

        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, ChanInfo_Header_Top_rowNum), _
            Get_Excel_xyCoord_Notation(borderWidth_numColumns, ChanInfo_Header_Top_rowNum) _
            ).Borders(Excel.XlBordersIndex.xlEdgeTop).Color = RGB(0, 0, 255)

        ' Add thick BLUE border line over CHANNEL DATA region
        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, chanData_Header_Top_rowNum), _
            Get_Excel_xyCoord_Notation(borderWidth_numColumns, chanData_Header_Top_rowNum) _
            ).Borders(Excel.XlBordersIndex.xlEdgeTop).Weight = 3

        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, chanData_Header_Top_rowNum), _
            Get_Excel_xyCoord_Notation(borderWidth_numColumns, chanData_Header_Top_rowNum) _
            ).Borders(Excel.XlBordersIndex.xlEdgeTop).Color = RGB(0, 0, 255)

        ' ----------------------------------------------------------------
        ' Make top chanName/vUnits header 9pt Arial bold Dark Gray.

        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, Header_Top_rowNum), _
            Get_Excel_xyCoord_Notation(gNumDigiCh + 1, Header_Top_rowNum + 1) _
            ).Font.Color = RGB(100, 100, 100) ' dark gray

        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, Header_Top_rowNum), _
            Get_Excel_xyCoord_Notation(gNumDigiCh + 1, Header_Top_rowNum + 1) _
            ).Font.Size = 9

        xlSheet.Range( _
            Get_Excel_xyCoord_Notation(1, Header_Top_rowNum), _
            Get_Excel_xyCoord_Notation(gNumDigiCh + 1, Header_Top_rowNum + 1) _
            ).Font.Bold = True

        ' ----------------------------------------------------------------
        ' Split the window into 2 panes. To top one shows the top 2 rows.
        ' The bottom one shows the data, and scrolls accordingly.

        ' xlBook.Windows(1) is always the ACTIVE window (i.e. worksheet
        ' being written to)

        ' split window into 2 panes, at Row #2
        osRoutine = "xlBook.Windows(1).SplitRow"
        If gDebug Then MsgBox(osRoutine)
        xlBook.Windows(1).SplitRow = 2

        ' place row #1 at top of top pane
        osRoutine = "xlBook.Windows(1).Panes(1).ScrollRow"
        If gDebug Then MsgBox(osRoutine)
        xlBook.Windows(1).Panes(1).ScrollRow = Header_Top_rowNum

        ' place row #3 at top of bottom pane
        xlBook.Windows(1).Panes(2).ScrollRow = Header_Top_rowNum + 2

        ' ----------------------------------------------------------------
        ' Exit w/ OK

        ' We did ok
        Write_Header_to_Spreadsheet = True

        ' Exit function w/o entering error handler
        Exit Function

        ' ----------------------------------------------------------------
        ' Handle error case.

ErrorHandler:

        MsgBox("ERROR: Direct To Excel, er = " + Format(Err().Number, "D") + ", func = " + func + ", osRout = " + osRoutine + ", errMsg = " + Err.Description)

        ' Shut down our Link to Excel, set xlSheet to nothing (disable
        ' segment processor that writes data to spreadsheet).
        ShutDownOurLinkToExcel()

    End Function

    ' ====================================================================================
    ' ====================================================================================
    '
    '                                       EXCEL MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   Open_Excel_Application()
    '
    ' PURPOSE    Called when window is 1st opened. This routine sets up the displays
    '            and the channels being digitized.
    '
    '            We return TRUE if we got a good version of Excel.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    ' -------------------------------------------------------------------------------------
    Function Open_Excel_Application() As Boolean

        ' -----------------------------------------------------
        ' Test to see if there is a copy of Microsoft Excel already running.

        ' assume we did not succeed, until very end
        Open_Excel_Application = False

        Dim excelWasRunning As Boolean
        Dim func, osRoutine As String

        func = "Open_Excel_Application"
        osRoutine = "begin"
        If gDebug Then MsgBox(osRoutine)

        ' Defer error trapping
        On Error Resume Next

        ' We now Get an Excel application program if it is running. One can
        ' do CTL ALT DEL on the keyboard to see if an Excel app is running
        ' on the computer (it is not always visible on the desktop).
        ' If the application is not running, an error occurs.
        Err().Clear()
        xlApp = CType(GetObject(, "Excel.Application"), Excel.Application)
        Dim get_xlApp_ErrorCode As Integer = Err().Number

        Const XL_NOTRUNNING As Long = 429   ' error code when Excel is not running

        ' Calculate if the Excel Application program is running.
        excelWasRunning = (get_xlApp_ErrorCode = 0)

        ' Clear Err object in case error occurred.
        Err().Clear()

        On Error GoTo ErrorHandler

        ' NOTE: IF YOU WANT DETAILED DOCUMENTATION ON HOW TO PROGRAM
        ' EXCEL FROM VB, YOU NEED TO GO TO THE MICROSOFT ONLINE
        ' LIBRARY (E.G. SEARCH "PersonalViewListSettings" AT wwww.microsoft.com)

        ' -----------------------------------------------------
        ' If Excel was not running tell it to Lauch a new instance 
        ' of the Excel application program

        If Not excelWasRunning Then

            ' create a NEW excel application object via CreateObject()
            osRoutine = "CType(CreateObject( Excel.Application ), Excel.Application)"
            If gDebug Then MsgBox(osRoutine)
            xlApp = CType(CreateObject("Excel.Application"), Excel.Application)

        Else
            ' -----------------------------------------------------
            ' If Excel was running, then tell it to make sure the program
            ' is running (Microsoft recommended this -- I'm not sure
            ' if it is necessary however).

            If IsNothing(xlApp) Then MsgBox("xlApp null") : Exit Function

            ' Check for Microsoft Excel. If Microsoft Excel is running,
            ' enter it into the Running Object table.
            Make_sure_existing_Excel_is_running()

        End If

        ' show the application window
        osRoutine = "xlApp.Visible, Open"
        If gDebug Then MsgBox(osRoutine)
        xlApp.Visible = True

        ' Don't minimize or maximize, show window normally
        ' (i.e. if end user had reseized last excel window
        ' to take up lower left area of crt, then we will do that).
        osRoutine = "Excel.XlWindowState.xlNormal"
        If gDebug Then MsgBox(osRoutine)
        xlApp.WindowState = Excel.XlWindowState.xlNormal

        ' If we made it to here w/o getting an Error trap, then we did good
        Open_Excel_Application = True

        ' Exit function w/o entering error handler
        Exit Function

        ' ----------------------------------------------------------------
        ' Handle error case.

ErrorHandler:

        MsgBox("ERROR: Direct To Excel, er = " + Format(Err().Number, "D") + ", func = " + func + ", osRout = " + osRoutine + ", errMsg = " + Err.Description)

    End Function


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Make_sure_existing_Excel_is_running()
    '
    ' PURPOSE    This makes both Microsoft Excel and the window containing the
    '            specified worksheet visible.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    ' -------------------------------------------------------------------------------------
    Sub Make_sure_existing_Excel_is_running()

        ' Clear Error codes
        Err().Clear()

        If gDebug Then MsgBox("Make_sure_existing_Excel_is_running - begin")

        ' If Excel is running this API call returns its handle.
        Dim hWnd As Long = FindWindow("XLMAIN", 0)

        Dim get_xlApp_ErrorCode As Integer = Err().Number

        Const ERROR_INVALID_HANDLE As Long = 6

        ' Calculate if the Excel Application program is running.
        Dim excelWasRunning As Boolean = (get_xlApp_ErrorCode = 0) And (hWnd <> 0)

        ' If excel was not running, then bail out of here
        If Not excelWasRunning Then

            Exit Sub

        Else

            ' send message to application (user message)
            Const WM_USER = 1024

            ' Else Excel is running so use the SendMessage API
            ' function to enter it in the Running Object Table.
            SendMessage(hWnd, WM_USER + 18, 0, 0)

        End If

        If gDebug Then MsgBox("Make_sure_existing_Excel_is_running - end")

    End Sub

    ' API routine used with Excel
    Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, _
        ByVal lpWindowName As Long) As Long

    ' API routine used with Excel
    Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, _
        ByVal wParam As Long, ByVal lParam As Long) As Long


    '-------------------------------------------------------------------------------------
    ' FUNCTION   ShutDownOurLinkToExcel()
    '
    ' PURPOSE    We shut down our link to excel and give the end user control of the
    '            Excel application. This will set xlSheet to Nothing.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    ' -------------------------------------------------------------------------------------
    Sub ShutDownOurLinkToExcel()

        ' ----------------------------------------------------
        ' Turn off our error reporting (if the end user closed
        ' the spreadsheet, then the below xlSheet.Visible thing
        ' will lead to an Exception error, and we don't want to
        ' show any dialogs in that case).

        On Error Resume Next

        ' ----------------------------------------------------
        ' Note from Microsoft:
        '
        ' Creating a new instance of Excel and opening a workbook results in an
        ' invisible instance of Excel and a hidden instance of the workbook. 
        ' Therefore, if you edit the workbook and save it, the workbook is saved
        ' as hidden. The next time the user opens Excel manually, the workbook
        ' is invisible and the user has to click Unhide on the Window menu to view the workbook.
        '
        ' To avoid this behavior, your Automation code should unhide the workbook
        ' before editing it and saving it. Note that this does not mean
        ' Microsoft Excel itself has to be visible.

        ' NOTE: IF YOU WANT DETAILED DOCUMENTATION ON HOW TO PROGRAM
        ' EXCEL FROM VB, YOU NEED TO GO TO THE MICROSOFT ONLINE
        ' LIBRARY (E.G. SEARCH "PersonalViewListSettings" AT wwww.microsoft.com)

        ' Make sure Excel worksheet is visible
        If Not IsNothing(xlSheet) Then xlSheet.Visible = True

        ' ----------------------------------------------------
        ' Give the user control of Microsoft Excel's lifetime.

        If Not IsNothing(xlBook) Then xlBook.UserControl = True
        If Not IsNothing(xlApp) Then xlApp.UserControl = True

        ' ----------------------------------------------------
        ' Make sure you release object references

        If Not IsNothing(xlBook) Then xlBook.finalize()
        If Not IsNothing(xlApp) Then xlApp.finalize()

        xlSheet = Nothing
        xlBook = Nothing
        xlApp = Nothing

        ' ----------------------------------------------------
        ' Force garbage collection so that Visual Basic actually
        ' releases control of these objects; otherwise, the end
        ' user will not be able to Exit Excel (an instance will
        ' still exist when you do CTRL ALT DEL).
        '
        ' Note: this garbage collect thing does not run under the 
        ' debugger so good. You need to run the actual program
        ' to get it to work well. Note that running VB "End" 
        ' causes good garbage collection as well.

        ' force garbage collection (i.e. close link to xlApp, xlSheet, etc)
        GC.Collect()

    End Sub

    ' ====================================================================================
    ' ====================================================================================
    '
    '                           END USER DIGITIZE/DATA MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SegmentProcessor()
    '
    ' PURPOSE    Process incoming digitized data, while it is being digitized.  This
    '            is called for each segment of data is pulled from each channel.
    '
    ' PARAMs     cNum: Digitize Channel number {0..numChannels-1} (from DigitizeList)
    '            segmentStart_ptNum: first ptNum {0..numValidPts} for the recently digitized segment
    '            segmentEnd_ptNum: last ptNum {0..numValidPts} for the recently digitized segment
    '            scanNumberToPull_base1: scan number, base 1, of the recently digitized segment
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------

    Public DebugPtNum As Integer = -1

    Public Sub EndUser_SegmentProcessor( _
        ByVal cNum As Short, ByVal segmentStart_ptNum As Integer, _
        ByVal segmentEnd_ptNum As Integer, ByVal scanNumberToPull_base1 As Integer)

        Dim ptNum As Integer
        Dim rangeStartStr, rangeEndStr, rangeStr As String

        ' Set to TRUE to enable debugging
        Dim Debug_ShowFakeData As Boolean = False
        Dim Debug_ShowParams As Boolean = False

        ' -------------------------------------------------------------------------------------
        ' If doing debug, we simulate getting 1 point at a time

        If Debug_ShowFakeData Then

            If (cNum = 0) Then DebugPtNum = DebugPtNum + 1

            If (DebugPtNum >= (gPtsPerScan_nextDigi - 1)) Then DebugPtNum = 0

            segmentStart_ptNum = DebugPtNum
            segmentEnd_ptNum = DebugPtNum
            gDigiChan(cNum).dataArrayY.data(DebugPtNum) = DebugPtNum + (cNum / 10)

        End If

        ' -------------------------------------------------------------------------------------
        ' If we are in shut down mode, then bail out of here

        ' if we had shut down our Link to excel, bail out
        If IsNothing(xlSheet) Then Exit Sub

        ' -------------------------------------------------------------------------------------
        ' If we hit an error (e.g. end user closed excel window), we will 
        ' jump to the error handler

        On Error GoTo ErrorHandler

        ' NOTE: IF YOU WANT DETAILED DOCUMENTATION ON HOW TO PROGRAM
        ' EXCEL FROM VB, YOU NEED TO GO TO THE MICROSOFT ONLINE
        ' LIBRARY (E.G. SEARCH "PersonalViewListSettings" AT wwww.microsoft.com)

        ' -------------------------------------------------------------------------------------
        ' If there are no points here, bail out, gsw 2/24/03

        Dim numOfPtsInSegment As Integer = 1 + segmentEnd_ptNum - segmentStart_ptNum

        If (numOfPtsInSegment <= 0) Then Exit Sub ' Exit subroutine (don't enter error handler)

        ' -------------------------------------------------------------------------------------
        ' Write seconds into column #1 (A column)

        ' if this is the 1st channel, then add the Time (secs) info
        If (cNum = 0) Then

            ' create an array to hold the Seconds column 1 data
            Dim timeColumn(2 + numOfPtsInSegment, 1) As Single

            ' Fill the time array w/ seconds data
            For ptNum = segmentStart_ptNum To segmentEnd_ptNum

                ' calculate time for this ptNum
                timeColumn(ptNum - segmentStart_ptNum, 0) = (ptNum + 1) / gSampleRate_currentData

            Next

            ' Calculate range coordinates (e.g. "A16", "A231") (we work with BASE 1)
            rangeStartStr = Get_Excel_xyCoord_Notation(1, (segmentStart_ptNum + chanData_Top_rowNum))
            rangeEndStr = Get_Excel_xyCoord_Notation(1, (segmentEnd_ptNum + chanData_Top_rowNum))

            ' Write this data to the spreadsheet range
            xlSheet.Range(rangeStartStr, rangeEndStr).Value = timeColumn

        End If

        ' -------------------------------------------------------------------------------------
        ' Write digitized data to excel spreadsheet

        ' create an array to hold the digitized data
        Dim excelData(2 + numOfPtsInSegment, 1) As Single

        ' Fill the array w/ digitized data
        For ptNum = segmentStart_ptNum To segmentEnd_ptNum

            ' calculate time for this ptNum
            excelData(ptNum - segmentStart_ptNum, 0) = gDigiChan(cNum).dataArrayY.data(ptNum)

        Next

        ' Calculate range coordinates (e.g. "A16", "A231") (we work with BASE 1)
        rangeStartStr = Get_Excel_xyCoord_Notation(2 + cNum, (segmentStart_ptNum + chanData_Top_rowNum))
        rangeEndStr = Get_Excel_xyCoord_Notation(2 + cNum, (segmentEnd_ptNum + chanData_Top_rowNum))

        ' Write this data to the spreadsheet range
        xlSheet.Range(rangeStartStr, rangeEndStr).Value = excelData

        ' -------------------------------------------------------------------------------------
        ' If doing debug, we print several params to the excel spreadsheet for each segment pulled

        If Debug_ShowParams And (cNum >= (gNumDigiCh - 1)) Then

            rangeStr = Get_Excel_xyCoord_Notation(2 + gNumDigiCh + 0, (segmentStart_ptNum + chanData_Top_rowNum))
            xlSheet.Range(rangeStr, rangeStr).Value = rangeStartStr
            rangeStr = Get_Excel_xyCoord_Notation(2 + gNumDigiCh + 1, (segmentStart_ptNum + chanData_Top_rowNum))
            xlSheet.Range(rangeStr, rangeStr).Value = rangeEndStr
            rangeStr = Get_Excel_xyCoord_Notation(2 + gNumDigiCh + 2, (segmentStart_ptNum + chanData_Top_rowNum))
            xlSheet.Range(rangeStr, rangeStr).Value = segmentStart_ptNum
            rangeStr = Get_Excel_xyCoord_Notation(2 + gNumDigiCh + 3, (segmentStart_ptNum + chanData_Top_rowNum))
            xlSheet.Range(rangeStr, rangeStr).Value = segmentEnd_ptNum
            rangeStr = Get_Excel_xyCoord_Notation(2 + gNumDigiCh + 4, (segmentStart_ptNum + chanData_Top_rowNum))
            xlSheet.Range(rangeStr, rangeStr).Value = numOfPtsInSegment

        End If

        ' -------------------------------------------------------------------------------------
        ' If we are on the last channel to digitize, then select the last point
        ' so that we can scroll to see it.

        ' if we just processed the last point AND end user has not hidden the window...
        If (cNum >= (gNumDigiCh - 1)) And (xlSheet.Visible = True) Then

            ' get a range (e.g. "A1:B234") that we are currently Viewing in the window
            Dim visibleRange As Excel.Range = xlBook.Windows(1).Panes(2).VisibleRange()

            ' get # of columns in visible region
            Dim visibleRange_numOfRows As Integer = visibleRange.Rows.Count

            ' get top/bottom row # of viewed region
            Dim visibleRange_Top_rowNum As Integer = xlBook.Windows(1).Panes(2).ScrollRow
            Dim visibleRange_Bot_rowNum As Integer = visibleRange_Top_rowNum + visibleRange_numOfRows - 1

            ' calc the last plotted row number (for data)
            Dim lastPlotted_rowNum As Integer = segmentEnd_ptNum + chanData_Top_rowNum

            ' If we are plotting below what we can see...
            If (lastPlotted_rowNum > visibleRange_Bot_rowNum) Then

                ' place the top of the pane such that 60% of the visible
                ' region will now show the data, and 40% of the bottom 
                ' part of the visible region will be empty and ready for new data
                Dim new_VisibleRange_top_rowNum As Integer = lastPlotted_rowNum - visibleRange_numOfRows * 0.6

                ' scroll the visible region downward
                If new_VisibleRange_top_rowNum > 1 Then

                    xlBook.Windows(1).Panes(2).ScrollRow = new_VisibleRange_top_rowNum

                End If

            End If

            ' dispose of this object reference
            visibleRange = Nothing

        End If

        ' -------------------------------------------------------------------------------------
        ' If we are on the last point, shut down our Excel link

        ' if we just processed the last point...
        If ((segmentEnd_ptNum >= (gPtsPerScan_nextDigi - 1)) And (cNum >= (gNumDigiCh - 1))) Then

            ' We shut down the digitize operation and release the link we
            ' have to Excel. We also set xlSheet to NOTHING.
            ShutDown_Digitize_Operation_And_Release_Link_toExcel(False)

        End If

        ' -------------------------------------------------------------------------------------
        ' If iW+ is not licensed, then shut this down after 20 points. gsw 7/3/03

        If ((g_iWp_licenseIsInstalledOk = False) And (segmentStart_ptNum > 20)) Then

            ' We shut down the digitize operation and release the link we
            ' have to Excel. We also set xlSheet to NOTHING.
            ShutDown_Digitize_Operation_And_Release_Link_toExcel(True)

            ' Tell user what we are doing
            MsgBox("Direct To Excel (this program) requires that an iW+ license be installed, which is not the case. Subsequently, we are halting operation. For details on iW+, see internet URL www.instrunet.com/plus")

        End If

        ' -------------------------------------------------------------------------------------
        ' Exit subroutine (don't enter error handler)

        Exit Sub

        ' -------------------------------------------------------------------------------------
        ' Error Handler

ErrorHandler:

        ' save error text
        Dim errDesc As String = Err.Description
        Err.Clear()

        ' turn off error handler
        On Error Resume Next

        ' We shut down the digitize operation and release the link we
        ' have to Excel. We also set xlSheet to NOTHING.
        ShutDown_Digitize_Operation_And_Release_Link_toExcel(True)

        ' Show alert with error
        If (errDesc <> "") Then MsgBox(errDesc + _
            ".  This could be caused by an end user who closed an Excel window while we were writing to it.")

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Get_Excel_xyCoord_Notation()
    '
    ' PURPOSE    Convert an x,y spreadsheet coord like {1,1} to "A1" or {3,4} to "C4".
    '
    '            xCoord and yCoord are BASE 1.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Function Get_Excel_xyCoord_Notation( _
        ByVal xCoord As Integer, ByVal yCoord As Integer) As String

        ' Chr(65) = "A"
        ' MyInt = Asc("A"), sets int to 65

        Dim numOf_a_to_z_ranges As Integer = Math.Round((xCoord / 26.0) - 0.501)
        numOf_a_to_z_ranges = IIf(numOf_a_to_z_ranges < 0, 0, numOf_a_to_z_ranges)
        Dim numOf_Columns_after_a_to_z_range As Integer = xCoord - (numOf_a_to_z_ranges * 26)

        ' calculate 1st char in column Designation (e.g. "A")
        Dim columnChar1 As String = IIf(numOf_a_to_z_ranges <= 0, "", Chr(64 + numOf_a_to_z_ranges))

        ' calculate 1st char in column Designation (e.g. "A")
        Dim columnChar2 As String = Chr(64 + numOf_Columns_after_a_to_z_range)

        ' Calculate range coordinates (e.g. "A16", "A231")
        Get_Excel_xyCoord_Notation = columnChar1 + columnChar2 + Format(yCoord, "D")

    End Function

    ' Testing
    '
    ' OK:  Dim test1 As String = Get_Excel_xyCoord_Notation(1, 1)
    ' OK:  Dim test2 As String = Get_Excel_xyCoord_Notation(26, 123)
    ' OK:  Dim test3 As String = Get_Excel_xyCoord_Notation(27, 1412)
    ' OK:  Dim test4 As String = Get_Excel_xyCoord_Notation(52, 1234)
    ' OK:  Dim test5 As String = Get_Excel_xyCoord_Notation(53, 1412)


    '-------------------------------------------------------------------------------------
    ' FUNCTION   ShutDown_Digitize_Operation_And_Release_Link_toExcel()
    '
    ' PURPOSE    We shut down the digitize operation and release the link we
    '            have to Excel. We also set xlSheet to NOTHING.
    '
    '            If press_STOP_button is True, we force the pressing of the STOP
    '            button if we are digitizing.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub ShutDown_Digitize_Operation_And_Release_Link_toExcel( _
        ByVal press_STOP_button As Boolean)

        ' We shut down our link to excel and give the end user control of the
        ' Excel application. This will set xlSheet to Nothing.
        ShutDownOurLinkToExcel()

        '   NOTE: gCurrentlyDigitizing is a VB variable, and may
        '   not always be so current

        ' Tell it to stop digitizing
        If gCurrentlyDigitizing And press_STOP_button Then Call METHOD_StartStopButton_Click()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_PostAcqAnalysis()
    '
    ' PURPOSE    Process incoming digitized data, after the digitization stops.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_PostAcqAnalysis()

        ' Please see EndUser_PostAcqAnalysis() in file EndUser Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SaveLoadResults()
    '
    ' PURPOSE    Save or Load end user data when the user presses the Save or Load buttons.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_SaveLoadResults(ByRef sPathName As String, ByVal saveOrLoad As Short)

        ' Please see EndUser_SaveLoadResults() in file EndUser Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   DigitizeProcess_Tick()
    '
    ' PURPOSE    Timer control calls this at a fixed rate.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub DigitizeProcess_Tick(ByVal obj As Object, ByVal eventArgs As EventArgs)

        METHOD_DigitizeProcess_Timer(obj, eventArgs)

    End Sub

    ' ====================================================================================
    ' ====================================================================================
    '
    '                       RESPOND TO a BUTTON CLICK AT TOP OF WINDOW
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   Channels_Button_Click()
    '
    ' PURPOSE    Called when end user presses the CHANNELS button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Channels_Button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles SetupChannels.Click

        ' Open the instruNet World NETWORK window
        ' to allow the user to set up channels.
        METHOD_Channels_Button_Click()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Help_button_Click()
    '
    ' PURPOSE    Called when end user presses the HELP button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Help_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles SetupHelp.Click

        ' Show the instruNet help text, which is stored in file reference below

        Call TextWindow.DefInstance.OpenTextWindow( _
            "c:\Program files\instruNet\Programming Interfaces\Visual Basic .Net\VB Direct To Excel\Working with Excel.txt", _
            "Direct To Excel Help", False)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   StartStopButton_Click()
    '
    ' PURPOSE    Called when end user presses the START/STOP button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub StartStopButton_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles StartStopButton.Click

        ' if we are currently digitizing...
        If gCurrentlyDigitizing Then

            ' Tell it to stop digitizing.
            Call METHOD_StartStopButton_Click()

            ' Shut down our Link to Excel, set xlSheet to nothing (disable
            ' segment processor that writes data to spreadsheet).
            ShutDownOurLinkToExcel()

        Else
            ' Else we need to start the digitizing

            ' Open a spreadsheet and write a Header to the new sheet
            Dim openedOk As Boolean = DirectToExcel_OpenNewSpreadSheet_And_WriteHeader()

            ' Tell it to start digitizing if the spreadsheet opened ok
            If openedOk Then Call METHOD_StartStopButton_Click()

        End If

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Load_button_Click()
    '
    ' PURPOSE    Called when end user presses the LOAD data & channel settings button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Load_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles LoadSetup.Click

        ' Load instruNet data via the File Open dialog.
        Call SaveOrLoad_DataAndState(True, iLoad, True, True, True, True, True, gEndUser_GRAPHICS)

    End Sub



    '-------------------------------------------------------------------------------------
    ' FUNCTION   Save_button_Click()
    '
    ' PURPOSE    Called when end user presses the SAVE data button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Save_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles SaveSetup.Click

        ' Save instruNet data via the File Save dialog.
        Call SaveOrLoad_DataAndState(True, iSave, True, True, True, True, True, gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Setup_Button_Click()
    '
    ' PURPOSE    Called when end user presses the SETUP data button. We respond by
    '            opening the instruNet NETWORK window, where one can set up channels.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Setup_Button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles SetupButton.Click

        ' Show the instruNet Setup dialog box. This also reset the hScales and 
        ' redraws the display boxes w/ the new hScales.
        instruNet_Setup_Dialog.DefInstance.ShowDialog()

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                           WINDOW OPEN/CLOSE/REDRAW/RESIZE MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Load()
    '
    ' PURPOSE    Called when End User window is 1st opened.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Load(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        ' Start the program
        EndUser_StartProgram()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Closed()
    '
    ' PURPOSE    Called AFTER the End User window has been closed.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Closed(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Closed

        ' End instruNet-based program, and close instruNet driver
        EndProgram_iNet("")

    End Sub

End Class