' ====================================================================================
' FORM:     EndUser Example1.vb
'
'           This is a simple example showing how to work with instruNet
'           from Visual Basic.
'
' HISTORY   6/6/02   updated to be compatible with Visual Studio (Visual Basic) .Net v7
' ====================================================================================

Option Strict Off
Option Explicit On 

' -------------------------------------------------------------------------
' CLASS     EndUser_Window
'
' EndUser_Window is a CLASS created by the end user that contains
' a window (i.e. Visual Basic FORM) and several callback functions:
' EndUser_SegmentProcessor(), EndUser_SaveLoadResults(), EndUser_PostAcqAnalysis()
'
Public Class EndUser_Window

    ' This class includes a Visual Basic FORM (i.e. window)
    Inherits System.Windows.Forms.Form

    ' Visual Studio generated the following code based on the
    ' dialog box graphical set up.
#Region "Windows Form Designer generated code "

    ' -------------------------------------------------------------------------
    ' FUNCTION    New() - Windows Form Designer generated code
    '
    ' PURPOSE     This is the New() method, which is generated by the windows
    '             Form Designer utility.  This code sets up the dialog and
    '             sets the attributes of the various fields.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Public Sub New()
        MyBase.New()
        If m_vb6FormDefInstance Is Nothing Then
            If m_InitializingDefInstance Then
                m_vb6FormDefInstance = Me
            Else
                Try
                    'For the start-up form, the first instance created is the default instance.
                    If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
                        m_vb6FormDefInstance = Me
                    End If
                Catch
                End Try
            End If
        End If
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub


    ' -------------------------------------------------------------------------
    ' FUNCTION    Dispose() - Windows Form Designer generated code
    '
    ' PURPOSE     Form overrides dispose to clean up the component list.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub


    ' -------------------------------------------------------------------------
    ' Required by the Windows Form Designer

    Private components As System.ComponentModel.IContainer
    Public WithEvents Exit_button As System.Windows.Forms.Button
    Public WithEvents Help_button As System.Windows.Forms.Button
    Public WithEvents Notes As System.Windows.Forms.ListBox
    Public WithEvents Stop_Renamed As System.Windows.Forms.Button
    Public WithEvents Start As System.Windows.Forms.Button


    ' -------------------------------------------------------------------------
    ' FUNCTION    InitializeComponent() - Windows Form Designer generated code
    '
    ' PURPOSE     The following procedure is required by the Windows Form Designer
    '             It can be modified using the Windows Form Designer.
    '             Do not modify it using the code editor.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Exit_button = New System.Windows.Forms.Button()
        Me.Help_button = New System.Windows.Forms.Button()
        Me.Notes = New System.Windows.Forms.ListBox()
        Me.Stop_Renamed = New System.Windows.Forms.Button()
        Me.Start = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'Exit_button
        '
        Me.Exit_button.BackColor = System.Drawing.SystemColors.Control
        Me.Exit_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Exit_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Exit_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Exit_button.Location = New System.Drawing.Point(360, 0)
        Me.Exit_button.Name = "Exit_button"
        Me.Exit_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Exit_button.Size = New System.Drawing.Size(121, 25)
        Me.Exit_button.TabIndex = 4
        Me.Exit_button.Text = "Exit"
        '
        'Help_button
        '
        Me.Help_button.BackColor = System.Drawing.SystemColors.Control
        Me.Help_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Help_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Help_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Help_button.Location = New System.Drawing.Point(240, 0)
        Me.Help_button.Name = "Help_button"
        Me.Help_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Help_button.Size = New System.Drawing.Size(121, 25)
        Me.Help_button.TabIndex = 3
        Me.Help_button.Text = "Help"
        '
        'Notes
        '
        Me.Notes.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.Notes.BackColor = System.Drawing.SystemColors.Window
        Me.Notes.Cursor = System.Windows.Forms.Cursors.Default
        Me.Notes.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Notes.ForeColor = System.Drawing.SystemColors.WindowText
        Me.Notes.ItemHeight = 14
        Me.Notes.Location = New System.Drawing.Point(0, 24)
        Me.Notes.Name = "Notes"
        Me.Notes.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Notes.ScrollAlwaysVisible = True
        Me.Notes.Size = New System.Drawing.Size(593, 438)
        Me.Notes.TabIndex = 2
        '
        'Stop_Renamed
        '
        Me.Stop_Renamed.BackColor = System.Drawing.SystemColors.Control
        Me.Stop_Renamed.Cursor = System.Windows.Forms.Cursors.Default
        Me.Stop_Renamed.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Stop_Renamed.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Stop_Renamed.Location = New System.Drawing.Point(120, 0)
        Me.Stop_Renamed.Name = "Stop_Renamed"
        Me.Stop_Renamed.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Stop_Renamed.Size = New System.Drawing.Size(121, 25)
        Me.Stop_Renamed.TabIndex = 1
        Me.Stop_Renamed.Text = "Stop Digitizing"
        '
        'Start
        '
        Me.Start.BackColor = System.Drawing.SystemColors.Control
        Me.Start.Cursor = System.Windows.Forms.Cursors.Default
        Me.Start.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Start.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Start.Name = "Start"
        Me.Start.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Start.Size = New System.Drawing.Size(121, 25)
        Me.Start.TabIndex = 0
        Me.Start.Text = "Start"
        '
        'EndUser_Window
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 13)
        Me.BackColor = System.Drawing.SystemColors.Window
        Me.ClientSize = New System.Drawing.Size(592, 456)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Exit_button, Me.Help_button, Me.Notes, Me.Stop_Renamed, Me.Start})
        Me.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ForeColor = System.Drawing.SystemColors.WindowText
        Me.Location = New System.Drawing.Point(81, 106)
        Me.MinimumSize = New System.Drawing.Size(10, 10)
        Me.Name = "EndUser_Window"
        Me.ShowInTaskbar = False
        Me.Text = "instruNet Example #1"
        Me.ResumeLayout(False)

    End Sub
#End Region

    ' -------------------------------------------------------------------------
    ' FUNCTION    Defines several properties to be used with the dialog.
    '
    ' PURPOSE     This was generated by the VS 7 Upgrade Wizard.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
#Region "Upgrade Support "

    Private Shared m_vb6FormDefInstance As EndUser_Window

    Private Shared m_InitializingDefInstance As Boolean

    Public Shared Property DefInstance() As EndUser_Window
        Get
            If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
                m_InitializingDefInstance = True
                m_vb6FormDefInstance = New EndUser_Window()
                m_InitializingDefInstance = False
            End If
            DefInstance = m_vb6FormDefInstance
        End Get
        Set(ByVal Value As EndUser_Window)
            m_vb6FormDefInstance = Value
        End Set
    End Property
#End Region


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Start_ExampleOne()
    '
    ' PURPOSE    This routine is the main routine in this example program.
    '            It exercises many of the instruNet features, and is
    '            run when the start button is pressed.
    '
    ' HISTORY    3/8/96  created Visual Basic version - sjm
    '
    '-------------------------------------------------------------------------------------
    Function EndUser_Start_ExampleOne() As Short

        ' -------------------------------------------------------
        ' Local variables

        Dim message As String
        Dim e, cNum, chExists, ExerciseTheInsruNetMacros As Short
        Dim vinAddr, voutAddr As chAddr
        Dim vinValue, voutValue As Single
        Dim voutVoltage As Double

        Static Start_Btn_Has_Been_Pressed_At_Least_Once As Boolean = False

        ' -------------------------------------------------------
        ' If we had already been here, then skip the loading of the
        ' instruNet driver.

        If Start_Btn_Has_Been_Pressed_At_Least_Once Then GoTo StartButtonHasAlreadyBeenPressed
        Start_Btn_Has_Been_Pressed_At_Least_Once = True

        ' -------------------------------------------------------
        ' Tell the user what we are doing.

        MsgBox("We are now executing the Start function (in file 'EndUser Example1.vb').  This will read several instruNet voltages and digitize several channels.  We recommend that you step through this function, one line at a time.")
        MsgBox("To learn more about programming instruNet in Visual Basic, please press the Help button in the Example1 window.  Please wait a moment after pressing OK.")

        ' -------------------------------------------------------
        ' INITIALIZE UTILITY CODE
        '
        ' Load instruNet Driver and Initialize VB interface utilities. We
        ' pass the instance of the visual basic FORM (i.e. window) and
        ' EndUser_Window CLASS to tell the instruNet interface code where 
        ' to direct graphics.

        Call Initialize_instruNet_MAIN(Me, EndUser_Window.DefInstance, _
            wJumpIntoDemoModeIfNoDeviceExists)

        ' Establishes a list box on the Form that will accept Print_to_ListBox() commands.
        Setup_ListBox(EndUser_Window.DefInstance.Notes)

        ' -------------------------------------------------------
        ' Print a message saying that the driver loaded ok

        message = "We just loaded the instruNet driver successfully (good!)."
        Print_to_ListBox(message)
        Print_to_ListBox("")
        MsgBox(message)

StartButtonHasAlreadyBeenPressed:

        ' -------------------------------------------------------
        ' Load address of 'Ch1 Vin+' and 'Ch3 Vout' into 'vin' and 'vout' structs
        ' (this assumes a instruNet 100 is the 1st device on the net).

        ' Set Ch1 Vin+ = {1,1,1,1} = {netNum, deviceNum, moduleNum, chanNum}
        chExists = LoadChannelAddress(vinAddr.chAddrDLL, 1, 1, 1, 1)
        If chExists = False Then e = NotifyWeCannotLocateThisChannel(vinAddr.chAddrDLL)

        ' Set Ch3 Vout address= {1,1,1,3} = {netNum, deviceNum, moduleNum, chanNum}
        chExists = LoadChannelAddress(voutAddr.chAddrDLL, 1, 1, 1, 3)
        If chExists = False Then e = NotifyWeCannotLocateThisChannel(voutAddr.chAddrDLL)

        ' -------------------------------------------------------
        ' Read 'Ch1 Vin+' value.
        ' read Ch1 Vin+ value
        vinValue = GetField_flt32(vinAddr.chAddrDLL, sgt_General, fldNum_General_valueEU, e)
        If AlertOnError(e) Then EndProgram_iNet("GetField_flt32() returned an error.")

        ' print this voltage
        Print_to_ListBox("Ch1 Vin+ Input Voltage is = " & Str(vinValue))

        ' -------------------------------------------------------
        ' Set 'Ch1 Vout' voltage.

        voutVoltage = 2 ' set Ch3 Vout to 2.0Volts.
        e = SetField_flt32(voutAddr.chAddrDLL, sgt_General, fldNum_General_valueEU, voutVoltage)
        If AlertOnError(e) Then EndProgram_iNet("SetField_flt32() returned an error.")

        ' print this voltage
        Print_to_ListBox("We just set Ch3 Vout Output Voltage to " & Str(voutVoltage))

        ' -------------------------------------------------------
        ' Open the iNet World Window.

        MsgBox("We are now going to tell the instruNet driver to open the Network page window.")

        'open the iNet World window, Network Page
        Open_instruNet_Window_VB(iNetCM_OpenWindow_Network)

        ' -------------------------------------------------------
        ' Print the values of the first 5 channels in your network.

        e = Print_iNet_Channels(5) 'print the value of 5 channels
        If AlertOnError(e) Then EndProgram_iNet("Print_iNet_Channels() returned an error.")

        ' -------------------------------------------------------
        ' Print the 1st 3 fields in the iNet network

        e = Print_iNet_Fields(3) 'Print the first 3 fields
        If AlertOnError(e) Then EndProgram_iNet("Print_iNet_Fields() returned an error.")

        ' -------------------------------------------------------
        ' R/W specific fields.

        e = ReadWriteFields_iNet() 'r/w specific fields
        If AlertOnError(e) Then EndProgram_iNet("ReadWriteFields_iNet() returned an error.")

        ' -------------------------------------------------------
        ' Digitize 3 instruNet channels and analyze the incoming data in
        ' realtime.

        ' tell user what we are going to do
        MsgBox("We are now going to digitize from 3 channels.")

        ' -------------------------------------------------------
        ' INITIALIZE DIGITIZING PARAMETERS

        gNumScans = 1                           ' # of scans to digitize

        gPtsPerScan_nextDigi = 1000             ' points per scan per channel

        gSampleRate_nextDigi = 1000             ' sample rate per channel (pts/sec)

        gContinuousScans = False                ' if true, we run with scans that are continous
        '                                         in time; otherwise, we retrigger for each

        gProcessSegmentsInsteadOfScans = True   ' if false, we process a scan when it has finished
        '                                         digitizing; otherwise, we process little segments
        '                                         as they are recorded.

        gRun_EndUser_PostAcqAnalysis = False    ' if true, then run EndUser_PostAcqAnalysis()
        '                                         at the end of the digitization.  This is an
        '                                         end user routine that processes the resulting data

        gRun_EndUser_SegmentProcessor = False   ' if true, then run EndUser_SegmentProcessor()
        '                                         while data is being digitized.  This is an end
        '                                         user routine that processes little segments of data.

        gCopyChannelsFromNetworkPage = False    ' true if we are to copy the Enabled channels
        '                                         in the Network page to rebuild the Digitize
        '                                         list, after the user closed the Network Window.

        gWaitTillDigitizationCompletes = False   ' If true, then DigitizeProcess_Start() waits for
        '                                         the entire digitization to complete; otherwise,
        '                                         the Timer control triggers the servicing of the
        '                                         digitize buffers, every 200ms or so, while digitizing.

        ' Set the timing parameters
        Call DigitizeProcess_SetTimingParams(gPtsPerScan_nextDigi, gNumScans, _
            gSampleRate_nextDigi, gContinuousScans, gProcessSegmentsInsteadOfScans, _
            gRun_EndUser_PostAcqAnalysis, gRun_EndUser_SegmentProcessor, _
            gCopyChannelsFromNetworkPage, gWaitTillDigitizationCompletes)

        ' Declares no digitize "StartStopButton" button.
        Call DigitizeProcess_SetControlItems(Nothing)

        ' -------------------------------------------------------
        ' DEFINE DIGITIZE CHANNELS
        '
        ' Specify channels to be digitized (i.e. Ch1/4/7 Vin+).

        ' Add Ch1 Vin+ to List of channels to digitize.  This will be digiChan #0.
        ' We set massageType to {jNoMassage, jFFTMassage} to specify that the
        ' digitized data is to be received as a timewave or fft wave.

        ' Resets the channels in the digitize list to 0
        DigitizeList_ResetList()

        If DigitizeList_AddOneItem(1, 1, 1, 1, jNoMassage, False) = False Then EndProgram_iNet("a")
        If DigitizeList_AddOneItem(1, 1, 1, 4, jNoMassage, False) = False Then EndProgram_iNet("b")
        If DigitizeList_AddOneItem(1, 1, 1, 7, jNoMassage, False) = False Then EndProgram_iNet("c")

        ' -------------------------------------------------------
        ' TELL IT TO RUN

        ' tell instruNet to start digitizing
        Call DigitizeProcess_Start()

        MsgBox("We digitized beautifully, and are now done!")

        ' -------------------------------------------------------
        ' Analyze resulting digitized data and print results to front panel.

        Print_to_ListBox("")
        Print_to_ListBox("Digitize Results:")

        Dim sampleRate, sum, avg As Double
        Dim last_ptNum, ptNum As Integer

        ' scan through all digitize channels
        For cNum = 0 To gNumDigiCh - 1

            ' w/ this channel...
            With gDigiChan(cNum)

                last_ptNum = .dataArrayY.numValidPts - 1
                sampleRate = .dataArrayY.ptsPerXunit - 1

                ' calculate the average value of this channel
                sum = 0
                For ptNum = 0 To last_ptNum
                    sum = sum + .dataArrayY.data(ptNum)
                Next ptNum
                avg = sum / .dataArrayY.numValidPts

                ' create a line of info to print to the window
                message = "Digitize Channel #" & Str(cNum) & ": " & Str(.dataArrayY.numValidPts) & " points, " & Str(.dataArrayY.ptsPerXunit) & " sample rate, " & Str(avg) & " average value "

                ' print this line to the window
                Print_to_ListBox(message)

            End With

        Next cNum

        ' -------------------------------------------------------
        ' Exercise the macros.  Please see the Macro file (i.e. "INET_Macros.vb")
        ' for documentation on each marcro.

        ' Make this a 1 if you want to exercise many instruNet macro functions
        ExerciseTheInsruNetMacros = False


        If ExerciseTheInsruNetMacros Then

            Print_to_ListBox("We will now exercise the Macros")
            e = Exercise_The_iNet_Macros() 'exercise the macros
            If AlertOnError(e) Then EndProgram_iNet(("Exercise_The_iNet_Macros() returned an error."))

        End If

        ' -------------------------------------------------------
        ' End of Start Button Subroutine (window stays OPEN)

        MsgBox("We finished processing the tasks in the START function (very good!!!).")

        EndUser_Start_ExampleOne = e

    End Function


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Exercise_The_iNet_Macros()
    '
    ' PURPOSE    Exercises the macros defined in the adjacent iNet macro file.  Please
    '            see the macro file for documentation on these macros.
    '
    ' HISTORY    2/4/96  created - gsw
    '            2/20/96  created Visual Basic version - sjm
    '-------------------------------------------------------------------------------------
    Function Exercise_The_iNet_Macros() As Short

        Dim fieldNum, settingGroupNum, chanNum, moduleNum, deviceNum, netNum As Short
        Dim showAlertStatus, showAlertWas_ON_BeforeThisCall, e, thisExists As Short
        Dim VbString, ArrayOfStrings(6) As String
        Dim ptrToStringArray, netnumlong, int32Value7, int32Value As Integer
        Dim flt32Value As Single

        netNum = 1
        deviceNum = 1
        moduleNum = 1
        chanNum = 1
        settingGroupNum = 1
        fieldNum = 1

        ' ============================ Press iNet Button (MACROS) =========================
        ' ok:       save, open, Timing
        '           start, stop, timing
        '           network, network

        ' not ok    start, stop, save, open, options, Timing (crash)
        '           options, timing
        '           options, options
        '           options, options
        '           network, network, timinig, timing (crash)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Start)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Stop)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Save)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Open)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Options)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Timing)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Trigger)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Record_Probe)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Network_Store)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Network_Restore)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Network_Save)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Network_Open)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Network_Clear)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Network_Reset)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Test_Search)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Test_Test)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Test_BigTest)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Test_SaveAs)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Test_Open)

        e = PRESS_iNet_BUTTON(iNetCM_BtnPress_Test_Clear)


        ' ============================= ERROR CONTROL (MACROS) =============================

        showAlertWas_ON_BeforeThisCall = DONT_SHOW_MESSAGE_DIALOG_UPON_ERROR()

        showAlertWas_ON_BeforeThisCall = SHOW_MESSAGE_DIALOG_UPON_ERROR()

        showAlertStatus = GET_SHOW_MESSAGE_UPON_ERROR_STATUS()


        ' ========================= INTERROGATE NETWORK MACROS ===============================

        int32Value = GET_NUMBER_OF_NETWORKS()

        int32Value = GET_NUMBER_OF_DEVICES(netNum)

        int32Value = GET_NUMBER_OF_MODULES(netNum, deviceNum)

        int32Value = GET_NUMBER_OF_CHANNELS(netNum, deviceNum, moduleNum)

        int32Value = GET_NUMBER_OF_SETTINGS(netNum, deviceNum, moduleNum, chanNum)

        int32Value = GET_NUMBER_OF_FIELDS(netNum, deviceNum, moduleNum, chanNum, settingGroupNum)


        ' =================== DETERMINE IF NETWORK ELEMENT EXISTS (MACROS) =====================

        thisExists = THIS_NETWORK_EXISTS(netNum)

        thisExists = THIS_DEVICE_EXISTS(netNum, deviceNum)

        thisExists = THIS_MODULE_EXISTS(netNum, deviceNum, moduleNum)

        thisExists = THIS_CHANNEL_EXISTS(netNum, deviceNum, moduleNum, chanNum)

        thisExists = THIS_SETTING_EXISTS(netNum, deviceNum, moduleNum, chanNum, settingGroupNum)

        thisExists = THIS_FIELD_EXISTS(netNum, deviceNum, moduleNum, chanNum, settingGroupNum, fieldNum)


        ' ============== Turn Channels on and off for digitizing (MACROS) ============

        e = ENABLE_CHANNEL_DIGITIZATION(netNum, deviceNum, moduleNum, chanNum)

        e = DISABLE_CHANNEL_DIGITIZATION(netNum, deviceNum, moduleNum, chanNum)


        ' ========================== TIMING (MACROS) =================================

        flt32Value = GET_SAMPLE_RATE_IN_HZ(netNum)

        flt32Value = 100 'flt32value * 0.5

        e = SET_SAMPLE_RATE_IN_HZ(netNum, flt32Value)

        int32Value = GET_POINTS_PER_SCAN(netNum)

        int32Value = int32Value * 0.5

        e = SET_POINTS_PER_SCAN(netNum, int32Value)

        int32Value = GET_NUMBER_OF_SCANS(netNum)

        int32Value = int32Value * 0.5

        e = SET_NUMBER_OF_SCANS(netNum, int32Value)

        int32Value = GET_SCAN_MODE(netNum)

        e = SET_SCAN_MODE(netNum, int32Value)

        int32Value7 = GET_NETWORK_BPS(netNum)

        e = SET_NETWORK_BPS(netNum, int32Value)

        int32Value = CONTROLLER_IS_DIGITIZING(netNum)

        e = SET_SAVE_DATA(ion_gSaveDataPopup_ToRamBuffer)

        e = SET_OVERFLOW_ALERT(ion_gOnOffPopup_Off)


        ' ===================================== TRIGGER (MACROS) ==================================

        e = SET_TRIGGER_MODE(netNum, ion_TriggerMode_Off)

        e = SET_TRIGGER_THRESHOLD(netNum, 1)

        e = SET_TRIGGER_SLOPE(netNum, ion_Rising)

        netnumlong = netNum

        e = SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcNet, netNum)
        e = SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcModule, moduleNum)
        e = SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcDevice, deviceNum)
        e = SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcChannel, chanNum)


        ' ========================== USER INTERFACE (MACROS) ============================

        int32Value = GET_USER_INTERFACE_TYPE(netNum, deviceNum, moduleNum, chanNum, _
            settingGroupNum, fieldNum)

        int32Value = GET_USER_INTERFACE_CATAGORY(netNum, deviceNum, moduleNum, chanNum, _
            settingGroupNum, fieldNum)

        int32Value = GET_NATIVE_STORAGE_TYPE(netNum, deviceNum, moduleNum, chanNum, _
            settingGroupNum, fieldNum)

        int32Value = GET_NUMBER_OF_POPUP_ITEMS(netNum, deviceNum_CONTROLLER, moduleNum_1stModule, _
            controller_ChanNum_C12_Digitizer, sgt_Timing, fldNum_Timing_scanMode)

        ' GET_ARRAY_OF_ADDRESS_NAMES_VB() IS NOT WORKING, PROBABLY BECAUSE VB (ver >= 7) IS HAVING TROUBLE 
        ' GETTING ACCESS TO STATIC VARIABLE SPACE INSIDE THE iNet32.dll, gsw 6/1/02.

        ' view string array ArrayOfStrings[0],  ArrayOfStrings[1], etc in debugger
        GET_ARRAY_OF_ADDRESS_NAMES_VB(netNum, deviceNum_CONTROLLER, moduleNum_1stModule, _
            controller_ChanNum_C12_Digitizer, sgt_Timing, fldNum_Timing_scanMode, ArrayOfStrings)

        ' OLD: No longer supported, gsw 6/1/02
        ' OLD: view Str15 C string array ptrToStringArray[0],  ptrToStringArray[1], etc in debugger
        ' OLD: ptrToStringArray = GET_PTR_TO_POPUP_ITEMS(netNum, deviceNum_CONTROLLER, moduleNum_1stModule, controller_ChanNum_C12_Digitizer, sgt_Timing, fldNum_Timing_scanMode)

        ' ====================== GET and SET CHANNEL VALUES (MACROS) ======================

        flt32Value = GET_CHANNEL_VALUE_FLT32(netNum, deviceNum, moduleNum, chanNum)

        int32Value = GET_CHANNEL_VALUE_INT32(netNum, deviceNum, moduleNum, chanNum)

        e = GET_CHANNEL_VALUE_VbString(netNum, deviceNum, moduleNum, chanNum, VbString)

        e = SET_CHANNEL_VALUE_FLT32(netNum_DRIVER, deviceNum_CONTROLLER, _
            moduleNum_1stModule, driver_ChanNum_RecordOptions, flt32Value)

        e = SET_CHANNEL_VALUE_INT32(netNum_DRIVER, deviceNum_CONTROLLER, _
            moduleNum_1stModule, driver_ChanNum_RecordOptions, int32Value)

        e = SET_CHANNEL_VALUE_VbString(netNum, deviceNum, moduleNum, 3, VbString)

        ' ===================== GET and SET NETWORK SETTINGS (MACROS) ===============

        Dim networkState_Array(10000) As Short
        Dim numValidBytesReturned As Integer

        ' get the iNet network state and place it into a strArray
        e = Get_instruNet_Network_State_VB(networkState_Array, 10000, numValidBytesReturned)

        ' set the network state with the data stored in the strArray
        e = Set_instruNet_Network_State_VB(networkState_Array, numValidBytesReturned)

        ' For another way to save/load network settings, please see
        ' SaveOrLoad_DataAndState() in file INET_Interface.VB

        ' ========================== DRIVER MANAGEMENT (MACROS) ===========================

        int32Value = DRIVER_IS_INSTALLED()

        flt32Value = SECONDS_SINCE_RESET(netNum)

        ' ========================== SHOW PROBE DIALOG (MACROS) ===========================

        ' use Open_instruNet_Window_VB() to show windows

    End Function


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Print_iNet_Channels()
    '
    ' PURPOSE    This routine prints the value of 'maxNumberOffChannelsToPrint'
    '            number of channels in your iNet network.(we print out the 1st
    '            ones that we find).
    '
    ' PARAMS     maxNumberOffChannelsToPrint   this is the maximum  of channels to print
    '
    ' HISTORY    2/20/96  created Visual Basic version - sjm
    '-------------------------------------------------------------------------------------
    Function Print_iNet_Channels(ByVal maxNumberOffChannelsToPrint As Short) As Short

        Dim chanNum, deviceNum, netNum, e, numberOfNetworks As Short
        Dim numberOfDevices, numberOfModules, numberOfChannels As Short
        Dim message As String
        Dim moduleNum As Byte

        ' print title
        Print_to_ListBox("")
        Print_to_ListBox("Channel Values:")
        e = iNetErr_None

        ' get  of iNet Networks in this Computer
        numberOfNetworks = GET_NUMBER_OF_NETWORKS()

        ' scan through all Networks
        For netNum = 1 To numberOfNetworks

            ' get  of Devices on this Network
            numberOfDevices = GET_NUMBER_OF_DEVICES(netNum)

            ' scan through all Devices
            For deviceNum = 1 To numberOfDevices

                ' get  of Modules in this Device
                numberOfModules = GET_NUMBER_OF_MODULES(netNum, deviceNum)

                ' scan through all Modules
                For moduleNum = 1 To numberOfModules

                    ' get  of Channels in this Module
                    numberOfChannels = GET_NUMBER_OF_CHANNELS(netNum, moduleNum, deviceNum)

                    ' scan through Channels
                    For chanNum = 1 To numberOfChannels

                        ' print the value field in the GENERAL Settings area, which is
                        ' the value of the channel.
                        e = PrintOneField_iNet(netNum, deviceNum, moduleNum, chanNum, sgt_General, fldNum_General_valueEU, message)

                        ' if we have printed enough channels...
                        maxNumberOffChannelsToPrint = maxNumberOffChannelsToPrint - 1
                        If maxNumberOffChannelsToPrint <= 0 Then GoTo ExitFunction

                    Next chanNum

                Next moduleNum

            Next deviceNum

        Next netNum

ExitFunction:

        Print_iNet_Channels = e

    End Function


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Print_iNet_Fields()
    '
    ' PURPOSE    This routine prints the value of 'maxNumberOffFieldsToPrint'
    '            number of fields in your iNet network (we print out the 1st
    '            ones that we find).
    '
    ' PARAMETERS maxNumberOffFieldsToPrint   this is the maximum  of fields to print
    '
    ' HISTORY    2/20/96  created Visual Basic version - sjm
    '-------------------------------------------------------------------------------------
    Function Print_iNet_Fields(ByVal maxNumberOffFieldsToPrint As Integer) As Short

        Dim e, fieldNum, chanNum, deviceNum, numberOfDevices As Short
        Dim numberOfChannels, numberOfFields, numberOfNetworks As Short
        Dim netNum, settingNum, numberOfModules, moduleNum, numberOfSettings As Short
        Dim message As String

        e = iNetErr_None

        ' print title
        Print_to_ListBox("")
        Print_to_ListBox("Field Values:")

        ' get  of iNet Networks in this Computer
        numberOfNetworks = GET_NUMBER_OF_NETWORKS()
        e = Get_iNet_Error()
        If ErrorHere(e, "GET_NUMBER_OF_NETWORKS()") Then GoTo ExitFunction

        'scan through all Networks
        For netNum = 1 To numberOfNetworks

            numberOfDevices = GET_NUMBER_OF_DEVICES(netNum)
            e = Get_iNet_Error()
            If ErrorHere(e, "GET_NUMBER_OF_DEVICES()") Then GoTo ExitFunction

            'scan through all devices
            For deviceNum = 1 To numberOfDevices

                numberOfModules = GET_NUMBER_OF_MODULES(netNum, deviceNum)
                e = Get_iNet_Error()
                If ErrorHere(e, "GET_NUMBER_OF_MODULES()") Then GoTo ExitFunction

                'scan through all modules
                For moduleNum = 1 To numberOfModules

                    numberOfChannels = GET_NUMBER_OF_CHANNELS(netNum, moduleNum, deviceNum)
                    e = Get_iNet_Error()
                    If ErrorHere(e, "GET_NUMBER_OF_CHANNELS()") Then GoTo ExitFunction

                    'scan through Channels
                    For chanNum = 1 To numberOfChannels

                        numberOfSettings = GET_NUMBER_OF_SETTINGS(netNum, moduleNum, deviceNum, chanNum)
                        e = Get_iNet_Error()
                        If ErrorHere(e, "GET_NUMBER_OF_SETTINGS()") Then GoTo ExitFunction

                        'scan through settings groups
                        For settingNum = 1 To numberOfSettings

                            numberOfFields = GET_NUMBER_OF_FIELDS(netNum, moduleNum, deviceNum, chanNum, settingNum)
                            e = Get_iNet_Error()
                            If ErrorHere(e, "GET_NUMBER_OF_FIELDS()") Then GoTo ExitFunction

                            'scan through each Field
                            For fieldNum = 1 To numberOfFields

                                e = PrintOneField_iNet(netNum, deviceNum, moduleNum, chanNum, settingNum, fieldNum, message)

                                maxNumberOffFieldsToPrint = maxNumberOffFieldsToPrint - 1
                                If (maxNumberOffFieldsToPrint) <= 0 Then GoTo ExitFunction

                            Next fieldNum
                        Next settingNum
                    Next chanNum
                Next moduleNum
            Next deviceNum
        Next netNum

ExitFunction:

        Print_iNet_Fields = e

    End Function


    '-------------------------------------------------------------------------------------
    ' FUNCTION    PrintOneField_iNet()
    '
    ' PURPOSE     This routine prints out 1 line of information on the specified field.
    '
    ' PARAMETERS
    '
    '   netNum         NETWORK number = {0...numNetworks}, 0 is Driver, 1 is 1st Controller
    '   deviceNum      DEVICE number {0...numDevices}, 0 = "Controller", 1 is 1st device
    '   moduleNum      MODULE number within a hardware DEVICE {1...32}.
    '   chanNum        CHANNEL number {1...32}.
    '   settingGroupNumOrType - SETTING Group number {1... numSettingsGroupsInChannel}
    '   fieldNum       FIELD number {1...32}.
    '   message        we fill this string with info
    '
    ' HISTORY     2/20/96  created Visual Basic version - sjm
    '-------------------------------------------------------------------------------------
    Function PrintOneField_iNet(ByVal netNum As Byte, ByVal deviceNum As Byte, _
        ByVal moduleNum As Byte, ByVal chanNum As Byte, ByVal settingGroupNumOrType As Short, _
        ByVal fieldNum As Short, ByRef message As String) As Short

        Dim e As Short
        Dim fieldNameStr As String
        Dim fieldValueStr As String

        ' get the field name
        e = iNet_VB_cString(netNum, deviceNum, moduleNum, chanNum, settingGroupNumOrType, _
            fieldNum, intention_getNameStr, fieldNameStr)
        If ErrorHere(e, "iNet_VB_cString(fieldName)") Then GoTo ExitFunction

        ' get the field value
        e = iNet_VB_cString(netNum, deviceNum, moduleNum, chanNum, settingGroupNumOrType, _
             fieldNum, intention_getValue, fieldValueStr)
        If ErrorHere(e, "iNet_VB_cString(fieldName)") Then GoTo ExitFunction

        ' create string that describes the channel
        message = "(" & Str(netNum) & "," & Str(deviceNum) & "," & Str(moduleNum) & "," & Str(chanNum) & ") = " & fieldNameStr & " = " & fieldValueStr

        ' print info about field
        Print_to_ListBox(message)

ExitFunction:

        PrintOneField_iNet = e

    End Function


    '-------------------------------------------------------------------------------------
    ' FUNCTION   ReadWriteFields_iNet()
    '
    ' PURPOSE    This routine reads and writes iNet hardware fields.
    '
    ' HISTORY    2/20/96  created Visual Basic version - sjm
    '-------------------------------------------------------------------------------------
    Function ReadWriteFields_iNet() As Short

        Dim valu As String
        Dim commaPosition, minValue, x, e As Short
        Dim s, valueStr, usersFieldStr, message As String
        Dim netNum, chanNum, deviceNum, fieldNum, moduleNum, settingNum As Short
        Dim addr(6) As Short

        Print_to_ListBox("")
        Print_to_ListBox("Read and write fields:")
        e = iNetErr_None

        '----------------------------------------------------------------------------
        ' Get device , channel , and field  from user.

LookAtAField:
        ' prompt user
        usersFieldStr = InputBox("Input netNum, devNum, modNum, chanNum, setNum, fieldNum (e.g. 1,1,1,1,1,1) ? ")
        If (usersFieldStr = "") Then
            Exit Function
        End If

        '-----------------------------------------------------------------------
        ' Pick out 6 numbers from user's string.

        For x = 0 To 5 ' interpret user's string

            ' get value of user's input
            addr(x) = Val(usersFieldStr)

            ' make sure the number is within range
            If x >= 2 Then
                minValue = 1
            Else
                minValue = 0
            End If

            If (addr(x) < minValue Or addr(x) > 20) Then
                MsgBox("Since you did not enter a valid address, we're going to proceed with the next exercise.")
                Exit Function
            End If
            ' find position of comma
            commaPosition = InStr(1, usersFieldStr, ",", 1)

            ' truncate up to next comma
            usersFieldStr = Mid(usersFieldStr, commaPosition + 1)

        Next x

        '-----------------------------------------------------------------------
        ' Print one field on one line.

PrintTheField:

        ' print the value of this field
        e = PrintOneField_iNet(addr(0), addr(1), addr(2), addr(3), addr(4), addr(5), message)
        s = InputBox("Do you want to Modify this field's value, Look at another field, or Exit (M, L, E)?  ")

        Select Case s

            Case "M", "m"       ' Modify Field Value

                valu = InputBox("What is the new value ?")

                ' set this field to the new value, which is in the form of a C string
                e = iNet_VB_cString(addr(1), deviceNum, moduleNum, chanNum, _
                    settingNum, fieldNum, intention_setValue, valu)

                If ErrorHere(e, "ReadWriteFields_iNet()") Then GoTo ExitFunction

                GoTo PrintTheField

            Case "L", "l"       ' Look at another Field

                GoTo LookAtAField

            Case "E", "e"       ' Exit
            Case Else

                GoTo ExitFunction

        End Select

ExitFunction:

        ReadWriteFields_iNet = e

    End Function


    ' ====================================================================================
    ' ====================================================================================
    '
    '                           END USER DIGITIZE/DATA MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_PostAcqAnalysis()
    '
    ' PURPOSE    Process incoming digitized data, after the digitization stops.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_PostAcqAnalysis()

        ' Please see EndUser_PostAcqAnalysis() in file EndUser_Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SaveLoadResults()
    '
    ' PURPOSE    Save or Load end user data when the user presses the Save or Load buttons.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_SaveLoadResults(ByRef sPathName As String, ByVal saveOrLoad As Short)

        ' Please see EndUser_SaveLoadResults() in file EndUser_Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SegmentProcessor()
    '
    ' PURPOSE    Process incoming digitized data, while it is being digitized.  This
    '            is called for each segment of data is pulled from each channel.
    '
    ' PARAMs     cNum: Digitize Channel number {0..numChannels-1} (from DigitizeList)
    '            segmentStart_ptNum: first ptNum {0..numValidPts} for the recently digitized segment
    '            segmentEnd_ptNum: last ptNum {0..numValidPts} for the recently digitized segment
    '            scanNumberToPull_base1: scan number, base 1, of the recently digitized segment
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_SegmentProcessor(ByVal cNum As Short, _
        ByVal segmentStart_ptNum As Integer, ByVal segmentEnd_ptNum As Integer, _
        ByVal scanNumberToPull_base1 As Integer)

        ' -------------------------------------------------------------------------------------
        ' If there are no points here, bail out, gsw 2/24/03

        Dim numOfPtsInSegment As Integer = 1 + segmentEnd_ptNum - segmentStart_ptNum

        If (numOfPtsInSegment <= 0) Then Exit Sub

        ' -------------------------------------------------------------------------------------
        ' Please see EndUser_SegmentProcessor() in file EndUser_Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   DigitizeProcess_Tick()
    '
    ' PURPOSE    This is a bit tricky.  The INET_Digitize.vb code creates a TIMER
    '            object and makes it a member of the end user's EndUser_CLASS (i.e.
    '            this Form).  This timer then tells an INET_Digitize.vb routine
    '            to execute every .. milliseconds, to service the digitize buffers.\
    '            The reason we involve the end user's Form here is because it control
    '            the processor excution and Threading.
    '
    '            In summary, the end user much include this DigitizeProcess_Tick()
    '            in their code.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub DigitizeProcess_Tick(ByVal myObject As Object, ByVal myEventArgs As EventArgs)

        METHOD_DigitizeProcess_Timer(myObject, myEventArgs)

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                       RESPOND TO a BUTTON CLICK AT TOP OF WINDOW
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   Help_button_Click()
    '
    ' PURPOSE    Respond to a HELP button click.
    '
    ' HISTORY    6/5/02 - updated, gsw
    '-------------------------------------------------------------------------------------
    Private Sub Help_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Help_button.Click

        ' Show the instruNet help text, which is stored in the file listed below

        Call TextWindow.DefInstance.OpenTextWindow( _
            "c:\Program files\instruNet\Programming Interfaces\Visual Basic .Net\Working with Visual BASIC .Net.txt", _
            "VB Help", False)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Start_Click()
    '
    ' PURPOSE    This routine is the main routine in this example program.
    '            It exercises many of the instruNet features, and is
    '            run when the start button is pressed.
    '
    ' HISTORY    2/20/96  created Visual Basic version - sjm
    '-------------------------------------------------------------------------------------
    Sub Start_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Start.Click

        ' Run the example code
        EndUser_Start_ExampleOne()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Stop_Renamed_Click()
    '
    ' PURPOSE    Respond to the pressing of the STOP button
    '
    ' HISTORY    2/20/96  created Visual Basic version - sjm
    '-------------------------------------------------------------------------------------
    Private Sub Stop_Renamed_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Stop_Renamed.Click

        ' tell instruNet to stop digitizing
        Call DigitizeProcess_Stop()

    End Sub

    ' ====================================================================================
    ' ====================================================================================
    '
    '                                 WINDOW OPEN/CLOSE MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Load()
    '
    ' PURPOSE    Respond to the running of the programming.
    '
    ' HISTORY    6/5/02 - updated, gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Load(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        MsgBox("Press the start button to exercise instruNet.")

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Exit_button_Click()
    '
    ' PURPOSE    Respond to the pressing of the EXIT button.
    '
    ' HISTORY    6/5/02 - updated, gsw
    '-------------------------------------------------------------------------------------
    Private Sub Exit_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Exit_button.Click

        ' Run EndUser_Window.unload() method and close the window.
        EndUser_Window.DefInstance.Close()

        ' End the entire program
        End

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Closed()
    '
    ' PURPOSE    Respond to the closing of the window (i.e. Unload)
    '
    ' HISTORY    6/5/02 - updated, gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Closed(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Closed

        ' End the program and unload the instruNet driver.
        EndProgram_iNet("")

    End Sub



    '-------------------------------------------------------------------------------------
    ' FUNCTION   Finalize()
    '
    ' PURPOSE    Implements Finalize method
    '
    ' HISTORY    6/5/02 - added by Visual Studio .Net 7 Upgrade wizard
    '-------------------------------------------------------------------------------------
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

End Class