' ====================================================================================
' FORM:     EndUser Instrument.vb
'
'           This example emulates an oscilloscope or strip chart recorded. It uses
'           the instruNet Display routines to build the displays.
'
' HISTORY   6/6/02   updated to be compatible with Visual Studio (Visual Basic) .Net v7
' ====================================================================================

Option Strict Off
Option Explicit On

' -------------------------------------------------------------------------
' CLASS     EndUser_Window
'
' EndUser_Window is a CLASS created by the end user that contains
' a window (i.e. Visual Basic FORM) and several callback functions:
' EndUser_SegmentProcessor(), EndUser_SaveLoadResults(), EndUser_PostAcqAnalysis()
'
Friend Class EndUser_Window

    ' This class includes a Visual Basic FORM (i.e. window)
    Inherits System.Windows.Forms.Form

    ' -------------------------------------------------------------
    ' Visual Studio generated the following code based on the
    ' dialog box graphical set up.
    '
#Region "Windows Form Designer generated code "

    ' -------------------------------------------------------------------------
    ' FUNCTION    New() - Windows Form Designer generated code
    '
    ' PURPOSE     This is the New() method, which is generated by the windows
    '             Form Designer utility.  This code sets up the dialog and
    '             sets the attributes of the various fields.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Public Sub New()
        MyBase.New()
        If m_vb6FormDefInstance Is Nothing Then
            If m_InitializingDefInstance Then
                m_vb6FormDefInstance = Me
            Else
                Try
                    'For the start-up form, the first instance created is the default instance.
                    If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
                        m_vb6FormDefInstance = Me
                    End If
                Catch
                End Try
            End If
        End If
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public WithEvents _hPos_scroll_0 As System.Windows.Forms.HScrollBar
    Public WithEvents Help_button As System.Windows.Forms.Button
    Public WithEvents Exit_button As System.Windows.Forms.Button
    Public WithEvents Print_button As System.Windows.Forms.Button
    Public WithEvents Channels_Button As System.Windows.Forms.Button
    Public WithEvents Setup_Button As System.Windows.Forms.Button
    Public WithEvents load_button As System.Windows.Forms.Button
    Public WithEvents Save_button As System.Windows.Forms.Button
    Public WithEvents StartStopButton As System.Windows.Forms.Button
    Public WithEvents _vPos_decrement_0 As System.Windows.Forms.Button
    Public WithEvents _hPos_increment_0 As System.Windows.Forms.Button
    Public WithEvents _hPos_decrement_0 As System.Windows.Forms.Button
    Public WithEvents _vPos_scroll_0 As System.Windows.Forms.VScrollBar
    Public WithEvents _vPos_increment_0 As System.Windows.Forms.Button
    Public WithEvents Box As Microsoft.VisualBasic.Compatibility.VB6.PictureBoxArray
    Public WithEvents hPos_decrement As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents hPos_increment As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents hPos_scroll As Microsoft.VisualBasic.Compatibility.VB6.HScrollBarArray
    Public WithEvents vPos_decrement As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents vPos_increment As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents vPos_scroll As Microsoft.VisualBasic.Compatibility.VB6.VScrollBarArray
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Private WithEvents _Box_0 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me._hPos_scroll_0 = New System.Windows.Forms.HScrollBar()
        Me.Help_button = New System.Windows.Forms.Button()
        Me.Exit_button = New System.Windows.Forms.Button()
        Me.Print_button = New System.Windows.Forms.Button()
        Me.Channels_Button = New System.Windows.Forms.Button()
        Me.Setup_Button = New System.Windows.Forms.Button()
        Me.load_button = New System.Windows.Forms.Button()
        Me.Save_button = New System.Windows.Forms.Button()
        Me.StartStopButton = New System.Windows.Forms.Button()
        Me._vPos_decrement_0 = New System.Windows.Forms.Button()
        Me._hPos_increment_0 = New System.Windows.Forms.Button()
        Me._hPos_decrement_0 = New System.Windows.Forms.Button()
        Me._vPos_scroll_0 = New System.Windows.Forms.VScrollBar()
        Me._Box_0 = New System.Windows.Forms.PictureBox()
        Me._vPos_increment_0 = New System.Windows.Forms.Button()
        Me.Box = New Microsoft.VisualBasic.Compatibility.VB6.PictureBoxArray(Me.components)
        Me.hPos_decrement = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.hPos_increment = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.hPos_scroll = New Microsoft.VisualBasic.Compatibility.VB6.HScrollBarArray(Me.components)
        Me.vPos_decrement = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.vPos_increment = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.vPos_scroll = New Microsoft.VisualBasic.Compatibility.VB6.VScrollBarArray(Me.components)
        CType(Me.Box, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.hPos_decrement, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.hPos_increment, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.hPos_scroll, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.vPos_decrement, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.vPos_increment, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.vPos_scroll, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        '_hPos_scroll_0
        '
        Me._hPos_scroll_0.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_scroll_0.Cursor = System.Windows.Forms.Cursors.Default
        Me.hPos_scroll.SetIndex(Me._hPos_scroll_0, CType(0, Short))
        Me._hPos_scroll_0.LargeChange = 5000
        Me._hPos_scroll_0.Location = New System.Drawing.Point(0, 554)
        Me._hPos_scroll_0.Maximum = 37766
        Me._hPos_scroll_0.Name = "_hPos_scroll_0"
        Me._hPos_scroll_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_scroll_0.Size = New System.Drawing.Size(680, 18)
        Me._hPos_scroll_0.SmallChange = 1000
        Me._hPos_scroll_0.TabIndex = 1
        Me._hPos_scroll_0.TabStop = True
        '
        'Help_button
        '
        Me.Help_button.BackColor = System.Drawing.SystemColors.Control
        Me.Help_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Help_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Help_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Help_button.Location = New System.Drawing.Point(472, 0)
        Me.Help_button.Name = "Help_button"
        Me.Help_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Help_button.Size = New System.Drawing.Size(81, 25)
        Me.Help_button.TabIndex = 14
        Me.Help_button.Text = "Help"
        '
        'Exit_button
        '
        Me.Exit_button.BackColor = System.Drawing.SystemColors.Control
        Me.Exit_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Exit_button.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Exit_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Exit_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Exit_button.Location = New System.Drawing.Point(552, 0)
        Me.Exit_button.Name = "Exit_button"
        Me.Exit_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Exit_button.Size = New System.Drawing.Size(81, 25)
        Me.Exit_button.TabIndex = 10
        Me.Exit_button.Text = "Exit"
        '
        'Print_button
        '
        Me.Print_button.BackColor = System.Drawing.SystemColors.Control
        Me.Print_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Print_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Print_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Print_button.Location = New System.Drawing.Point(392, 0)
        Me.Print_button.Name = "Print_button"
        Me.Print_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Print_button.Size = New System.Drawing.Size(81, 25)
        Me.Print_button.TabIndex = 9
        Me.Print_button.Text = "Print"
        '
        'Channels_Button
        '
        Me.Channels_Button.BackColor = System.Drawing.SystemColors.Control
        Me.Channels_Button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Channels_Button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Channels_Button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Channels_Button.Location = New System.Drawing.Point(152, 0)
        Me.Channels_Button.Name = "Channels_Button"
        Me.Channels_Button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Channels_Button.Size = New System.Drawing.Size(81, 25)
        Me.Channels_Button.TabIndex = 13
        Me.Channels_Button.Text = "Channels"
        '
        'Setup_Button
        '
        Me.Setup_Button.BackColor = System.Drawing.SystemColors.Control
        Me.Setup_Button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Setup_Button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Setup_Button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Setup_Button.Location = New System.Drawing.Point(72, 0)
        Me.Setup_Button.Name = "Setup_Button"
        Me.Setup_Button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Setup_Button.Size = New System.Drawing.Size(81, 25)
        Me.Setup_Button.TabIndex = 7
        Me.Setup_Button.Text = "Setup"
        '
        'load_button
        '
        Me.load_button.BackColor = System.Drawing.SystemColors.Control
        Me.load_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.load_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.load_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.load_button.Location = New System.Drawing.Point(232, 0)
        Me.load_button.Name = "load_button"
        Me.load_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.load_button.Size = New System.Drawing.Size(81, 25)
        Me.load_button.TabIndex = 12
        Me.load_button.Text = "Load"
        '
        'Save_button
        '
        Me.Save_button.BackColor = System.Drawing.SystemColors.Control
        Me.Save_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Save_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Save_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Save_button.Location = New System.Drawing.Point(312, 0)
        Me.Save_button.Name = "Save_button"
        Me.Save_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Save_button.Size = New System.Drawing.Size(81, 25)
        Me.Save_button.TabIndex = 11
        Me.Save_button.Text = "Save"
        '
        'StartStopButton
        '
        Me.StartStopButton.BackColor = System.Drawing.SystemColors.Control
        Me.StartStopButton.Cursor = System.Windows.Forms.Cursors.Default
        Me.StartStopButton.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.StartStopButton.ForeColor = System.Drawing.SystemColors.ControlText
        Me.StartStopButton.Name = "StartStopButton"
        Me.StartStopButton.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartStopButton.Size = New System.Drawing.Size(73, 25)
        Me.StartStopButton.TabIndex = 8
        Me.StartStopButton.Text = "Start"
        '
        '_vPos_decrement_0
        '
        Me._vPos_decrement_0.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_decrement_0.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_decrement_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_decrement_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_decrement_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_decrement.SetIndex(Me._vPos_decrement_0, CType(0, Short))
        Me._vPos_decrement_0.Location = New System.Drawing.Point(727, 40)
        Me._vPos_decrement_0.Name = "_vPos_decrement_0"
        Me._vPos_decrement_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_decrement_0.Size = New System.Drawing.Size(17, 17)
        Me._vPos_decrement_0.TabIndex = 6
        Me._vPos_decrement_0.Text = "--"
        '
        '_hPos_increment_0
        '
        Me._hPos_increment_0.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_increment_0.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_increment_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_increment_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_increment_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_increment.SetIndex(Me._hPos_increment_0, CType(0, Short))
        Me._hPos_increment_0.Location = New System.Drawing.Point(703, 554)
        Me._hPos_increment_0.Name = "_hPos_increment_0"
        Me._hPos_increment_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_increment_0.Size = New System.Drawing.Size(25, 18)
        Me._hPos_increment_0.TabIndex = 4
        Me._hPos_increment_0.Text = ">"
        '
        '_hPos_decrement_0
        '
        Me._hPos_decrement_0.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_decrement_0.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_decrement_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_decrement_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_decrement_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_decrement.SetIndex(Me._hPos_decrement_0, CType(0, Short))
        Me._hPos_decrement_0.Location = New System.Drawing.Point(679, 554)
        Me._hPos_decrement_0.Name = "_hPos_decrement_0"
        Me._hPos_decrement_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_decrement_0.Size = New System.Drawing.Size(25, 18)
        Me._hPos_decrement_0.TabIndex = 3
        Me._hPos_decrement_0.Text = "<"
        '
        '_vPos_scroll_0
        '
        Me._vPos_scroll_0.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_scroll_0.Cursor = System.Windows.Forms.Cursors.Default
        Me.vPos_scroll.SetIndex(Me._vPos_scroll_0, CType(0, Short))
        Me._vPos_scroll_0.LargeChange = 5000
        Me._vPos_scroll_0.Location = New System.Drawing.Point(727, 56)
        Me._vPos_scroll_0.Maximum = 37766
        Me._vPos_scroll_0.Name = "_vPos_scroll_0"
        Me._vPos_scroll_0.Size = New System.Drawing.Size(17, 499)
        Me._vPos_scroll_0.SmallChange = 1000
        Me._vPos_scroll_0.TabIndex = 2
        Me._vPos_scroll_0.TabStop = True
        '
        '_Box_0
        '
        Me._Box_0.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._Box_0.BackColor = System.Drawing.Color.White
        Me._Box_0.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me._Box_0.Cursor = System.Windows.Forms.Cursors.Cross
        Me._Box_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._Box_0.ForeColor = System.Drawing.Color.FromArgb(CType(128, Byte), CType(128, Byte), CType(128, Byte))
        Me.Box.SetIndex(Me._Box_0, CType(0, Short))
        Me._Box_0.Location = New System.Drawing.Point(0, 24)
        Me._Box_0.Name = "_Box_0"
        Me._Box_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._Box_0.Size = New System.Drawing.Size(728, 531)
        Me._Box_0.TabIndex = 0
        Me._Box_0.TabStop = False
        '
        '_vPos_increment_0
        '
        Me._vPos_increment_0.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_increment_0.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_increment_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_increment_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_increment_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_increment.SetIndex(Me._vPos_increment_0, CType(0, Short))
        Me._vPos_increment_0.Location = New System.Drawing.Point(727, 24)
        Me._vPos_increment_0.Name = "_vPos_increment_0"
        Me._vPos_increment_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_increment_0.Size = New System.Drawing.Size(17, 17)
        Me._vPos_increment_0.TabIndex = 5
        Me._vPos_increment_0.Text = "+"
        '
        'hPos_decrement
        '
        '
        'hPos_increment
        '
        '
        'hPos_scroll
        '
        '
        'vPos_decrement
        '
        '
        'vPos_increment
        '
        '
        'vPos_scroll
        '
        '
        'EndUser_Window
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.CancelButton = Me.Exit_button
        Me.ClientSize = New System.Drawing.Size(742, 570)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me._hPos_scroll_0, Me.Help_button, Me.Exit_button, Me.Print_button, Me.Channels_Button, Me.Setup_Button, Me.load_button, Me.Save_button, Me.StartStopButton, Me._vPos_decrement_0, Me._hPos_increment_0, Me._hPos_decrement_0, Me._vPos_scroll_0, Me._Box_0, Me._vPos_increment_0})
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ForeColor = System.Drawing.Color.FromArgb(CType(128, Byte), CType(128, Byte), CType(255, Byte))
        Me.MaximumSize = New System.Drawing.Size(10000, 10000)
        Me.MinimumSize = New System.Drawing.Size(300, 200)
        Me.Name = "EndUser_Window"
        Me.ShowInTaskbar = False
        Me.Text = "instruNet Instrument"
        CType(Me.Box, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.hPos_decrement, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.hPos_increment, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.hPos_scroll, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.vPos_decrement, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.vPos_increment, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.vPos_scroll, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub
#End Region

    ' -------------------------------------------------------------------------
    ' FUNCTION    Defines several properties to be used with the dialog.
    '
    ' PURPOSE     This was generated by the VS 7 Upgrade Wizard.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
#Region "Upgrade Support "
    Private Shared m_vb6FormDefInstance As EndUser_Window
    Private Shared m_InitializingDefInstance As Boolean
    Public Shared Property DefInstance() As EndUser_Window
        Get
            If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
                m_InitializingDefInstance = True
                m_vb6FormDefInstance = New EndUser_Window()
                m_InitializingDefInstance = False
            End If
            DefInstance = m_vb6FormDefInstance
        End Get
        Set(ByVal Value As EndUser_Window)
            m_vb6FormDefInstance = Value
        End Set
    End Property
#End Region

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_StartProgram()
    '
    ' PURPOSE    Called when window is 1st opened. This routine sets up the displays
    '            and the channels being digitized.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Sub EndUser_StartProgram()

        ' -------------------------------------------------------------
        ' INITIALIZE UTILITY CODE
        '
        ' Load instruNet Driver and Initialize VB interface utilities

        Call Initialize_instruNet_MAIN( _
            Me, _
            EndUser_Window.DefInstance, _
            wJumpIntoDemoModeIfNoDeviceExists)

        ' -------------------------------------------------------------
        ' Open instruNet World NETWORK window.

        ' commented out for now:
        '   Call Initialize_instruNet_MAIN(EndUser_Window, wJumpIntoRightNow)

        ' -------------------------------------------------------------
        ' INITIALIZE DIGITIZING PARAMETERS

        gNumScans = 1                           ' # of scans to digitize

        gPtsPerScan_nextDigi = 10000            ' points per scan per channel

        gSampleRate_nextDigi = 1000             ' sample rate per channel (pts/sec)

        gContinuousScans = False                ' if true, we run with scans that are continous
        '                                         in time; otherwise, we retrigger for each

        gProcessSegmentsInsteadOfScans = True   ' if false, we process a scan when it has finished
        '                                         digitizing; otherwise, we process little segments
        '                                         as they are recorded.

        gRun_EndUser_PostAcqAnalysis = True     ' if true, then run EndUser_PostAcqAnalysis()
        '                                         at the end of the digitization.  This is an
        '                                         end user routine that processes the resulting data

        gRun_EndUser_SegmentProcessor = False   ' if true, then run EndUser_SegmentProcessor()
        '                                         while data is being digitized.  This is an end
        '                                         user routine that processes little segments of data.

        gCopyChannelsFromNetworkPage = True     ' true if we are to copy the Enabled channels
        '                                         in the Network page to rebuild the Digitize
        '                                         list, after the user closed the Network Window.

        gWaitTillDigitizationCompletes = False  ' If true, then DigitizeProcess_Start() waits for
        '                                         the entire digitization to complete; otherwise,
        '                                         the Timer control triggers the servicing of the
        '                                         digitize buffers, every 200ms or so, while digitizing.

        ' -------------------------------------------------------------
        ' Set the timing parameters

        Call DigitizeProcess_SetTimingParams(gPtsPerScan_nextDigi, gNumScans, _
            gSampleRate_nextDigi, gContinuousScans, gProcessSegmentsInsteadOfScans, _
            gRun_EndUser_PostAcqAnalysis, gRun_EndUser_SegmentProcessor, _
            gCopyChannelsFromNetworkPage, gWaitTillDigitizationCompletes)

        ' -------------------------------------------------------------
        ' Declare the "StartStopButton" button and the "DigitizeProcess" Timer.

        Call DigitizeProcess_SetControlItems(StartStopButton)

        ' -------------------------------------------------------------
        ' SETUP BOX(0) TO SHOW ALL DIGITIZED CHANNELS IN ONE BOX.

        ' Create 1x DisplayBox (this corresponds to a VB PictureBox object on
        ' the FORM w/ name "_Box_0" and index = 0). We set up this box with
        ' horiz/vertical scrollbars.  As you enable channels for digitizing
        ' in the instruNet World NETWORK window (i.e. CHANNELS button on this form),
        ' it will add a corresponding Display to this _Box_0 DisplayBox.

        Call Add_One_DisplayBox_To_Window(_Box_0, hPos_scroll(0), vPos_scroll(0), _
            EndUser_Window.DefInstance, "Time Waveforms", hAutoAddTimeWaves, gEndUser_GRAPHICS)

        ' Add 1 marker to Box(0).
        Add_One_Marker_To_OneBox(0)

        ' -------------------------------------------------------------
        ' Redraw the screen.

        Call Redraw_AllBoxes(gEndUser_GRAPHICS)

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                           END USER DIGITIZE/DATA MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SegmentProcessor()
    '
    ' PURPOSE    Process incoming digitized data, while it is being digitized.  This
    '            is called for each segment of data is pulled from each channel.
    '
    ' PARAMs     cNum: Digitize Channel number {0..numChannels-1} (from DigitizeList)
    '            segmentStart_ptNum: first ptNum {0..numValidPts} for the recently digitized segment
    '            segmentEnd_ptNum: last ptNum {0..numValidPts} for the recently digitized segment
    '            scanNumberToPull_base1: scan number, base 1, of the recently digitized segment
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_SegmentProcessor(ByVal cNum As Short, ByVal segmentStart_ptNum As Integer, _
        ByVal segmentEnd_ptNum As Integer, ByVal scanNumberToPull_base1 As Integer)

        ' -------------------------------------------------------------------------------------
        ' If there are no points here, bail out, gsw 2/24/03

        Dim numOfPtsInSegment As Integer = 1 + segmentEnd_ptNum - segmentStart_ptNum

        If (numOfPtsInSegment <= 0) Then Exit Sub

        ' -------------------------------------------------------------------------------------
        ' Please see EndUser_SegmentProcessor() in file EndUser Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_PostAcqAnalysis()
    '
    ' PURPOSE    Process incoming digitized data, after the digitization stops.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_PostAcqAnalysis()

        ' Please see EndUser_PostAcqAnalysis() in file EndUser Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SaveLoadResults()
    '
    ' PURPOSE    Save or Load end user data when the user presses the Save or Load buttons.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_SaveLoadResults(ByRef sPathName As String, ByVal saveOrLoad As Short)

        ' Please see EndUser_SaveLoadResults() in file EndUser Scope.vb
        ' for an example of how to do this.

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   DigitizeProcess_Tick()
    '
    ' PURPOSE    Timer control calls this at a fixed rate.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub DigitizeProcess_Tick(ByVal myObject As Object, ByVal myEventArgs As EventArgs)

        METHOD_DigitizeProcess_Timer(myObject, myEventArgs)

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                       RESPOND TO a BUTTON CLICK AT TOP OF WINDOW
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   Channels_Button_Click()
    '
    ' PURPOSE    Called when end user presses the CHANNELS button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Channels_Button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Channels_Button.Click

        ' Open the instruNet World NETWORK window
        ' to allow the user to set up channels.
        METHOD_Channels_Button_Click()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Help_button_Click()
    '
    ' PURPOSE    Called when end user presses the HELP button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Help_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Help_button.Click

        ' Show the instruNet help text, which is stored in the file listed below

        Call TextWindow.DefInstance.OpenTextWindow( _
            "c:\Program files\instruNet\Programming Interfaces\Visual Basic .Net\Working with Visual BASIC .Net.txt", _
            "VB Help", False)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   StartStopButton_Click()
    '
    ' PURPOSE    Called when end user presses the START/STOP button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub StartStopButton_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles StartStopButton.Click

        ' Handle the event
        Call METHOD_StartStopButton_Click()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Load_button_Click()
    '
    ' PURPOSE    Called when end user presses the LOAD data & channel settings button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Load_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles load_button.Click

        ' Load instruNet data via the File Open dialog.
        Call SaveOrLoad_DataAndState(True, iLoad, True, True, True, True, True, gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Save_button_Click()
    '
    ' PURPOSE    Called when end user presses the SAVE data button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Save_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Save_button.Click

        ' Save instruNet data via the File Save dialog.
        Call SaveOrLoad_DataAndState(True, iSave, True, True, True, True, True, gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Setup_Button_Click()
    '
    ' PURPOSE    Called when end user presses the SETUP data button. We respond by
    '            opening the instruNet NETWORK window, where one can set up channels.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Setup_Button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Setup_Button.Click

        ' Show the instruNet Setup dialog box. This also reset the hScales and 
        ' redraws the display boxes w/ the new hScales.
        instruNet_Setup_Dialog.DefInstance.ShowDialog()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Print_button_Click()
    '
    ' PURPOSE    Called when end user presses the PRINT data button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Print_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Print_button.Click

        ' Handle the Event and print all Display Boxes, print 1 pg per displayBox.
        Call METHOD_Print_All_DisplayBoxes_Button()

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                           WINDOW OPEN/CLOSE/REDRAW/RESIZE MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Activated()
    '
    ' PURPOSE    OS calls this routine when End User Window is activated (clicked on
    '            to bring to front). At this point, our window needs to go 
    '            live (handle mouse events) and needs to be redrawn.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Activated(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Activated

        ' redraw entire window
        Redraw_AllBoxes(gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_REDRAW()
    '
    ' PURPOSE    OS calls this routine when a dialog box was covering the End User window,
    '            yet was recently moved and the OS is telling us we need to redraw our window.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_REDRAW(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

        ' redraw entire window
        Redraw_AllBoxes(gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_RESIZE()
    '
    ' PURPOSE    OS calls this routine when a end user window is Resized. Respond by
    '            Recalculating all DisplayBoxes and all Displays enclosed within them.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_RESIZE(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.EventArgs) Handles MyBase.Resize

        ' If the Graphics record is not up yet...
        If IsNothing(gEndUser_GRAPHICS) Then Exit Sub

        ' We must delete the Graphics Record and Create a new one
        ' to make sure that it's VisibleClipBounds is updated to the 
        ' new Form size (not sure why we need to do this manually like this).
        gEndUser_GRAPHICS.Dispose()
        gEndUser_GRAPHICS = MyBase.CreateGraphics

        ' Recalculates all x/y coordinates for All Displays within All DisplayBoxes.  
        ' This is useful after end user has Resized the main window (i.e. VB Form).
        DisplayBox_All_Recalculate(gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Load()
    '
    ' PURPOSE    Called when End User window is 1st opened.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Load(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        ' Start the program
        EndUser_StartProgram()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Exit_button_Click()
    '
    ' PURPOSE    Called when end user presses the EXIT button.
    '
    '            We tell the OS to close the End User Window (which will
    '            cause EndUser_Window_Closed() to run.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Exit_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Exit_button.Click

        ' Run EndUser_Window.unload() method and close the window.
        EndUser_Window.DefInstance.Close()

        ' End the entire program
        End

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Closed()
    '
    ' PURPOSE    Called AFTER the End User window has been closed.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Closed(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Closed

        ' End instruNet-based program, and close instruNet driver
        EndProgram_iNet("")

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                                   SCROLL BAR/MOUSE DOWN MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Form_MouseDown()
    '
    ' PURPOSE    Handles mouse down in a end user window.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Form_MouseDown(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown

        ' Handle the event and move the marker to the mouse
        ' down location within the display.
        Call METHOD_Form_MouseDown(eventSender, eventArgs)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_scroll_Change()
    '
    ' PURPOSE    Update horizontal position for this DispBox.
    '            Invoked by key down in Horiz scrollbar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_scroll_Change(ByRef Index As Short, ByVal newScrollValue As Integer)

        ' Handle the Event
        Call METHOD_hPos_scroll_Change(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_scroll_KeyDown()
    '
    ' PURPOSE    Update horizontal position for this DispBox.
    '            Invoked by key down in Horiz scrollbar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_scroll_KeyDown(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles hPos_scroll.KeyDown

        Dim KeyCode As Short = eventArgs.KeyCode
        Dim Shift As Short = eventArgs.KeyData \ &H10000
        Dim Index As Short = hPos_scroll.GetIndex(eventSender)

        ' Handle the Event
        Call METHOD_hPos_scroll_KeyDown(Index, KeyCode, Shift)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_scroll_Scroll()
    '
    ' PURPOSE    Update horizontal position for this DispBox.
    '            Invoked by mouse down in Horiz scrollbar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_scroll_Scroll(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles hPos_scroll.Scroll

        Dim Index As Short = hPos_scroll.GetIndex(eventSender)

        Select Case eventArgs.Type

            Case System.Windows.Forms.ScrollEventType.EndScroll
                hPos_scroll_Change(Index, eventArgs.NewValue)

        End Select

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_increment_Click()
    '
    ' PURPOSE    Increment horizontal scale (e.g. ms/div).
    '            Invoked by a CLICK on the hPos_increment button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_increment_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles hPos_increment.Click

        Dim Index As Short = hPos_increment.GetIndex(eventSender)

        ' Handle the event.
        METHOD_hPos_increment_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_decrement_Click()
    '
    ' PURPOSE    Decrement horizontal scale (e.g. ms/div).
    '            Invoked by a Click on hPos_decrement button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_decrement_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles hPos_decrement.Click

        Dim Index As Short = hPos_decrement.GetIndex(eventSender)

        ' Handle the event
        METHOD_hPos_decrement_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_increment_Click()
    '
    ' PURPOSE    Decrement vertical position of display.
    '            Invoked by a Click on vPos_decrement button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_decrement_Click(ByVal eventSender As System.Object, _
            ByVal eventArgs As System.EventArgs) Handles vPos_decrement.Click

        Dim Index As Short = vPos_decrement.GetIndex(eventSender)

        ' handle the event
        METHOD_vPos_decrement_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_increment_Click()
    '
    ' PURPOSE    Increment vertical position of display.
    '            Invoked by a Click on vPos_increment button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_increment_Click(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.EventArgs) Handles vPos_increment.Click

        Dim Index As Short = vPos_increment.GetIndex(eventSender)

        ' handle the event
        METHOD_vPos_increment_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_scroll_Change()
    '
    ' PURPOSE    Update vertical position of a display.
    '            Invoked by the change of the Vertical Scroll bar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_scroll_Change(ByRef Index As Short, ByVal newScrollValue As Integer)

        ' Handle the event
        Call METHOD_vPos_scroll_Change(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_scroll_KeyDown()
    '
    ' PURPOSE    Update vertical position of a display.
    '            Handle a key down in the vPos scroll bar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_scroll_KeyDown(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles vPos_scroll.KeyDown

        Dim KeyCode As Short = eventArgs.KeyCode
        Dim Shift As Short = eventArgs.KeyData \ &H10000
        Dim Index As Short = vPos_scroll.GetIndex(eventSender)

        ' Handle the event
        Call METHOD_vPos_scroll_KeyDown(Index, KeyCode, Shift)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_scroll_Scroll()
    '
    ' PURPOSE    Update vertical position of a display.
    '            Handle Mouse Draggin in the vPos scroll bar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_scroll_Scroll(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles vPos_scroll.Scroll

        Dim Index As Short = vPos_scroll.GetIndex(eventSender)

        Select Case eventArgs.Type
            Case System.Windows.Forms.ScrollEventType.EndScroll
                vPos_scroll_Change(Index, eventArgs.NewValue)
        End Select
    End Sub

End Class