' ====================================================================================
' FORM:     EndUser Scope.vb
'
'           This example emulates an oscilloscope or strip chart recorded. It uses
'           the instruNet Display routines to build the displays.
'
' HISTORY   6/6/02   updated to be compatible with Visual Studio (Visual Basic) .Net v7
' ====================================================================================

Option Strict Off
Option Explicit On 

' -------------------------------------------------------------------------
' CLASS     EndUser_Window
'
' EndUser_Window is a CLASS created by the end user that contains
' a window (i.e. Visual Basic FORM) and several callback functions:
' EndUser_SegmentProcessor(), EndUser_SaveLoadResults(), EndUser_PostAcqAnalysis()
'
Friend Class EndUser_Window

    ' This class includes a Visual Basic FORM (i.e. window)
    Inherits System.Windows.Forms.Form

    ' -------------------------------------------------------------
    ' Visual Studio generated the following code based on the
    ' dialog box graphical set up.
    '
#Region "Windows Form Designer generated code "

    ' -------------------------------------------------------------------------
    ' FUNCTION    New() - Windows Form Designer generated code
    '
    ' PURPOSE     This is the New() method, which is generated by the windows
    '             Form Designer utility.  This code sets up the dialog and
    '             sets the attributes of the various fields.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
    Public Sub New()
        MyBase.New()
        If m_vb6FormDefInstance Is Nothing Then
            If m_InitializingDefInstance Then
                m_vb6FormDefInstance = Me
            Else
                Try
                    'For the start-up form, the first instance created is the default instance.
                    If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
                        m_vb6FormDefInstance = Me
                    End If
                Catch
                End Try
            End If
        End If
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub


    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub


    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public WithEvents _vPos_increment_2 As System.Windows.Forms.Button
    Public WithEvents _vPos_decrement_2 As System.Windows.Forms.Button
    Public WithEvents _Box_2 As System.Windows.Forms.PictureBox
    Public WithEvents _vPos_scroll_2 As System.Windows.Forms.VScrollBar
    Public WithEvents _hPos_scroll_2 As System.Windows.Forms.HScrollBar
    Public WithEvents _hPos_decrement_2 As System.Windows.Forms.Button
    Public WithEvents _hPos_increment_2 As System.Windows.Forms.Button
    Public WithEvents Help_button As System.Windows.Forms.Button
    Public WithEvents _hPos_increment_1 As System.Windows.Forms.Button
    Public WithEvents _hPos_decrement_1 As System.Windows.Forms.Button
    Public WithEvents _hPos_scroll_1 As System.Windows.Forms.HScrollBar
    Public WithEvents Exit_button As System.Windows.Forms.Button
    Public WithEvents Print_button As System.Windows.Forms.Button
    Public WithEvents Channels_Button As System.Windows.Forms.Button
    Public WithEvents Setup_Button As System.Windows.Forms.Button
    Public WithEvents load_button As System.Windows.Forms.Button
    Public WithEvents Save_button As System.Windows.Forms.Button
    Public WithEvents StartStopButton As System.Windows.Forms.Button
    Public WithEvents _vPos_scroll_1 As System.Windows.Forms.VScrollBar
    Public WithEvents _vPos_decrement_0 As System.Windows.Forms.Button
    Public WithEvents _Box_1 As System.Windows.Forms.PictureBox
    Public WithEvents _hPos_increment_0 As System.Windows.Forms.Button
    Public WithEvents _hPos_decrement_0 As System.Windows.Forms.Button
    Public WithEvents _vPos_scroll_0 As System.Windows.Forms.VScrollBar
    Public WithEvents _hPos_scroll_0 As System.Windows.Forms.HScrollBar
    Public WithEvents _Box_0 As System.Windows.Forms.PictureBox
    Public WithEvents _vPos_decrement_1 As System.Windows.Forms.Button
    Public WithEvents _vPos_increment_1 As System.Windows.Forms.Button
    Public WithEvents Notes As System.Windows.Forms.TextBox
    Public WithEvents _vPos_increment_0 As System.Windows.Forms.Button
    Public WithEvents Box As Microsoft.VisualBasic.Compatibility.VB6.PictureBoxArray
    Public WithEvents hPos_decrement As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents hPos_increment As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents hPos_scroll As Microsoft.VisualBasic.Compatibility.VB6.HScrollBarArray
    Public WithEvents vPos_decrement As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents vPos_increment As Microsoft.VisualBasic.Compatibility.VB6.ButtonArray
    Public WithEvents vPos_scroll As Microsoft.VisualBasic.Compatibility.VB6.VScrollBarArray


    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me._vPos_increment_2 = New System.Windows.Forms.Button()
        Me._vPos_decrement_2 = New System.Windows.Forms.Button()
        Me._Box_2 = New System.Windows.Forms.PictureBox()
        Me._vPos_scroll_2 = New System.Windows.Forms.VScrollBar()
        Me._hPos_scroll_2 = New System.Windows.Forms.HScrollBar()
        Me._hPos_decrement_2 = New System.Windows.Forms.Button()
        Me._hPos_increment_2 = New System.Windows.Forms.Button()
        Me.Help_button = New System.Windows.Forms.Button()
        Me._hPos_increment_1 = New System.Windows.Forms.Button()
        Me._hPos_decrement_1 = New System.Windows.Forms.Button()
        Me._hPos_scroll_1 = New System.Windows.Forms.HScrollBar()
        Me.Exit_button = New System.Windows.Forms.Button()
        Me.Print_button = New System.Windows.Forms.Button()
        Me.Channels_Button = New System.Windows.Forms.Button()
        Me.Setup_Button = New System.Windows.Forms.Button()
        Me.load_button = New System.Windows.Forms.Button()
        Me.Save_button = New System.Windows.Forms.Button()
        Me.StartStopButton = New System.Windows.Forms.Button()
        Me._vPos_scroll_1 = New System.Windows.Forms.VScrollBar()
        Me._vPos_decrement_0 = New System.Windows.Forms.Button()
        Me._Box_1 = New System.Windows.Forms.PictureBox()
        Me._hPos_increment_0 = New System.Windows.Forms.Button()
        Me._hPos_decrement_0 = New System.Windows.Forms.Button()
        Me._vPos_scroll_0 = New System.Windows.Forms.VScrollBar()
        Me._hPos_scroll_0 = New System.Windows.Forms.HScrollBar()
        Me._Box_0 = New System.Windows.Forms.PictureBox()
        Me._vPos_decrement_1 = New System.Windows.Forms.Button()
        Me._vPos_increment_1 = New System.Windows.Forms.Button()
        Me.Notes = New System.Windows.Forms.TextBox()
        Me._vPos_increment_0 = New System.Windows.Forms.Button()
        Me.Box = New Microsoft.VisualBasic.Compatibility.VB6.PictureBoxArray(Me.components)
        Me.hPos_decrement = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.hPos_increment = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.hPos_scroll = New Microsoft.VisualBasic.Compatibility.VB6.HScrollBarArray(Me.components)
        Me.vPos_decrement = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.vPos_increment = New Microsoft.VisualBasic.Compatibility.VB6.ButtonArray(Me.components)
        Me.vPos_scroll = New Microsoft.VisualBasic.Compatibility.VB6.VScrollBarArray(Me.components)
        CType(Me.Box, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.hPos_decrement, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.hPos_increment, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.hPos_scroll, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.vPos_decrement, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.vPos_increment, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.vPos_scroll, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        '_vPos_increment_2
        '
        Me._vPos_increment_2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_increment_2.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_increment_2.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_increment_2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_increment_2.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_increment.SetIndex(Me._vPos_increment_2, CType(2, Short))
        Me._vPos_increment_2.Location = New System.Drawing.Point(726, 269)
        Me._vPos_increment_2.Name = "_vPos_increment_2"
        Me._vPos_increment_2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_increment_2.Size = New System.Drawing.Size(17, 17)
        Me._vPos_increment_2.TabIndex = 29
        Me._vPos_increment_2.Text = "+"
        '
        '_vPos_decrement_2
        '
        Me._vPos_decrement_2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_decrement_2.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_decrement_2.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_decrement_2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_decrement_2.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_decrement.SetIndex(Me._vPos_decrement_2, CType(2, Short))
        Me._vPos_decrement_2.Location = New System.Drawing.Point(726, 285)
        Me._vPos_decrement_2.Name = "_vPos_decrement_2"
        Me._vPos_decrement_2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_decrement_2.Size = New System.Drawing.Size(17, 17)
        Me._vPos_decrement_2.TabIndex = 28
        Me._vPos_decrement_2.Text = "--"
        '
        '_Box_2
        '
        Me._Box_2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._Box_2.BackColor = System.Drawing.Color.White
        Me._Box_2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me._Box_2.Cursor = System.Windows.Forms.Cursors.Cross
        Me._Box_2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._Box_2.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Box.SetIndex(Me._Box_2, CType(2, Short))
        Me._Box_2.Location = New System.Drawing.Point(432, 269)
        Me._Box_2.Name = "_Box_2"
        Me._Box_2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._Box_2.Size = New System.Drawing.Size(294, 145)
        Me._Box_2.TabIndex = 27
        Me._Box_2.TabStop = False
        '
        '_vPos_scroll_2
        '
        Me._vPos_scroll_2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_scroll_2.Cursor = System.Windows.Forms.Cursors.Default
        Me.vPos_scroll.SetIndex(Me._vPos_scroll_2, CType(2, Short))
        Me._vPos_scroll_2.LargeChange = 5000
        Me._vPos_scroll_2.Location = New System.Drawing.Point(726, 301)
        Me._vPos_scroll_2.Maximum = 37766
        Me._vPos_scroll_2.Name = "_vPos_scroll_2"
        Me._vPos_scroll_2.Size = New System.Drawing.Size(17, 113)
        Me._vPos_scroll_2.SmallChange = 1000
        Me._vPos_scroll_2.TabIndex = 26
        Me._vPos_scroll_2.TabStop = True
        '
        '_hPos_scroll_2
        '
        Me._hPos_scroll_2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_scroll_2.Cursor = System.Windows.Forms.Cursors.Default
        Me.hPos_scroll.SetIndex(Me._hPos_scroll_2, CType(2, Short))
        Me._hPos_scroll_2.LargeChange = 5000
        Me._hPos_scroll_2.Location = New System.Drawing.Point(432, 413)
        Me._hPos_scroll_2.Maximum = 37766
        Me._hPos_scroll_2.Name = "_hPos_scroll_2"
        Me._hPos_scroll_2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_scroll_2.Size = New System.Drawing.Size(246, 18)
        Me._hPos_scroll_2.SmallChange = 1000
        Me._hPos_scroll_2.TabIndex = 25
        Me._hPos_scroll_2.TabStop = True
        '
        '_hPos_decrement_2
        '
        Me._hPos_decrement_2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_decrement_2.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_decrement_2.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_decrement_2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_decrement_2.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_decrement.SetIndex(Me._hPos_decrement_2, CType(2, Short))
        Me._hPos_decrement_2.Location = New System.Drawing.Point(677, 413)
        Me._hPos_decrement_2.Name = "_hPos_decrement_2"
        Me._hPos_decrement_2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_decrement_2.Size = New System.Drawing.Size(25, 18)
        Me._hPos_decrement_2.TabIndex = 24
        Me._hPos_decrement_2.Text = "<"
        '
        '_hPos_increment_2
        '
        Me._hPos_increment_2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_increment_2.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_increment_2.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_increment_2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_increment_2.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_increment.SetIndex(Me._hPos_increment_2, CType(2, Short))
        Me._hPos_increment_2.Location = New System.Drawing.Point(701, 413)
        Me._hPos_increment_2.Name = "_hPos_increment_2"
        Me._hPos_increment_2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_increment_2.Size = New System.Drawing.Size(25, 18)
        Me._hPos_increment_2.TabIndex = 23
        Me._hPos_increment_2.Text = ">"
        '
        'Help_button
        '
        Me.Help_button.BackColor = System.Drawing.SystemColors.Control
        Me.Help_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Help_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Help_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Help_button.Location = New System.Drawing.Point(472, 0)
        Me.Help_button.Name = "Help_button"
        Me.Help_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Help_button.Size = New System.Drawing.Size(81, 25)
        Me.Help_button.TabIndex = 22
        Me.Help_button.Text = "Help"
        '
        '_hPos_increment_1
        '
        Me._hPos_increment_1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_increment_1.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_increment_1.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_increment_1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_increment_1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_increment.SetIndex(Me._hPos_increment_1, CType(1, Short))
        Me._hPos_increment_1.Location = New System.Drawing.Point(701, 253)
        Me._hPos_increment_1.Name = "_hPos_increment_1"
        Me._hPos_increment_1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_increment_1.Size = New System.Drawing.Size(25, 18)
        Me._hPos_increment_1.TabIndex = 21
        Me._hPos_increment_1.Text = ">"
        '
        '_hPos_decrement_1
        '
        Me._hPos_decrement_1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_decrement_1.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_decrement_1.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_decrement_1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_decrement_1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_decrement.SetIndex(Me._hPos_decrement_1, CType(1, Short))
        Me._hPos_decrement_1.Location = New System.Drawing.Point(677, 253)
        Me._hPos_decrement_1.Name = "_hPos_decrement_1"
        Me._hPos_decrement_1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_decrement_1.Size = New System.Drawing.Size(25, 18)
        Me._hPos_decrement_1.TabIndex = 20
        Me._hPos_decrement_1.Text = "<"
        '
        '_hPos_scroll_1
        '
        Me._hPos_scroll_1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_scroll_1.Cursor = System.Windows.Forms.Cursors.Default
        Me.hPos_scroll.SetIndex(Me._hPos_scroll_1, CType(1, Short))
        Me._hPos_scroll_1.LargeChange = 5000
        Me._hPos_scroll_1.Location = New System.Drawing.Point(432, 253)
        Me._hPos_scroll_1.Maximum = 37766
        Me._hPos_scroll_1.Name = "_hPos_scroll_1"
        Me._hPos_scroll_1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_scroll_1.Size = New System.Drawing.Size(246, 18)
        Me._hPos_scroll_1.SmallChange = 1000
        Me._hPos_scroll_1.TabIndex = 19
        Me._hPos_scroll_1.TabStop = True
        '
        'Exit_button
        '
        Me.Exit_button.BackColor = System.Drawing.SystemColors.Control
        Me.Exit_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Exit_button.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Exit_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Exit_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Exit_button.Location = New System.Drawing.Point(553, 0)
        Me.Exit_button.Name = "Exit_button"
        Me.Exit_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Exit_button.Size = New System.Drawing.Size(78, 25)
        Me.Exit_button.TabIndex = 15
        Me.Exit_button.Text = "Exit"
        '
        'Print_button
        '
        Me.Print_button.BackColor = System.Drawing.SystemColors.Control
        Me.Print_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Print_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Print_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Print_button.Location = New System.Drawing.Point(392, 0)
        Me.Print_button.Name = "Print_button"
        Me.Print_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Print_button.Size = New System.Drawing.Size(81, 25)
        Me.Print_button.TabIndex = 14
        Me.Print_button.Text = "Print"
        '
        'Channels_Button
        '
        Me.Channels_Button.BackColor = System.Drawing.SystemColors.Control
        Me.Channels_Button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Channels_Button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Channels_Button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Channels_Button.Location = New System.Drawing.Point(152, 0)
        Me.Channels_Button.Name = "Channels_Button"
        Me.Channels_Button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Channels_Button.Size = New System.Drawing.Size(81, 25)
        Me.Channels_Button.TabIndex = 18
        Me.Channels_Button.Text = "Channels"
        '
        'Setup_Button
        '
        Me.Setup_Button.BackColor = System.Drawing.SystemColors.Control
        Me.Setup_Button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Setup_Button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Setup_Button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Setup_Button.Location = New System.Drawing.Point(72, 0)
        Me.Setup_Button.Name = "Setup_Button"
        Me.Setup_Button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Setup_Button.Size = New System.Drawing.Size(81, 25)
        Me.Setup_Button.TabIndex = 11
        Me.Setup_Button.Text = "Setup"
        '
        'load_button
        '
        Me.load_button.BackColor = System.Drawing.SystemColors.Control
        Me.load_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.load_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.load_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.load_button.Location = New System.Drawing.Point(233, 0)
        Me.load_button.Name = "load_button"
        Me.load_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.load_button.Size = New System.Drawing.Size(79, 25)
        Me.load_button.TabIndex = 17
        Me.load_button.Text = "Load"
        '
        'Save_button
        '
        Me.Save_button.BackColor = System.Drawing.SystemColors.Control
        Me.Save_button.Cursor = System.Windows.Forms.Cursors.Default
        Me.Save_button.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Save_button.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Save_button.Location = New System.Drawing.Point(312, 0)
        Me.Save_button.Name = "Save_button"
        Me.Save_button.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Save_button.Size = New System.Drawing.Size(81, 25)
        Me.Save_button.TabIndex = 16
        Me.Save_button.Text = "Save"
        '
        'StartStopButton
        '
        Me.StartStopButton.BackColor = System.Drawing.SystemColors.Control
        Me.StartStopButton.Cursor = System.Windows.Forms.Cursors.Default
        Me.StartStopButton.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.StartStopButton.ForeColor = System.Drawing.SystemColors.ControlText
        Me.StartStopButton.Name = "StartStopButton"
        Me.StartStopButton.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartStopButton.Size = New System.Drawing.Size(73, 25)
        Me.StartStopButton.TabIndex = 13
        Me.StartStopButton.Text = "Start"
        '
        '_vPos_scroll_1
        '
        Me._vPos_scroll_1.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_scroll_1.Cursor = System.Windows.Forms.Cursors.Default
        Me.vPos_scroll.SetIndex(Me._vPos_scroll_1, CType(1, Short))
        Me._vPos_scroll_1.LargeChange = 5000
        Me._vPos_scroll_1.Location = New System.Drawing.Point(726, 60)
        Me._vPos_scroll_1.Maximum = 37766
        Me._vPos_scroll_1.Name = "_vPos_scroll_1"
        Me._vPos_scroll_1.Size = New System.Drawing.Size(17, 193)
        Me._vPos_scroll_1.SmallChange = 1000
        Me._vPos_scroll_1.TabIndex = 4
        Me._vPos_scroll_1.TabStop = True
        '
        '_vPos_decrement_0
        '
        Me._vPos_decrement_0.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_decrement_0.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_decrement_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_decrement_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_decrement_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_decrement.SetIndex(Me._vPos_decrement_0, CType(0, Short))
        Me._vPos_decrement_0.Location = New System.Drawing.Point(416, 40)
        Me._vPos_decrement_0.Name = "_vPos_decrement_0"
        Me._vPos_decrement_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_decrement_0.Size = New System.Drawing.Size(17, 17)
        Me._vPos_decrement_0.TabIndex = 10
        Me._vPos_decrement_0.Text = "--"
        '
        '_Box_1
        '
        Me._Box_1.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._Box_1.BackColor = System.Drawing.Color.White
        Me._Box_1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me._Box_1.Cursor = System.Windows.Forms.Cursors.Cross
        Me._Box_1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._Box_1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Box.SetIndex(Me._Box_1, CType(1, Short))
        Me._Box_1.Location = New System.Drawing.Point(432, 24)
        Me._Box_1.Name = "_Box_1"
        Me._Box_1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._Box_1.Size = New System.Drawing.Size(294, 230)
        Me._Box_1.TabIndex = 8
        Me._Box_1.TabStop = False
        '
        '_hPos_increment_0
        '
        Me._hPos_increment_0.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_increment_0.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_increment_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_increment_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_increment_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_increment.SetIndex(Me._hPos_increment_0, CType(0, Short))
        Me._hPos_increment_0.Location = New System.Drawing.Point(392, 413)
        Me._hPos_increment_0.Name = "_hPos_increment_0"
        Me._hPos_increment_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_increment_0.Size = New System.Drawing.Size(25, 18)
        Me._hPos_increment_0.TabIndex = 7
        Me._hPos_increment_0.Text = ">"
        '
        '_hPos_decrement_0
        '
        Me._hPos_decrement_0.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_decrement_0.BackColor = System.Drawing.SystemColors.Control
        Me._hPos_decrement_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._hPos_decrement_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._hPos_decrement_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.hPos_decrement.SetIndex(Me._hPos_decrement_0, CType(0, Short))
        Me._hPos_decrement_0.Location = New System.Drawing.Point(368, 413)
        Me._hPos_decrement_0.Name = "_hPos_decrement_0"
        Me._hPos_decrement_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_decrement_0.Size = New System.Drawing.Size(25, 18)
        Me._hPos_decrement_0.TabIndex = 6
        Me._hPos_decrement_0.Text = "<"
        '
        '_vPos_scroll_0
        '
        Me._vPos_scroll_0.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_scroll_0.Cursor = System.Windows.Forms.Cursors.Default
        Me.vPos_scroll.SetIndex(Me._vPos_scroll_0, CType(0, Short))
        Me._vPos_scroll_0.LargeChange = 5000
        Me._vPos_scroll_0.Location = New System.Drawing.Point(416, 56)
        Me._vPos_scroll_0.Maximum = 37766
        Me._vPos_scroll_0.Name = "_vPos_scroll_0"
        Me._vPos_scroll_0.Size = New System.Drawing.Size(17, 358)
        Me._vPos_scroll_0.SmallChange = 1000
        Me._vPos_scroll_0.TabIndex = 5
        Me._vPos_scroll_0.TabStop = True
        '
        '_hPos_scroll_0
        '
        Me._hPos_scroll_0.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._hPos_scroll_0.Cursor = System.Windows.Forms.Cursors.Default
        Me.hPos_scroll.SetIndex(Me._hPos_scroll_0, CType(0, Short))
        Me._hPos_scroll_0.LargeChange = 5000
        Me._hPos_scroll_0.Location = New System.Drawing.Point(0, 413)
        Me._hPos_scroll_0.Maximum = 37766
        Me._hPos_scroll_0.Name = "_hPos_scroll_0"
        Me._hPos_scroll_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._hPos_scroll_0.Size = New System.Drawing.Size(369, 18)
        Me._hPos_scroll_0.SmallChange = 1000
        Me._hPos_scroll_0.TabIndex = 3
        Me._hPos_scroll_0.TabStop = True
        '
        '_Box_0
        '
        Me._Box_0.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me._Box_0.BackColor = System.Drawing.Color.White
        Me._Box_0.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me._Box_0.Cursor = System.Windows.Forms.Cursors.Cross
        Me._Box_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._Box_0.ForeColor = System.Drawing.Color.FromArgb(CType(128, Byte), CType(128, Byte), CType(128, Byte))
        Me.Box.SetIndex(Me._Box_0, CType(0, Short))
        Me._Box_0.Location = New System.Drawing.Point(0, 24)
        Me._Box_0.Name = "_Box_0"
        Me._Box_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._Box_0.Size = New System.Drawing.Size(417, 390)
        Me._Box_0.TabIndex = 2
        Me._Box_0.TabStop = False
        '
        '_vPos_decrement_1
        '
        Me._vPos_decrement_1.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_decrement_1.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_decrement_1.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_decrement_1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_decrement_1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_decrement.SetIndex(Me._vPos_decrement_1, CType(1, Short))
        Me._vPos_decrement_1.Location = New System.Drawing.Point(726, 43)
        Me._vPos_decrement_1.Name = "_vPos_decrement_1"
        Me._vPos_decrement_1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_decrement_1.Size = New System.Drawing.Size(17, 17)
        Me._vPos_decrement_1.TabIndex = 1
        Me._vPos_decrement_1.Text = "--"
        '
        '_vPos_increment_1
        '
        Me._vPos_increment_1.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_increment_1.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_increment_1.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_increment_1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_increment_1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_increment.SetIndex(Me._vPos_increment_1, CType(1, Short))
        Me._vPos_increment_1.Location = New System.Drawing.Point(726, 26)
        Me._vPos_increment_1.Name = "_vPos_increment_1"
        Me._vPos_increment_1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_increment_1.Size = New System.Drawing.Size(17, 17)
        Me._vPos_increment_1.TabIndex = 0
        Me._vPos_increment_1.Text = "+"
        '
        'Notes
        '
        Me.Notes.AcceptsReturn = True
        Me.Notes.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.Notes.AutoSize = False
        Me.Notes.BackColor = System.Drawing.SystemColors.Window
        Me.Notes.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Notes.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.Notes.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Notes.ForeColor = System.Drawing.SystemColors.WindowText
        Me.Notes.Location = New System.Drawing.Point(0, 428)
        Me.Notes.MaxLength = 0
        Me.Notes.Multiline = True
        Me.Notes.Name = "Notes"
        Me.Notes.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Notes.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.Notes.Size = New System.Drawing.Size(745, 142)
        Me.Notes.TabIndex = 12
        Me.Notes.Text = ""
        '
        '_vPos_increment_0
        '
        Me._vPos_increment_0.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
        Me._vPos_increment_0.BackColor = System.Drawing.SystemColors.Control
        Me._vPos_increment_0.Cursor = System.Windows.Forms.Cursors.Default
        Me._vPos_increment_0.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._vPos_increment_0.ForeColor = System.Drawing.SystemColors.ControlText
        Me.vPos_increment.SetIndex(Me._vPos_increment_0, CType(0, Short))
        Me._vPos_increment_0.Location = New System.Drawing.Point(416, 24)
        Me._vPos_increment_0.Name = "_vPos_increment_0"
        Me._vPos_increment_0.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me._vPos_increment_0.Size = New System.Drawing.Size(17, 17)
        Me._vPos_increment_0.TabIndex = 9
        Me._vPos_increment_0.Text = "+"
        '
        'hPos_decrement
        '
        '
        'hPos_increment
        '
        '
        'hPos_scroll
        '
        '
        'vPos_decrement
        '
        '
        'vPos_increment
        '
        '
        'vPos_scroll
        '
        '
        'EndUser_Window
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.CancelButton = Me.Exit_button
        Me.ClientSize = New System.Drawing.Size(742, 570)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me._vPos_increment_2, Me._vPos_decrement_2, Me._Box_2, Me._vPos_scroll_2, Me._hPos_scroll_2, Me._hPos_decrement_2, Me._hPos_increment_2, Me.Help_button, Me._hPos_increment_1, Me._hPos_decrement_1, Me._hPos_scroll_1, Me.Exit_button, Me.Print_button, Me.Channels_Button, Me.Setup_Button, Me.load_button, Me.Save_button, Me.StartStopButton, Me._vPos_scroll_1, Me._vPos_decrement_0, Me._Box_1, Me._hPos_increment_0, Me._hPos_decrement_0, Me._vPos_scroll_0, Me._hPos_scroll_0, Me._Box_0, Me._vPos_decrement_1, Me._vPos_increment_1, Me.Notes, Me._vPos_increment_0})
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ForeColor = System.Drawing.Color.FromArgb(CType(128, Byte), CType(128, Byte), CType(255, Byte))
        Me.MaximumSize = New System.Drawing.Size(10000, 10000)
        Me.MinimumSize = New System.Drawing.Size(400, 300)
        Me.Name = "EndUser_Window"
        Me.ShowInTaskbar = False
        Me.Text = "instruNet Scope"
        CType(Me.Box, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.hPos_decrement, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.hPos_increment, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.hPos_scroll, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.vPos_decrement, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.vPos_increment, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.vPos_scroll, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub
#End Region

    ' -------------------------------------------------------------------------
    ' FUNCTION    Defines several properties to be used with the dialog.
    '
    ' PURPOSE     This was generated by the VS 7 Upgrade Wizard.
    '
    ' HISTORY     6/5/02 Updated for Visual Basic 7, gsw
    ' -------------------------------------------------------------------------
#Region "Upgrade Support "
    Private Shared m_vb6FormDefInstance As EndUser_Window
    Private Shared m_InitializingDefInstance As Boolean
    Public Shared Property DefInstance() As EndUser_Window
        Get
            If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
                m_InitializingDefInstance = True
                m_vb6FormDefInstance = New EndUser_Window()
                m_InitializingDefInstance = False
            End If
            DefInstance = m_vb6FormDefInstance
        End Get
        Set(ByVal Value As EndUser_Window)
            m_vb6FormDefInstance = Value
        End Set
    End Property
#End Region

    ' -------------------------------------------------------------------------
    ' Gobal Variables -- used to hold analysis results

    Dim gAnalysis_Min() As Double
    Dim gAnalysis_Max() As Double
    Dim gAnalysis_Min_PtNum() As Double
    Dim gAnalysis_Max_PtNum() As Double

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_StartProgram()
    '
    ' PURPOSE    Called when window is 1st opened. This routine sets up the displays
    '            and the channels being digitized.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Sub EndUser_StartProgram()

        ' -------------------------------------------------------------
        ' INITIALIZE UTILITY CODE
        '
        ' Load instruNet Driver and Initialize VB interface utilities

        Call Initialize_instruNet_MAIN(Me, EndUser_Window.DefInstance, _
           wJumpIntoDemoModeIfNoDeviceExists)

        ' Establish that Print_to_TextBox() commands will write to our Form's "Notes" TextBox 
        Setup_TextBox(Notes)

        ' -------------------------------------------------------------
        ' INITIALIZE PARAMETERS

        gNumScans = 1                             ' # of scans to digitize

        gPtsPerScan_nextDigi = 10000              ' points per scan per channel

        gSampleRate_nextDigi = 1000               ' sample rate per channel (pts/sec)

        gContinuousScans = False                  ' if true, we run with scans that are continous
        '                                           in time; otherwise, we retrigger for each

        gProcessSegmentsInsteadOfScans = True     ' if false, we process a scan when it has finished
        '                                           digitizing; otherwise, we process little segments
        '                                           as they are recorded.

        gRun_EndUser_PostAcqAnalysis = True       ' if true, then run EndUser_PostAcqAnalysis()
        '                                           at the end of the digitization.  This is an
        '                                           end user routine that processes the resulting dat

        gRun_EndUser_SegmentProcessor = True      ' if true, then run EndUser_SegmentProcessor()
        '                                           while data is being digitized.  This is an end
        '                                           user routine that processes little segments of data.

        gCopyChannelsFromNetworkPage = False      ' true if we are to copy the Enabled channels
        '                                           in the Network page to rebuild the Digitize
        '                                           list, after the user closed the Network Window.

        gWaitTillDigitizationCompletes = False    ' If true, then DigitizeProcess_Start() waits for
        '                                           the entire digitization to complete; otherwise,
        '                                           the Timer control triggers the servicing of the
        '                                           digitize buffers, every 200ms or so, while digitizing.

        ' -------------------------------------------------------------
        ' Set the timing parameters

        Call DigitizeProcess_SetTimingParams(gPtsPerScan_nextDigi, gNumScans, _
            gSampleRate_nextDigi, gContinuousScans, gProcessSegmentsInsteadOfScans, _
            gRun_EndUser_PostAcqAnalysis, gRun_EndUser_SegmentProcessor, _
            gCopyChannelsFromNetworkPage, gWaitTillDigitizationCompletes)

        ' -------------------------------------------------------------
        ' Declare the "StartStopButton" button and the "DigitizeProcess" Timer.

        Call DigitizeProcess_SetControlItems(StartStopButton)

        ' -------------------------------------------------------------
        ' Set up all displays from scratch.

        Setup_All_Displays_From_Scratch()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Setup_All_Displays_From_Scratch()
    '
    ' PURPOSE    Sets up all displays from scratch.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Sub Setup_All_Displays_From_Scratch()

        Dim ptsPerXunit As Double
        Dim numCalculatedMagnitudes, power As Integer

        ' -------------------------------------------------------------
        ' Reset the # of DisplayBoxes to 0; and reset the Digitize List to 0

        ' Reset # of DisplayBoxes to 0
        ReDim gBox(0)
        gNumBoxes = 0

        ' Resets the number of items in the list to 0
        DigitizeList_ResetList()

        ' -------------------------------------------------------------
        ' DEFINE DIGITIZE CHANNELS
        '
        ' Specify channels to be digitized (i.e. Ch1 Vin+ and Ch4 Vin+).

        ' Add Ch1 Vin+ to List of channels to digitize.  This will be digiChan #0.
        '
        ' We set massageType to {jNoMassage, jFFTMassage} to specify that the
        ' digitized data is to be received as a timewave or fft wave.
        If DigitizeList_AddOneItem(1, 1, 1, 1, jNoMassage, True) = False Then EndProgram_iNet("")

        ' Add Ch4 Vin+ to List of channels to digitize.  This will be digiChan #1.
        If DigitizeList_AddOneItem(1, 1, 1, 4, jNoMassage, True) = False Then EndProgram_iNet("")

        ' Measure actual sample rate = function( gSampleRate_nextDigi, channels )
        gSampleRate_nextDigi = DigitizeProcess_MeasureActualSampleRate()

        ' -------------------------------------------------------------
        ' SETUP BOX(0) TO SHOW ALL DIGITIZED CHANNELS IN ONE BOX.

        ' Create 2x DisplayBoxes (this corresponds to a PictureBox object on
        ' the front panel w/ the name "Box" and index = 0.
        ' Setup Box(0) w/ horiz/vertical scrollbars. "_Box_0" is a picture box
        ' object that resides on the Window.
        Call Add_One_DisplayBox_To_Window(_Box_0, hPos_scroll(0), _
            vPos_scroll(0), EndUser_Window.DefInstance, "Time Waveforms", _
            hAutoAddNone, gEndUser_GRAPHICS)

        ' Add 1 marker to Box(0).
        Add_One_Marker_To_OneBox(0)

        ' Add 2 Displays to Box(0) and attach these to digitize channels
        ' DigiChan(0 to 1) into Box(0).
        Call Add_DigitizeChannels_To_OneBox(0, 0, 1, kYindexDisplay, gEndUser_GRAPHICS)

        ' -------------------------------------------------------------
        ' SETUP BOX(1) TO SHOW AN FFT OF DIGITIZE CHANNEL#0
        '
        ' We are going to fill this Box with 1 Display that contains
        ' an fft of digitizeChannel#0.
        '
        ' We do this with the user defined EndUser_SegmentProcessor()
        ' analysis routine, which is automatically called every time a little
        ' segment is digitized.

        ' Setup Box(1) w/ horiz/vertical scrollbars. "_Box_1" is a picture box
        ' object that resides on the Window.
        Call Add_One_DisplayBox_To_Window(_Box_1, hPos_scroll(1), _
            vPos_scroll(1), EndUser_Window.DefInstance, _
            "Frequency Waveforms", hAutoAddNone, gEndUser_GRAPHICS)

        ' Add 1 marker to Box(1)
        Add_One_Marker_To_OneBox(1)

        ' calc the # of pts (numPts = 2 ^ power)
        power = Int(System.Math.Log(gPtsPerScan_nextDigi) / System.Math.Log(2))

        ' calc the # of resulting freq amplitude points
        numCalculatedMagnitudes = (2 ^ power) / 2

        ' update the pts-per Hz unit (we are plotting amplitudes vs. Hz).
        ptsPerXunit = numCalculatedMagnitudes / (gSampleRate_currentData / 2)

        ' Add a display to Box(1), that has it's own local data.
        Call Add_NonDigitizeDisplay_To_OneBox(1, kYindexDisplay, _
            numCalculatedMagnitudes, gPtsPerScan_nextDigi, _
            ptsPerXunit, "fft", gEndUser_GRAPHICS)

        ' -------------------------------------------------------------
        ' SETUP BOX(2) TO SHOW AN X vs Y GRAPH OF DIGITIZE CHANNEL#0 & CHANNEL#1
        '
        ' We are going to fill this Box with 1 Display that contains
        ' an x vs y plot of digitizeChannel#0 vs digitizeChannel#1.
        '
        ' We do this with the user defined EndUser_SegmentProcessor()
        ' analysis routine, which is automatically called every time a little

        ' Setup Box(2) w/ horiz/vertical scrollbars.  "_Box_2" is a picture box
        ' object that resides on the Window.
        Call Add_One_DisplayBox_To_Window(_Box_2, hPos_scroll(2), _
            vPos_scroll(2), EndUser_Window.DefInstance, "XY Display", _
            hAutoAddNone, gEndUser_GRAPHICS)

        ' Add a display to Box(2).
        Call Add_NonDigitizeDisplay_To_OneBox(2, kXYDisplay, _
            gPtsPerScan_nextDigi, gPtsPerScan_nextDigi, gSampleRate_nextDigi, _
            "xy", gEndUser_GRAPHICS)

        ' -------------------------------------------------------------
        ' Redraw the screen.

        Call Redraw_AllBoxes(gEndUser_GRAPHICS)

    End Sub

    ' ====================================================================================
    ' ====================================================================================
    '
    '                           END USER DIGITIZE/DATA MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SegmentProcessor()
    '
    ' PURPOSE    Process incoming digitized data, while it is being digitized.  This
    '            is called for each segment of data is pulled from each channel.
    '
    ' PARAMs     cNum: Digitize Channel number {0..numChannels-1} (from DigitizeList)
    '            segmentStart_ptNum: first ptNum {0..numValidPts} for the recently digitized segment
    '            segmentEnd_ptNum: last ptNum {0..numValidPts} for the recently digitized segment
    '            scanNumberToPull_base1: scan number, base 1, of the recently digitized segment
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_SegmentProcessor( _
        ByVal cNum As Short, _
        ByVal segmentStart_ptNum As Integer, _
        ByVal segmentEnd_ptNum As Integer, _
        ByVal scanNumberToPull_base1 As Integer)

        Dim ptNum, lastTime_ptNum, power As Integer
        Dim numCalculatedMagnitudes, bNum, dNum As Integer

        ' -------------------------------------------------------------------------------------
        ' If there are no points here, bail out, gsw 2/24/03

        Dim numOfPtsInSegment As Integer = 1 + segmentEnd_ptNum - segmentStart_ptNum

        If (numOfPtsInSegment <= 0) Then Exit Sub

        ' ------------------------------------------------------------------
        ' FFT OF DIGITIZE CHANNEL#0 (Ch1 Vin+) INTO BOX(1).

        ' if this is a segment of data from Digitize Chan#0...
        If (cNum = 0) Then

            ' if this segment pulled to the end of the scan...
            If (segmentEnd_ptNum = (gPtsPerScan_currentData - 1)) Then

                ' we'll place the data into Box(1), Display(0)
                bNum = 1
                dNum = 0

                ' with the data array attached to this Display...
                With gBox(bNum).disp(dNum).dataArrayY

                    ' calc the # of pts (numPts = 2 ^ power)
                    power = Int(System.Math.Log(gSegmentEnd_ptNum + 1) / System.Math.Log(2))
                    lastTime_ptNum = (2 ^ power) - 1

                    ' Make sure the data buffers are long enough, sssssssssss
                    If (.data.Length < (lastTime_ptNum - 1)) Then EndProgram_iNet("disp Buffer too short")
                    If (gDigiChan(cNum).dataArrayY.data.Length < (lastTime_ptNum - 1)) Then EndProgram_iNet("digi Buffer too short")

                    ' Copy the time data into the buffer used by the display, which is not
                    ' attached to a digitize channel -- it is more independent.
                    For ptNum = 0 To lastTime_ptNum
                        .data(ptNum) = gDigiChan(cNum).dataArrayY.data(ptNum)
                    Next ptNum

                    ' Do an fft on the digitize data, in place; and update
                    ' the data array's numValidPts/ptsPerXunit fields.
                    Call FFT_DataArray(gBox(bNum).disp(dNum).dataArrayY, power, _
                        numCalculatedMagnitudes, gSampleRate_currentData)

                    ' Set the pts-per-hScale (based on the sample rate of the data).
                    Call hScale_SetPtsPerHscale_OneDisp(bNum, dNum, .ptsPerXunit)

                    ' Clear the plot region
                    Call Plot_Clear_OneDisp(bNum, dNum, gEndUser_GRAPHICS)

                    ' Draw the grid.
                    Call Grid_Draw_OneDisp(bNum, dNum, gBox(bNum), gBox(bNum).disp(dNum), gEndUser_GRAPHICS)

                    ' Plot entire display, from left to right edges.
                    Call Plot_Segment_OneDisp(bNum, dNum, gBox(bNum), gBox(bNum).disp(dNum), 0, _
                        (gDigiChan(cNum).dataArrayY.numValidPts - 1), gEndUser_GRAPHICS)

                End With

            End If

        End If

        ' ------------------------------------------------------------------
        ' XY PLOT OF DIGITIZE CHANNEL#0 & #1 INTO BOX(2).

        ' if this is a segment of data from Digitize Chan#1...
        If (cNum = 1) Then

            ' we'll place the data into Box(2), Display(1)
            bNum = 2
            dNum = 0

            ' with this Display...
            With gBox(bNum).disp(dNum)

                ' if we are starting out..
                If segmentStart_ptNum = 0 Then
                    ReDim .dataArrayX.data(gPtsPerScan_currentData + 2)
                    ReDim .dataArrayY.data(gPtsPerScan_currentData + 2)
                    .dataArrayX.numBufferPts = gPtsPerScan_currentData
                    .dataArrayY.numBufferPts = gPtsPerScan_currentData
                End If

                ' Copy the digitize data into the display data buffers
                For ptNum = segmentStart_ptNum To segmentEnd_ptNum
                    .dataArrayX.data(ptNum) = gDigiChan(0).dataArrayY.data(ptNum)
                    .dataArrayY.data(ptNum) = gDigiChan(1).dataArrayY.data(ptNum)
                    .dataArrayX.numValidPts = segmentEnd_ptNum
                    .dataArrayY.numValidPts = segmentEnd_ptNum
                Next ptNum

                ' if this is the beginning of the scan, then clear the plot region
                If segmentStart_ptNum = 0 Then

                    ' Clear the plot region
                    Call Plot_Clear_OneDisp(bNum, dNum, gEndUser_GRAPHICS)

                    ' Draw the grid.
                    Call Grid_Draw_OneDisp(bNum, dNum, gBox(bNum), gBox(bNum).disp(dNum), gEndUser_GRAPHICS)

                End If

                ' Plot the segment
                Call Plot_Segment_OneDisp(bNum, dNum, gBox(bNum), gBox(bNum).disp(dNum), _
                    segmentStart_ptNum, segmentEnd_ptNum, gEndUser_GRAPHICS)

            End With

        End If

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_PostAcqAnalysis()
    '
    ' PURPOSE    Process incoming digitized data, after the digitization stops.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_PostAcqAnalysis()

        ' Calculate Statistics on Waveform and place into the text region on the screen.
        Call EndUser_Calculations()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Calculations()
    '
    ' PURPOSE    Calculate Statistics on Waveform and place into the text region on the screen.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Calculations()

        Dim dataValue, dataMax_yEu, dataMin_yEu As Single
        Dim dataMax_ptNum, dataMin_ptNum, lastValid_ptNum, cNum, ptNum As Integer
        Dim nameStr As String

        ' Initialize arrays to hold waveform statistics results.  'gNumDigiCh'
        ' is the # of channels that we have enabled for digitizing.
        ReDim gAnalysis_Min(gNumDigiCh)
        ReDim gAnalysis_Max(gNumDigiCh)
        ReDim gAnalysis_Min_PtNum(gNumDigiCh)
        ReDim gAnalysis_Max_PtNum(gNumDigiCh)

        ' calculate min/max statistics on all digitized waves
        For cNum = 0 To (gNumDigiCh - 1)

            ' in data buffer, last valid ptNum
            lastValid_ptNum = gDigiChan(cNum).dataArrayY.numValidPts - 1

            dataMin_yEu = 1.0E+18
            dataMax_yEu = -1.0E+18
            dataMin_ptNum = 0
            dataMax_ptNum = 0

            ' go thru every point in each wave
            For ptNum = 0 To lastValid_ptNum

                ' get data point value
                dataValue = gDigiChan(cNum).dataArrayY.data(ptNum)

                ' calc max
                If dataValue > dataMax_yEu Then
                    dataMax_yEu = dataValue
                    dataMax_ptNum = ptNum
                End If

                ' calc min
                If dataValue < dataMin_yEu Then
                    dataMin_yEu = dataValue
                    dataMin_ptNum = ptNum
                End If

            Next ptNum

            ' remember what we found
            gAnalysis_Min(cNum) = dataMin_yEu
            gAnalysis_Max(cNum) = dataMax_yEu
            gAnalysis_Min_PtNum(cNum) = dataMin_ptNum
            gAnalysis_Max_PtNum(cNum) = dataMax_ptNum

        Next cNum

        ' print the time and date to the Notes TextRegion in the window
        Print_to_TextBox(VB6.Format(Today, "Long Date") & ", " & VB6.Format(TimeOfDay, "hh:mm:ss AMPM"))

        'print channel statistics to text region
        Print_to_TextBox(" Sample Interval = " & Str(gSampleRate_currentData) & " [Hz]")

        ' print the # of data pts collected
        Print_to_TextBox(" Number of Data Points = " & Str(gPtsPerScan_currentData))

        ' print min/max info for each digitized waveform
        For cNum = 0 To (gNumDigiCh - 1)

            ' get the name of the channel
            Call iNet_VB_GetFieldcStr(gDigiChan(cNum), sgt_General, fldNum_General_userName, nameStr)

            Dim chanInfo As String = ""

            ' print channel name
            chanInfo = " Channel#" & Str(cNum) & ", " & nameStr

            ' print max value
            chanInfo = chanInfo + ", Max = " & NumToStr(gAnalysis_Max(cNum))

            ' print min value
            chanInfo = chanInfo + ", Min = " & NumToStr(gAnalysis_Min(cNum))

            ' add a Carriage Return
            Print_to_TextBox(chanInfo)

        Next cNum

        ' add a Carriage Return
        Print_to_TextBox("")

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_SaveLoadResults()
    '
    ' PURPOSE    Save or Load end user data when the user presses the Save or Load buttons.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub EndUser_SaveLoadResults(ByRef sPathName As String, ByVal saveOrLoad As Short)

        Dim dValue As Double
        Dim info As String
        Dim save, hitError, fileNum, cNum, numUnrecognizedLines, numDigiCh As Integer

        ' --------------------------------------------------------------
        ' CREATE or OPEN "\EndUser.dat" FILE

        save = (saveOrLoad = iSave) ' true if we are saving
        hitError = False
        On Error GoTo ErrorHandler

        ' create/open a file and place it in the data folder that we just created.
        fileNum = FreeFile()
        If save Then
            FileOpen(fileNum, (sPathName & "\EndUser.dat"), OpenMode.Output)
        Else
            FileOpen(fileNum, (sPathName & "\EndUser.dat"), OpenMode.Input)
        End If

        If hitError Then Exit Sub

        ' --------------------------------------------------------------
        ' SAVE/LOAD USER INFO
        ' --------------------------------------------------------------

        If save Then ' if saving...

            ' header for this section of data
            WriteLine(fileNum, 0, "EndUser_Start", gNumDigiCh)

            ' scan through all Digitize Channels
            For cNum = 0 To (gNumDigiCh - 1)
                WriteLine(fileNum, cNum, "gAnalysis_Min", gAnalysis_Min(cNum))
                WriteLine(fileNum, cNum, "gAnalysis_Max", gAnalysis_Max(cNum))
                WriteLine(fileNum, cNum, "gAnalysis_Min_PtNum", gAnalysis_Min_PtNum(cNum))
                WriteLine(fileNum, cNum, "gAnalysis_Max_PtNum", gAnalysis_Max_PtNum(cNum))
            Next cNum

            If hitError Then Exit Sub

            ' footer for this section of data
            WriteLine(fileNum, 0, "EndUser_End", 0)

            ' -----------------------------------
        Else ' else, we are loading

            Do  ' load in the DisplayInfo data

                ' load in 1 line of info
                Input(fileNum, cNum)
                Input(fileNum, info)
                Input(fileNum, dValue)

                ' If we do not have a box or display to put the data in, then go to the next
                ' section in the file.
                If (cNum < 0 Or cNum >= gNumDigiCh) Then

                    ' record that we hit an unrecognized line
                    numUnrecognizedLines = numUnrecognizedLines + 1

                    ' bail out of this section if we are at the end
                    If StrComp(info, "EndUser_End") = 0 Then Exit Do

                Else ' else, read this data & place into internal parameters

                    ' if we are at the beginnning, get the # of
                    ' DigitizeChannels, and set the gDigiChan() array
                    ' accordingly.
                    If StrComp(info, "EndUser_Start") = 0 Then

                        numDigiCh = dValue ' # of digitize channels

                        ' Set the size of the array to accomodate the info.
                        ReDim Preserve gAnalysis_Min(numDigiCh)
                        ReDim Preserve gAnalysis_Max(numDigiCh)
                        ReDim Preserve gAnalysis_Min_PtNum(numDigiCh)
                        ReDim Preserve gAnalysis_Max_PtNum(numDigiCh)

                    End If

                    If StrComp(info, "EndUser_End") = 0 Then
                        Exit Do
                    ElseIf StrComp(info, "EndUser_Start") = 0 Then
                        dValue = dValue * 1 ' this was handled above

                    ElseIf StrComp(info, "gAnalysis_Min") = 0 Then
                        gAnalysis_Min(cNum) = dValue
                    ElseIf StrComp(info, "gAnalysis_Max") = 0 Then
                        gAnalysis_Max(cNum) = dValue
                    ElseIf StrComp(info, "gAnalysis_Min_PtNum") = 0 Then
                        gAnalysis_Min_PtNum(cNum) = dValue
                    ElseIf StrComp(info, "gAnalysis_Max_PtNum") = 0 Then
                        gAnalysis_Max_PtNum(cNum) = dValue

                    Else
                        numUnrecognizedLines = numUnrecognizedLines + 1
                    End If

                End If

            Loop While Not (EOF(fileNum))

        End If

        ' --------------------------------------------------------------
        ' CLOSE FILE

        ' close the open file
        FileClose(fileNum)
        If hitError Then Exit Sub

        ' --------------------------------------------------------------
        ' Exit

        If (numUnrecognizedLines > 0) Then
            MsgBox("We hit " & Str(numUnrecognizedLines) & " lines of unrecognized End User data.")
        End If

        Exit Sub ' end of this subroutine

        ' --------------------------------------------------------------
        ' Handle file I/O error case.

ErrorHandler:

        If (hitError = False) Then MsgBox(Err.Description) ' show msg about error

        hitError = True

        Resume

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   DigitizeProcess_Tick()
    '
    ' PURPOSE    Timer control calls this at a fixed rate.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Public Sub DigitizeProcess_Tick(ByVal myObject As Object, ByVal myEventArgs As EventArgs)

        METHOD_DigitizeProcess_Timer(myObject, myEventArgs)

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                       RESPOND TO a BUTTON CLICK AT TOP OF WINDOW
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   Channels_Button_Click()
    '
    ' PURPOSE    Called when end user presses the CHANNELS button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Channels_Button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Channels_Button.Click

        ' Open the instruNet World NETWORK window
        ' to allow the user to set up channels.
        METHOD_Channels_Button_Click()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Help_button_Click()
    '
    ' PURPOSE    Called when end user presses the HELP button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Help_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Help_button.Click

        ' Show the instruNet help text, which is stored in the file listed below

        Call TextWindow.DefInstance.OpenTextWindow( _
            "c:\Program files\instruNet\Programming Interfaces\Visual Basic .Net\Working with Visual BASIC .Net.txt", _
            "VB Help", False)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   StartStopButton_Click()
    '
    ' PURPOSE    Called when end user presses the START/STOP button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub StartStopButton_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles StartStopButton.Click

        ' Handle the event
        Call METHOD_StartStopButton_Click()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Load_button_Click()
    '
    ' PURPOSE    Called when end user presses the LOAD data & channel settings button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Load_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles load_button.Click

        ' Load instruNet data via the File Open dialog.
        Call SaveOrLoad_DataAndState(True, iLoad, True, True, True, True, True, gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Save_button_Click()
    '
    ' PURPOSE    Called when end user presses the SAVE data button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Save_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Save_button.Click

        ' Save instruNet data via the File Save dialog.
        Call SaveOrLoad_DataAndState(True, iSave, True, True, True, True, True, gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Setup_Button_Click()
    '
    ' PURPOSE    Called when end user presses the SETUP data button. We respond by
    '            opening the instruNet NETWORK window, where one can set up channels.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Setup_Button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Setup_Button.Click

        ' Show the instruNet Setup dialog box. This also reset the hScales and 
        ' redraws the display boxes w/ the new hScales.
        instruNet_Setup_Dialog.DefInstance.ShowDialog()

        ' Set up all displays from scratch.  Displays will be set up 
        ' with the parameters from the SETUP dialog that just closed.
        ' (e.g. # of pts in NonDigitize data() arrays inside
        ' displays, such as the FFT wave and the xy Display x wave)
        Setup_All_Displays_From_Scratch()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Print_button_Click()
    '
    ' PURPOSE    Called when end user presses the PRINT data button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Print_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Print_button.Click

        ' Print all DisplayBoxes, 1 printed page per displayBox
        Call METHOD_Print_All_DisplayBoxes_Button()

    End Sub


    ' ====================================================================================
    ' ====================================================================================
    '
    '                                 WINDOW OPEN/CLOSE MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Activated()
    '
    ' PURPOSE    OS calls this routine when End User Window is activated (clicked on
    '            to bring to front). At this point, our window needs to go 
    '            live (handle mouse events) and needs to be redrawn.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Activated(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Activated

        ' redraw entire window
        Redraw_AllBoxes(gEndUser_GRAPHICS)

    End Sub

    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_REDRAW()
    '
    ' PURPOSE    OS calls this routine when a dialog box was covering the End User window,
    '            yet was recently moved and the OS is telling us we need to redraw our window.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_REDRAW(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

        ' redraw entire window
        Redraw_AllBoxes(gEndUser_GRAPHICS) ' redraw entire window

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_RESIZE()
    '
    ' PURPOSE    OS calls this routine when a end user window is Resized. Respond by
    '            Recalculating all DisplayBoxes and all Displays enclosed within them.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_RESIZE(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.EventArgs) Handles MyBase.Resize

        ' If the Graphics record is not up yet...
        If IsNothing(gEndUser_GRAPHICS) Then Exit Sub

        ' We must delete the Graphics Record and Create a new one
        ' to make sure that it's VisibleClipBounds is updated to the 
        ' new Form size (not sure why we need to do this manually like this).
        gEndUser_GRAPHICS.Dispose()
        gEndUser_GRAPHICS = MyBase.CreateGraphics

        ' Recalculates all x/y coordinates for All Displays within All DisplayBoxes.  
        ' This is useful after end user has Resized the main window (i.e. VB Form).
        DisplayBox_All_Recalculate(gEndUser_GRAPHICS)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Load()
    '
    ' PURPOSE    Called when End User window is 1st opened.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Load(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        ' Start the program
        EndUser_StartProgram()

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Exit_button_Click()
    '
    ' PURPOSE    Called when end user presses the EXIT button.
    '
    '            We tell the OS to close the End User Window (which will
    '            cause EndUser_Window_Closed() to run.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Exit_button_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles Exit_button.Click

        ' Run EndUser_Window.unload() method and close the window.
        EndUser_Window.DefInstance.Close()

        ' End the entire program
        End

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   EndUser_Window_Closed()
    '
    ' PURPOSE    Called AFTER the End User window has been closed.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub EndUser_Window_Closed(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles MyBase.Closed

        ' End instruNet-based program, and close instruNet driver
        EndProgram_iNet("")

    End Sub



    ' ====================================================================================
    ' ====================================================================================
    '
    '                                   SCROLL BAR/MOUSE DOWN MANAGEMENT
    '
    ' ====================================================================================
    ' ====================================================================================


    '-------------------------------------------------------------------------------------
    ' FUNCTION   Form_MouseDown()
    '
    ' PURPOSE    Handles mouse down in a end user window.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub Form_MouseDown(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown

        ' Handle the event and move the marker to the mouse
        ' down location within the display.
        Call METHOD_Form_MouseDown(eventSender, eventArgs)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_scroll_Change()
    '
    ' PURPOSE    Update horizontal position for this DispBox.
    '            Invoked by key down in Horiz scrollbar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_scroll_Change(ByRef Index As Short, ByVal newScrollValue As Integer)

        ' Handle the Event
        Call METHOD_hPos_scroll_Change(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_scroll_KeyDown()
    '
    ' PURPOSE    Update horizontal position for this DispBox.
    '            Invoked by key down in Horiz scrollbar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_scroll_KeyDown(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles hPos_scroll.KeyDown

        Dim KeyCode As Short = eventArgs.KeyCode
        Dim Shift As Short = eventArgs.KeyData \ &H10000
        Dim Index As Short = hPos_scroll.GetIndex(eventSender)

        ' Handle the Event
        Call METHOD_hPos_scroll_KeyDown(Index, KeyCode, Shift)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_scroll_Scroll()
    '
    ' PURPOSE    Update horizontal position for this DispBox.
    '            Invoked by mouse down in Horiz scrollbar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_scroll_Scroll(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles hPos_scroll.Scroll

        Dim Index As Short = hPos_scroll.GetIndex(eventSender)

        Select Case eventArgs.Type

            Case System.Windows.Forms.ScrollEventType.EndScroll
                hPos_scroll_Change(Index, eventArgs.NewValue)

        End Select

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_increment_Click()
    '
    ' PURPOSE    Increment horizontal scale (e.g. ms/div).
    '            Invoked by a CLICK on the hPos_increment button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_increment_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles hPos_increment.Click

        Dim Index As Short = hPos_increment.GetIndex(eventSender)

        ' Handle the event.
        METHOD_hPos_increment_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   hPos_decrement_Click()
    '
    ' PURPOSE    Decrement horizontal scale (e.g. ms/div).
    '            Invoked by a Click on hPos_decrement button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub hPos_decrement_Click(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.EventArgs) Handles hPos_decrement.Click

        Dim Index As Short = hPos_decrement.GetIndex(eventSender)

        ' Handle the event
        METHOD_hPos_decrement_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_increment_Click()
    '
    ' PURPOSE    Decrement vertical position of display.
    '            Invoked by a Click on vPos_decrement button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_decrement_Click(ByVal eventSender As System.Object, _
            ByVal eventArgs As System.EventArgs) Handles vPos_decrement.Click

        Dim Index As Short = vPos_decrement.GetIndex(eventSender)

        ' handle the event
        METHOD_vPos_decrement_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_increment_Click()
    '
    ' PURPOSE    Increment vertical position of display.
    '            Invoked by a Click on vPos_increment button.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_increment_Click(ByVal eventSender As System.Object, _
         ByVal eventArgs As System.EventArgs) Handles vPos_increment.Click

        Dim Index As Short = vPos_increment.GetIndex(eventSender)

        ' handle the event
        METHOD_vPos_increment_Click(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_scroll_Change()
    '
    ' PURPOSE    Update vertical position of a display.
    '            Invoked by the change of the Vertical Scroll bar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_scroll_Change(ByRef Index As Short, ByVal newScrollValue As Integer)

        ' Handle the event
        Call METHOD_vPos_scroll_Change(Index)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_scroll_KeyDown()
    '
    ' PURPOSE    Update vertical position of a display.
    '            Handle a key down in the vPos scroll bar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_scroll_KeyDown(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles vPos_scroll.KeyDown

        Dim KeyCode As Short = eventArgs.KeyCode
        Dim Shift As Short = eventArgs.KeyData \ &H10000
        Dim Index As Short = vPos_scroll.GetIndex(eventSender)

        ' Handle the event
        Call METHOD_vPos_scroll_KeyDown(Index, KeyCode, Shift)

    End Sub


    '-------------------------------------------------------------------------------------
    ' FUNCTION   vPos_scroll_Scroll()
    '
    ' PURPOSE    Update vertical position of a display.
    '            Handle Mouse Draggin in the vPos scroll bar.
    '
    ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    '-------------------------------------------------------------------------------------
    Private Sub vPos_scroll_Scroll(ByVal eventSender As System.Object, _
        ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles vPos_scroll.Scroll

        Dim Index As Short = vPos_scroll.GetIndex(eventSender)

        Select Case eventArgs.Type
            Case System.Windows.Forms.ScrollEventType.EndScroll
                vPos_scroll_Change(Index, eventArgs.NewValue)
        End Select
    End Sub


    ' OLD:  '-------------------------------------------------------------------------------------
    ' OLD:  ' FUNCTION   Box_MouseDown()
    ' OLD:  '
    ' OLD:  ' PURPOSE    Handles mouse down in a display box.
    ' OLD:  '
    ' OLD:  ' HISTORY    6/5/02 - updated to Visual Basic 7 - gsw
    ' OLD:  '-------------------------------------------------------------------------------------
    ' OLD:  Private Sub Box_MouseDown(ByVal eventSender As System.Object, _
    ' OLD:       ByVal eventArgs As System.Windows.Forms.MouseEventArgs) Handles _Box_1.MouseDown
    ' OLD:  
    ' OLD:      Dim Button As Short = eventArgs.Button \ &H100000
    ' OLD:       Dim Shift As Short = System.Windows.Forms.Control.ModifierKeys \ &H10000
    ' OLD:       Dim x As Single = VB6.PixelsToTwipsX(eventArgs.X)
    ' OLD:       Dim Y As Single = VB6.PixelsToTwipsY(eventArgs.Y)
    ' OLD:      Dim Index As Short = Box.GetIndex(eventSender)
    ' OLD:  
    ' OLD:       ' Handle the event and move the marker to the mouse
    ' OLD:       ' down location within the display.
    ' OLD:      Call METHOD_Box_MouseDown(Index, Button, Shift, x, Y)
    ' OLD:  
    ' OLD:   End Sub
    ' OLD:  
    ' OLD:    Private Sub _Box_1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _Box_1.Click
    ' OLD:        vPos_scroll_Change(0, 0)
    ' OLD:    End Sub


End Class