VERSION 4.00
Begin VB.Form EndUser_Window 
   Caption         =   "instruNet To Excel Control Panel"
   ClientHeight    =   780
   ClientLeft      =   1110
   ClientTop       =   5640
   ClientWidth     =   7440
   Height          =   1185
   Left            =   1050
   LinkTopic       =   "Form1"
   ScaleHeight     =   780
   ScaleWidth      =   7440
   Top             =   5295
   Width           =   7560
   Begin VB.Timer DigitizeProcess 
      Left            =   6600
      Top             =   -240
   End
   Begin VB.CommandButton SetupHelp 
      Caption         =   "Help"
      Height          =   375
      Left            =   1320
      TabIndex        =   6
      Top             =   240
      Width           =   1095
   End
   Begin VB.CommandButton LoadSetup 
      Caption         =   "Load"
      Height          =   375
      Left            =   5040
      TabIndex        =   5
      Top             =   240
      Width           =   1095
   End
   Begin VB.CommandButton SaveSetup 
      Caption         =   "Save"
      Height          =   375
      Left            =   6120
      TabIndex        =   4
      Top             =   240
      Width           =   1095
   End
   Begin VB.CommandButton SetupButton 
      Caption         =   "Setup"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   240
      Width           =   1095
   End
   Begin VB.CommandButton SetupChannels 
      Caption         =   "Channels"
      Height          =   375
      Left            =   3960
      TabIndex        =   1
      Top             =   240
      Width           =   1095
   End
   Begin VB.CommandButton StartStopButton 
      Caption         =   "Start"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1095
   End
   Begin VB.Frame SetupFrame 
      Caption         =   "Setup"
      Height          =   735
      Left            =   2760
      TabIndex        =   7
      Top             =   0
      Width           =   4575
   End
   Begin VB.Frame Frame1 
      Caption         =   "Control"
      Height          =   735
      Left            =   120
      TabIndex        =   8
      Top             =   0
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   15
      Left            =   1560
      TabIndex        =   2
      Top             =   720
      Width           =   15
   End
End
Attribute VB_Name = "EndUser_Window"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' Global variables
Dim weHaveASpreadSheet As Boolean
Dim objExcel As Object





' Sets up 1 Excel spreadsheet and gets ready for digitization.
Sub SetupOneExcelSpreadsheet(ByRef objExcel As Object)

    ' ----------------------------------------------------------
    ' LOCAL VARIABLES
    
    Dim e As Integer
    Dim cNum As Integer
    Dim arg_VB_string As String
    Dim channelName As String
    
    Dim netNum As Integer
    Dim deviceNum As Integer
    Dim moduleNum As Integer
    Dim chanNum As Integer
    
    ' ----------------------------------------------------------
    ' Write the channel parameter names to the top part of column 1.
    
    objExcel.ActiveCell(3, 1).Select
    objExcel.ActiveCell.Value = "Date & Time"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "ChanName"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "UserName"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "vUnits"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "hUnits"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "PtsPerScan"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "SamplePeriod"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "1stPtTime"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "NetNum"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "DevNum"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "ModuleNum"
    objExcel.ActiveCell.Offset(1, 0).Select
    objExcel.ActiveCell.Value = "ChanNum"
    
    ' select the second cell in the second column to start writing the channel parameter values
    ' for the first channel
    objExcel.ActiveCell.Offset(-11, 1).Select
    
    ' ----------------------------------------------------------
    ' Scan through all channels selected for digitizing.
    
    For cNum = 0 To gNumDigiCh - 1
    
        ' get the channel address, 4/30/97
        Call GetChannelAddress(gDigiChan(cNum), netNum, deviceNum, moduleNum, chanNum)
        
        ' get the current Date and Time and write it to Excel
        objExcel.ActiveCell.Value = Now
        objExcel.ActiveCell.Offset(1, 0).Select
    
       ' get the ChanName for this channel and write it to Excel
        thisFieldExist = iNet_VB_GetFieldcStr(cNum, gDigiChan(), sgt_General, fldNum_General_chanName, channelName)
        objExcel.ActiveCell.Value = channelName
        objExcel.ActiveCell.Offset(1, 0).Select
    
        ' get the UserName for this channel and write it to Excel
        thisFieldExist = iNet_VB_GetFieldcStr(cNum, gDigiChan(), sgt_General, fldNum_General_userName, arg_VB_string)
        objExcel.ActiveCell.Value = arg_VB_string
        objExcel.ActiveCell.Offset(1, 0).Select
    
        ' get the vUnits and write it to Excel
        thisFieldExist = iNet_VB_GetFieldcStr(cNum, gDigiChan(), sgt_General, fldNum_General_unitsLabel, arg_VB_string)
        objExcel.ActiveCell.Value = arg_VB_string
        objExcel.ActiveCell.Offset(1, 0).Select
    
        ' set the hUnits to seconds
        objExcel.ActiveCell.Value = "Seconds"
        objExcel.ActiveCell.Offset(1, 0).Select
        
        ' get the PtsPerScan and write it to Excel
        ptsPerScan = GET_POINTS_PER_SCAN(ByVal netNum)
        objExcel.ActiveCell.Value = ptsPerScan
        objExcel.ActiveCell.Offset(1, 0).Select
    
        ' get the SamplePeriod and write it to Excel
        sampleRate = GET_SAMPLE_RATE_IN_HZ(ByVal netNum)
        objExcel.ActiveCell.Value = sampleRate
        objExcel.ActiveCell.Offset(1, 0).Select
    
        ' get the Starting Time for the first point and write it to Excel
        startTime = GET_START_TIME_IN_SEC(ByVal netNum)
        objExcel.ActiveCell.Value = startTime
        objExcel.ActiveCell.Offset(1, 0).Select
    
        ' write the netnum, devicenum, modulenum and channelnum for this channel to excel
        objExcel.ActiveCell.Value = netNum
        objExcel.ActiveCell.Offset(1, 0).Select
        objExcel.ActiveCell.Value = deviceNum
        objExcel.ActiveCell.Offset(1, 0).Select
        objExcel.ActiveCell.Value = moduleNum
        objExcel.ActiveCell.Offset(1, 0).Select
        objExcel.ActiveCell.Value = chanNum
    
        ' ----------------------------------------------------------
        ' write the channel numbers at the top of the data
        
        If cNum = 0 Then
        
            ' Write "Secs" at the top of the time column
            objExcel.ActiveCell.Offset(1, -1).Select
            objExcel.ActiveCell.Value = "Secs"
            
            ' Move over one cell and write the first channel name
            objExcel.ActiveCell.Offset(0, 1).Select
            objExcel.ActiveCell.Value = channelName
            
        Else
        
            objExcel.ActiveCell.Offset(1, 0).Select
            objExcel.ActiveCell.Value = channelName
            
        End If
        
        ' go to the top of the next column to start writing the next channel parameter values
        objExcel.ActiveCell.Offset(-12, 1).Select
        
    Next cNum

End Sub




' Start the End User program
'
Sub EndUser_StartProgram()
    
    ' -------------------------------------------------------------
    ' INITIALIZE UTILITY CODE
    '
    ' Load instruNet Driver and Initialize VB interface utilities
    
    Call Initialize_instruNet_MAIN(EndUser_Window, wJumpIntoDemoModeIfNoDeviceExists)
           
    ' -------------------------------------------------------------
    ' INITIALIZE DIGITIZING PARAMETERS
    
    gNumScans = 1                           ' # of scans to digitize
    
    gPtsPerScan_nextDigi = 100              ' points per scan per channel
    
    gSampleRate_nextDigi = 1                ' sample rate per channel (pts/sec)
    
    gContinuousScans = False                ' if true, we run with scans that are continous
                                            ' in time; otherwise, we retrigger for each
    
    gProcessSegmentsInsteadOfScans = True   ' if false, we process a scan when it has finished
                                            ' digitizing; otherwise, we process little segments
                                            ' as they are recorded.
    
    gRun_EndUser_PostAcqAnalysis = True     ' if true, then run EndUser_PostAcqAnalysis()
                                            ' at the end of the digitization.  This is an
                                            ' end user routine that processes the resulting data
                                            
    gRun_EndUser_SegmentProcessor = True    ' if true, then run EndUser_SegmentProcessor()
                                            ' while data is being digitized.  This is an end
                                            ' user routine that processes little segments of data.
    
    gCopyChannelsFromNetworkPage = True     ' true if we are to copy the Enabled channels
                                            ' in the Network page to rebuild the Digitize
                                            ' list, after the user closed the Network Window.
    
    gWaitTillDigitizationCompletes = False  ' If true, then DigitizeProcess_Start() waits for
                                            ' the entire digitization to complete; otherwise,
                                            ' the Timer control triggers the servicing of the
                                            ' digitize buffers, every 200ms or so, while digitizing.
                                            
                                            ' Set the digitize parameters
    Call DigitizeProcess_SetTimingParams(gPtsPerScan_nextDigi, gNumScans, _
            gSampleRate_nextDigi, gContinuousScans, gProcessSegmentsInsteadOfScans, _
            gRun_EndUser_PostAcqAnalysis, gRun_EndUser_SegmentProcessor, _
            gCopyChannelsFromNetworkPage, gWaitTillDigitizationCompletes)
    
                                            ' Declares "StartStopButton" button and the
                                            ' "DigitizeProcess" Timer. Pass "Nothing"
                                            ' if there are none
    Call DigitizeProcess_SetControlItems(StartStopButton, DigitizeProcess)
        
End Sub



' Process incoming digitized data, after the digitization stops.
Public Sub EndUser_PostAcqAnalysis()
                          
    ' Please see EndUser_PostAcqAnalysis() in file EndUser_Scope.frm
    ' for an example of how to do this.
                          
End Sub


    
    
' Save or Load end user data when the user presses the Save or Load buttons.
'
Public Sub EndUser_SaveLoadResults( _
    ByRef sPathName As String, _
    ByVal saveOrLoad As Integer)
       
    ' Please see EndUser_SaveLoadResults() in file EndUser_Scope.frm
    ' for an example of how to do this.
    
End Sub



' Process incoming digitized data, while it is being digitized.  This
' is called for each segment of data is pulled from each channel.
'
'   cNum: Digitize Channel number {0..numChannels-1} (from DigitizeList)
'   segmentStart_ptNum: first ptNum {0..numValidPts} for the recently digitized segment
'   segmentEnd_ptNum: last ptNum {0..numValidPts} for the recently digitized segment
'   scanNumberToPull_base1: scan number, base 1, of the recently digitized segment
'
Public Sub EndUser_SegmentProcessor( _
    ByVal cNum As Integer, _
    ByVal segmentStart_ptNum As Long, _
    ByVal segmentEnd_ptNum As Long, _
    ByVal scanNumberToPull_base1 As Long)
       
    Dim ptNum As Long

    ' Transfer a little segment from this channel to Excel.
    For ptNum = segmentStart_ptNum To segmentEnd_ptNum
    
        ' if this is the 1st channel...
        If (cNum = 0) Then
        
            ' Time goes in the first column cells.
            objExcel.Cells(ptNum + 16, 1).Value _
                = (ptNum + 1) / gSampleRate_currentData
        End If
        
        ' Acquired data goes in the other column cells.
        objExcel.Cells(ptNum + 16, cNum + 2).Value = gDigiChan(cNum).dataArrayY.data(ptNum)
    
    Next
   
End Sub


Private Sub DigitizeProcess_Timer()

    ' respond to the periodic interrupt coming
    ' from the front panel timer control, which
    ' tells vb to services the digitize buffers.
    Call METHOD_DigitizeProcess_Timer

End Sub

Private Sub Form_Unload(Cancel As Integer)

  CloseDriverAndReleaseDriverRam    ' close iNet driver

End Sub


Private Sub LoadSetup_Click()

    ' Load instruNet data via the File Open dialog.
    Call SaveOrLoad_DataAndState(True, iLoad, True, True, True, True, True)

End Sub






Private Sub Form_Load()

    ' Start the program and initialize everything.
    Call EndUser_StartProgram

End Sub



Private Sub SaveSetup_Click()

    ' Save instruNet data via the File Save dialog.
    Call SaveOrLoad_DataAndState(True, iSave, True, True, True, True, True)

End Sub


Private Sub SetTrigger_Click()

    ' Open the instruNet World trigger dialog.
    Open_instruNet_Window_VB (iNetCM_OpenWindow_RecTrigger)

End Sub


Private Sub Setup_DragDrop(Source As Control, X As Single, Y As Single)

End Sub


Private Sub SetupButton_Click()

    ' Show the instruNet Setup dialog box, 1=Modal Dialog.
    ' (this also reset the hScales and redraws the display
    ' boxes w/ the new hScales)
    instruNet_Setup_Dialog.Show 1

End Sub

Private Sub SetupChannels_Click()

    ' Open the instruNet World NETWORK window
    ' to allow the user to set up channels.
    METHOD_Channels_Button_Click
 
End Sub

Private Sub SetupHelp_Click()

    ' Show the Direct To Excel Help text
    
    Call TextWindow.OpenTextWindow( _
      "c:\Program files\instruNet\Microsoft Visual BASIC\VB Direct To Excel\Working with Excel.txt", _
      "Direct To Excel Help", False)

End Sub

' User pressed Start button, to initiate digitizing printing to an
' Excel spreadsheet in realtime.
'
Private Sub DirectToExcel_StartDigitizing()

' -----------------------------------------------------------------------
' Make sure channels are selected

Dim message As String
Dim e As Integer

If gNumDigiCh = 0 Then   ' if we have no channels to digitize...
    MsgBox ("No channels have been selected to digitize.  To do this, Press the 'Select Channels' button and select channels as desired.")
    Exit Sub
End If

' -----------------------------------------------------------------------
' Set up Excel

' turn off error handling for the Excel Load
On Error GoTo cannotFindExcelErrorHandler

' Open Excel and create a workbook the first time the program is run.
If weHaveASpreadSheet = False Then

    ' Create the Excel and Excel Workbook objects and the Active sheet
    Set objExcel = CreateObject("Excel.Application")
    objExcel.Application.Workbooks.Add
    objExcel.Application.Visible = True
    weHaveASpreadSheet = True
    
End If

' If the user quits Excel it needs to be launched again and a new
' Workbook needs to be added to it.
If objExcel.Application.Visible = False Then

    Set objExcel = CreateObject("Excel.Application")
    objExcel.Application.Workbooks.Add
    objExcel.Application.Visible = True
    weHaveASpreadSheet = True
    
End If

' Add a new workbook for each data set collected. This is a safety in
' case the current workbook is closed
objExcel.Application.Workbooks.Add

' Create the Excel header file. The header will vary depending
' on the number of channels and the channel settings
Call SetupOneExcelSpreadsheet(objExcel)

' Turn VB error handling back on
On Error GoTo 0

' -----------------------------------------------------------------------
' Tell instruNet to start digitizing,

' select the appropriate cell
objExcel.ActiveCell(13, 0).Select

' start digitizing (the Timer will cause the DigitizeProcess_ServiceIncomingData()
' routine to be called every 200ms or so), and this will process the
' incoming data.  DigitizeProcess_Start() just starts this process.
Call DigitizeProcess_Start

' exit this subroutine
Exit Sub

' ----------------------------------------------------------------
' Handle error case.

' This error handling routine is only used if Excel can't be found
' Release the buffers and put up a message box with the error

cannotFindExcelErrorHandler:
    
    If err.Number <> 0 Then
        MsgBox ("We cannot digitize because we could not find a version of Microsoft Excel on this computer that is compatible with this program (e.g. Excel 8.0).")
    End If
    
End Sub


Private Sub StartStopButton_Click()

    If gCurrentlyDigitizing Then            ' if we are currently digitizing...
        DigitizeProcess_Stop                ' tell instruNet to stop digitizing
    Else                                    ' Else we are not digitizing, and need to
        DirectToExcel_StartDigitizing       ' tell instruNet to start digitizing
    End If

End Sub


