Attribute VB_Name = "Analysis_Utilities"



' Perform a hamming window, fft, and magnitude calculation on the data() array.
' data() must be an existing arrya that is at least (2^power+2) long.
' We return the # of calculated magnidues inside 'numCalculatedMagnitudes'.
'
Public Sub FFT_DataArray( _
    ByRef dataArrayY As DataArrayType, _
    ByVal power As Integer, _
    ByRef numCalculatedMagnitudes As Long, _
    ByVal digitized_sampleRate)
    
    ' calc the # of time pts to do the fft on
    numpts& = 2 ^ power
    
    ' # of complex {real, imaginary} values
    numCalculatedMagnitudes = numpts& / 2
   
    ' this will show an error if the data does not exist
    firstPt! = dataArrayY.data(0)
    lastPt! = dataArrayY.data(numpts& + 1)
    
    ' multiply the time data by a hamming widnow
    ok# = MultiplyArrayByHammWindow_DLL(iNet_Get_VarPtr(dataArrayY.data(0)), power)
    If (ok# = False) Then
        numCalculatedMagnitudes = 0
        Exit Sub
    End If
    
    ' do an fft on the data (we us a version that is compiled C inside
    ' the iNet32.dll).
    Call fft_DLL(iNet_Get_VarPtr(dataArrayY.data(0)), power)
        
    ' calc magnitudes
    Call ComplexToMagnitudes_DLL(iNet_Get_VarPtr(dataArrayY.data(0)), numCalculatedMagnitudes)
    
    ' calc # of pts after the magnitudes
    numRemaingTimePtsAfterFFTdata& = numpts& - numCalculatedMagnitudes
       
    ' update the # of resulting data points
    dataArrayY.numValidPts = numCalculatedMagnitudes
                    
    ' update the pts-per Hz unit (we are plotting amplitudes vs. Hz).
    dataArrayY.ptsPerXunit = numCalculatedMagnitudes / (digitized_sampleRate / 2)

    ' update 1st pt xUnit
    dataArrayY.firstPt_Xunits = 0
    
End Sub

