Attribute VB_Name = "Declaration_Utilities"
'*********************************************************************
'INET_Declarations.Bas
'
'------------------ D O C U  M E N T A T I O N ---------------------------
'
' This iNet Interface file contains many Global Constants
' and must be included in every Visual Basic program that
' accesses iNet hardware
'
'-------------------------  H I S T O R Y --------------------------------
'HISTORY  Copyright c 1994-96 GWI.  All rights reserved.
'4/16/94  created - gsw
'*********************************************************************

'============================ iNetTrue/iNetFalse ============================

Global Const iNetTrue = 1               ' instruNet DLL uses non-zero for TRUE
Global Const iNetFalse = 0              ' instruNet DLL uses 0 for FALSE
                                        ' (VB true/false is similar at -1/0)
                                        
'============================ SettingsTypes ============================
' Types of Settings for each channel.
                        
Global Const sgt_noneFound = -1
Global Const sgt_UnRecognizedType = -2
          
'Vin "Hardware" settingGroupType {sensorType, a/d range, analog lp, function}
Global Const sgt_VinHardware = -3

'Vin "Constants" settingGroupType {Ro,Rshunt,Vexcit,GF,alpha,delta}
Global Const sgt_VinConstants = -4

'8bit Mod 100 Digital I/O settingGroup = {din, dout, direction}
Global Const sgt_Mod100DinDout = -5

'General settingGroupType struct {valueEU, chanName, unitsLabel, userName...}
Global Const sgt_General = -6

'DISPLAY settingGroup = {dispOnOff, dispMaxEU, dispMinEU}
Global Const sgt_Display = -7

'Mapping settingGroup = {Internal1, External1, Internal2, External2}
Global Const sgt_Mapping = -20
                                        
'LOW PASS filter settingGroup type
Global Const sgt_LowPass = -8
                       
'HIGH PASS filter settingGroup type
Global Const sgt_HighPass = -9
                  
'BAND PASS filter settingGroup type
Global Const sgt_BandPass = -10
                        
'BAND STOP filter settingGroup type
Global Const sgt_BandStop = -11
                            
'Timing = {DigitizeOnOff, PtsPerScan, NoOfScans,ContinuousOnOff, SampleRate}
Global Const sgt_Timing = -12

'Trigger = {TriggerMode, ThresholdEu, Slope, PreTrigSec, SrcNet, SrcModule, SrcDevice, SrcChannel}
Global Const sgt_Trigger = -13

'TIMER settingGroup = {functionPop, clkTotalSecs, clkHiSecs,
'measHiOrCyclePop, measResolution, measNumPeriods}
Global Const sgt_Timer = -14
                                        
'Driver Ram Buffer = {DigitizeOnOff, ScanNumIn, PtNumIn..}
Global Const sgt_DriverRamBuffer = -15

'User Ram Buffer = {DigitizeOnOff, userBufferAddr, ptrSize, ScanNumIn, PtNumIn..}
Global Const sgt_UserRamBuffer = -16

'File = {FileName, Command, ScanNumIn, PtNumIn, ScanNumIn ..}
Global Const sgt_File = -17

'RECORD OPTIONS settingGroup = {}
Global Const sgt_RecordOptions = -18

'MASTER DIRECTORY settingGroup = {pathname, command, save/load settings}
Global Const sgt_MasterDirectory = -19
             
'CAL OPTIONS = {CalBtn, CalOnStart, CalOnWarm, AutoCalRate}
 Global Const sgt_CalOptions = -21

'======================== Field Access Intentions ========================

Global Const intention_getValue = 1       'get the value of the field
Global Const intention_setValue = 2       'set the value of the field
Global Const intention_getNameStr = 3     'get name of field (i.e. string)
Global Const intention_getMaxValue = 4    'get maximum value of the field
Global Const intention_getMinValue = 5    'get minimum value of the field
Global Const intention_getUserInterfaceType = 6 'get user interface type {e.g. }
Global Const intention_getDefaultValue = 7      'get the defaultValue of the field
Global Const intention_nativeStorageType = 8    'get the native storageType of the field
Global Const intention_getValueAndPullData = 9  'get the value of the field (USER RAM BUFFER userBufferAddr
                                          'field or DRIVER RAM BUFFER bufferPtr field) and
                                          'also pull data out of the buffer and place
                                          'pointToPullindex'into A, 'numPointsToPull'into B,
                                          'and 'scanNumIn'into C. gsw 11/25/95
'ADMINISTRATIVE
Global Const intention_doNothing = 4000
Global Const intention_DisableAllChannelDigitizing = 4005

'SHOW ALERT UPON ERROR CONTROL
Global Const intention_ShowAlertOnError = 8000
Global Const intention_NoShowAlertOnError = 8001
Global Const intention_GetShowAlertOnErrorStatus = 8002
      
'DETERMINE IF NETWORK ELEMENT EXISTS
Global Const intention_ThisExists_Network = 8003
Global Const intention_ThisExists_Device = 8004
Global Const intention_ThisExists_Module = 8005
Global Const intention_ThisExists_Channel = 8006
Global Const intention_ThisExists_Setting = 8007
Global Const intention_ThisExists_Field = 8008

'INTERROGATE NETWORK
Global Const intention_GetNumNetworks = 8009
Global Const intention_GetNumDevices = 8010
Global Const intention_GetNumModules = 8011
Global Const intention_GetNumChannels = 8012
Global Const intention_GetNumSettings = 8013
Global Const intention_GetNumFields = 8014

'USER INTERFACE
Global Const intention_Get_UI_Catagory = 8017
Global Const intention_Get_NumPopupItems = 8018
Global Const intention_Get_PopupStringArray = 8019
Global Const intention_Get_AddrNamesStringArray = 8020
Global Const intention_GetChannelDirection = 8021

'GET/SET NETWORK STATE
Global Const intention_getHandleToNetworkState = 8022
Global Const intention_setNetworkStateWithHandle = 8023
Global Const intention_disposeOfNetworkState = 8024

'SERVICE THE DIGITIZATON PROCESS
Global Const intention_serviceAllDigitizeBuffers = 8028
Global Const intention_SetUpDigitization = 8044
          
'SHOW PROBE DIALOG
Global Const intention_showProbeDialog_Full = 8031
Global Const intention_showProbeDialog_ChannelAddrOnl = 8032
Global Const intention_showProbeDialog_FieldAddrOnl = 8033
Global Const intention_showProbeDialog_FieldAddrOnly = 8033
Global Const intention_showProbeDialog_fixedChanAddr = 8034
Global Const intention_showProbeDialog_fixedChanAddrAndSettingGp = 8035

' MANAGEMENT
Global Const intention_Set_gClickOnThisWindowToQuitiNet = 8040
Global Const intention_lockInternalMemory = 8041
Global Const intention_unlockInternalMemory = 8042
Global Const intention_SetDemoMode = 8037

'================================== Data Types ===================================

Global Const iNetDT_INT16 = 0      '16bit integer, signed
Global Const iNetDT_INT16bus = 1   '16bit integer, signed; yet data is on a card and
Global Const iNetDT_UINT16 = 2     '16bit integer, unsigned
                                   'must be transferred to with 16bit transfers.

Global Const iNetDT_INT32 = 3      '32bit integer, signed
Global Const iNetDT_UINT32 = 4     '32bit integer, unsigned

Global Const iNetDT_FLT32 = 5      '32bit float (ieee Macintosh format)
Global Const iNetDT_Double = 6     ''double', as determined by the compiler (e.g. flt64, flt80, flt96, flt128)
Global Const iNetDT_INT16comp = 7  '16bit integer, signed; yet compressed in the standard iNet
                                   'iNetDT_INT16comp" manner.
Global Const iNetDT_P_Str15 = 8    'PASCAL Str15 string (15 chars, 0th char is length)
Global Const iNetDT_P_Str255 = 9   'PASCAL Str255 string (255 chars, 0th char is length)
Global Const iNetDT_C_Str15 = 10   'C Str15 string (15 chars, 0x00 terminate)
Global Const iNetDT_C_Str255 = 11  'C Str255 string (255 chars, 0x00 terminate)
 
Global Const iNetDT_READ_ONLY_BIT = 128         'this is ADDED to the iNetDataType value if the
                                                'field is read only.
 
Global Const iNetDataType_MIN = iNetDT_INT16
Global Const iNetDataType_MAX = iNetDT_C_Str255

Global Const iNetDataType_MASK = &H7F           'mask to strip off special on/off bits
                                                '(e.g. iNetDT_READ_ONLY_BIT)

'============================= iNetError error codes =============================

Global Const iNetErr_None = 0                      'no error
Global Const iNetErr_General = 1                   'general error
Global Const iNetErr_ControllerNotInitialized = 2  'InitializeDriverAndControllers_iNet() has not been called
Global Const iNetErr_InitializationFailed = 3      'InitializeDriverAndControllers_iNet was called, yet failed
Global Const iNetErr_DeviceNumOutOfRange = 4       'Device number is out of range (is it connected & powered on?)
Global Const iNetErr_ChannelNumOutOfRange = 5      'Channel number is out of range
Global Const iNetErr_FieldNumOutOfRange = 6        'Field number is out of range
Global Const iNetErr_ControllerNotFound = 7        'iNet Controller not found
Global Const iNetErr_FieldDoesNotExist = 8         '(deviceNum, chanNum, fieldNum) refer to field that
Global Const iNetErr_BadfieldNativeDataType = 9    'bad iNetFieldDataType value
Global Const iNetErr_BadFieldReadType = 10         'bad iNetFieldReadType value
Global Const iNetErr_TimeoutAtReadBegin = 11       'time out at read begin
Global Const iNetErr_TimeoutAtWaitForReadDone = 12 'timeout at wait for read done
Global Const iNetErr_ControllerIsInWeeds = 13      'controller is in the weeds
Global Const iNetErr_illegalDataType = 14          'illegal data type
Global Const iNetErr_FailedCopyDataTest = 15       'failed the CopyWaveData() test
Global Const iNetErr_CompressorHitError = 16       'compressor hit error
Global Const iNetErr_FailedRamTest = 17            'failed board ram test
Global Const iNetErr_RanOutOfMemory = 18           'ran out of memory
Global Const iNetErr_AlertFailed = 19              'the routine that shows an alert failed

'Controller Errors
Global Const iNetErr_CtrlrRomNotBooting = 20
Global Const iNetErr_CtrlrRamNotBooting = 21
Global Const iNetErr_DriverDownloadFailed = 22
Global Const iNetErr_CtrlrRWTestFailed = 23
Global Const iNetErr_InterfaceBlockTestFailed = 24
Global Const iNetErr_IncCounterTestFailed = 25
Global Const iNetErr_EchoCmdToStatusTestFailed = 26
Global Const iNetErr_ControllerBootTestFailed = 27
Global Const iNetErr_ControlleFailedToBoot = 28
Global Const iNetErr_ControllerCmdFailed = 29
 
Global Const iNetErr_GUI = 30

Global Const iNetErr_QSPI_Busy = 31
Global Const iNetErr_QSPI_Halted = 32
Global Const iNetErr_QSPI_ArgOutOfRange = 33
Global Const iNetErr_QSPI_TimeOutErr = 34
Global Const iNetErr_FlakyNetwork = 35

'Driver Errors
Global Const iNetErr_CouldNotLocateDriverFile = 36
Global Const iNetErr_netNumOutOfRange = 37
Global Const iNetErr_SettingGroupNumOutOfRange = 38
Global Const iNetErr_UnitTypeOutOfRange = 39
Global Const iNetErr_DriverDidNotSetErrCode = 40
          
Global Const iNetErr_SettingGroupTypeOutOfRange = 41

'Etc Codes
Global Const iNetErr_ModuleNumOutOfRange = 42
Global Const iNetErr_IntentionNumOutOfRange = 43
Global Const iNetErr_ReadOnlyField = 44
Global Const iNetErr_WriteOnlyField = 45
Global Const iNetErr_FieldValueOutOfRange = 46
Global Const iNetErr_ArgTypeOutOfRange = 47
Global Const iNetErr_BadKeyInFieldHierarchy = 48
Global Const iNetErr_Max_LT_MinInFieldHierarchy = 49
Global Const iNetErr_HierarchyFieldDataInTrouble = 50
Global Const iNetErr_ChannelNameInvalid = 51
Global Const iNetErr_tempUnits_outOfRange = 52
Global Const iNetErr_sensorType_outOfRange = 53

'Digitize Errors.
Global Const iNetErr_CircBufErr = 54
Global Const iNetErr_DataBufferOverflow = 55
Global Const iNetErr_PulledTooMuchOnLastPull = 56

'Filter Error Codes
Global Const ERequired_fbx_DCIIR = 57
Global Const EFreqTooLarge_fx_DCIIR = 58
Global Const EFreqsNotAscending_DCIIR = 59
Global Const ERequired_fx_DCIIR = 60
Global Const ERequired_adelx_DCIIR = 61
Global Const EInvalidArg_DCIIR = 62
Global Const EOrderTooHigh_DCIIR = 63
Global Const EEven_ndeg_DCIIR = 64
Global Const EOrderTooLow_DCIIR = 65
Global Const EActualOrder_DCIIR = 66

'New Error Codes
Global Const iNetErr_InterfaceCompiledBadly = 67
Global Const iNetErr_BadInterfaceKey = 68
Global Const iNetErr_BadAddrPassedToDriver = 69
Global Const iNetErr_BadStaticVarInDriver = 70
Global Const iNetErr_BadIntegerMathInDriver = 71

Global Const iNetErr_BadChannelType = 72
Global Const iNetErr_CppCompilerDidBad = 73
Global Const iNetErr_MemMngr_Failed = 74
Global Const iNetErr_Toolbox_Failed = 75
Global Const iNetErr_CrtRect_Failed = 76
Global Const iNetErr_DlogCode_Failed = 77
Global Const iNetErr_DrvrNeedsFpu_Failed = 78
Global Const iNetErr_iirCode_Failed = 79
Global Const iNetErr_sprintf_Failed = 80

Global Const iNetErr_DigitizeInit = 81
Global Const iNetErr_SPE_off = 82
Global Const iNetErr_Halt_on = 83
Global Const iNetErr_CPTQP_failed_to_clr = 84
Global Const iNetErr_qspiBusyBeforeDigitize = 85
Global Const iNetErr_weAbortedEarly = 86
Global Const iNetErr_CtlrIsBusyDoingSomething = 87
Global Const iNetErr_CtrlDidNotFinishCmd = 88
Global Const iNetErr_CodeGenSegmentError = 89
Global Const iNetErr_CPTQP_is_Bad = 90
Global Const iNetErr_CompilerErr = 91
Global Const iNetErr_DrvrOrUserBufferOverflow = 92
Global Const iNetErr_NonCompatible_OS = 93
Global Const iNetErr_badChanPtsPerScan = 94

'STATUS register error codes.
Global Const iNetErr_StatusRegBase = 10000
Global Const iNetErr_StatusRegEnd = 10255

'Operating System Error (Macintosh or Windows Error)
'iNetError = (OSErr + iNetErr_OsBase)
Global Const iNetErr_OsRegMin = -32000              'min Operating System Error
Global Const iNetErr_OsBase = -16000                'max Operating System Error
Global Const iNetErr_OsRegMax = -1                  'max Operating System Error

'SubErrors
Global Const ioSubNetErr_None = 0
Global Const ioSubNetErr_BadLastRAMAddr = 1
Global Const ioSubNetErr_BadBaseAddr = 2
Global Const ioSubNetErr_FirstRamAddrBad = 3
Global Const ioSubNetErr_FailedFloatTest = 4
Global Const ioSubNetErr_DataLinesBad = 5
Global Const ioSubNetErr_AddrLinesBad = 6
Global Const ioSubNetErr_QuickIOtestFailed = 7
 
'================================== beep signal ====================================

Global Const beepSignal_OS_Version_too_old = 3
Global Const beepSignal_NUM_BEEPS_IF_NO_DRIVER_FILE = 4
Global Const beepSignal_CouldNotShowAn_Alert = 5
Global Const beepSignal_PopupTrouble = 6
Global Const beepSignal_CouldNotLoadRsrc = 7
 
'======================== Types of Controllers ====================================
 
Global Const ctlr_NotIdentified = &H0               'Not yet identified
Global Const ctlr_Nubus = &H1234                    'Nubus (Macintosh only)
Global Const ctlr_PCI = &H1235                      'PCI (Windows or Mac)
Global Const ctlr_Ext_ISA = &H1236                  'Extended ISA
Global Const ctlr_PCMCIA = &H1237                   'PCMCIA (Windows or Mac)
 
'============================= Field Hierarchy Limits =============================

Global Const MAX_NUM_settinggroup_PER_CHANNEL = 32  'max  of settinggroups per CHANNEL
Global Const MIN_NUM_settinggroup_PER_CHANNEL = 1   'min  of settinggroups per CHANNEL

Global Const MAX_NUM_CHANNELS_PER_MODULE = 32       'max  of CHANNELS per MODULE
Global Const MIN_NUM_CHANNELS_PER_MODULE = 1        'min  of CHANNELS per MODULE

Global Const MAX_NUM_MODULES_PER_DEVICE = 16        'max  of MODULES per hardware DEVICE
Global Const MIN_NUM_MODULES_PER_DEVICE = 1         'min  of MODULES per hardware DEVICE

Global Const MAX_NUM_DEVICES_PER_NETWORK = 32       'max  of hardware DEVICES per NETWORK (doesn't include CONTROLLER)
Global Const MIN_NUM_DEVICES_PER_NETWORK = 1        'min  of hardware DEVICES per NETWORK

Global Const cltrNum_DRIVER = 0                     'cltrNum'= driver
Global Const cltrNum_NONE = -1                      'cltrNum'= no controller, or driver
Global Const FIRST_NETWORK = 1                      'netNum of first network

Global Const MAX_NUM_NETWORKS = 16                  'maximum  of hardware controllers/networks (does not include DRIVER)

Global Const netNum_DRIVER = 0                      'netNum'of 0 means "driver"
Global Const netNum_1stController = 1               'netNum'of the 1st controller
Global Const cltrNum_AllControllers = -1            '-1 means all network controllers

Global Const deviceNum_CONTROLLER = 0               'deviceNum'of 0 means iNet Controller"
Global Const deviceNum_1stDevice = 1                'deviceNum'of the 1st DEVICE on network

Global Const moduleNum_1stModule = 1                'moduleNum'of the 1st MODULE in DEVICE

Global Const chanNum_1stChannel = 1                 'channelNum'of the 1st CHANNEL in MODULE

Global Const settingNum_1stSetting = 1              'settingNum'of the 1st SETTING Group in CHANNEL

Global Const fieldNum_1stField = 1                  'fieldNum'of the 1st FIELD in SETTING Group

'============================ little/big Endian ==================================

Global Const bigEndian_ion = 0                      'big endian, e.g. Motorola 68K, 68332
Global Const littleEndian_ion = 1                   'ittle endian, e.g. Intel x86

Global Const THIS_COMPILERS_ENDIAN_MODE = littleEndian_ion  'Intel x86 used by Microsoft Windows
 
'========================= Open Window Commands ===================================
          
Global Const iNetCM_OpenWindow_Record = 1           'open the RECORD page
Global Const iNetCM_OpenWindow_Network = 2          'open the NETWORK page
Global Const iNetCM_OpenWindow_Test = 3             'open the TEST page
Global Const iNetCM_OpenWindow_Service = 4          'open the SERVICE page
Global Const iNetCM_OpenWindow_ChanSelection = 5    'open channel selection dialog
Global Const iNetCM_OpenWindow_FieldSelection = 6   'open field selection dialog
Global Const iNetCM_OpenWindow_OneFieldSet = 7      'open Probe dialog with fixed channel address & setting group
Global Const iNetCM_OpenWindow_AllFieldSets = 8     'open Probe dialog with fixed channel address
Global Const iNetCM_OpenWindow_RecTiming = 9        'open Timing dialog
Global Const iNetCM_OpenWindow_RecTrigger = 10      'open Trigger dialog
Global Const iNetCM_OpenWindow_RecOptions = 11      'open the Record Options dialog
Global Const iNetCM_OpenWindow_RecFile = 12         'open the Record File dialog
Global Const iNetCM_OpenWindow_SimpleTiming = 13    'open the SimpleTiming dlog (pts -per-scan and sample-rate)
Global Const iNetCM_OpenWindow_CalOptions = 14      'open the Calibration Options dlog

'========================= Button Press Commands ===================================
          
'RECORD page
Global Const iNetCM_BtnPress_Record_Start = 1       'press 'Start'button in RECORD page
Global Const iNetCM_BtnPress_Record_Stop = 2        'press 'Stop'button in RECORD page
Global Const iNetCM_BtnPress_Record_Open = 3        'press 'Open'button in RECORD page
Global Const iNetCM_BtnPress_Record_Save = 4        'press 'Save'button in RECORD page
Global Const iNetCM_BtnPress_Record_Options = 5     'press 'Options'button in RECORD page
Global Const iNetCM_BtnPress_Record_Timing = 6      'press 'Timing'button in RECORD page
Global Const iNetCM_BtnPress_Record_Trigger = 7     'press 'Trigger'button in RECORD page
Global Const iNetCM_BtnPress_Record_Probe = 8       'press 'Probe'button in RECORD page
          
'NETWORK page
Global Const iNetCM_BtnPress_Network_Restore = 9    'press 'Restore'button in NETWORK page
Global Const iNetCM_BtnPress_Network_Store = 10     'press 'Store'button in NETWORK page
Global Const iNetCM_BtnPress_Network_Open = 11      'press 'Open'button in NETWORK page
Global Const iNetCM_BtnPress_Network_Save = 12      'press 'Start'button in NETWORK page
Global Const iNetCM_BtnPress_Network_Clear = 13     'press 'Clear'button in NETWORK page
Global Const iNetCM_BtnPress_Network_Reset = 14     'press 'Reset'button in NETWORK page
 
'TEST page
Global Const iNetCM_BtnPress_Test_Search = 15       'press 'Search'button in TEST page
Global Const iNetCM_BtnPress_Test_Test = 16         'press 'Test'button in TEST page
Global Const iNetCM_BtnPress_Test_BigTest = 17      'press 'Big Test'button in TEST page
Global Const iNetCM_BtnPress_Test_Open = 18         'press 'Open'button in TEST page
Global Const iNetCM_BtnPress_Test_SaveAs = 19       'press 'Save As'button in TEST page
Global Const iNetCM_BtnPress_Test_Clear = 20        'press 'Clear'button in TEST page

' RECENT ADDITIONS
Global Const iNetCM_BtnPress_Record_Directory = 21  'press 'Directory' button in RECORD page
Global Const iNetCM_BtnPress_Network_Recal = 22     'press 'Recal' button in NETWORK page, 4/21/97
Global Const iNetCM_BtnPress_Record_Setup = 23      'press 'Setup' button in RECORD page
Global Const iNetCM_BtnPress_Record_Print = 32      'press 'Print' button in RECORD page, gsw 8/22/98

Global Const iNetCM_BtnPress_Test_Print = 33        'press 'Print' button in TEST page, gsw 8/22/98
Global Const iNetCM_BtnPress_Basic_Print = 34       'press 'Print' button in BASIC page, gsw 8/22/98

' BASIC page
Global Const iNetCM_BtnPress_Basic_Execute = 24    'press 'Execute' button in BASIC page
Global Const iNetCM_BtnPress_Basic_Stop = 25       'press 'Stop' button in BASIC page
Global Const iNetCM_BtnPress_Basic_Open = 26       'press 'Open' button in BASIC page
Global Const iNetCM_BtnPress_Basic_Save = 27       'press 'Save' button in BASIC page
Global Const iNetCM_BtnPress_Basic_SaveAs = 28     'press 'Save As' button in BASIC page
Global Const iNetCM_BtnPress_Basic_Clear = 29      'press 'Clear' button in BASIC page

' RECENT ADDITIONS
Global Const iNetCM_BtnPress_Record_CalOptions = 30 'press 'Calibrate Options' button in RECORD page
Global Const iNetCM_BtnPress_Test_Report = 31      'press 'Report' button in TEST page

'=========================== DRIVER CHANNEL NUMBERS ==============================
          
Global Const driver_ChanNum_OpenWindow = 1          'Open Window Command (DRIVER channel type)
Global Const driver_ChanNum_PushButton = 2          'Push Button Command (DRIVER channel type)
Global Const driver_ChanNum_RecordOptions = 3       'RECORD OPTIONS = {hScale, hPosition, maxPtsPerPix, gridOnOff, plotLinesDots}

'================================= HARDWARE Settings ===============================

'FIELD NUMBERS for HARDWARE settingGroup
Global Const fldNum_Vin_sensorType = 1              'sensorType
Global Const fldNum_Vin_wiring = 2                  'wiring options
Global Const fldNum_Vin_AnaLpFltr_Hz = 3            'analog lp filter hz value (e.g. 0, 40, 16000 for Model 100)
Global Const fldNum_Vin_ad_IntegrateSecs = 4        ' of seconds that a/d integrates via multiple readings. 1/19/96
Global Const fldNum_Vin_ad_VmaxRange = 5            'voltage range (max voltage) (i.e. a/d gain) {e.g. 5, 1.25, 0.3175, 0.078125}
 
' SENSOR TYPES
Global Const ion_SensorType_Voltage = 1
Global Const ion_SensorType_Current = 2
Global Const ion_SensorType_Resistance = 3
Global Const ion_SensorType_StrainGauge = 4
Global Const ion_SensorType_RTD = 5
Global Const ion_SensorType_TC_J = 6
Global Const ion_SensorType_TC_K = 7
Global Const ion_SensorType_TC_T = 8
Global Const ion_SensorType_TC_E = 9
Global Const ion_SensorType_TC_R = 10
Global Const ion_SensorType_TC_S = 11
Global Const ion_SensorType_TC_B = 12
Global Const ion_SensorType_TC_N = 13
Global Const ion_SensorType_Thermister = 14
Global Const ion_SensorType_Digital = 15

'WIRING OPTIONS
Global Const ion_Wiring_Differential = 1
Global Const ion_Wiring_SingleEnded = 2
Global Const ion_Wiring_Shunt_Resistor = 3
Global Const ion_Wiring_Voltage_Divider = 4
Global Const ion_Wiring_Bridge = 5
Global Const ion_Wiring_Q_Bridge_Bend = 6
Global Const ion_Wiring_H_Bridge_Bend = 7
Global Const ion_Wiring_H_Bridge_Axial = 8
Global Const ion_Wiring_F_Bridge_Bend_I = 9
Global Const ion_Wiring_F_Bridge_Axial_I = 10
Global Const ion_Wiring_F_Bridge_Axial_II = 11
  
'Analog Low Pass Filter Options (e.g. Model 100)
Global Const ion_AD_AnaLpFltr_Pop_Off = 1  'off
Global Const ion_AD_AnaLpFltr_Pop_40Hz = 2  '40Hz
Global Const ion_AD_AnaLpFltr_Pop_4KHz = 3  '4KHz
 
' ion_AD_AnaLpFltr_Pop
Global Const ion_AD_AnaLpFltr_Pop_MIN = ion_AD_AnaLpFltr_Pop_Off
Global Const ion_AD_AnaLpFltr_Pop_MAX = ion_AD_AnaLpFltr_Pop_4KHz
Global Const ion_AD_AnaLpFltr_Pop_DEF = ion_AD_AnaLpFltr_Pop_Off

' A/D Range Options (e.g. popup)
Global Const ion_AD_RangePop_5V = 1       '+/- 5.0V
Global Const ion_AD_RangePop_0_625V = 2   '+/- .625V
Global Const ion_AD_RangePop_0_078V = 3   '+/- 0.078V
Global Const ion_AD_RangePop_0_010V = 4   '+/- 0.010V
 
'  ion_AD_RangePop
Global Const ion_AD_RangePop_MIN = ion_AD_RangePop_5V
Global Const ion_AD_RangePop_MAX = ion_AD_RangePop_0_010V
Global Const ion_AD_RangePop_DEF = ion_AD_RangePop_5V

'=========================== Vin CONSTANTS Settings =======================

' FIELD NUMBERS for Vin CONSTANTS settingGroup
Global Const fldNum_VinCon_Ro = 1               'Ro constant
Global Const fldNum_VinCon_Rshunt = 2           'Rshunt constant
Global Const fldNum_VinCon_Vexcitation = 3      'Vexcitation constant
Global Const fldNum_VinCon_Vinit = 4            'Vinit constant
Global Const fldNum_VinCon_alpha = 5            'alpha constant
Global Const fldNum_VinCon_delta = 6            'delta constant
Global Const fldNum_VinCon_GF = 7               'GF constant
Global Const fldNum_VinCon_v_Poisson = 8        'v_Poisson constant
 
'===================== CONTROLLER CHANNEL NUMBERS =========================

'Channels numbers for the NETWORK's Controller (counter/timer/digital in/digitial out)
Global Const controller_ChanNum_Ch1_Dio = 1  'Ch1 Dio
Global Const controller_ChanNum_Ch2_Dio = 2  'Ch2 Dio
Global Const controller_ChanNum_Ch3_Dio = 3  'Ch3 Dio
Global Const controller_ChanNum_Ch4_Dio = 4  'Ch4 Dio
Global Const controller_ChanNum_Ch5_Dio = 5  'Ch5 Dio
Global Const controller_ChanNum_Ch6_Dio = 6  'Ch6 Dio
Global Const controller_ChanNum_Ch7_Dio = 7  'Ch7 Dio
Global Const controller_ChanNum_Ch8_Dio = 8  'Ch8 Dio
Global Const controller_ChanNum_Ch9_Dio = 9  'Ch9 Dio
Global Const controller_ChanNum_C10_Dio = 10 'Ch10 Dio
 
Global Const controller_ChanNum_C11_Time = 11 'Ch11 Time (get time in seconds since reset, accurate to .25us)
Global Const controller_ChanNum_C12_Digitizer = 12 'Ch12 Digitizer {control timebase and trigger while digitizing on network}

Global Const controller_Channels_Numbers_MIN = controller_ChanNum_Ch1_Dio
Global Const controller_Channels_Numbers_MAX = controller_ChanNum_C12_Digitizer

'================================ GENERAL Settings =================================

'FIELD NUMBERS for GENERAL settingGroup
Global Const fldNum_General_valueEU = 1     'inputValue (engineering units)
Global Const fldNum_General_unitsLabel = 2  'units label (editable); e.g. "Volts", "C", "F", "mmHg".
Global Const fldNum_General_userName = 3    'user name (editable)
Global Const fldNum_General_ad_sampleRateMult = 4  'sampleRateMult (0.001x to 1.0x of master sample rate)
Global Const fldNum_General_chanName = 5    'channel name (non-editable)
 
'================================ DISPLAY Settings =================================

'DISPLAY settingGroup = {dispOnOff, dispMaxEU, dispMinEU}
Global Const fldNum_Display_dispOnOff = 1  '1 = display is turned on (in RECORD window); or off (2)
Global Const fldNum_Display_dispMaxEU = 2  'EU value of top line of display (RECORD window, and PROBE dialog)
Global Const fldNum_Display_dispMinEU = 3  'EU value of bottom line of display (RECORD window, and PROBE dialog)
 
'================================ MAPPING Settings =================================

'MAPPING settingGroup = {Internal1, External1, Internal2, External2}
Global Const fldNum_Mapping_internal1 = 1  'Mapping point 1, coordinate system inside driver
Global Const fldNum_Mapping_external1 = 2  'Mapping point 1, coordinate system outside driver
Global Const fldNum_Mapping_internal2 = 3  'Mapping point 2, coordinate system inside driver
Global Const fldNum_Mapping_external2 = 4  'Mapping point 2, coordinate system outside driver
Global Const fldNum_Mapping_scale = 5      'Mapping scale, "y=scale*x + offset"
Global Const fldNum_Mapping_offset = 6     'Mapping offset, "y=scale*x + offset"
 
'=========================== DIGITAL FILTER Settings ===============================

'FIELD NUMBERS for DIGITAL FILTER settingGroup (1 for each
'filter in each channel = {passband1_Hz, passBand_Ripple_dB,...}
Global Const fldNum_DigitalFilter_filterMethod = 1
Global Const fldNum_DigitalFilter_passBand_Ripple_dB = 2    'passband ripple (dB)
Global Const fldNum_DigitalFilter_stopBand_Attn_dB = 3      'stopband attenuation (dB)
Global Const fldNum_DigitalFilter_filterOrder = 4
Global Const fldNum_DigitalFilter_passband1_Hz = 5          '(lower) passband cutoff frequency
Global Const fldNum_DigitalFilter_stopband1_Hz = 6          '(lower) stopband cutoff frequency
Global Const fldNum_DigitalFilter_passband2_Hz = 7          'upper passband cutoff (BANDPASS_DCIIR/BANDSTOP_DCIIR only)
Global Const fldNum_DigitalFilter_stopband2_Hz = 8          'upper stopband cutoff (BANDPASS_DCIIR/BANDSTOP_DCIIR only)
 
'Filter Method (this is a popup menu)
Global Const FILTEROFF_DCIIR = 1
Global Const ELLIPTIC_DCIIR = 2
Global Const CHEBYSHEV_P_DCIIR = 3
Global Const CHEBYSHEV_S_DCIIR = 4
Global Const BUTTERWORTH_DCIIR = 5

'=========================== RECORD OPTIONS Settings ===============================

'FIELD NUMBERS for RECORD OPTIONS settingGroup (1 for each driver)
' = {hScale, hPosition, maxPtsPerPix, gridOnOff, plotLinesDots}
Global Const fldNum_RecordOptions_hScale = 1        'horiz scale (e.g. 0.1 Seconds per horiz division)
                                                    'if == 0, we do an auto-scale and set ~5 digitized points per pixel
Global Const fldNum_RecordOptions_hPosition = 2     'horiz position (i.e time of left edge, e.g. 0 Seconds)
Global Const fldNum_RecordOptions_plotLinesDots = 3 'plot dots or connect dots with lines
Global Const fldNum_RecordOptions_gridOnOff = 4     'grid is on or off
Global Const fldNum_RecordOptions_maxPtsPerPix = 5  'maximum points per vertical pixel column when plotting
Global Const fldNum_RecordOptions_saveData = 6      'save data {off / To Ram Buffer / To Disk / User Control}
Global Const fldNum_RecordOptions_overflowAlert = 7 'show alert on buffer overflow ON/OFF, gsw 11/25/95

'Off/To Ram Buffer/To Disk Popup
Global Const ion_gSaveDataPopup_Off = 1
Global Const ion_gSaveDataPopup_ToRamBuffer = 2
Global Const ion_gSaveDataPopup_ToDisk = 3
Global Const ion_gSaveDataPopup_UserControl = 4
 
'================================ FILE Settings ===================================

'FIELD NUMBERS for FILE settingGroup
  
Global Const fldNum_File_FileOnOff = 1
Global Const fldNum_File_DigitizeOnOff = 2
Global Const fldNum_File_FileName = 3
Global Const fldNum_File_fileCmd = 4        ' command = fileCmd_FileToRamBuffer (ScanNum)
                                            ' fileCmd_RamBufferToFile (ScanNum),
                                            ' fileCmd_FileToUserBuffer (ScanNum)
Global Const fldNum_File_ScanNum = 5
Global Const fldNum_File_FirstPointNum = 6
Global Const fldNum_File_NumPts = 7

'File Command Options (e.g. popup)
Global Const fileCmd_Off = 1                ' minimum
Global Const fileCmd_FileToRamBuffer = 2    ' Transfer data from FILE @ 'ScanNum'to DRIVER RAM BUFFER
Global Const fileCmd_RamBufferToFile = 3    ' Transfer data from DRIVER RAM BUFFER to FILE @ 'ScanNum'
Global Const fileCmd_FileToUserBuffer = 4   ' Transfer data from FILE @ 'ScanNum'to USER RAM BUFFER
Global Const fileCmd_UserBufferToFile = 5   ' Transfer data from USER RAM BUFFER to File @ 'ScanNum'
Global Const fileCmd_Get_File_Info = 6      ' Get info on FILE (ScanNum =  of scans; NumPts = pts per scan)
 
'============================= MASTER DIRECTORY Settings ============================

'FIELD NUMBERS for MASTER DIRECTORY settingGroup
Global Const fldNum_Directory_PathName = 1          'Path Name (for directory that contains a file)
Global Const fldNum_Directory_NewDirectoryName = 2  'New Directory Name = { ndn_PromptUser, ndn_AutoGenerate }
Global Const fldNum_Directory_SaveSettingsOnOff = 3 'When we create a new directory we can save network
Global Const fldNum_Directory_LoadSettingsOnOff = 4 'When we are asked to redirect our directory, then if
Global Const fldNum_Directory_FileType = 5          'FileType = {ft_Text, ft_iNet_Binary}
Global Const fldNum_Directory_dirCmd = 6            'dirCmd = {dirCmd_CreateNewDirectory, dirCmd_ShowDirectoryDlog}

' New Name = {Prompt User/Auto Generate} options (e.g. popup)
Global Const ndn_PromptUser = 1
Global Const ndn_AutoGenerate = 2
 
'FileType Options.
Global Const ft_iNet_Binary = 1
Global Const ft_Text = 2
Global Const ft_TextMerge = 3
Global Const ft_BinaryMerge = 4
 
'MASTER DIRECTORY Command Options
Global Const dirCmd_CreateNewDirectory = 1
Global Const dirCmd_ShowDirectoryDlog = 2
 
' ============================== CALIBRATION Settings ===============================

' FIELD NUMBERS for CALIBRATION settingGroup
Global Const fldNum_CalOptions_CalBtn = 1        'Cal Btn = { measure, bal gages }
Global Const fldNum_CalOptions_CalOnStart = 2    'Cal On Start = on/off
Global Const fldNum_CalOptions_CalOnWarm = 3     'Cal On Warm (10min,25min after launch) = on/off
Global Const fldNum_CalOptions_AutoCalRate = 4   'Auto Cal Rate (minutes), 0=never
                                        
'CalBtn = {Measure/Bal Gages} determines what happens when the Calibrate button is pressed.
Global Const ion_gCalBtnPop_Measure = 1          'calibrate the instruNet hardware for measurement
Global Const ion_gCalBtnPop_BalGages = 2         'Balance strain gages
Global Const ion_gCalBtnPop_BalBridges = 3       'Balance Bridges
Global Const ion_gCalBtnPop_BalVdividers = 4     'Balance voltage dividers

 
'============================= USER RAM BUFFER Settings ============================

'FIELD NUMBERS for USER RAM BUFFER settingGroup
Global Const fldNum_UserBuffer_DigitizeOnOff = 1    'on/off for Moving Digitized Data to buffer at Digitize Time
Global Const fldNum_UserBuffer_UserBufferAddr = 2
Global Const fldNum_UserBuffer_UserPtrSizeInBytes = 3 'This is the size of the user's buffer in Bytes.
Global Const fldNum_UserBuffer_ScanNumIn = 4        'Scan  of last point pushed into buffer = {1...numScans}
Global Const fldNum_UserBuffer_PtNumIn = 5          'Point  of last point pushed into buffer = {1...PtsPerScan}
Global Const fldNum_UserBuffer_ScanNumOut = 6       'Scan  of last point pulled out of buffer = {1...umScans}
Global Const fldNum_UserBuffer_PtNumOut = 7         'Point  of last point pulled out of buffer = {1...PtsPerScan}

'=========================== DRIVER RAM BUFFER Settings ============================

'FIELD NUMBERS for DRIVER RAM BUFFER settingGroup
Global Const fldNum_DvrBuffer_DigitizeOnOff = 1     'on/off for Moving Digitized Data to buffer at Digitize Time
Global Const fldNum_DvrBuffer_BufferAddr = 2        'driver's addr to a buffer in RAM; 0 if not used (off)
Global Const fldNum_DvrBuffer_BufferAddrSizeInBytes = 3
Global Const fldNum_DvrBuffer_ScanNumIn = 4         'Scan  of last point pushed into buffer = {1...numScans}
Global Const fldNum_DvrBuffer_PtNumIn = 5           'Point  of last point pushed into buffer = {1...PtsPerScan}
Global Const fldNum_DvrBuffer_ScanNumOut = 6        'Scan  of last point pulled out of buffer = {1...numScans}
Global Const fldNum_DvrBuffer_PtNumOut = 7          'Point  of last point pulled out of buffer = {1...PtsPerScan}

'=============================== TIMING Settings ===================================

'FIELD NUMBERS for TIMING settingGroup
Global Const fldNum_Timing_digitizeOnOff = 1    '1 = digitizer turned on; 2 = off
Global Const fldNum_Timing_ptsPerScan = 2       'points per scan (i.e. pts/trace)
Global Const fldNum_Timing_noOfScans = 3        ' of scans
Global Const fldNum_Timing_scanMode = 4         'space between scans = {ion_gScanModePopup_StripChart  '
                                                ' ion_gScanModePopup_OscilloQueued  'ion_gScanModePopup_Oscilloscope}
Global Const fldNum_Timing_sampleRate = 5       'master sample rate (pts/second)
Global Const fldNum_Timing_minSecsBetweenTsfrs = 6 'minimum secs between 16bit tsfrs.
                                                '(It gives the analog electronics time to adjust from
                                                '1 channel to the other. gsw 2/22/96)
Global Const fldNum_Timing_network_bps = 7      'network data clock rate (bits per second)  'gsw 11/25/95
Global Const fldNum_Timing_switching = 8        'switch channels quickly or with more accuracy

'ON/OFF Options (e.g. popup)
Global Const ion_gOnOffPopup_On = 1                 'on
Global Const ion_gOnOffPopup_Off = 2                'off
 
'LINES/DOTS Options (e.g. popup)
Global Const ion_gLinesDots_Lines = 1               'Lines
Global Const ion_gLinesDots_Dots = 2                'Dots

'OSC/OSC_QUEUED/STRIP-CHART Options (e.g. popup)
Global Const ion_gScanModePopup_StripChart = 1      'STRIP CHART  continuous scans
Global Const ion_gScanModePopup_Oscilloscope = 2    'OSCILLOSCOPE non-continuous scans
                                                    'pulled out of controllers buffer
                                                    'in a filo method (first in, last out)
Global Const ion_gScanModePopup_OscilloQueued = 3   'OSCILLO QUEUED non-continuous scans
                                                    'pulled out of a controllers buffer
                                                    'in a fifo method (first in, first out)
 
'switch channels quickly or with more accuracy
Global Const ion_gSwitchingPopup_Accurate = 1       'switch slower, yet more accurate
Global Const ion_gSwitchingPopup_Fast = 2           'switch faster, yet more accurate

'========================= TRIGGER Settings  =============================

Global Const fldNum_Trigger_triggerModePop = 1      'trigger mode popup {1=off  '2=auto  '3=normal}
Global Const fldNum_Trigger_thresholdEu = 2         'trigger threshold engineering units
Global Const fldNum_Trigger_slopeRisFalPop = 3      'slope {1=rising edge, 2=falling edge}
Global Const fldNum_Trigger_preTrigSec = 4          'pretrigger (seconds)
Global Const fldNum_Trigger_srcNet = 5              'trigger source netNum
Global Const fldNum_Trigger_srcModule = 6           'trigger source moduleNum
Global Const fldNum_Trigger_srcDevice = 7           'trigger source deviceNum
Global Const fldNum_Trigger_srcChannel = 8          'trigger source channeNum
  
'MODE options in TRIGGER Settings Group
Global Const ion_TriggerMode_Off = 1
Global Const ion_TriggerMode_Auto = 2
Global Const ion_TriggerMode_Norm = 3

Global Const ion_TriggerModePopup_MIN = ion_TriggerMode_Off
Global Const ion_TriggerModePopup_MAX = ion_TriggerMode_Norm
Global Const ion_TriggerModePopup_DEF = ion_TriggerMode_Off

'SLOPE options in TRIGGER Settings Group
Global Const ion_Rising = 1                         'trigger on rising edge
Global Const ion_Falling = 2                        'trigger on falling edge
 
Global Const ion_RiseFallPopup_MIN = ion_Rising
Global Const ion_RiseFallPopup_MAX = ion_Falling
Global Const ion_RiseFallPopup_DEF = ion_Rising

'=============================== TIMER Settings  ==================================

'FIELD NUMBERS for TIMER settingGroup
Global Const fldNum_Timer_functionPop = 1

Global Const fldNum_Timer_clkTotalSecs = 2
Global Const fldNum_Timer_clkHiSecs = 3
Global Const fldNum_Timer_measHiOrCyclePop = 4
Global Const fldNum_Timer_measResolutionPop = 5
Global Const fldNum_Timer_measNumPeriods = 6
  
' uController TPU Channel Timer/Din/Dout Function Options (e.g. popup)

Global Const ion_TimerFuncPopup_Din = 1      'digital input
Global Const ion_TimerFuncPopup_Dout = 2     'digital output
Global Const ion_TimerFuncPopup_ClkOut = 3   'clock output
Global Const ion_TimerFuncPopup_PerMeas = 4  'period measurement
 
'uController TPU Channel measure CYCLE time
Global Const ion_measHiOrCyclePop_CycleTime = 1  'measure cycle time (falling edge to falling edge)
Global Const ion_measHiOrCyclePop_HighTime = 2   'measure high time (rising edge to falling edge)
 
'25us/8ms Resolution Popup
Global Const ion_timeResolutionPop_quarterMicroSec = 1  '.25us resolution
Global Const ion_timeResolutionPop_eightMilliSec = 2    '8ms resolution
 
'====================== DIGITAL I/O Settings Field Numbers  =========================

'FIELD NUMBERS for 8bit Mod 100 DigitalI/O settingGroup {din, dout, direction}
Global Const fldNum_Mod100DinDout_dout = 1       'digital output, {0..255}
Global Const fldNum_Mod100DinDout_direction = 2  'direction, {0..255}
  
'========================= User Interface Types For Fields ==========================

'types of user interfaces for fields
Global Const fuit_unknown = 0

Global Const fuit_editField_flt32 = 1               'Edit Field with FLT32 data
Global Const fuit_editField_double = 2              'Edit Field with double data
Global Const fuit_editField_int16 = 3               'Edit Field with INT16 data
Global Const fuit_editField_int32 = 4               'Edit Field with INT32 data
Global Const fuit_editField_uint32 = 5              'Edit Field with UINT32 data
Global Const fuit_editField_str15 = 6               'Edit Field with STR15 data
Global Const fuit_editField_str255 = 7              'Edit Field with STR255 data

Global Const fuit_staticText_flt32 = 10             'Static Text with FLT32 data
Global Const fuit_staticText_int16 = 11             'Static Text with INT16 data
Global Const fuit_staticText_int32 = 12             'Static Text with INT32 data
Global Const fuit_staticText_uint32 = 13            'Static Text with UINT32 data
Global Const fuit_staticText_str15 = 14             'Static Text with STR15 data
 
Global Const fuit_popup_Mod100analogLpFltrPop = 20  'Model 100 Analog Low Pass Filter Popup {off, 40Hz, 4KHz}
Global Const fuit_popup_Mod100rangePop = 21         'Model 100 Range Popup {+/-5V, +/-1.25V, +/-.37V, +/-.08V}
Global Const fuit_popup_Mod100sensorPosTypePop = 22 'Model 100 POS SensorType {voltage, J, K, RTD..}
Global Const fuit_popup_Mod100sensorNegTypePop = 23 'Model 100 NEG SensorType {diff/se VOLTS}
Global Const fuit_popup_Mod100WiringPosTypePop = 24 'Model 100 POS Wiring {diff, se, bridge, R shunt, V divider}
Global Const fuit_popup_Mod100WiringNegTypePop = 25 'Model 100 NEG Wiring {diff, se}
 
Global Const fuit_popup_continuousOnOff = 26        'On/Off Popup {1=on 2=off,3=offWithSkip}
Global Const fuit_popup_saveData = 27               'save data {off / To Ram Buffer / To Disk / User Control}
Global Const fuit_popup_OnOff = 28                  'On/Off Popup {1=on 0=off}
Global Const fuit_popup_LinesDots = 29              'Lines/Dots Popup {1=lines 2=dots}
Global Const fuit_popup_triggerMode = 30            'trigger mode popup {1=off, 2=auto, 3=normal}
Global Const fuit_popup_riseFall = 31               'slope {1=rising edge, 2=falling edge}
Global Const fuit_popup_timerFunction = 32          'function mode popup {1=digitalIn, 2=digitalOut, 3=clkOut, 4=periodMeas}
Global Const fuit_popup_measHiOrCycle = 33          'periodMeasureCyclePop {1=measureCycleTime, 2=measureHighTime}
Global Const fuit_popup_measResolution = 34         'periodMeasureResolutionPop {1 = 0.25us, 2 = 4ms}
Global Const fuit_popup_filterMethod = 35           'filter method = {FILTEROFF_DCIIR, BUTTERWORTH_DCIIR, etc}
Global Const fuit_popup_DirCmd = 36                 'text to the DirCmd popup
Global Const fuit_popup_FileType = 37               'text to the FileType popup
Global Const fuit_popup_NewDirName = 38             'text to the NewDirName popup
Global Const fuit_popup_FileCmd = 39                'text to the FileCmd popup
Global Const fuit_popup_PushButton = 40             'DRIVER Push Button Command
Global Const fuit_popup_OpenWindow = 41             'DRIVER Open Window Command
Global Const fuit_popup_switching = 42              'channel switching {accurate, fast}

'=========================== user interface catagory =============================

'Types of items to add to a dialog.
Global Const ion_NotDefined = 0                     'not defined
Global Const ion_Button = 1                         'button
Global Const ion_CheckBox = 2                       'checkbox
Global Const ion_RadioBtn = 3                       'radio button
Global Const ion_StaticText = 4                     'static text
Global Const ion_EditText = 5                       'edit text
Global Const ion_UserItem = 6                       'user item
Global Const ion_Icon = 7                           'icon item
Global Const ion_Picture = 8                        'picture item
Global Const ion_Control = 9                        'control item
 
'=========================== request struct interface =============================
'These macros are the offset's from the beginning of the iNet_Request struct
'to the specified field. A pointer to the iNet_Request struct is passed to the driver.

Global Const netNum_OFFSET = &H0
Global Const deviceNum_OFFSET = &H1
Global Const moduleNum_OFFSET = &H2
Global Const chanNum_OFFSET = &H3

Global Const settingGroupNum_OFFSET = &H4
Global Const fieldNum_OFFSET = &H6
Global Const intention_OFFSET = &H8
Global Const argType_OFFSET = &HA
Global Const error_OFFSET = &HE
Global Const ptrToArg_OFFSET = &H10

Global Const A_OFFSET = &H14
Global Const B_OFFSET = &H18
Global Const C_OFFSET = &H1C
Global Const D_OFFSET = &H20
Global Const E_OFFSET = &H24
Global Const F_OFFSET = &H28

Global Const netP_OFFSET = &H2C
Global Const interfaceBlockP_OFFSET = &H30
Global Const deviceGlobalsP_OFFSET = &H34
Global Const moduleGlobalsP_OFFSET = &H38
Global Const channelGlobalsP_OFFSET = &H3C
Global Const settingGroup__P_OFFSET = &H40
Global Const settingGroupType_OFFSET = &H44
Global Const key_OFFSET = &H46

' This is used for passing a complete channel address
' (i.e. netNum, devNum, modNum, chanNum) to a DLL
Public Type chAddrP

    ' The instruNet driver packs this 32bit long with
    ' 8bit netNum, 8bit devNum, 8bit modNum, 8bit chanNum.
    iNetAddress As Long

End Type

Global tempArr() As Single   'use this with memcopy and varptr dll's
Global chan0Buff()
Global chan1Buff()
Global chan2Buff()
Global chan3Buff()
Global chan4Buff()
Global message$(255, 0)
Global ioArray()

' ---------------------------------------------------------------------------
' Loaded with address of digitized channels. This is used
' by VB and not the iNet DLL, which wants one Long variable.

Public Type DataArrayType

    ' contains the data, of length 'numValidPts'
    data() As Single
    
    ' # of valid points contained within data() buffer.
    numValidPts As Long
    
    ' # of pts in within the data() buffer.
    numBufferPts As Long
    
    ' sample rate of the data, in pts-per-sec
    ' (or pts-per-plotted-xUnit)
    ptsPerXunit As Double
    
    ' first point (zeroth) time in seconds
    firstPt_Xunits As Double
    
End Type

' ---------------------------------------------------------------------------
' Loaded with address of digitized channels. This is used
' by VB and not the iNet DLL, which wants one Long variable.

Public Type chAddr

    ' iNet DLL likes one long variable to contain the channel address
    chAddrDLL As Long
    
    ' VB likes 4 fields to contain the channel address
    netNum As Byte
    deviceNum As Byte
    moduleNum As Byte
    chanNum As Byte
    
    ' {bNum, dispNum} references the address of a
    ' front panel VB display that contains this channel.
    bNum As Integer
    dNum As Integer
    
    ' dataArrayY Contains:
    '
    '   .numValidPts = # of valid points contained within the data() buffer
    '   .numBufferPts = buffer size
    '   .data() = data is stored in this array
    '   .ptsPerXunit = sample rate of the data
    '   .firstPt_Xunits = first point time in seconds
    dataArrayY As DataArrayType
     
    ' 'massageType' is set to {jNoMassage, jFFTMassage} and indicates how
    ' the data is to be massaged immediately after it is digitized.
    massageType As Integer
    
    ' if true, then the digitize code calls
    ' EndUser_SegmentProcessor() each time a little
    ' segment of data is digitized.
    runEndUser_SegmentProcessor As Integer
    
End Type


