/* ***********************************************************************************
iNet_MCS.h											Companion: (none)
													OWNER: 840av

	-------------------------- D O C U M E N T A T I O N -----------------------------

	This instruNet C Interface file contains macros used by the End User to control the
	instruNet driver. 
	
	This file expects tabs every 4 characters. 
	
	-------------------------------  H I S T O R Y -----------------------------------
	HISTORY		Copyright c 1994-98 GWI.  All rights reserved.
	4/16/94		created - gsw

************************************************************************************ */

#ifndef __iNetMacros__					/*	only include this file once */
#define __iNetMacros__

#include "INET_INT.H"					/*	must 1st include the interface to iNet */

#ifdef __cplusplus						/*	if running C++... */
	extern "C" {						/* make this a C function */
#endif									/* gsw 9/21/97 */

/* ======================== PROTOTYPES FOR HELPFUL ROUTINES ============================= */
/* 						(these are exported out of the Win95 DLL) 						  */

//	---------------------------  BASE FUNCTIONS  ---------------------------
//	---------------------------  BASE FUNCTIONS  ---------------------------
//	---------------------------  BASE FUNCTIONS  ---------------------------

//	===== READ/WRITE CHANNEL VALUE ===== 

	iNetFLT32 EXT_FUNC_TYPE GetChannelValue_iNet(iNetUINT8 netNum, 
		iNetUINT8 devNum, iNetUINT8 modNum, iNetUINT8 chNum, iNetError *errP);
	
	iNetError /* iNetINT16 */ EXT_FUNC_TYPE SetChannelValue_iNet(iNetUINT8 netNum,
		iNetUINT8 devNum, iNetUINT8 modNum, iNetUINT8 chNum, iNetFLT32 flt32_newValue);
	
	iNetFLT32 EXT_FUNC_TYPE GetFieldValue_iNet( iNetUINT8 netNum, iNetUINT8 devNum,
		iNetUINT8 modNum, iNetUINT8 chNum, iNetINT16 settingGroupNumOrType,
		iNetINT16 fieldNum, iNetError *errP);
	
	iNetError /* iNetINT16 */ EXT_FUNC_TYPE SetFieldValue_iNet( iNetUINT8 netNum,
		iNetUINT8 devNum, iNetUINT8 modNum, iNetUINT8 chNum,
		iNetINT16 settingGroupNumOrType, iNetINT16 fieldNum, iNetFLT32 flt32_newValue);
			
//	========== DIGITIZE ========== 

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Set_iNet_TIMING_Parameters( iNetFLT32 samplesPerSecond,
		iNetINT32 pointsPerScan, iNetINT32 numberOfScans, iNetINT16 stripChartRecorder,
		iNetINT16 saveDataOption, iNetINT16 showAlertOnOverflow, iNetINT16 switchAccurately);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Set_iNet_TRIGGER_Parameters(iNetINT16 triggerMode, iNetFLT32
		triggerThreshold, iNetINT16 triggerSlope, iNetFLT32 hysteresis,
		iNetChannelAddr *triggerSourceP);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE ResetChannelList( void );

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE AddToChannelList(iNetUINT8 netNum,
		iNetUINT8 devNum, iNetUINT8 modNum, iNetUINT8 chNum, iNetFLT32 *bufferP,
		iNetUINT32 bufferSizeBytes);	
	
	iNetError /* iNetINT16 */ EXT_FUNC_TYPE PutEnabledChInDigitizeList(
		iNetFLT32 *sampleRateP, iNetINT32 *pointsPerScanP, iNetINT32 *numChToDigitizeP);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE DigitizeListOfChannels(iNetINT16
		allowMouseDownToStopDigitize, iNetINT16 processOneScanAtATime,
		iNetUINT32 *last_scanNum_base1_pulled_inFull_oneCtlr);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE GetDigitizedSegment(iNetINT16 digChNum,
		iNetFLT32 **bufferStartAddrP, iNetUINT32 *pointToPullindex_base1,
		iNetUINT32 *numPointsToPull, iNetUINT32 *scanNumberToPull_base1);

	iNetINT16 EXT_FUNC_TYPE ThisIsAlreadyInChannelList( iNetUINT8 netNum,
		iNetUINT8 devNum, iNetUINT8 modNum, iNetUINT8 chNum);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE CalcDigiIntegrationTimes(
		iNetUINT8 netNum, iNetINT16 *numIntegrationChannels, iNetFLT32 *totalIntegrationTime);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE GetOutputSegmentBuffer(iNetINT16 digChNum,
		iNetFLT32 **bufferStartAddrP, iNetUINT32 *pointToPushindex_base1,
		iNetUINT32 *numPointsToPush, iNetUINT32 *scanNumberToPush_base1);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE SubmitOutputSegment(
		iNetINT16 digChNum, iNetUINT32 numPointsToPush);

//	=========== UTILITY ========== 

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Load_instruNet_Driver(iNetINT16 forceInstruNetReset,
		iNetINT16 *driverIsInstalledOK, iNetINT16 *numNetworks);		

	void EXT_FUNC_TYPE CloseDriverAndReleaseDriverRam(void);	

	void EXT_FUNC_TYPE libEntry(void);
	void EXT_FUNC_TYPE libExit(void);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Show_ALERT_if_hit_iNet_Error(iNetError e);

	void EXT_FUNC_TYPE Show_Simple_Alert(char *cString);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Open_instruNet_Window(iNetINT16
		iNetWindowType, iNetINT16 *netNumP, iNetINT16 *deviceNumP, iNetINT16 
		*moduleNumP, iNetINT16 *chanNumP, iNetINT16 *settingGpP,
		iNetINT16 *fieldNumP, iNetINT16 *userPressedOkP);	

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Press_instruNet_Button(
		iNetINT16 buttonToPress); 	/* gsw 9/5/97 */

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Set_instruNet_Network_State(
		iNetINT16 *arrayStart, iNetUINT32 dataSize);
		
	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Get_instruNet_Network_State( 
		iNetINT16 *arrayStart, iNetUINT32 arraySize, iNetUINT32 *sizeP);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE  SelectNextChannelAddress(iNetUINT8 *netNum,
		iNetUINT8 *devNum, iNetUINT8 *modNum, iNetUINT8 *chNum, iNetINT16 channelType_toLookFor);

//	---------------------------  ADVANCED FUNCTIONS  ---------------------------
//	---------------------------  ADVANCED FUNCTIONS  ---------------------------
//	---------------------------  ADVANCED FUNCTIONS  ---------------------------

//	===== ADVANCED READ/WRITE FIELD ===== 

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE SetField_int32( iNetChannelAddr *chAddrP, iNetINT16
		settingGroupNumOrType, iNetINT16 fieldNum, iNetINT32 int32Value);
		
	iNetError /* iNetINT16 */ EXT_FUNC_TYPE SetField_uint32( iNetChannelAddr *chAddrP, iNetINT16
		settingGroupNumOrType, iNetINT16 fieldNum, iNetUINT32 uint32Value);	

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE SetField_flt32( iNetChannelAddr *chAddrP, iNetINT16
		settingGroupNumOrType, iNetINT16 fieldNum, iNetFLT32 flt32Value);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE SetField_cStr( iNetChannelAddr *chAddrP, iNetINT16
		settingGroupNumOrType, iNetINT16 fieldNum, char *cString);	

	iNetINT32 EXT_FUNC_TYPE GetField_int32( iNetChannelAddr *chAddrP, iNetINT16
		settingGroupNumOrType, iNetINT16 fieldNum, iNetError *errP);
		
	iNetUINT32 EXT_FUNC_TYPE GetField_uint32(iNetChannelAddr *chAddrP, iNetINT16
		settingGroupNumOrType, iNetINT16 fieldNum, iNetError *errP);

	iNetFLT32 EXT_FUNC_TYPE GetField_flt32( iNetChannelAddr *chAddrP, iNetINT16
		settingGroupNumOrType, iNetINT16 fieldNum, iNetError *errP);

	iNetINT16 EXT_FUNC_TYPE GetField_cStr( iNetChannelAddr *chAddrP, iNetINT16 
		settingGroupNumOrType, iNetINT16 fieldNum, char *cString);

	iNetINT32 EXT_FUNC_TYPE iNet_int32(iNetUINT8 netNum, iNetUINT8 devNum, iNetUINT8 modNum,
		 iNetUINT8 chNum, iNetINT16 settingGroupNum, iNetINT16 fieldNum,
		 iNetINT16 intention, iNetINT32 int32Value);

	iNetUINT32 EXT_FUNC_TYPE iNet_uint32(iNetUINT8 netNum, iNetUINT8 devNum, iNetUINT8 modNum,
		 iNetUINT8 chNum, iNetINT16 settingGroupNum, iNetINT16 fieldNum,
		 iNetINT16 intention, iNetUINT32 uint32Value);

	iNetFLT32 EXT_FUNC_TYPE iNet_flt32(iNetUINT8 netNum, iNetUINT8 devNum, iNetUINT8 modNum,
		 iNetUINT8 chNum, iNetINT16 settingGroupNum, iNetINT16 fieldNum,
		 iNetINT16 intention, iNetFLT32 flt32Value);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE iNet_cString(iNetUINT8 netNum, iNetUINT8 devNum, iNetUINT8 modNum,
		 iNetUINT8 chNum, iNetINT16 settingGroupNum, iNetINT16 fieldNum,
		 iNetINT16 intention, char *cString);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE iNet_pString(iNetUINT8 netNum, iNetUINT8 devNum, iNetUINT8 modNum,
		 iNetUINT8 chNum, iNetINT16 settingGroupNum, iNetINT16 fieldNum,
		 iNetINT16 intention, unsigned char *pString);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE iNet_DLL(iNetUINT8 netNum, iNetUINT8 devNum,
		iNetUINT8 modNum, iNetUINT8 chNum, iNetINT16 settingGroupNumOrType,
		iNetINT16 fieldNum, iNetINT16 intention, iNetUINT8 argType, void *ptrToArg);


//	========== ADVANCED DIGITIZE ========== 

	iNetINT16 /* T/F (1/0) */ EXT_FUNC_TYPE LoadChannelAddress( iNetChannelAddr *chAddrP, iNetUINT8 netNum,
		iNetUINT8 devNum, iNetUINT8 modNum, iNetUINT8 chNum);

	void EXT_FUNC_TYPE GetChannelAddress(iNetChannelAddr *chAddrP, iNetINT16 *netNumP,
		iNetINT16 *deviceNumP, iNetINT16 *moduleNumP, iNetINT16 *chanNumP);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE EnableChannelForDigitizing(	iNetChannelAddr *chAddrP);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE DisableAllChannelsForDigitizing(void);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Service_All_iNet_Digitize_Buffers(iNetUINT8 netNum,
		iNetINT16 *theNextDataAccessIsTheLast, iNetINT16 *theNextDataAccessWillPullToTheEndOfAScan,
		iNetINT16 *controllerIsFinishedWithDigitization, iNetUINT32 *last_scanNum_base1_pulled_inFull,
		iNetUINT32 *last_scanNum_base1_pushed_inFull);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Access_Digitized_Data_In_Ram_Buffer(
		iNetChannelAddr *channelAddr, Boolean driverRamBuffer, iNetFLT32 **bufferStartAddrP,
		iNetUINT32 *pointToPullindex, iNetUINT32 *numPointsToPull,
		iNetUINT32 *scanNumberToPull);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Get_Ctlr_Ram_Buff_Info(
		iNetUINT8 netNum_forBuffInfo, iNetINT32 *ctlrRamBufferSizePts, iNetINT32 *numPtsNotYetPulled);

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Set_iNet_Demo_Mode( iNetINT16 demoMode );


//	=========== ADVANCED UTILITY ========== 

	iNetError /* iNetINT16 */ EXT_FUNC_TYPE Get_iNet_Error(void);
	
	void EXT_FUNC_TYPE Get_Last_iNet_Call(iNetUINT8 **gRequestPP);

	iNetINT16 EXT_FUNC_TYPE iNet_Peek_int16(iNetUINT32 address);
	iNetINT32 EXT_FUNC_TYPE iNet_Peek_int32(iNetUINT32 address);
	iNetFLT32 EXT_FUNC_TYPE iNet_Peek_flt32(iNetUINT32 address);

	void EXT_FUNC_TYPE iNet_Poke_int16(iNetUINT32 address, iNetINT16 int16value);
	void EXT_FUNC_TYPE iNet_Poke_int32(iNetUINT32 address, iNetINT32 int32value);
	void EXT_FUNC_TYPE iNet_Poke_flt32(iNetUINT32 address, iNetFLT32 flt32value);

	iNetUINT32 EXT_FUNC_TYPE iNet_Get_VarPtr(void *Addr_Of_A_Variable);

	void EXT_FUNC_TYPE iNet_memcopy(void *srcAddr, void *destAddr, iNetUINT32 numBytes);

	void EXT_FUNC_TYPE  iNet_Dispose_Handle(char * handleInRam);

	double EXT_FUNC_TYPE GetiNetTime_Double( void );

	iNetError EXT_FUNC_TYPE Get_DLL_Globals( iNetUINT32 /* HWND */ *ghwndPortWnd,	
		iNetUINT32 /* HDC */ *ghdcPortDC, iNetUINT32 /* HCURSOR */ *ghMSCursor,
		iNetUINT32 /* HINSTANCE */ *ghInstance);

	iNetINT16 EXT_FUNC_TYPE Get_iWp_LicenseState( void );

//	=========== ANALYSIS ========== 

	void EXT_FUNC_TYPE MultiplyTwoFlt32Arrays_DLL(iNetFLT32 *sourceArray,
		iNetFLT32 *destArray, iNetINT32 numPts);

	iNetINT16 EXT_FUNC_TYPE CalculateWindow_DLL(iNetINT32 numPts,
		iNetINT16 type, iNetFLT32 *windowPf);

	void EXT_FUNC_TYPE fft_DLL(iNetFLT32 *data, iNetINT16 power);

	void EXT_FUNC_TYPE ComplexToMagnitudes_DLL(iNetFLT32 *sourceArray, iNetINT32 numComplexPairs);

	iNetINT16 EXT_FUNC_TYPE MultiplyArrayByHammWindow_DLL(iNetFLT32 *data, iNetINT16 power);

	void EXT_FUNC_TYPE MultConstantByArray_DLL(iNetFLT32 *sourceArray, 
		iNetFLT32 *destArray, iNetFLT32 constant, iNetINT32 numPts);

//	------------  GENERIC FUNCTIONS  (uses short, long, double, void *) --------------
//	------------  GENERIC FUNCTIONS  (uses short, long, double, void *) --------------
//	------------  GENERIC FUNCTIONS  (uses short, long, double, void *) --------------
//
//	GENERIC functions use short, long, double and pointers, with the following 
//	sizes (in number of bytes):
//
//			OS			short		long 		double		void *
//			-----		-----		----		------		------
//			Win95		2			4			8			4
//			WinNT		2			4			8			4
//			Mac PPC		2			4			8			4
//			Mac 68K		2			4			10?			4

double EXT_FUNC_TYPE GetChannelValue_iNet_Generic(short netNum, short devNum,
	short modNum, short chNum, short *errP);				

short /* iNetError */ EXT_FUNC_TYPE SetChannelValue_iNet_Generic(	
	short netNum, short devNum, short modNum, short chNum, double newValue);

short /* iNetError */ EXT_FUNC_TYPE PutEnabledChInDigitizeList_generic(
	double *sampleRateP, long *pointsPerScanP, long *numChToDigitizeP);
	
short /* iNetError */ EXT_FUNC_TYPE ResetChannelList_Generic(void);

short /* iNetError */ EXT_FUNC_TYPE AddToChannelList_Generic(
	short netNum, short devNum, short modNum, short chNum,
	long *bufferP, long bufferSizeBytes);

short /* iNetError */ EXT_FUNC_TYPE AddToChannelList_DB_Generic(	/* gsw 8/20/97 */
	short netNum, short devNum, short modNum, short chNum, long bufferSizeBytes);

short /* iNetError */ EXT_FUNC_TYPE Set_iNet_TIMING_Parameters_Generic(double samplesPerSecond, 
	long pointsPerScan, long numberOfScans, short stripChartRecorder, short saveDataOption,
	short showAlertOnOverflow, short switchAccurately);

short /* iNetError */ EXT_FUNC_TYPE Set_iNet_TRIGGER_Parameters_Generic( short triggerMode,
	double triggerThreshold, short triggerSlope, double hysteresis,
	short netNum_trig, short deviceNum_trig, short moduleNum_trig, short chanNum_trig);

short /* iNetError */ EXT_FUNC_TYPE DigitizeListOfChannels_Generic( short allowMouseDownToStopDigitize,
	short processOneScanAtATime, long *last_scanNum_base1_pulled_inFull_oneCtlr);

short /* iNetError */ EXT_FUNC_TYPE Stop_iNet_Digitizing( void );

short /* iNetError */ EXT_FUNC_TYPE Load_instruNet_Driver_Generic(
	short forceInstruNetReset, short *driverIsInstalledOK, short *numNetworks);	

short /* iNetError */ EXT_FUNC_TYPE Show_ALERT_if_hit_iNet_Error_Generic(short e);

short /* iNetError */ EXT_FUNC_TYPE Open_instruNet_Window_Generic(		
	short iNetWindowType, short *netNumP, short *deviceNumP, short *moduleNumP,
	short *chanNumP, short *settingGpP, short *fieldNumP, short *userPressedOkP);

short /* iNetError */ EXT_FUNC_TYPE Open_instruNet_Window_Easy( short iNetWindowType);

short /* iNetError */ EXT_FUNC_TYPE Get_instruNet_Network_State_Generic(
	short *arrayStart, long arraySizeBytes, long *numBytesOfDataP);

short /* iNetError */ EXT_FUNC_TYPE Set_instruNet_Network_State_Generic(short  *arrayStart,	long dataSize);

short /* iNetError */ EXT_FUNC_TYPE iNet_Generic(short netNum, short devNum, short modNum,
	short chNum, short settingGroupNumOrType, short fieldNum, short intention,
	short argType, short *ptrToArg);
	
short /* iNetError */ EXT_FUNC_TYPE iNet_rw_int16( short netNum, short devNum, short modNum,
	short chNum, short settingGroupNumOrType, short fieldNum, short intention, short *ptrToArg);

short /* iNetError */ EXT_FUNC_TYPE iNet_rw_int32( short netNum, short devNum, short modNum,
	short chNum, short settingGroupNumOrType, short fieldNum, short intention, long *ptrToArg);

short /* iNetError */ EXT_FUNC_TYPE iNet_rw_Double( short netNum, short devNum, short modNum,
	short chNum, short settingGroupNumOrType, short fieldNum, short intention, double *ptrToArg);

short /* iNetError */ EXT_FUNC_TYPE iNet_rw_cStr( short netNum, short devNum, short modNum,
	short chNum, short settingGroupNumOrType, short fieldNum, short intention, char *ptrToArg);

void EXT_FUNC_TYPE Flt32ToDouble_iNet_Generic(long * /* (iNetFLT32 *) */ srcAddr_flt32Array, 
	double *destAddr_doubleArray, long numPoints);

void EXT_FUNC_TYPE Flt32ToDouble_iNet_Vee(long /* (iNetFLT32 *) */ srcAddr_flt32Array,
	double *destAddr_doubleArray, long numPoints);

void EXT_FUNC_TYPE DoubleToFlt32_iNet_Generic( double *srcAddr_doubleArray,
	long * /* (iNetFLT32 *) */ destAddr_flt32Array, long numPoints);
	
void EXT_FUNC_TYPE DoubleToFlt32_iNet_Vee( double *srcAddr_doubleArray,
	long /* (iNetFLT32 *) */ destAddr_flt32Array, long numPoints);	

short /* iNetError */ EXT_FUNC_TYPE GetDigitizedSegment_Generic(short digChNum,
	void **bufferStartAddrP, long *pointToPullindex_base1, long *numPointsToPull,
	long *scanNumberToPull_base1);

short /* iNetError */ EXT_FUNC_TYPE GetDigitizedSegment_Vee(short digChNum,
	/* (iNetFLT32 **) */ long *bufferStartAddrP, long *pointToPullindex_base1,
	long *numPointsToPull, long *scanNumberToPull_base1);

void EXT_FUNC_TYPE iNet_SetStaticVar(short address, short value);
short EXT_FUNC_TYPE iNet_GetStaticVar(short address);

//	void CloseDriverAndReleaseDriverRam( void );

//	void EXT_FUNC_TYPE Show_Simple_Alert(char *cString);


/* ======================== Open instruNet World Window (MACROS) ==============================
 *
 *	These macros are used to open to a specific page in the instruNet World window.  When
 *	this occurs, program control is owned by the driver (i.e. inside the macro) until
 *	the user Quits/Exits the instruNet World window.  instruNet World is fully functional
 *	while it is open, and the user can stay in there as long as desired.
 *
 *	OPEN_iNet_WINDOW(iNetCM_OpenWindow_Record)			Open instruNet World's Record Page.
 *	OPEN_iNet_WINDOW(iNetCM_OpenWindow_Network)			Open instruNet World's Network Page.
 *	OPEN_iNet_WINDOW(iNetCM_OpenWindow_Test)			Open instruNet World's Test Page.
 *	OPEN_iNet_WINDOW(iNetCM_OpenWindow_Probe)			Open instruNet World Probe dialog.
 *	OPEN_iNet_WINDOW(iNetCM_OpenWindow_SimpleTiming)	Open the SampleRate & PtsPerScan dlog.
 */
 
										/*	open instruNet World's window */
#define /* iNetError */ OPEN_iNet_WINDOW(specificPage)  \
	(iNetError) iNet_int32((iNetUINT8) netNum_DRIVER /* 0 */, (iNetUINT8) deviceNum_DRIVER /* 0 */,	 \
		  (iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) driver_ChanNum_OpenWindow /* 1 */,  \
		 sgt_General /* -6 */, fldNum_General_valueEu /* 1 */, intention_setValue /* 2 */,  \
		 (iNetINT32) specificPage)


/* ============================ Press instruNet Button (MACROS) ==============================
 *	
 *	These macros are used to press a Button within the instruNet World window (i.e. the buttons
 *	at the top of the instruNet World window).  The instruNet World window does not need to
 *	be open in order to do this.  For example, if you press the 'Store' button in NETWORK page,
 *	the state of all fields will be stored to disk, even though the user does not "see
 *	anything".
 *
 *	Values for 'specificButton' defined in file "inet_int.h"
 *  (search for "iNet_Standard_ButtonID"):
 *
 *		iNet_ButtonID_Record_Start			Press 'Start' button in RECORD page
 *		iNet_ButtonID_Record_Stop			Press 'Stop' button in RECORD page
 *		iNet_ButtonID_Record_Open			Press 'Open' button in RECORD page
 *		iNet_ButtonID_Record_Save			Press 'Save' button in RECORD page
 *		iNet_ButtonID_Record_Setup			Press 'Setup' button in RECORD page
 *		iNet_ButtonID_Record_Print			Press 'Print' button in RECORD page
 *		iNet_ButtonID_Record_Options		Press 'Options' button in RECORD page
 *		iNet_ButtonID_Record_Timing			Press 'Timing' button in RECORD page
 *		iNet_ButtonID_Record_Trigger		Press 'Trigger' button in RECORD page
 *		iNet_ButtonID_Record_Probe			Press 'Probe' button in RECORD page
 *		iNet_ButtonID_Record_Directory		Press 'Directory' button in RECORD page
 *		iNet_ButtonID_Record_CalOptions		Press 'Calibration Options' button in RECORD page
 *
 *		iNet_ButtonID_Network_Restore		Press 'Restore' button in NETWORK page
 *		iNet_ButtonID_Network_Store			Press 'Store' button in NETWORK page
 *		iNet_ButtonID_Network_Open			Press 'Open' button in NETWORK page
 *		iNet_ButtonID_Network_Save			Press 'Save' button in NETWORK page
 *		iNet_ButtonID_Network_Clear			Press 'Clear' button in NETWORK page
 *		iNet_ButtonID_Network_Reset			Press 'Reset' button in NETWORK page
 *		iNet_ButtonID_Network_Recal			Press 'Recal' button in NETWORK page
 *		iNet_ButtonID_Network_Create		Press 'Create' button in NETWORK page
 *		iNet_ButtonID_Network_Detete		Press 'Detete' button in NETWORK page
 *
 *		iNet_ButtonID_Script_Execute		Press 'Execute' button in SCRIPT page
 *		iNet_ButtonID_Script_Stop			Press 'Stop' button in SCRIPT page
 *		iNet_ButtonID_Script_Open			Press 'Open' button in SCRIPT page
 *		iNet_ButtonID_Script_Save			Press 'Save' button in SCRIPT page
 *		iNet_ButtonID_Script_SaveAs			Press 'Save As' button in SCRIPT page
 *		iNet_ButtonID_Script_Clear			Press 'Clear' button in SCRIPT page
 *		iNet_ButtonID_Script_Print			Press 'Print' button in SCRIPT page
 *
 *		iNet_ButtonID_Test_Test				Press 'Test' button in TEST page
 *		iNet_ButtonID_Test_BigTest			Press 'Big Test' button in TEST page
 *		iNet_ButtonID_Test_Open				Press 'Open' button in TEST page
 *		iNet_ButtonID_Test_SaveAs			Press 'Save As' button in TEST page
 *		iNet_ButtonID_Test_Clear			Press 'Clear' button in TEST page
 *		iNet_ButtonID_Test_Report			Press 'Report' button in TEST page
 *		iNet_ButtonID_Test_Print			Press 'Print' button in TEST page
 */
										/*	press button in instruNet World */
#define /* iNetError */ PRESS_iNet_BUTTON(specificButton)  \
	(iNetError) iNet_int32((iNetUINT8) netNum_DRIVER /* 0 */, (iNetUINT8) deviceNum_DRIVER /* 0 */,  \
		  (iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) driver_ChanNum_PushButton /* 2 */,  \
		  sgt_General /* -6 */, fldNum_General_valueEu /* 1 */, intention_setValue /* 2 */,  \
		  (iNetINT32) specificButton)


/* ============================= ERROR CONTROL (MACROS) =================================
 *
 *	These marcos are used to control and monitor whether or not the driver shows
 *	an ERROR ALERT (i.e. a dialog box) when an error occurs.
 *
 *	SHOW_MESSAGE_DIALOG_UPON_ERROR()		
 *
 *		Tells Driver to show a Error message dialog box whenever an error occurs.
 *		Returns TRUE (1) if Driver WAS (before this call) set up to show an alert
 *		upon error; FALSE (0) otherwise
 *
 *	DONT_SHOW_MESSAGE_DIALOG_UPON_ERROR()		
 *
 *		Tells Driver to NOT show an Error message dialog box whenever an error occurs.
 *		Returns TRUE (1) if Driver WAS (before this call) set up to show an alert
 *		upon error; FALSE (0) otherwise
 *
 *	GET_SHOW_MESSAGE_UPON_ERROR_STATUS()
 *
 *		Returns TRUE (1) if Driver is set up to show an alert upon error; FALSE (0) otherwise.
 *
 *	SET_ALL_ALERTS_ON_OFF( showAlerts_ )
 *
 *		If 'showAlerts_' == 0, all alerts are turned OFF; otherwise, we show them normally.
 *		Careful, this might turn off important and necessary alerts and cause major problems.
 *		Use at your own risk. CAREFUL.  gsw 10/28/97
 *
 *	SET_DEMO_MODE( demoMode )
 *
 *		Sets 1x iNet100 demonstration mode.  Please see Set_iNet_Demo_Mode() in INET_INT.C
 *		to learn more. gsw 3/8/98
 *
 *	GET_DEVICE_SIMULATION_STATE( netNum, devNum )
 *
 *		Returns 1 if the device is currently being simulated, 0 otherwise. gsw 1/15/99
 */

#define SHOW_MESSAGE_DIALOG_UPON_ERROR()  \
	iNet_int32(0,0,0,0,0,0,intention_ShowAlertOnError /* 8000 */,0)

#define DONT_SHOW_MESSAGE_DIALOG_UPON_ERROR()  \
	iNet_int32(0,0,0,0,0,0,intention_NoShowAlertOnError /* 8001 */,0)

#define GET_SHOW_MESSAGE_UPON_ERROR_STATUS()  \
	iNet_int32(0,0,0,0,0,0,intention_GetShowAlertOnErrorStatus /* 8002 */,0)

#define SET_ALL_ALERTS_ON_OFF(showAlerts_) 	\
	iNet_int32(0,0,0,0,0,0,(iNetINT16) intention_SetAllAlertsOnOff /* 8029 */, \
		(iNetINT32) showAlerts_)

//	End Users should call Set_iNet_Demo_Mode() instead of SET_DEMO_MODE()
#define SET_DEMO_MODE(demoMode_) 	\
	iNet_int32(0,0,0,0,0,0,(iNetINT16) intention_SetDemoMode /* 8037 */, (iNetINT32) demoMode_)

#define GET_DEVICE_SIMULATION_STATE(netNum_, devNum) 	\
	((Boolean) iNet_int32(netNum_, devNum, 0,0,0,0,(iNetINT16) intention_GetDevSimuState /* 8038 */, 0L))


 /* ============================= INTERNAL MEMORY CONTROL =================================
 *
 *	LOCK_INTERNAL_INET_MEMORY()
 *
 *		Lock internal memory so that future calls to iNet() are less likely to move
 *		memory (useful when calling iNet from interrupts). gsw 1/27/97
 *
 *	UNLOCK_INTERNAL_INET_MEMORY()
 *
 *		Internal memory is not locked when the processor is outside of iNet(). gsw 1/27/97
 */
 
#define LOCK_INTERNAL_INET_MEMORY()	 \
	iNet_int32(0,0,0,0,0,0,intention_lockInternalMemory /* 8041 */,0)

#define UNLOCK_INTERNAL_INET_MEMORY()  \
	iNet_int32(0,0,0,0,0,0,intention_unlockInternalMemory /* 8042 */,0)


/* ========================= INTERROGATE NETWORK MACROS ===============================
 *
 *	These marcos are used to determine the number of Networks, Devices, Modules,
 *	Channels, Settings and Fields are in the instruNet Hierarchial network.
 *
 *	GET_NUMBER_OF_NETWORKS()		
 *
 *		Returns the # of instruNet Networks.
 *
 *	GET_NUMBER_OF_DEVICES(netNum)	
 *
 *		Returns the # of Devices in the specified Network.
 *									
 *	GET_NUMBER_OF_MODULES(netNum, devNum)
 *
 *		Returns the # of Modules in the specified {Network, Device}.
 *					
 *	GET_NUMBER_OF_CHANNELS(netNum, devNum, modNum)
 *
 *		Returns the # of Channels in the specified {Network, Device, Module}.
 *
 *	GET_NUMBER_OF_SETTINGS(netNum, devNum, modNum, chNum)
 *
 *		Returns the # of Settings in the specified {Network, Device, Module, Channel}.
 *
 *	GET_NUMBER_OF_FIELDS(netNum, devNum, modNum, chNum, settingsGroupNum)
 *
 *		Returns the # of Fields in the specified {Network, Device, Module, Channel, SettingGroup}.
 */

#define GET_NUMBER_OF_NETWORKS()    \
	iNet_int32(0,0,1,1,1,1, intention_GetNumNetworks /* 8009 */, (iNetINT32) 0)

#define GET_NUMBER_OF_DEVICES(netNum)    \
	iNet_int32((iNetUINT8) netNum,0,1,1,1,1,intention_GetNumDevices /* 8010 */,0)

#define GET_NUMBER_OF_MODULES(netNum,devNum)    \
	iNet_int32((iNetUINT8)netNum,(iNetUINT8)devNum,1,1,1,1,intention_GetNumModules /* 8011 */,0)
										
#define GET_NUMBER_OF_CHANNELS(netNum,devNum,modNum)    \
	iNet_int32((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,1,1,1,intention_GetNumChannels /* 8012 */,0)
	
#define GET_NUMBER_OF_SETTINGS(netNum,devNum,modNum,chNum)    \
	iNet_int32((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,(iNetUINT8)chNum,1,1,intention_GetNumSettings /* 8013 */,0)

#define GET_NUMBER_OF_FIELDS(netNum,devNum,modNum,chNum,settingGroupNum)    \
	iNet_int32((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,(iNetUINT8)chNum,settingGroupNum,1,intention_GetNumFields /* 8014 */,0)


/* =================== DETERMINE IF NETWORK ELEMENT EXISTS (MACROS) =====================
 *
 *	These marcos are used to determine if the specified network elements
 *	exists.
 *
 *	THIS_NETWORK_EXISTS(netNum)		
 *
 *		Returns 1 if NETWORK = {netNum} exists; FALSE (0) otherwise.
 *
 *	THIS_DEVICE_EXISTS(netNum, devNum)		
 *
 *		Returns 1 if DEVICE = {netNum, devNum} exists; FALSE (0) otherwise.
 *
 *	THIS_MODULE_EXISTS(netNum, devNum, modNum)		
 *
 *		Returns 1 if MODULE = {netNum, devNum, modNum} exists; FALSE (0) otherwise.
 *
 *	THIS_CHANNEL_EXISTS(netNum, devNum, modNum, chNum)	
 *
 *		Returns 1 if CHANNEL = {netNum, devNum, modNum, channelNum} exists;
 *		FALSE (0) otherwise.
 *
 *	THIS_SETTING_EXISTS(netNum, devNum, modNum, chNum, settingsGroupNum)	
 *
 *		Returns 1 if SETTING = {netNum, devNum, modNum, channelNum, settingNum}
 *		exists; FALSE (0) otherwise.
 *
 *	THIS_FIELD_EXISTS(netNum, devNum, modNum, chNum, settingsGroupNum, fieldNum)		
 *
 *		Returns 1 if FIELD = {netNum, devNum, modNum, channelNum, settingNum,
 *		fieldNum} exists; FALSE (0) otherwise.
 */

#define THIS_NETWORK_EXISTS(netNum)    \
	(((Boolean) (0L != iNet_int32((iNetUINT8) netNum,0,1,1,1,1,intention_ThisExists_Network /* 8003 */,0))) ? 1 : 0)

#define THIS_DEVICE_EXISTS(netNum,devNum)    \
	(((Boolean) (0L != iNet_int32((iNetUINT8) netNum,(iNetUINT8) devNum,1,1,1,1,intention_ThisExists_Device /* 8004 */,0))) ? 1 : 0)

#define THIS_MODULE_EXISTS(netNum,devNum,modNum)    \
	(((Boolean) (0L != iNet_int32((iNetUINT8) netNum,(iNetUINT8) devNum,(iNetUINT8) modNum,1,1,1,intention_ThisExists_Module /* 8005 */,0))) ? 1 : 0)
	
#define THIS_CHANNEL_EXISTS(netNum,devNum,modNum,chNum)    \
	(((Boolean) (0L != iNet_int32((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,(iNetUINT8)chNum,1,1,intention_ThisExists_Channel /* 8006 */,0))) ? 1 : 0)

#define THIS_SETTING_EXISTS(netNum,devNum,modNum,chNum,settingGroupNum)    \
	(((Boolean) (0L != iNet_int32((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,(iNetUINT8)chNum,settingGroupNum,1,intention_ThisExists_Setting /* 8007 */,0))) ? 1 : 0)

#define THIS_FIELD_EXISTS(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)    \
	(((Boolean) (0L != iNet_int32((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,(iNetUINT8)chNum,settingGroupNum,fieldNum,intention_ThisExists_Field /* 8008 */,0))) ? 1 : 0)


/* ================== Turn Channels on and off for digitizing (MACROS) ====================
 *
 *	ENABLE_CHANNEL_DIGITIZATION(netNum,devNum,modNum,chNum) 	
 *
 *		Enable Channel digitization by turning "Display" field ON in DISPLAY Setting.
 *
 *	DISABLE_CHANNEL_DIGITIZATION(netNum,devNum,modNum,chNum)
 *
 *		Disable Channel digitization by turning "Display" field OFF in DISPLAY Setting.
 *
 *	DISABLE_ALL_CHANNEL_DIGITIZING()
 *
 *		Disables channel digitizing for all channels in this network.  This will make
 *		sure that the "Display" field in the DISPLAY SettingGroups is OFF, and that
 *		the "Digitize" field is OFF in the FILE, USERBUFFER, and DRIVERBUFFER 
 *		SettingGroups. gsw 3/16/96
 *
 *	SET_UP_DIGITIZATION()
 *	
 *		Sets up digitization, establishes sample rate, sets up BUFFERS, yet does not
 *		actually do the digitization. gsw 8/16/98
 */

#define /* iNetError */ ENABLE_CHANNEL_DIGITIZATION(netNum, devNum, modNum, chNum)   \
	(iNetError) iNet_int32((iNetUINT8)netNum, (iNetUINT8)devNum, (iNetUINT8)modNum,  \
		(iNetUINT8)chNum,  sgt_Display /* -7 */, fldNum_Display_dispOnOff /* 1 */,  \
		intention_setValue /* 2 */, (iNetINT32) ion_gOnOffPopup_On /* 1 */)
	
#define /* iNetError */ DISABLE_CHANNEL_DIGITIZATION(netNum, devNum, modNum, chNum)  \
	(iNetError) iNet_int32((iNetUINT8)netNum, (iNetUINT8)devNum, (iNetUINT8)modNum,  \
		(iNetUINT8)chNum, sgt_Display /* -7 */, fldNum_Display_dispOnOff /* 1 */,  \
		 intention_setValue /* 2 */, (iNetINT32) ion_gOnOffPopup_Off /* 2 */)


#define DISABLE_ALL_CHANNEL_DIGITIZING(netNum) 		\
	iNet_int32((iNetUINT8) netNum, (iNetUINT8) 1, (iNetUINT8) 1, (iNetUINT8) 1,  \
				(iNetINT16) 1, (iNetINT16) 1, (iNetINT16) intention_DisableAllChannelDigitizing /* 4005 */,  \
				(iNetINT32) 0)
	
#define SET_UP_DIGITIZATION() 	\
	iNet_int32(0,0,0,0,0,0,(iNetINT16) intention_SetUpDigitization /* 8044 */, (iNetINT32) 0)


/* ===================================== TIMING (MACROS) ==================================
 *
 *	GET_SAMPLE_RATE_IN_HZ(netNum) 	
 *
 *		Returns the sample rate, in samples per second for each channel.
 *
 *	SET_SAMPLE_RATE_IN_HZ(netNum, newSampleRate_Hz)	
 *
 *		Sets the sample rate, in samples per second for each channel.
 *
 *	GET_POINTS_PER_SCAN(netNum)
 *
 *		Returns the number of POINTS in each SCAN.
 *
 *	SET_POINTS_PER_SCAN(netNum, numberOfPointsPerScan)
 *
 *		Sets the number of POINTS in each SCAN.
 *
 *	GET_NUMBER_OF_SCANS(netNum)
 *
 *		Returns the number SCANS.
 *
 *	SET_NUMBER_OF_SCANS(netNum, numberOfScans)
 *
 *		Sets the number SCANS.
 *
 *	GET_SCAN_MODE(netNum)
 *	
 *		Returns the Continous Mode (On (1), Off (2) or Off With Skip (3)).
 *
 *	SET_SCAN_MODE(netNum, ion_gScanModePopup_StripChart (1))
 *	SET_SCAN_MODE(netNum, ion_gScanModePopup_OscilloQueued (2))
 *	SET_SCAN_MODE(netNum, ion_gScanModePopup_Oscilloscope (3))
 *
 *		Sets the Scans mode to Strip Chart, Oscilloscope, or Oscillo Queued.
 *
 *	GET_NETWORK_BPS(netNum) 	
 *
 *		Returns the network data transfer rate, in bits per second.
 *
 *	SET_NETWORK_BPS(netNum, new_Network_BPS)	
 *
 *		Sets the network data transfer rate, in bits per second.
 *
 *	GET_SWITCHING(netNum) 	
 *
 *		Returns the channel switching mode as Accurate (1) or Fast (2).
 *
 *	SET_SWITCHING(netNum, switchingMode)	
 *
 *		Sets the channel switching mode to Accurate (1) or Fast (2).
 *
 *	CONTROLLER_IS_DIGITIZING(netNum)
 *
 *		Returns TRUE (1) if the controller is digitizing; FALSE (0) otherwise.
 *		
 *	GET_DIGITIZE_STATUS(netNum)
 *
 *		Returns the digitizing status of a instruNet DSP card { 1=digitize_off,
 *		2=digitize_interrupt_on, 3=digitize_highspeed_on }
 *
 *	SET_DIGITIZE_INTO(ion_gSaveDataPopup_Off)			Don't save data
 *	SET_DIGITIZE_INTO(ion_gSaveDataPopup_ToRamBuffer)	Save Data to RAM
 *	SET_DIGITIZE_INTO(ion_gSaveDataPopup_ToDisk)		Save Data to DISK
 *	SET_DIGITIZE_INTO(ion_gSaveDataPopup_UserControl)	Let user determine where to save
 *
 *		Save data to RAM, Disk or nowhere.
 *
 *	SET_OVERFLOW_ALERT(ion_gOnOffPopup_On)			Show an alert when buffer overflow occurs.
 *	SET_OVERFLOW_ALERT(ion_gOnOffPopup_Off)			Don't show an alert when buffer overflow occurs.
 *
 *		Set the Overflow Alert Field.
 */

#define GET_SAMPLE_RATE_IN_HZ(netNum)    									\
	iNet_flt32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_sampleRate /* 5 */, intention_getValue /* 1 */, (float) 0.0)

#define /* iNetError */ SET_SAMPLE_RATE_IN_HZ(netNum, newSampleRate_Hz)					\
	(iNetError) iNet_flt32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */,  \
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		sgt_Timing /* -13 */, fldNum_Timing_sampleRate /* 5 */, intention_setValue /* 2 */,  \
		(iNetFLT32) newSampleRate_Hz)

#define GET_POINTS_PER_SCAN(netNum)    										\
	iNet_uint32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */,  \
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		sgt_Timing /* -13 */, fldNum_Timing_ptsPerScan /* 2 */, intention_getValue /* 1 */, 0)

#define /* iNetError */ SET_POINTS_PER_SCAN(netNum, numberOfPointsPerScan)					\
	(iNetError) iNet_uint32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_ptsPerScan /* 2 */, intention_setValue /* 2 */, (iNetUINT32) numberOfPointsPerScan)

#define GET_NUMBER_OF_SCANS(netNum)    										\
	iNet_uint32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_noOfScans /* 3 */, intention_getValue /* 1 */, (iNetUINT32) 0)

#define /* iNetError */ SET_NUMBER_OF_SCANS(netNum, numberOfScans)							\
	(iNetError) iNet_uint32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_noOfScans /* 3 */, intention_setValue /* 2 */, (iNetUINT32) numberOfScans)

#define GET_SCAN_MODE(netNum)    										\
	iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */,  \
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		sgt_Timing /* -13 */, fldNum_Timing_scanMode /* 4 */, intention_getValue /* 1 */, (iNetINT32) 0)

#define /* iNetError */ SET_SCAN_MODE(netNum, scanMode)										\
	(iNetError) iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_scanMode /* 4 */, intention_setValue /* 2 */, (iNetINT32) scanMode)
		
#define GET_NETWORK_BPS(netNum)    											\
	iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_network_bps /* 6 */, intention_getValue /* 1 */,(iNetINT32) 0)

#define /* iNetError */ SET_NETWORK_BPS(netNum, new_Network_BPS)							\
	(iNetError) iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_network_bps /* 6 */, intention_setValue /* 2 */, (iNetINT32) new_Network_BPS)

#define GET_SWITCHING(netNum)    											\
	iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_switching /* 8 */, intention_getValue /* 1 */, (iNetINT32) 0)

#define /* iNetError */ SET_SWITCHING(netNum, switchingMode)							\
	(iNetError) iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, sgt_Timing /* -13 */,	\
		fldNum_Timing_switching /* 8 */, intention_setValue /* 2 */, (iNetINT32) switchingMode)
		
#define CONTROLLER_IS_DIGITIZING(netNum)    								\
	(((Boolean) (iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, (iNetUINT8) moduleNum_1stModule /* 1 */,	\
		(iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, (iNetINT16) sgt_Timing /* -13 */,	\
		(iNetINT16) fldNum_Timing_digitizeOnOff /* 1 */, (iNetINT16) intention_getValue /* 1 */, (iNetUINT32) 0)	\
			== ion_gOnOffPopup_On)) ? 1 : 0)

#define GET_DIGITIZE_STATUS(netNum__)    \
	iNet_int32((iNetUINT8) netNum__,0,0,0,0,0, intention_GetDigitizeStatus /* 8030 */, (iNetINT32) 0)

#define /* iNetError */ SET_DIGITIZE_INTO(saveDataOption)    									\
	(iNetError) iNet_int32((iNetUINT8) netNum_DRIVER /* 0 */, (iNetUINT8) deviceNum_DRIVER /* 0 */,	\
		  (iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) driver_ChanNum_RecordOptions,  \
		  (iNetINT16) sgt_RecordOptions, (iNetINT16) fldNum_RecordOptions_digitizeInto /* 6 */,	\
		  (iNetINT16) intention_setValue /* 2 */, (iNetINT32) saveDataOption)

#define /* iNetError */ SET_OVERFLOW_ALERT(overflowAlertOption)    		\
	(iNetError) iNet_int32((iNetUINT8) netNum_DRIVER /* 0 */, (iNetUINT8) deviceNum_DRIVER /* 0 */,	\
		  (iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) driver_ChanNum_RecordOptions,		\
		  (iNetINT16) sgt_RecordOptions, (iNetINT16) fldNum_RecordOptions_overflowAlert /* 7 */,	\
		  (iNetINT16) intention_setValue /* 2 */, (iNetINT32) overflowAlertOption)


/* ===================================== TRIGGER (MACROS) ==================================
 *
 *	SET_TRIGGER_MODE(netNum, ion_TriggerMode_Off) 	
 *	SET_TRIGGER_MODE(netNum, ion_TriggerMode_Auto) 	
 *	SET_TRIGGER_MODE(netNum, ion_TriggerMode_Norm) 	
 *
 *		Sets the Trigger mode to OFF, NORMAL or AUTOMATIC.
 *
 *	SET_TRIGGER_THRESHOLD(netNum, triggerThresholdEu)
 *
 *		Sets the Trigger threshold (engineering units) value.
 *
 *	SET_TRIGGER_SLOPE(netNum, ion_Rising)
 *	SET_TRIGGER_SLOPE(netNum, ion_Falling)
 *
 *		Set the Trigger slope to rising or falling.
 *
 *	SET_TRIGGER_HYSTERESIS(netNum, hysteresisEu)
 *
 *		Set the trigger hysteresis in engineering units.  If set to
 *		0.0, then the trigger hysteresis is automatically chosen.
 *
 *	SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcNet, netNum)
 *	SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcDevice, devNum)
 *	SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcModule, modNum)
 *	SET_TRIGGER_SOURCE(netNum, fldNum_Trigger_srcChannel, chNum)
 *
 *		Sets the network address of the trigger source.
 */

#define /* iNetError */ SET_TRIGGER_MODE(netNum, triggerMode)								\
	(iNetError) iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, 	\
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		(iNetINT16) sgt_Trigger /* -14 */, (iNetINT16) fldNum_Trigger_triggerModePop /* 1 */,	\
		(iNetINT16) intention_setValue /* 2 */, (iNetINT32) triggerMode)

#define /* iNetError */ SET_TRIGGER_THRESHOLD(netNum, triggerThresholdEu)					\
	(iNetError) iNet_flt32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, 	\
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		(iNetINT16) sgt_Trigger /* -14 */, (iNetINT16) fldNum_Trigger_thresholdEu /* 2 */,	\
		(iNetINT16) intention_setValue /* 2 */, triggerThresholdEu)

#define /* iNetError */ SET_TRIGGER_SLOPE(netNum, triggerSlope)								\
	(iNetError) iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, 	\
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		(iNetINT16) sgt_Trigger /* -14 */, (iNetINT16) fldNum_Trigger_slopeRisFalPop /* 3 */,	\
		(iNetINT16) intention_setValue /* 2 */, (iNetINT32) triggerSlope)

#define /* iNetError */ SET_TRIGGER_HYSTERESIS(netNum, hysteresisEu)					\
	(iNetError) iNet_flt32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, 	\
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		(iNetINT16) sgt_Trigger /* -14 */, (iNetINT16) fldNum_Trigger_hysteresis /* 4 */,	\
		(iNetINT16) intention_setValue /* 2 */, (iNetFLT32) hysteresisEu)

#define /* iNetError */ SET_TRIGGER_SOURCE(netNum, fldNum_Src, srcNum)						\
	(iNetError) iNet_int32((iNetUINT8) netNum, (iNetUINT8) deviceNum_CONTROLLER /* 0 */, 	\
		(iNetUINT8) moduleNum_1stModule /* 1 */, (iNetUINT8) controller_ChanNum_C12_Digitizer /* 12 */, \
		(iNetINT16) sgt_Trigger /* -14 */, (iNetINT16) fldNum_Src,			\
		(iNetINT16) intention_setValue /* 2 */, (iNetINT32) srcNum)


/* =============================== USER INTERFACE (MACROS) ===============================
 *
 *	GET_USER_INTERFACE_TYPE(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)
 *
 *		Returns the user interface type (i.e. fieldUserInterfaceType enum in
 *		header file; e.g. fuit_editField_flt32, fuit_staticText_int16, 
 *		fuit_popup_OnOff).
 *
 *	GET_USER_INTERFACE_CATAGORY(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)
 *
 *		Returns the user interface catagory (i.e. itemType_iNet enum in
 *		header file; e.g. i_sText (3), i_eText (4), 
 *		i_uItem (popup) (5)).
 *
 *	GET_NATIVE_STORAGE_TYPE(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)
 *
 *		Returns the native storage type for the field (i.e. iNetDataType enum in
 *		header file; e.g. iNetDT_INT16 (0), iNetDT_INT32 (3), iNetDT_UINT32 (4)
 *		iNetDT_FLT32 (5)).
 *
 *	GET_CHANNEL_DIRECTION(netNum,devNum,modNum,chNum)
 *
 *		Returns the direction of the channel: 0 is input (e.g. a/d), and 1 is output (e.g. d/a).
 *		gsw 5/1/96
 *
 *	GET_CHANNEL_CATEGORY(netNum,devNum,modNum,chNum)
 *
 *		Returns the channel category: (dir_hdwr_input_circBuf = 1) for input channels (e.g. a/d),
 *		(dir_hdwr_output_circBuf = 2) for output channels (e.g. d/a), and
 *		(dir_hdwr_inAndOut_circBuf = 4) for both input and output channel, yet digitized
 *		as in input (e.g. iNet 100 digital i/o, controller digital/timer i/o). gsw 10/27/97 
 *
 *	GET_CHANNEL_TYPE(netNum,devNum,modNum,chNum)
 *
 *		Returns the type of the channel (please see the ion_channelType in file
 *		INET_INT.H for a list of types). gsw 10/27/97
 *
 *	GET_CHANNEL_DIGITIZEABLE(netNum,devNum,modNum,chNum)
 *
 *		Returns true (1) if this channel is digitizeable (e.g. d/a, a/d, model 100 digital i/o).
 *		If not digitizeable, you must use the low speed scalar read/write channel
 *		routines to read the channel. gsw 10/27/97 
 *
 *	GET_NUMBER_OF_POPUP_ITEMS(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)
 *
 *		Returns the number of items in a popup, if the field user interface is a popup.
 *		(e.g. returns 2 if the popup shows {"ON", "Off"}).
 *
 *	GET_PTR_TO_POPUP_ITEMS(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)
 *
 *		Returns the pointer to an array of C Str15 strings that contain the items
 *		in the popup (i.e. iNetStr15 popupItems[]). 
 *
 *	GET_PTR_TO_ADDRESS_NAMES(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)
 *
 *		Returns the pointer to an array of C Str15 strings that contain the names
 *		of the Network, Device, Module, Channel, Settings, Field (i.e. 
 *		iNetStr15 array[0] = Network Name, array[1] = Device Name, array[2] = Module Name,
 *		array[3] = Channel Name, array[4] = Settings Name, array[5] = Field Name).
 */

#define GET_USER_INTERFACE_TYPE(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8) devNum,(iNetUINT8) modNum, \
	(iNetUINT8) chNum,settingGroupNum,fieldNum,intention_getUserInterfaceType,0)

#define GET_USER_INTERFACE_CATAGORY(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8) devNum,(iNetUINT8) modNum, \
	(iNetUINT8) chNum,settingGroupNum,fieldNum,intention_Get_UI_Catagory,0)

#define GET_NATIVE_STORAGE_TYPE(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8) devNum,(iNetUINT8) modNum,\
	(iNetUINT8) chNum,settingGroupNum,fieldNum,intention_nativeStorageType,0)

#define GET_CHANNEL_DIRECTION(netNum,devNum,modNum,chNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,\
	(iNetUINT8)chNum,1,1,intention_GetChannelDirection,0)

#define GET_CHANNEL_CATEGORY(netNum,devNum,modNum,chNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum, \
	(iNetUINT8)chNum,1,1,intention_GetChannelCategory,0)

#define GET_CHANNEL_TYPE(netNum,devNum,modNum,chNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,\
	(iNetUINT8)chNum,1,1,intention_GetChannelType,0)

#define GET_CHANNEL_DIGITIZEABLE(netNum,devNum,modNum,chNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum,\
	(iNetUINT8)chNum,1,1,intention_GetChannelDigitizeable,0)

#define GET_NUMBER_OF_POPUP_ITEMS(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)	\
	iNet_int32((iNetUINT8) netNum,(iNetUINT8) devNum,(iNetUINT8) modNum,\
	(iNetUINT8) chNum,settingGroupNum,fieldNum,intention_Get_NumPopupItems,0)

#define GET_PTR_TO_POPUP_ITEMS(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)		\
	iNet_uint32((iNetUINT8) netNum,(iNetUINT8) devNum,(iNetUINT8) modNum,\
	(iNetUINT8) chNum,settingGroupNum,fieldNum,intention_Get_PopupStringArray,0)

#define GET_PTR_TO_ADDRESS_NAMES(netNum,devNum,modNum,chNum,settingGroupNum,fieldNum)	\
	iNet_uint32((iNetUINT8) netNum,(iNetUINT8) devNum,(iNetUINT8) modNum,\
	(iNetUINT8) chNum,settingGroupNum,fieldNum,intention_Get_AddrNamesStringArray,0)


/* ========================= GET and SET CHANNEL VALUES (MACROS) ==========================
 *
 *	GET_CHANNEL_VALUE_FLT32(netNum, devNum, modNum, chNum)
 *
 *		Returns the realtime value of the channel, in floating point format.
 *
 *	GET_CHANNEL_VALUE_INT32(netNum, devNum, modNum, chNum)
 *
 *		Returns the realtime value of the channel, in +/- 2billion integer format.
 *
 *	GET_CHANNEL_VALUE_C_STR255(netNum, devNum, modNum, chNum, ptrTo_Callers_C_Str255)
 *
 *		Returns the realtime value of the channel, into a pointer to the caller's C string.
 *
 *	SET_CHANNEL_VALUE_FLT32(netNum, devNum, modNum, chNum, newValue_flt32)
 *
 *		Sets the value of the channel, with a floating point number.
 *
 *	SET_CHANNEL_VALUE_INT32(netNum, devNum, modNum, chNum, newValue_int32)
 *
 *		Sets the realtime value of the channel, with a +/- 2billion integer format.
 *
 *	SET_CHANNEL_VALUE_C_STR255(netNum, devNum, modNum, chNum, ptrTo_Callers_C_Str255)
 *
 *		Sets the realtime value of the channel, with a pointer to the caller's C string.
 */
 
#define GET_CHANNEL_VALUE_FLT32(netNum,devNum,modNum,chNum) \
	iNet_flt32((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum, \
		(iNetUINT8)chNum,(iNetINT16)sgt_General /* -6 */, \
		(iNetINT16)fldNum_General_valueEu /* 1 */, (iNetINT16)intention_getValue /* 1 */, (float) 0.0)

#define GET_CHANNEL_VALUE_INT32(netNum,devNum,modNum,chNum)  \
	iNet_int32((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum, \
		(iNetUINT8)chNum,(iNetINT16)sgt_General /* -6 */, \
		(iNetINT16)fldNum_General_valueEu /* 1 */, (iNetINT16)intention_getValue /* 1 */,0)

#define GET_CHANNEL_VALUE_C_STR255(netNum,devNum,modNum,chNum,ptrTo_Callers_C_Str255) \
	iNet_cString((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum, \
		(iNetUINT8)chNum,(iNetINT16)sgt_General /* -6 */,(iNetINT16)fldNum_General_valueEu /* 1 */, \
		(iNetINT16)intention_getValue /* 1 */, (char *) ptrTo_Callers_C_Str255) 

#define /* iNetError */ SET_CHANNEL_VALUE_FLT32(netNum,devNum,modNum,chNum,newValue_flt32)	\
	(iNetError) iNet_flt32((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum, \
		(iNetUINT8)chNum,(iNetINT16)sgt_General /* -6 */,(iNetINT16)fldNum_General_valueEu /* 1 */, \
		(iNetINT16)intention_setValue /* 2 */, (iNetFLT32) newValue_flt32)

#define /* iNetError */ SET_CHANNEL_VALUE_INT32(netNum,devNum,modNum,chNum,newValue_int32) \
	(iNetError) iNet_int32((iNetUINT8)netNum,(iNetUINT8)devNum,(iNetUINT8)modNum, \
		(iNetUINT8)chNum,(iNetINT16)sgt_General /* -6 */,(iNetINT16)fldNum_General_valueEu /* 1 */, \
		(iNetINT16)intention_setValue /* 2 */, (iNetINT32) newValue_int32)

#define SET_CHANNEL_VALUE_C_STR255(netNum,devNum,modNum,chNum,ptrTo_Callers_C_Str255) \
	iNet_cString((iNetUINT8) netNum,(iNetUINT8)devNum,(iNetUINT8)modNum, \
		(iNetUINT8)chNum,(iNetINT16)sgt_General /* -6 */,(iNetINT16)fldNum_General_valueEu /* 1 */, \
		(iNetINT16) intention_setValue /* 2 */, (char *) ptrTo_Callers_C_Str255)


/* ========================= LOAD/SAVE instruNet NETWORK STATE (MACROS) ==========================
 *
 *	GET_HANDLE_TO_NETWORK_STATE()
 *
 *		Returns a Handle to the Network State (in uint32). The Caller must dispose of it
 *		after using it (e.g. DisposHandle() on Macintosh, GlobalFree() on Windows). To get
 *		the Handle size, call GetHandleSize() on Macintosh, ssssssss() on Windows).
 *
 *	SET_NETWORK_STATE_WITH_HANDLE(callerHandleToNetworkState)
 *
 *		Sets the network state with the passed Handle. The Caller must dispose after
 *		calling this routine.  The handle must have originated from a 
 *		GET_HANDLE_TO_NETWORK_STATE() call that was done previously.
 *
 *	DISPOSE_OF_HANDLE()
 *
 *		Disposes of a handle's memory, and sets the handle to 0.
 *
 *	DISPOSE_OF_ALL_NETWORK_STATE()
 *
 *		Dispose of all instruNet network state.  This will cause the the next
 *		call to the instruNet driver to implement the POWER ON boot process. 
 *		Call CloseDriverAndReleaseDriverRam() to release ram held by the driver
 *		itself. gsw 9/8/96 gsw 9/8/96
 *
 *	MOUSE_BUTTON_IS_DOWN()
 *
 *		Returns TRUE (1) if the mouse button is down; FALSE (0) otherwise.
 */

#define GET_HANDLE_TO_NETWORK_STATE() 	\
	iNet_uint32(0,0,1,1,1,1, (iNetINT16) intention_getHandleToNetworkState /* 8022 */, \
		(iNetUINT32) 0)

#define SET_NETWORK_STATE_WITH_HANDLE(callerHandleToNetworkState) 	\
	iNet_uint32(0,0,1,1,1,1,(iNetINT16)intention_setNetworkStateWithHandle /* 8023 */,\
		 (iNetUINT32) callerHandleToNetworkState)

#define DISPOSE_OF_ALL_NETWORK_STATE()		\
	iNet_int32(0,0,1,1,1,1, (iNetINT16) intention_disposeOfNetworkState /* 8024 */, \
		(iNetINT32) 0)

#if (MACHINE_TYPE_ == MACINTOSH_iNet)	/*	============== Macintosh =============== */
									
										// 	use iNet_Dispose_Handle() instead of: #define DISPOSE_OF_HANDLE(h) DisposHandle((*(Handle *) &h)); (*(Handle *) &h) = (Handle) 0L
	#include <Events.h>					/*	for Button() */

										/*	returns true if mouse button is down */
	#define MOUSE_BUTTON_IS_DOWN()		Button()
	
#elif (MACHINE_TYPE_ == WINTEL_iNet) 	/*	============  Windows/Intel ============ */

										// use iNet_Dispose_Handle() instead of: #define DISPOSE_OF_HANDLE(h) GlobalFree((*(HGLOBAL *) &h)); (*(HGLOBAL *) &h) = (HGLOBAL) 0L

										/*	true if mouse button is down */
	#define MOUSE_BUTTON_IS_DOWN()		( GetAsyncKeyState( VK_LBUTTON ) < 0 )

#endif

	

/* ====================== SERVICE THE DIGITIZATON PROCESS (MACROS) ========================
 *
 *	SERVICE_ALL_DIGITIZE_BUFFERS()
 *
 *		Services all buffers during the digitization process if they are holding new data,
 *		otherwise this does nothing.  This must be done continuously
 *		while digitizing.  Returns TRUE (1) if the next data pulled out
 *		out of the buffers is that last pull; FALSE (0) otherwise. A_PARAM()
 *		is set to TRUE (1) if we pulled to the end of a Scan; FALSE (0)
 *		otherwise.  B_PARAM() is set to the last scan # (base 1) that was pulled in full
 *		from 'netNum' controller. C_PARAM() is set to the last scan # (base 1) that
 *		was pushed in full from 'netNum' controller.
 */

#define SERVICE_ALL_DIGITIZE_BUFFERS(netNum) 	\
	 iNet_int32((iNetUINT8)netNum, 0,1,1,1,1,(iNetINT16)intention_serviceAllDigitizeBuffers, (iNetINT32) 0)

/* Get info about controller ram buffer, gsw 2/28/98 */

#define GET_CTLR_BUFFER_INFO(netNum) 	\
	 iNet_int32((iNetUINT8)netNum, 0,1,1,1,1,(iNetINT16)intention_getCtlrBufferInfo, (iNetINT32) 0)


/* ============================ DRIVER MANAGEMENT (MACROS) ===============================
 *
 *	DRIVER_IS_INSTALLED()
 *
 *		Returns TRUE (1) if the instruNet Driver is installed; FALSE (0) otherwise.
 *
 *	SECONDS_SINCE_RESET(netNum)
 *
 *		Returns the # of seconds since reset.  This is derived from a 62bit
 *		4MHZ counter on the instruNet Controller board
 *
 *  GET_IWP_LICENSE_STATE()
 *
 *		Returns 1 if licensed for iW+, 0 otherwise. Requires iNet software >= 2.0, gsw 7/7/03
 */

#define DRIVER_IS_INSTALLED() 	\
	 ((GET_NUMBER_OF_NETWORKS() < INT32_MAX) ? ((error_PARAM(gRequestP) == iNetErr_None) ? 1 /* driver installed */ : 0 /* not installed */) : 0)

#define SECONDS_SINCE_RESET(netNum) 	\
	iNet_flt32((iNetUINT8) netNum, (iNetUINT8)deviceNum_CONTROLLER /* 0 */, \
		(iNetUINT8)moduleNum_1stModule /* 1 */, (iNetUINT8)controller_ChanNum_C11_Time /* 11 */, \
		(iNetINT16)sgt_General /* -6 */, (iNetINT16)fldNum_General_valueEu /* 1 */, \
		(iNetINT16) intention_getValue /* 1 */, (iNetFLT32) 0.0)

#define GET_IWP_LICENSE_STATE()  \
	iNet_int32(0,0,0,0,0,0,intention_Get_iWp_LicenseState /* 8045 */,0)

/* ============================== SHOW PROBE DIALOG (MACROS) =============================
 *
 *	SHOW_PROBE_DIALOG()
 *
 *		Shows the full probe dialog.  On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP),
 * 		etc contain the accessed address.
 *
 *	SHOW_CHANNEL_ADDRESS_DIALOG()
 *
 *		Shows the probe dialog with the channel address only ([net/dev/mod/chan] popups).
 *		On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), etc contain the accessed
 *		address. A_PARAM(gRequestP) is set to 1 if the user pressed CANCEL, 0 if the user pressed
 *		OK to exit the dialog.
 *
 *	SHOW_FIELD_ADDRESS_DIALOG()
 *
 *		Shows the probe dialog with the field address only ([net/dev/mod/chan/set/Field] popups).
 *		On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), etc contain the accessed
 *		address. A_PARAM(gRequestP) is set to 1 if the user pressed CANCEL, 0 if
 *		the user pressed OK to exit the dialog.
 *
 *	SHOW_PROBE_DIALOG_WITH_FIXED_CHANNEL()	
 *
 *		Shows the probe dialog with a fixed field address (net/dev/mod/chan).
 *		On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), etc contain the accessed
 *		address. A_PARAM(gRequestP) is set to 1 if the user pressed CANCEL, 0 if
 *		the user pressed OK to exit the dialog. gsw 2/18/97
 *
 *	SHOW_PROBE_DIALOG_WITH_FIXED_CHANNEL_AND_GROUP()
 *
 *		Shows the probe dialog with a fixed field address (net/dev/mod/chan) and fixed SettingsGroup.
 *		On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), etc contain the accessed
 *		address. A_PARAM(gRequestP) is set to 1 if the user pressed CANCEL, 0 if
 *		the user pressed OK to exit the dialog. gsw 2/18/97
 */

#define /* iNetError */ SHOW_PROBE_DIALOG(netNum, devNum, modNum, chNum, settingNum) 		\
	((iNetError) ((iNet_int32((iNetUINT8) netNum, (iNetUINT8) devNum, (iNetUINT8) modNum,\
		  (iNetUINT8) chNum,(iNetINT16) settingNum, (iNetINT16) 1,(iNetINT16) \
		  intention_showProbeDialog_Full /* 8031 */, (iNetINT32) 0) == 0L) ? error_PARAM(gRequestP) : error_PARAM(gRequestP)))

#define /* iNetError */ SHOW_CHANNEL_ADDRESS_DIALOG(netNum, devNum, modNum, chNum) 			\
	((iNetError) ((iNet_int32((iNetUINT8) netNum, (iNetUINT8) devNum, (iNetUINT8) modNum,\
		  (iNetUINT8) chNum, (iNetINT16) 1, (iNetINT16) 1, (iNetINT16) 		\
		  intention_showProbeDialog_ChannelAddrOnly /* 8032 */, (iNetINT32) 0) == 0L) ? error_PARAM(gRequestP) : error_PARAM(gRequestP)))

#define /* iNetError */ SHOW_FIELD_ADDRESS_DIALOG(netNum,devNum,modNum,chNum,settingNum,fieldNum) 	\
	((iNetError) ((iNet_int32((iNetUINT8) netNum, (iNetUINT8) devNum, (iNetUINT8) modNum,		\
		  (iNetUINT8) chNum,(iNetINT16) settingNum, (iNetINT16) fieldNum, (iNetINT16) \
		  intention_showProbeDialog_FieldAddrOnly /* 8033 */, (iNetINT32) 0) == 0L) ? error_PARAM(gRequestP) : error_PARAM(gRequestP)))

#define /* iNetError */ SHOW_PROBE_DIALOG_WITH_FIXED_CHANNEL(netNum,devNum,modNum,chNum,settingNum,fieldNum) 	\
	((iNetError) ((iNet_int32((iNetUINT8) netNum, (iNetUINT8) devNum, (iNetUINT8) modNum,		\
		  (iNetUINT8) chNum,(iNetINT16) settingNum, (iNetINT16) fieldNum, (iNetINT16) \
		  intention_showProbeDialog_fixedChanAddr /* 8034 */, (iNetINT32) 0) == 0L) ? error_PARAM(gRequestP) : error_PARAM(gRequestP)))

#define /* iNetError */ SHOW_PROBE_DIALOG_WITH_FIXED_CHANNEL_AND_GROUP(netNum,devNum,modNum,chNum,settingNum,fieldNum) 	\
	((iNetError) ((iNet_int32((iNetUINT8) netNum, (iNetUINT8) devNum, (iNetUINT8) modNum,		\
		  (iNetUINT8) chNum,(iNetINT16) settingNum, (iNetINT16) fieldNum, (iNetINT16) \
		  intention_showProbeDialog_fixedChanAddrAndSettingGp /* 8035 */, (iNetINT32) 0) == 0L) ? error_PARAM(gRequestP) : error_PARAM(gRequestP)))
	
/*	-------------------------------------------------------------------------- */

#ifdef __cplusplus						/*	if running C++ */
	}									/* make this a C function */
#endif									/* gsw 9/21/97 */

#endif	/* __iNetMacros__ */



