/* ***********************************************************************************
INET_INT.H														OWNER: 840av
 
	-------------------------- D O C U M E N T A T I O N -----------------------------

	This instruNet .H Interface file contains many 1st level defines and variable type
	declarations, and should be the first file included by the End Use's file, the
	Host Driver and the uController Driver.  
	
	This file expects tabs every 4 characters.
 
	---------------------------------- N O T E S -------------------------------------	
	
	MACHINE_TYPE_	This label is set to MACINTOSH_iNet or WINTEL_iNet depending on
					whether we are compiling for the Macintosh or Windows operating sytem.
			
	-------------------------------  H I S T O R Y -----------------------------------
	HISTORY		Copyright c 1994-98 GWI.  All rights reserved.
	4/16/94		created - gsw 

************************************************************************************ */

#ifndef __iNetCInterface__				/*	only include this file once */
#define __iNetCInterface__
 
#include <assert.h>                     /*	For ansi assert() macro */

#ifdef __cplusplus						/*	if running C++... */
	extern "C" {						/*	make this a C function */
#endif

/*	============================ Determine Machine Type ============================ */

										/*	--------------------------------------
										 *	DEFINE MACHINE TYPES
										 *	
										 *	These macros signal to the complier what
										 *  kind of computer we are on. */

#define MACINTOSH_iNet 		1			/*	compiling for Mactintosh computer */
#define WINTEL_iNet 		2			/*	compiling for Windows/Intel computer */
#define CONTROLLER_iNet 	3			/*	compiling for microcode in uController */
  										
  										/*	--------------------------------------
										 *	DETERMINE IF WE ARE COMPILING FOR MACINTOSH.
										 *
										 *  ThinkC defines: THINK_C, THINK_CPLUS, m68K, mc68000, MC68000
										 *	Symantec ppc C defines: SYMANTEC_C, powerc, __powerc, SYMANTEC_CPLUS, SC_PLUS_SYMANTEC
										 *	CodeWarrior defines: __MWERKS__, __MC68K__ to 1 or 0, __MC68020__ to 1 or 0, __POWERPC__ to 1 or 0, */
										
										/*	true if running under Symantec PPC Macintosh compiler... */
#if (defined(SYMANTEC_C) || defined(SYMANTEC_CPLUS) || defined(SC_PLUS_SYMANTEC))
	#if (defined(powerc) || defined(__powerc))
		#define SYMANTEC_PPC_MAC_COMPILER 1
	#endif
#endif
#ifndef SYMANTEC_PPC_MAC_COMPILER
	#define SYMANTEC_PPC_MAC_COMPILER 0
#endif
									    
										/*	true if running under ThinkC 68 Macintosh compiler... */
#define THINKC_68K_MAC_COMPILER			(defined(THINK_C) || defined(THINK_CPLUS))

#if defined(__MWERKS__)					/*	if we are on the metrowerks Mac compilier */
	
	#if __MC68K__						/*	if this is a 68K Macintosh... */
		#define COMPILING_FOR_68K_MAC 1
		#define COMPILING_FOR_PPC_MAC 0
										/*	if we are building a code rsrc... */
		#if !defined(DRIVER_IS_COMPILED_INTO_AN_APP)
			#define BUILDING_68K_MAC_CODE_RSRC 1										
		#endif
	#elif __POWERPC__					/*	if this is a ppc Macintosh... */
		#define COMPILING_FOR_68K_MAC 0
		#define COMPILING_FOR_PPC_MAC 1
	#else
		#define COMPILING_FOR_68K_MAC 0
		#define COMPILING_FOR_PPC_MAC 0
	#endif
										/*	else if we are running under Think 68K C or Symantec ppc C ... */
#elif (SYMANTEC_PPC_MAC_COMPILER || THINKC_68K_MAC_COMPILER)

	#if (defined(m68K) || defined(mc68000) || defined(MC68000))		
		#define COMPILING_FOR_68K_MAC 1
		#define COMPILING_FOR_PPC_MAC 0
										/*	if we are building a code rsrc... */
		#if !defined(DRIVER_IS_COMPILED_INTO_AN_APP)
			#define BUILDING_68K_MAC_CODE_RSRC 1										
		#endif
	#elif (defined(powerc) || defined(__powerc))				
		#define COMPILING_FOR_68K_MAC 0
		#define COMPILING_FOR_PPC_MAC 1
	#else
		#define COMPILING_FOR_68K_MAC 0
		#define COMPILING_FOR_PPC_MAC 0
	#endif

#else									/*	else we are not on a Macintosh compiler... */

		#define COMPILING_FOR_68K_MAC 0
		#define COMPILING_FOR_PPC_MAC 0
#endif
	
  										/*	-------------------------------------- */
										/*	COMPILING FOR 68K or PPC MACINTOSH */

#if (COMPILING_FOR_68K_MAC || COMPILING_FOR_PPC_MAC)
																		 								
										/*	say that we are compiling for a Macintosh */
	#define  MACHINE_TYPE_  MACINTOSH_iNet
									
	#include <Types.h>					/*	for Ptr, Boolean */

  										/*	-------------------------------------- */
#elif defined(i_ctrlLER)				/*	INSTRUNET MICROCONTROLLER
										 *
										 *	i_ctrlLER is defined in "INET_DVR.H" and is 
										 *	defined here, if "INET_DVR.H" is included 1st, which
										 * 	occurs with the uController Driver (not Host code). */	
	
										/*	say that we are compiling for a uController Driver */
	#define  MACHINE_TYPE_  CONTROLLER_iNet

	#define COMPILER_GENS_EXT_FPU_IC_CODE 0	/* 	compiler does NOT generates direct external fpu ic code, */

	#include "stypes.h"					/*	for types */

	#ifndef Boolean
		typedef signed char Boolean;	/*	8bit signed integer */
	#endif

	#ifndef Huge_
		#define Huge_ /* nothing */
	#endif
	
  										/*	-------------------------------------- */
#else									/*	COMPILING FOR MS-WINDOWS */

										/*	say that we are compiling for Windows/Intel */
	#define  MACHINE_TYPE_  WINTEL_iNet

										/* 	compiler does NOT generates direct external fpu ic code, */
	#define COMPILER_GENS_EXT_FPU_IC_CODE 0

	#ifndef Boolean
		typedef signed char Boolean;	/*	8bit signed integer */
	#endif

	#include <windows.h>
	#include <windowsx.h>
	#include <time.h>
	#include <limits.h>

	#if defined(DRIVER_IS_COMPILED_INTO_AN_APP)	|| defined(DRIVER_IS_COMPILED_INTO_A_WINDOWS_DLL)
		#include "resource.h"			/*	iNet resource.h file */
	#endif									
										/* Used to simulate MAC filetypes */
	#define CHARS_TO_FILE_TYPE(a,b,c)  \
		((iNetUINT32)((iNetUINT32) '\0' << 24 | (c) << 16 | (b) << 8 | (a) ))
	
										/*	true if compiling for >= 32bit Win95;
										 *	false if compiling for 16bit Win3.1 */
	#define COMPILED_FOR_WIN32 (WINVER >= 0x0400)

	#if COMPILED_FOR_WIN32 				/* ======== Windows 95 or NT ==========*/
	
										/* Win95: "Win95\system\iNet32.dll" */
										/* WinNT: "WinNT\system32\iNet32.dll" */
		#define		iNetDRIVER_NAME		"iNet32.dll"

	#else 								/* =========== Windows 3.1 ============*/
	
		#define		iNetDRIVER_NAME		"iNet16.dll"

		CAREFUL: The instruNet driver does not support Windows 3.1.  Therefore,
		if you get a compile error here, you should switch to Windows 95.
		The 3.1 code here does not work properly (please ignor it). gsw 8/10/96
		
		#include <commdlg.h>
		#include <stdlib.h>
		#include <errno.h>
				
		#define LPCTSTR LPSTR
		#define TCHAR char
		#define WCHAR char
		#define LPWSTR LPSTR
		
		#define CREATE_ALWAYS 1234		/*	Compiler should never come here, since this is */
		#define OPEN_EXISTING 4321		/*	for Windows 3.1, which does not exist.  This
										 *	code assume the compiler defined WINVER >= 0x0400.
										 *	If this is not the case, it needs to be done. */

		#define MAX_PATH	_MAX_PATH
		#define MAX_DRIVE	_MAX_DRIVE
		#define MAX_DIR		_MAX_DIR
		#define MAX_FNAME	_MAX_FNAME
		#define MAX_EXT		_MAX_EXT
		
		typedef unsigned long ULONG;
		
		#pragma pack( 1 )
		typedef struct DialogBoxHeader {
					DWORD style;	BYTE  cdit;
					WORD  x;		WORD  y;
					WORD  cx;		WORD  cy;
					//char  * szMenuName;
					//char  * szClassName;
					//char  * szCaption;
					//WORD  wPointSize;    /* only if DS_SETFONT */
					//char  *szFaceName;  /* only if DS_SETFONT */
		} DLGTEMPLATE, FAR * LPDLGTEMPLATE;
		
		typedef struct ControlData {
					WORD  x;	WORD  y;
				    WORD  cx;	WORD  cy;
				    WORD  wID;	DWORD style;
				    union	{
				        BYTE classID;   /* if (class & 0x80) */
				        char *szClass;	/* otherwise         */
				    } ClassID;
				    //szText;           // Null terminated string
		} DLGITEMTEMPLATE, FAR * LPDLGITEMTEMPLATE;
		#pragma pack()

		int  GetLastError();
		void SetLastError();
		
		// function replacements
		#define SetCurrentDirectory( d ) _chdir( d )
		#define GetCurrentDirectory( bufLen, buffer ) _getcwd( (buffer), (bufLen) )
        #define GetTextExtentPoint32( a, b, c, d ) GetTextExtentPoint( (a), (b), (c), (d) )
	#endif

#endif

/*	============================= External Function Types ============================ */

#if (MACHINE_TYPE_ == MACINTOSH_iNet)	/*	============= Macintosh ============= */

	#define EXT_FUNC_TYPE				/* nothing */

#elif (MACHINE_TYPE_ == WINTEL_iNet)	/*	=========== Windows/Intel =========== */

	#if defined(DRIVER_IS_COMPILED_INTO_AN_APP)

		#define EXT_FUNC_TYPE			/* nothing */
	#else
										/* 	windows DLL's need this function type */
		#define EXT_FUNC_TYPE			WINAPI
	#endif

#endif

/*	================================ Profiling ====================================== */

#define DO_PROFILING 0					//	turn Macintosh CodeWarrior profiling on/off

	//	Need to set Preferences Processor Code Model to Large instead
	//	of Smart when profiling is on, if running Mac 68K.
	
#if DO_PROFILING
	#pragma profile on					/*	turn on generation of profiler calls */
										/*	(you really need to do this outside the precompiled
										 *	header in order for the preprocessor to set it). */
	#include <profiler.h>
	extern Boolean gProfilerHasBeenInitialized;
#endif

/*	================================== Variable Types ================================ */

typedef signed char iNetINT8;			/*	8bit signed integer */
typedef unsigned char iNetUINT8;		/*	8bit unsigned integer */

typedef signed short iNetINT16;			/*	16bit signed integer */
typedef unsigned short iNetUINT16;		/*	16bit unsigned integer */

typedef signed long iNetINT32;			/*	32bit signed integer */
typedef unsigned long iNetUINT32;		/*	32bit UNsigned integer */

typedef float iNetFLT32;				/*	32bit floating point variable */

#define iNetSizeOfInt16  2				/*	2 bytes per int16 value */
#define iNetSizeOfFlt32  4				/*	4 bytes per flt32 value */

#ifndef LOW8BITS
 #define  LOW8BITS  ( 0x000000FF )		/*	mask for low 8bits */
#endif

/*	============================ Fastest Floating Point Type ========================== */

										/*	Calc the fastest floating point type (flt32 to
										 *	flt128 for this computer) -- used to optimize
										 *	code. */

										/*	if compling for a Macintosh... */
#if (MACHINE_TYPE_ == MACINTOSH_iNet)
	
	#if COMPILING_FOR_PPC_MAC			/*	if compiling for ppc Mac */
										/*	fastest floating point variable type */
		#define FASTEST_FLOAT_TYPE float
	#else								/*	else we are compiling 68K code... */

										/*	if we are compiling external fpu ic based code... */
										/*	e.g. 68K with 881 fpu */
		#if COMPILER_GENS_EXT_FPU_IC_CODE		
			#define FASTEST_FLOAT_TYPE double
		#else							/*	else we are doing 68K non-fpu code */
										/*	e.g. Windows 95, PPC Mac */
			#define FASTEST_FLOAT_TYPE float
		#endif
	#endif
										/*	if compling for Windows/Inte... */
#elif (MACHINE_TYPE_ == WINTEL_iNet)
										/*	fastest floating point variable type */
	#define FASTEST_FLOAT_TYPE float
										/*	else if we are compiling for uController  */
#elif (MACHINE_TYPE_ == CONTROLLER_iNet) 
										/*	fastest floating point variable type */
	#define FASTEST_FLOAT_TYPE float
#endif


/*	================================= String Types ================================== */

/*	these are PASCAL strings, where the 0th char is the length of the string */

#define Str7_SIZE		7					/*	# of chars in Str7 */
#define Str11_SIZE		11					/*	# of chars in Str11 */
#define Str15_SIZE		15					/*	# of chars in Str15 */
#define Str31_SIZE		31					/*	# of chars in Str31	*/
#define Str63_SIZE		63					/*	# of chars in Str63	*/
#define Str83_SIZE		83					/*	# of chars in Str83 */
#define Str127_SIZE		127					/*	# of chars in Str127 */
#define Str255_SIZE		255					/*	# of chars in Str255 */
#define Str1023_SIZE 	1023				/*	# of chars in Str1024 */

typedef unsigned char iNetStr7[Str7_SIZE + 1];		/*	7    char pStr, consumes 8bytes */
typedef unsigned char iNetStr11[Str11_SIZE + 1];	/*	11   char pStr, consumes 12bytes */
typedef unsigned char iNetStr15[Str15_SIZE +1];		/*	31   char pStr, consumes 32bytes */
typedef unsigned char iNetStr31[Str31_SIZE +1];		/*	31   char pStr, consumes 32bytes */
typedef unsigned char iNetStr83[Str83_SIZE +1];		/*	83   char pStr, consumes 84bytes */
typedef unsigned char iNetStr127[Str127_SIZE+1];	/*	127  char pStr, consumes 128bytes */
typedef unsigned char iNetStr255[Str255_SIZE+1];	/*	255  char pStr, consumes 256bytes */

typedef char iNetcStr7[7 + 1];				/*	7    char cStr, consumes 8bytes */
typedef char iNetcStr11[11 + 1];			/*	11   char cStr, consumes 12bytes */
typedef char iNetcStr15[Str15_SIZE+1];		/*	15   char cStr, consumes 16bytes */
typedef char iNetcStr31[Str31_SIZE+1];		/*	31   char cStr, consumes 32bytes */
typedef char iNetcStr63[Str63_SIZE+1];		/*	63   char cStr, consumes 64bytes */
typedef char iNetcStr127[Str127_SIZE+1];	/*	127  char cStr, consume 128bytes */
typedef char iNetcStr255[Str255_SIZE+1];	/*	255  char cStr, consume 256bytes */
typedef char iNetcStr1023[Str1023_SIZE+1];	/*1024 char cStr, consume 1024bytes */

/*	============================== Variable Limits ================================== */

#define UINT8_MAX 	255
#define UINT8_MIN 	0

#define INT8_MAX 	127
#define INT8_MIN 	-128

#define INT16_MAX 	32767
#define INT16_MIN 	-32768

#define UINT16_MAX 	65535
#define UINT16_MIN 	0

#define INT32_MAX 	2147483647
#define INT32_MIN 	(~2147483647)

#define UINT32_CYCLE_double 	((double) 4294967296.0)
#define UINT32_MAX 	((iNetUINT32) 0xFFFFFFFF)
#define UINT32_MIN 	0

#define UINT64_MAX ((double) UINT32_CYCLE_double * (double) UINT32_MAX + (double) UINT32_MAX)

										/*	convert doubleVar to the 2 UINT32 MSB/LSB combintation */
#define CALC_UINT32_MSB(doubleVar)	 ((iNetUINT32) ((double) 0.5 /* round off */ + (((double) (doubleVar)) / UINT32_CYCLE_double)))
#define CALC_UINT32_LSB(doubleVar, UINT32_MSB)	 ((iNetUINT32) ((double) 0.5 /* round off */ + ((double) (doubleVar)) - ((double) UINT32_MSB * UINT32_CYCLE_double )))

#define FLT32_MAX 	+1.0e+38			/*	most compilers/cpu's/os's should support this range, gsw 11/11/96 */
#define FLT32_MIN 	-1.0e+38

#define iROUND_OFF 	0.5					/*	helps rounding off */

/*	=============================== Useful define's ================================== */

#define  iNetOr				||			/*	logical or */
#define  iNetAnd			&&			/*	logical and */
#define  iNetBitwiseOr		|			/*	bitwise or */
#define  iNetBitwiseEOr		^			/*	bitwise eor */
#define  iNetBitwiseAnd		&			/*	bitwise and */

#ifndef TRUE
	#define TRUE ((Boolean) 1)			/*	boolean true */
#endif

#ifndef FALSE
	#define FALSE ((Boolean) 0)			/*	boolean false */
#endif
										/* 	set value to min if < min, or max if > max */
#define  MAKE_SURE_IN_RANGE(value, min, max) 	 \
	value = (((value) < (min)) ? (min) : (((value) > (max)) ? (max) : (value)))

										/* 	true if < min or > max (i.e. out of range) */
#define  OUT_OF_RANGE(value, min, max) 	 ((Boolean) (((value) < (min))  iNetOr  ((value) > (max))))

 										/* 	ascii values */
#define  ASCII_TAB   	((unsigned char) '\t')
#define  ASCII_ZERO  	((unsigned char) '0')
#define  ASCII_NINE  	((unsigned char) '9')
#define  ASCII_CR  		((unsigned char) '\r')
#define  ASCII_LF   	((unsigned char) '\n')
		
										/*	returns TRUE if this character is \r or \n, */
#define  CR_OR_LF(c) 	 ((((unsigned char) (c)) == ASCII_CR)  iNetOr (((unsigned char) (c)) == ASCII_LF))

										/*	returns TRUE if this character is a digit, */
#define  THIS_IS_A_DIGIT(c) 	 (((unsigned char) c) >= ASCII_ZERO  iNetAnd  ((unsigned char) c) <= ASCII_NINE)

										/*	returns TRUE if this is lower case alphabetical char */
#define  THIS_IS_A_LOWERCASE_ALPHABETICAL_CHAR(c_)		((Boolean)	\
	 (((char) ((char) c_) >= 'a')  iNetAnd  ((char)		((char) c_) <= 'z')))

										/*	returns TRUE if this is Upper case alphabetical char */
#define  THIS_IS_AN_UPPERCASE_ALPHABETICAL_CHAR(c_) 	((Boolean)	\
	 (((char) ((char) c_) >= 'A')  iNetAnd  ((char) ((char) c_) <= 'Z')))

										/*	returns TRUE if this is Upper or Lower case alphabetical char */
#define  THIS_IS_AN_ALPHABETICAL_CHAR(c_) 				((Boolean)	\
	(THIS_IS_A_LOWERCASE_ALPHABETICAL_CHAR(c_)  iNetOr  THIS_IS_AN_UPPERCASE_ALPHABETICAL_CHAR(c_)))

										/*	convert 1 character to lower case, gsw 1/1/03 */	
#define   CONVERT_CHAR_TO_LOWER_CASE(c)								\
	 ((((c) >= ((char)  'A'))  iNetAnd  ((c) <= ((char) 'Z')))		\
	?  ((c) + ((((char) 'a')) - ((char) 'A')))						\
	:	(c))

										/*	returns TRUE if this character is with an INT number, */
#define  IS_INT_NUMBER_CHAR(c)	(THIS_IS_A_DIGIT(c)								||	\
								 (((unsigned char) c) == (unsigned char) '-')	||	\
								 (((unsigned char) c) == (unsigned char) '+'))

										/*	returns TRUE if this character is a number, */
#define  IS_NUMBER_CHAR(c_)	( ((char) (c_) >= '0' iNetAnd (char) (c_) <= '9') iNetOr \
							  ((char) (c_) == '-')	iNetOr	\
							  ((char) (c_) == '+')	iNetOr	\
							  ((char) (c_) == '.')	)

										/*	true if this is an acceptable char for
										 *	a channel's username, not including " " space */
#define ACCEPTABLE_USERNAME_CHAR_NOT_INCLUDING_SPACE(c_)	((Boolean) \
	(   IS_NUMBER_CHAR(c_)						iNetOr		\
		THIS_IS_AN_ALPHABETICAL_CHAR(c_)		iNetOr		\
		((char) (c_) == '_')					iNetOr		\
		((char) (c_) == '*')					iNetOr		\
		((char) (c_) == '/')  )  )

										/*	true if this is an acceptable char for
										 *	a channel's username, including " " space */
#define ACCEPTABLE_USERNAME_CHAR_INCLUDING_SPACE(c_)		((Boolean)	\
	(   ACCEPTABLE_USERNAME_CHAR_NOT_INCLUDING_SPACE(c_)	iNetOr		\
		((char) (c_) == ' ')))

										/*	returns TRUE if this character is a digit */
#define  CHAR_IS_NUMBER(c) 	 (((char) c >= '0')  iNetAnd  ((char) c <= '9'))

										/* convert 2 ascii chars to a 0...99 value */
										/* e.g. 21 = CALC_uint8_VALUE('2', '1') */
#define CALC_uint8_VALUE(charTens_, charOnes_)		\
		 ((CHAR_IS_NUMBER(charTens_) iNetAnd CHAR_IS_NUMBER(charOnes_))	\
			? (((char) charTens_ - '0') * 10 + (charOnes_ - (char) '0'))\
			: (CHAR_IS_NUMBER(charTens_)			\
				? ((char) charTens_ - '0')			\
				: (CHAR_IS_NUMBER(charOnes_)		\
					? ((char) charOnes_ - '0')		\
					: 0)))		

										/* 	makes sure that the p string length does not 
										 *	exceed 'maxNumChars'. */
#define MAKE_SURE_pSTRING_DOES_NOT_EXCEED_THIS_SIZE(s, maxNumChars)		\
	(s)[0] = ((unsigned char)											\
					(													\
						((long) (* (unsigned char *) s) > (long) (gMaxNumChars = (maxNumChars)))							\
						? ((gMaxNumChars < 0L) ? ShowErrorAlert("negative size in MAKE_SURE_pSTRING_DOES") : gMaxNumChars)	\
						: ((s)[0])										\
					)													\
			  )
											
										/*	Convert FLT value to NEAREST integer
										 *	we assume compiler rounds toward 0. */
#define  FLT32_TO_BOOL(fv_)		  \
	((Boolean) ((((fv_) > -0.5) iNetAnd ((fv_) < +0.5)) ? 0 : 1))

#define  FLT32_TO_UINT8(fv_)	((iNetUINT8) (((gTempFLT32_conv = (fv_)) < +0.5) ?	\
	0 : ((iNetUINT8) ((iNetFLT32) gTempFLT32_conv + 0.5))))

#define  FLT32_TO_INT32(fv_)	((iNetINT32) (((gTempFLT32_conv = (fv_)) > 0.0) ?	\
	((iNetINT32) ((iNetFLT32) gTempFLT32_conv + 0.5)) :								\
	((iNetINT32) ((iNetFLT32) gTempFLT32_conv - 0.5))))

#define  FLT32_TO_INT16(fv_)	((iNetINT16) (((gTempFLT32_conv = (fv_)) > 0.0) ?	\
	((iNetINT16) ((iNetFLT32) gTempFLT32_conv + 0.5)) :								\
	((iNetINT16) ((iNetFLT32) gTempFLT32_conv - 0.5))))

										/*	Convert double value to NEAREST integer
										 *	we assume compiler rounds toward 0. */
#define  DOUBLE_TO_BOOL(dv_)	\
	((Boolean)   ((((dv_) > -0.5) iNetAnd ((dv_) < +0.5)) ? 0 : 1))

#define  DOUBLE_TO_UINT8(dv_)	((iNetUINT8) \
	(((gTempD_conv = (dv_)) < +0.5) ? 0 : ((iNetUINT8) ((double) gTempD_conv + 0.5))))

#define  DOUBLE_TO_UINT32(dv_)	((iNetUINT32) \
	(((gTempD_conv = (dv_)) < +0.5) ? 0L : ((iNetUINT32) ((double) gTempD_conv + 0.5))))

#define  DOUBLE_TO_INT32(dv_)	((iNetINT32) \
	(((gTempD_conv = (dv_)) > 0.0) ? \
	((iNetINT32) ((double) gTempD_conv + 0.5)) : ((iNetINT32) ((double) gTempD_conv - 0.5))))

#define  DOUBLE_TO_INT16(dv_)	((iNetINT16) \
	(((gTempD_conv = (dv_)) > 0.0) ? \
	((iNetINT16) ((double) gTempD_conv + 0.5)) : ((iNetINT16) ((double) gTempD_conv - 0.5))))

										/*	take absolure value of FLT */
#define  ABS_FLT(value)		(((value) > 0.0) ? (value) : -(value))

										/*	take absolure value of INT32 */
#define  ABS_INT32(value)	(((value) > 0L) ? (value) : -(value))

										/*	take absolure value of INT16 */
#define  ABS_INT16(value)	(((value) > 0)  ? (value) : -(value))
									
										/* 	return maximum of 2 parameters 'a' and 'b'. */	
#define	 MAXIMUM_FLT(a,b)	(((a) > (b)) ? (a) : (b))
#define	 MAXIMUM_INT(a,b)	(((a) > (b)) ? (a) : (b))

										/* 	return minimum of 2 parameters 'a' and 'b'. */	
#define	 MINIMUM_FLT(a,b)	(((a) < (b)) ? (a) : (b))
#define	 MINIMUM_INT(a,b)	(((a) < (b)) ? (a) : (b))

										/*	returns TRUE if FLT32 'a' and 'b' are similar in value */
#define  FLT32s_ARE_SIMILAR(a,b) 	((Boolean)		\
	((double) ABS_FLT(((a)-(b)))   <=				\
     (double) (1.e-5 * MINIMUM_FLT(ABS_FLT(a), ABS_FLT(b)))))

										/*	returns TRUE if double 'a' and 'b' are similar in value */
#define  DOUBLEs_ARE_SIMILAR(a,b) 	((Boolean)		\
	((double) ABS_FLT(((a)-(b))) <=					\
	 (double) (1.e-6 * MINIMUM_FLT(ABS_FLT(a), ABS_FLT(b)))))

										/*	calc rectangle heights and widths */
#define WIDTH_RECT(rP)		((iNetINT32) (rP)->right   -  (rP)->left)
#define HEIGHT_RECT(rP)		((iNetINT32) (rP)->bottom  -  (rP)->top)

extern iNetINT32	gTempINT32iNet, gTempCompiler, gTemp32A, gTemp32B, gTemp32C, 
					gTemp32_seti, gTemp32_setd, gMaxNumChars;
extern iNetINT16	gTempINT16iNet;	
extern iNetUINT16	gTempUINT16iNet;
extern iNetFLT32	gTempFLT32iNet, gTempFLT32iNetA, gTempFLT32iNetB, gTempFLT32iNetC, 
					gTempFLT32_conv, gTempFLT32_setf;	
extern double		gTempDoubleiNet, gTempDoubleiNetA, gTempDoubleiNetB, gTempDoubleiNetC,
					gTempDouble_setPos, gTempD_conv;

										/*	put unreferenced variable in here to use
										 *	it to fool compiler warning feature, bug fix 10/28/98 */
#define STOP_COMPILER_WARNING(variable_)	gTempCompiler = (iNetINT32) &variable_


/*	========================== KEYS used for testing ================================= */

#define INET_INT16_KEY	0x55b4			/*	key field is preset to this value */

#define INET_INT32_KEY	0x12345678		/*	int32 key field preset to this value */

#define INET_FLT32_KEY	1234.56			/*	float32 key field preset to this value */

/*	================ sprintf and scanf formats (base 16 hexadecimal) ================= */

#define UINT32_HEX_FORMAT_sprintf 	"0x%08lx"
#define UINT16_HEX_FORMAT_sprintf 	"0x%04hx"

#define UINT32_HEX_FORMAT_scanf 	"%lx"
#define UINT16_HEX_FORMAT_scanf	 	"%hx"
#define INT16_HEX_FORMAT_scanf	 	"%hi"

extern char *gCr;

/*	============================== DIGITIZE LIST ==================================== */

#define  MAX_NUM_DIGI_CH  512			/*	max # of digitize channels */
										/*	changed from 256, to 512 
											for ver 1.31, gsw 1/15/99 */

#if COMPILING_FOR_PPC_MAC
	#pragma options align=mac68k
#elif (MACHINE_TYPE_ == WINTEL_iNet)
	#pragma pack(1)	
#endif
										//	----------------------------------
typedef struct iNetChannelAddr {		//	Defines an instruNet channel's address
										//	(this prototype should never change)

	iNetUINT8 netNum;					//	NETWORK number = {0...numNetworks}, 0 is Driver,
										//	1 is the first controller installed into the computer.										
	iNetUINT8 devNum;					//	DEVICE number {0...numDevices}, 0 = "Controller", 1 = 1st device on network
	iNetUINT8 modNum; 					//	MODULE number within a hardware DEVICE {1...32}.
										//	Many devices have only 1 module.
	iNetUINT8 chNum; 					//	Hardware CHANNEL number {1...32}. Each device contains
										//	a number of channels, each of which has it's own
										//	channel number.
} iNetChannelAddr;	

/*	========================== REQUEST MACROS ======================== */

										//	convert chAddr {n/d/m/c} to requestP {n/d/m/c} 
										//	where other requestP items are set to 0
#define chAddr_TO_requestP(chAddrP_, requestP_) 	\
	memset(requestP_, 0x00, sizeof(*requestP_));	\
	(requestP_)->netNum = (chAddrP_)->netNum;		\
	(requestP_)->devNum = (chAddrP_)->devNum;		\
	(requestP_)->modNum = (chAddrP_)->modNum;		\
	(requestP_)->chNum  = (chAddrP_)->chNum

										//	convert requestP {n/d/m/c} to chAddr {n/d/m/c} 
#define requestP_TO_chAddr(requestP_, chAddrP_) 	\
	(chAddrP_)->netNum = (requestP_)->netNum;		\
	(chAddrP_)->devNum = (requestP_)->devNum;		\
	(chAddrP_)->modNum = (requestP_)->modNum;		\
	(chAddrP_)->chNum  = (requestP_)->chNum

										//	load the chAddr w/ the specified values
#define SET_chAddr(chAddrP, n, d, m, c)				\
	assert /* ansi */ (chAddrP);					\
	(chAddrP)->netNum	= (iNetUINT8) (n);			\
	(chAddrP)->devNum	= (iNetUINT8) (d);			\
	(chAddrP)->modNum	= (iNetUINT8) (m);			\
	(chAddrP)->chNum	= (iNetUINT8) (c)

#if COMPILING_FOR_PPC_MAC
	#pragma options align=reset
#elif (MACHINE_TYPE_ == WINTEL_iNet)
	#pragma pack()
#endif

extern char g_Channel_dType[];			//	digitize channel list

extern char gDLL_ver_cStr[ ];			/*	"iNet95.dll" Win32 DLL Version # */
extern iNetUINT32 gDLL_ver_majorVer;
extern iNetUINT32 gDLL_ver_minorVer;
extern iNetUINT32 gDLL_ver_subminorVer;

/*	================================ SettingsTypes ==================================== */

										/*	------------------------------------ */
typedef enum ion_settingGroupType {		//	settinggroup (i.e. "Settings") types
										//	(settingGroupType's must be negative)
									
										/*	#### these #'s must not change */
										
										//	----------------------------------------
										//	BAD
	
	sgt_SelectDefault = 0,				//	tell us to select the default type 
										//	for a given channel

	sgt_noneFound = -1,					//	nothing found

	sgt_UnRecognizedType = -2,			//	unrecognized (user
										//	probably needs a newer driver that
										//	works with this hardware ??)			

										//	----------------------------------------
										//	MODEL 100 LIKE HARDWARE DEVICE
										
	sgt_VinHardware = -3,				//	Vin "Hardware" settingGroupType {sensorType, a/d range, analog lp, function}
	sgt_VinConstants = -4,				//	Vin "Constants" settingGroupType {Ro,Rshunt,Vexcit,GF,alpha,delta}
	sgt_Mod100DinDout = -5,				//	8bit Mod 100 Digital I/O settingGroup = {din, dout, direction}

										//	----------------------------------------
										//	GENERAL.
										
	sgt_General = -6,					//	General settingGroupType struct {valueEU, chanName, unitsLabel, userName...}
	
	sgt_Display = -7,					//	DISPLAY settingGroup = {dispOnOff, dispMaxEU, dispMinEU, dispShowHidePop}

	sgt_Mapping = -20,					//	Mapping settingGroup = {Internal1,External1,Internal2,External2}

	sgt_Control = -22,					//	Control settingGroup = {outputValueScript}, gsw 1/1/03
										//	Used with Vout and DioBit channels

	sgt_PanelM_TextF_or_Popup = -23,	//	PANEL METER / POPUP / TEXT FIELD = {Position, Page, Order,
										//		unitsLabel_ShowHide, CalculatedValue}, gsw 1/1/03
										//	Used with All digital and analog and timer i/o channels

	sgt_DioBitOptions = -29,			//	Digital I/O Bit options = { io_direction }

										//	----------------------------------------
										//	FILTER.

	sgt_LowPass = -8,					//	LOW PASS filter settingGroup type
	sgt_HighPass = -9,					//	HIGH PASS filter settingGroup type
	sgt_BandPass = -10,					//	BAND PASS filter settingGroup type
	sgt_BandStop = -11,					//	BAND STOP filter settingGroup type

										//	----------------------------------------
										//	DIGITIZER channel in CONTROLLER device.
										
	sgt_Timing = -12,					//	{DigitizeOnOff, PtsPerScan, NoOfScans, ScanMode, SampleRate}
	sgt_Trigger = -13,					//	{TriggerMode, ThresholdEu, Slope, hysteresis, SrcNet, SrcModule, SrcDevice, SrcChannel}

										//	----------------------------------------
										//	CONTROLLER timer channel

	sgt_Timer = -14,					//	TIMER settingGroup = {functionPop, clkTotalSecs, clkHiSecs,
										//	measHiOrCyclePop, measResolution, measNumPeriods}

										//	----------------------------------------
										//	BUFFERS
		
	sgt_DriverRamBuffer = -15,			//	Driver Ram Buffer = {DigitizeOnOff, ScanNumIn, PtNumIn..}
	sgt_UserRamBuffer = -16,			//	User Ram Buffer = {DigitizeOnOff, userBufferAddr, ptrSize, ScanNumIn, PtNumIn..}
	sgt_File = -17,						//	File = {FileName, Command, ScanNumIn, PtNumIn, ScanNumIn ..}

										//	----------------------------------------
										//	DRIVER

	sgt_RecordOptions = -18,			//	RECORD OPTIONS settingGroup = {}
	sgt_MasterDirectory = -19,			//	MASTER DIRECTORY settingGroup = {pathname, command, save/load settings}
	sgt_CalOptions = -21,				//	CAL OPTIONS = {CalBtn, CalOnStart, CalOnWarm, AutoCalRate}
	sgt_Script = -24,					//	Script Management = { debug, controlRateHz, userRateHz}, gsw 1/20/03
	sgt_UserItems = -25,				//	User Items - # of user tabs/btns/editFields/Popups/panelitems, gsw 1/20/03
	sgt_WindowOptions = -28,			//	Window Options = show/hide menubar/btnbar/tabbar, save winPos/pgSel w/ prf on/off

										/*	#### these #'s must not change */

										//	----------------------------------------
										//	USER ITEMS

	sgt_UserPage = -26,					//	USER PAGE = { Show/Hide, Tab Char Spacing }
	sgt_UserBtn = -27					//	USER BUTTON = { Page, Show/Hide }	

										//	----------------------------------------
										//	Etc	
} ion_settingGroupType;
										/*	#### we want 'ion_settingGroupType_MIN' as low
										 *	#### as possible, since it sets the size of an
										 *	#### array in the channel struct */
										
#define ion_settingGroupType_MAX		sgt_VinHardware
#define ion_settingGroupType_MIN		sgt_DioBitOptions

#define ion_settingGroupType_MAX_valid	sgt_VinHardware
#define ion_settingGroupType_MIN_valid	sgt_DioBitOptions
	
#define MAX_NUM_settinggroup_TYPES	(-ion_settingGroupType_MIN)

/*	============================= Field Access Intentions =========================== */

										/*	------------------------------------ */
typedef enum ion_intention {			//	thing that you want to do when you

										/*	#### these #'s must not change */
										/*	#### these #'s must not change */
										
										//	=====================================
										//	Ring 0 causes individual fields to
										//	be processed.

	intention_getValue = 1,				//	get the value of the field
	intention_setValue = 2,				//	set the value of the field
	intention_getNameStr = 3,			//	get name of field (i.e. string)
	intention_getMaxValue = 4,			//	get maximum value of the field
	intention_getMinValue = 5,			//	get minimum value of the field
	intention_getUserInterfaceType = 6,	//	get user interface type {e.g. }
	intention_getDefaultValue = 7,		//	get the defaultValue of the field
	intention_nativeStorageType = 8,	//	get the native storageType of the field
										//	{e.g. iNetDT_FLT32, iNetDT_INT16, iNetDT_P_Str15}

	intention_getValueAndPullData = 9,	//	get the value of the field (USER RAM BUFFER userBufferAddr
										//	field or DRIVER RAM BUFFER bufferPtr field) and
										//	also pull data out of the buffer and place
										//	'pointToPullindex' into A, 'numPointsToPull' into B,
										//	and 'scanNumIn' into C. gsw 11/25/95

	intention_getOutSegmentBuffer = 10,	//	Get location of output segment buffer, gsw 10/20/98
	
	intention_submitOutSegment = 11,	//	Tell driver that an output segment has been
										//	submitted, gsw 10/20/98

										//	=====================================
										//	Ring 1 is before Process_Request_with_Correct_And_Updated_Struct()
										//	(after we evaluate the network address, and before we process the
										//	specific field).
	
										//	-------------------------------------
										//	ADMINISTRATIVE
	
	intention_doNothing = 4000,			//	do nothing (just process iNet_Request struct)
										//	(all we do is check the network address and
										//	and then calc the Global struct ptrs)
	
	intention_DisableAllChannelDigitizing = 4005,
										//	Disable channel digitizing for all channels in this
										//	network.  This will make sure that the
										//	"Display" field in the DISPLAY SettingGroups
										//	is OFF, and that the "Digitize" field
										//	is OFF in the FILE, USERBUFFER, and DRIVERBUFFER
										//	SettingGroups.
	
										//	=====================================
										//	Ring 2 is before Process_iNet_Request()
										//	(before we evaluate the network address)

										//	-------------------------------------
										//	SHOW ALERT UPON ERROR CONTROL

	intention_ShowAlertOnError = 8000,	//	tells driver to show an alert upon error (this is the default)
										//	returns 1 if driver WAS set up to show an alert upon error; 0 otherwise
	intention_NoShowAlertOnError = 8001,//	tells driver to NOT show an alert upon error
										//	returns 1 if driver WAS set up to show an alert upon error; 0 otherwise
	intention_GetShowAlertOnErrorStatus = 8002,	
										//	returns 1 if driver WAS set up to show an alert upon error; 0 otherwise
	intention_SetAllAlertsOnOff = 8029,	//	if 0, all alerts are turned OFF; otherwise, we
										//	show them normally. Careful, this might
										//	turn off important and necessary alerts and 
										//	cause major problems.  Use at your own risk. CAREFUL.
										//	gsw 10/28/97
				
										//	-------------------------------------
										//	NETWORK STATUS

	intention_GetDigitizeStatus = 8030,	//	Returns the digitizing status of an		10/30/97
										//	instruNet DSP card { 1=digitize_off,
										//	2=digitize_interrupt_on, 3=digitize_highspeed_on }
	
	intention_SetDemoMode = 8037,		//	Sets 1x iNet100 demonstration mode.  Please see
										//	Set_iNet_Demo_Mode() in INET_INT.C to learn more.

	intention_GetDevSimuState = 8038,	//	returns 1 if device is simulated, otherwise 0
										//	gsw 1/15/99

										//	-------------------------------------
										//	DETERMINE IF NETWORK ELEMENT EXISTS
	
										//	Returns 1 if NETWORK = {netNum} exists; FALSE (0) otherwise.
	intention_ThisExists_Network = 8003,	
										//	Returns 1 if DEVICE = {netNum, devNum} exists; FALSE (0) otherwise.
	intention_ThisExists_Device = 8004,	
										//	Returns 1 if MODULE = {netNum, devNum, modNum} exists; FALSE (0) otherwise.
	intention_ThisExists_Module = 8005,	
										//	Returns 1 if CHANNEL = {netNum, devNum, modNum, channelNum}
										//	exists; FALSE (0) otherwise.
	intention_ThisExists_Channel = 8006,
										//	Returns 1 if SETTING = {netNum, devNum, modNum, channelNum,
										//	settingNum} exists; FALSE (0) otherwise.
	intention_ThisExists_Setting = 8007,
										//	Returns 1 if FIELD = {netNum, devNum, modNum, channelNum,
										//	settingNum, fieldNum} exists; FALSE (0) otherwise.
	intention_ThisExists_Field = 8008,

										//	-------------------------------------
										//	INTERROGATE NETWORK
										
	intention_GetNumNetworks = 8009,	//	Returns the # of instruNet Networks.
	intention_GetNumDevices = 8010,		//	Returns the # of Devices in the specified Network.
	intention_GetNumModules = 8011,		//	Returns the # of Modules in the specified {Network, Device}.
	intention_GetNumChannels = 8012,	//	Returns the # of Channels in the specified {Network, Device, Module}.
	intention_GetNumSettings = 8013,	//	Returns the # of Settings in the specified {Network, Device, Module, Channel}.
	intention_GetNumFields = 8014,		//	Returns the # of Fields in the specified {Network, Device, Module, Channel, SettingGroup}.

										//	-------------------------------------
										//	USER INTERFACE
	
	intention_GetChannelType = 8015,	//	Returns the type of the channel (please see the
										//	ion_channelType in file INET_INT.H for a list of
										//	types). gsw 10/27/97
	intention_GetChannelCategory = 8016,//	Returns the type of the channel: (dir_hdwr_input_circBuf = 1)
										//	for input channels (e.g. a/d), 
										//	(dir_hdwr_output_circBuf = 2) for output
										//	channels (e.g. d/a), and (dir_hdwr_inAndOut_circBuf
										//	= 4) for both input and output channel yet
										//	digitized as in input (e.g. iNet 100 digital
										//	i/o, controller digital/timer i/o). gsw 10/27/97 
	intention_GetChannelDirection = 8021,
										//	Returns the direction of the channel: 0 is
										//	input (e.g. a/d), and 1 is output (e.g. d/a). 5/1/96
	intention_GetChannelDigitizeable = 8025,
										//	Returns true (1) if this channel is digitizeable
										//	(e.g. d/a, a/d, model 100 digital i/o). If not
										//	digitizeable, you must use the low speed scalar
										//	read/write channel routines to read the channel. gsw 10/27/97 

	intention_Get_UI_Catagory = 8017,	//	Returns the user interface catagory (i.e.
										//	itemType_iNet enum in header file; e.g.
										//	i_sText (4), i_eText (5), 
 										//	i_uItem (popup) (6)).
 	intention_Get_NumPopupItems = 8018,	//	Returns the number of items in a popup,
 										//	if the field user interface is a popup.
										//	(e.g. returns 2 if the popup shows {"ON", "Off"}).
 	intention_Get_PopupStringArray = 8019,
 										//	Returns the pointer to an array of C
 										//	Str15 strings that contain the items
										//	in the popup (i.e. iNetStr15 popupItems[]).
	intention_Get_AddrNamesStringArray = 8020,
										//	Returns the pointer to an array of C
										//	Str15 strings that contain the names
										//	of the Network, Device, Module, Channel,
										//	Settings, Field (i.e. iNetStr15 array[0] =
										//	Network Name, array[1] = Device Name,
										//	array[2] = Module Name, array[3] = Channel
										//	Name, array[4] = Settings Name, array[5] =
										//	Field Name).
								
										//	-------------------------------------
										//	GET/SET NETWORK STATE
										
	intention_getHandleToNetworkState = 8022,
										//	Returns a Handle to the Network State (in uint32).
										//	The Caller must dispose of it after using it (e.g. DisposHandle()
										//	on Macintosh, GlobalFree() on Windows). To get the Handle size, call
										//	GetHandleSize() on Macintosh, on Windows) gsw 11/25/95

	intention_setNetworkStateWithHandle = 8023,
										//	Sets the network state with the passed Handle.
										//	The Caller must dispose after calling this routine.
										//	The handle must have originated from a 
										//	GET_HANDLE_TO_NETWORK_STATE() call that was done
										//	previously. gsw 11/25/95

	intention_disposeOfNetworkState = 8024,
										//	Dispose of all instruNet network state.  This
										//	will cause the the next	call to the instruNet
										//	driver to implement the POWER ON boot
										//	process. Call CloseDriverAndReleaseDriverRam()
										//	to release ram held by the driver itself. gsw 9/8/96

										//	-------------------------------------
										//	SERVICE THE DIGITIZATON PROCESS
										
	intention_serviceAllDigitizeBuffers = 8028,
										//	Services buffers during the digitization process
										//	if they are holding new data (otherwise this does nothing).
										//	This must be done continuously while digitizing.
										//	Returns TRUE (1) if the next data pulled out
										//	out of the buffers is that last pull;
										//	FALSE (0) otherwise. A_PARAM() is set to
										//	TRUE (1) if we pulled to the end of a Scan;
										//	FALSE (0) otherwise.  B_PARAM() is set to the
										//	last scan # (base 1) that was pulled in full. C_PARAM()
										//	is set to the last scan # (base 1) that was pushed in full.

	intention_getCtlrBufferInfo = 8036, //	returns controller ram buffer statistics
										//	gsw 2/28/98

	intention_SetUpDigitization = 8044, //	Sets up digitization, establishes sample rate,
										//	sets up BUFFERS, yet does not actually do the
										//	digitization. gsw 8/16/98

										//	-------------------------------------
										//	SHOW PROBE DIALOG
										
	intention_showProbeDialog_Full = 8031,
										//	Shows the full probe dialog.  On return,
										//	netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), 
										//	etc contain the accessed address.
	
	intention_showProbeDialog_ChannelAddrOnly = 8032,
										//	Shows the probe dialog with the channel
										//	address only ([net/dev/mod/chan] popups).
										//	On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), 
										//	etc contain the accessed address. A_PARAM(gRequestP)
										//	is set to 1 if the user pressed CANCEL, 0 if
										//	the user pressed OK to exit the dialog.

	intention_showProbeDialog_FieldAddrOnly = 8033,
										//	Shows the probe dialog with the field
										//	address only ([net/dev/mod/chan/set/Field] popups).
										//	On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), 
										//	etc contain the accessed address. A_PARAM(gRequestP)
										//	is set to 1 if the user pressed CANCEL, 0 if
										//	the user pressed OK to exit the dialog.

	intention_showProbeDialog_fixedChanAddr = 8034,
										//	Shows the probe dialog with a fixed channel
										//	address (net/dev/mod/chan).
										//	On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), 
										//	etc contain the accessed address. A_PARAM(gRequestP)
										//	is set to 1 if the user pressed CANCEL, 0 if
										//	the user pressed OK to exit the dialog. gsw 2/18/97

	intention_showProbeDialog_fixedChanAddrAndSettingGp = 8035,
										//	Shows the probe dialog with a fixed channel
										//	address (net/dev/mod/chan) and fixed settings group.
										//	On return, netNum_PARAM(gRequestP), deviceNum_PARAM(gRequestP), 
										//	etc contain the accessed address. A_PARAM(gRequestP)
										//	is set to 1 if the user pressed CANCEL, 0 if
										//	the user pressed OK to exit the dialog. gsw 2/18/97
										
										//	-------------------------------------
										//	MANAGEMENT
										
	intention_Set_gClickOnThisWindowToQuitiNet = 8040,
										//	Setting a WindowPtr_ such that if this
										//	window is clicked on while the instruNet World
										//	Window is opened, then the instruNet World
										//	Window will QUIT (e.g. the host application
										//	window). gsw 3/3/96
										
	intention_lockInternalMemory = 8041,//	Lock internal memory so that future calls
										//	to iNet() are less likely to move memory (useful
										//	when calling iNet from interrupts). gsw 1/27/97
	intention_unlockInternalMemory = 8042,
										//	Internal memory is not locked when the processor
										//	is outside of iNet(). gsw 1/27/97
										
	intention_getDLLglobals = 8043,		//	returns globals in DLL. gsw 10/16/97
	
										//	returns 1 if licensed for iW+, 0 otherwise.
										//	Requires iNet software >= 2.0, gsw 7/7/03
	intention_Get_iWp_LicenseState = 8045	

} ion_intention; 

#define  intention_MIN  intention_getValue
#define  intention_MAX  intention_Get_iWp_LicenseState
										
										/*	-------------------------------------
										//	Ring 2 is before Process_iNet_Request()  */	
#define	 intention_ring2_MIN  	8000		
#define	 intention_ring2_MAX 	11999
										/*	-------------------------------------
										//	Ring 1 is before Process_Request_with_Correct_And_Updated_Struct()  */
#define	 intention_ring1_MIN  	4000	
#define	 intention_ring1_MAX 	7999
										/*	-------------------------------------
										//	Ring 0 is inside SG_rec_xxxx_PROCESS_REQUEST() */
#define	 intention_ring0_MIN  	1			
#define	 intention_ring0_MAX	3999

/*	================================== Data Types =================================== */

										/*	------------------------------------ */
typedef enum iNetDataType {				//	types of data (this must fit into an UINT8 = {0...255})
	
										/*	#### these #'s must not change */

	iNetDT_INT16 = 0,					//	16bit integer, signed
	iNetDT_INT16bus = 1,				//	16bit integer, signed; yet data is on a card and
	iNetDT_UINT16 = 2,					//	16bit integer, unsigned
										//	must be transferred to with 16bit transfers.

	iNetDT_INT32 = 3,					//	32bit integer, signed
	iNetDT_UINT32 = 4,					//	32bit integer, unsigned

	iNetDT_FLT32 = 5,					//	32bit float (ieee Macintosh format)
	iNetDT_Double = 6,					//	'double', as determined by the compiler (e.g. flt64, flt80, flt96, flt128)
	iNetDT_INT16comp = 7,				//	16bit integer, signed; yet compressed in the standard iNet
										//	'iNetDT_INT16comp" manner.
	iNetDT_P_Str15 = 8,					//	PASCAL Str15 string (15 chars, 0th char is length)
	iNetDT_P_Str255 = 9,				//	PASCAL Str255 string (255 chars, 0th char is length)
	iNetDT_C_Str15 = 10,				//	C Str15 string (15 chars, 0x00 terminate)
	iNetDT_C_Str255 = 11,				//	C Str255 string (255 chars, 0x00 terminate)
	
	iNetDT_READ_ONLY_BIT = 128			//	this is ADDED to the iNetDataType value if the
										//	field is read only.
	
} iNetDataType;						

#define  iNetDataType_MIN  iNetDT_INT16
#define  iNetDataType_MAX  iNetDT_C_Str255

#define iNetDataType_MASK  0x7F			/* 	mask to strip off special on/off bits */
										/*	(e.g. iNetDT_READ_ONLY_BIT) */

/*	============================= DSP Card Status ============================= */

typedef enum DigitizeStatus {			
										/*	#### these #'s must not change */
	digitize_off = 1,					//	not digitizing
	digitize_interrupt_on = 2,			//	digitizing <1Ks/sec medium speed via internal interrupts
	digitize_highspeed_on = 3			//	digitizing <1Ks/sec high speed, dsp is fully busy

} DigitizeStatus ;

/*	============================= iNetError error codes ============================= */

typedef iNetINT16 iNetError;			//	error codes are 16bit integers

										/*	------------------------------------ */
typedef enum iNetErrorCode {			//	iNet error codes
										//	iNetINT16 -32K to +32K values

										/*	#### these #'s must not change */

	iNetErr_None = 0,					//	no error
	iNetErr_General = 1,				//	general error
	iNetErr_ControllerNotInitialized=2,	//	InitializeDriverAndControllers_iNet() has not been called
	iNetErr_InitializationFailed = 3,	//	InitializeDriverAndControllers_iNet was called, yet failed
	iNetErr_DeviceNumOutOfRange = 4,	//	Device number is out of range (is it connected & powered on?)
	iNetErr_ChannelNumOutOfRange = 5,	//	Channel number is out of range
	iNetErr_FieldNumOutOfRange = 6,		//	Field number is out of range
	iNetErr_ControllerNotFound = 7,		//	iNet Controller not found
	iNetErr_FieldDoesNotExist = 8,		//	(devNum, chNum, fieldNum) refer to field that
										//	does not exist
										
										//	added lots of numbers to this enum,
										
	iNetErr_BadfieldNativeDataType = 9,	//	bad iNetFieldDataType value
	iNetErr_BadFieldReadType = 10,		//	bad iNetFieldReadType value

	iNetErr_TimeoutAtReadBegin = 11,	//	time out at read begin
	iNetErr_TimeoutAtWaitForReadDone = 12,
										//	timeout at wait for read done
	iNetErr_ControllerIsInWeeds = 13,	//	controller is in the weeds
	iNetErr_illegalDataType = 14,		//	illegal data type
	iNetErr_FailedCopyDataTest = 15,	//	failed the CopyWaveData() test
	iNetErr_CompressorHitError = 16,	//	compressor hit error
	iNetErr_FailedRamTest = 17,			//	failed board ram test
	
	iNetErr_RanOutOfMemory = 18,		//	ran out of memory
	iNetErr_AlertFailed = 19,			//	the routine that shows an alert failed
	iNetErr_CtrlrRomNotBooting = 20,	//	iNet Controller's ROM does not seem to 
										//	boot up (poss problem: controller, bus, rom)
	iNetErr_CtrlrRamNotBooting = 21,	//	iNet Controller's driver in RAM does not seem to 
										//	boot up (poss problem: controller, bus, ram, rom,
										//	download from ucontroller, bad driver downloaded
										//	from host)
	iNetErr_DriverDownloadFailed = 22,	//	the download of the uController driver into controller
										//	ram failed (driver may be bad, or hardware is bad)
										//	(the keys and copyright did not match up).
	iNetErr_CtrlrRWTestFailed = 23,		//	failed during controller r/w test in
										//	Test_DualPort_Ram()
	iNetErr_InterfaceBlockTestFailed = 24,
										//	Interface block between uController and host computer
										//	is invalid
	iNetErr_IncCounterTestFailed = 25,	//	Controller failed CounterInc test
	iNetErr_EchoCmdToStatusTestFailed = 26,
										//	Controller failed EchoCmdToStatus test
	iNetErr_ControllerBootTestFailed = 27,
										//	Controller failed Test_A_Booted_Controller test
	iNetErr_ControlleFailedToBoot = 28,	//	Controller failed to Boot.
	iNetErr_ControllerCmdFailed = 29,	//	Controller failed to execute command
	
										//	----------------------------------------
										//	GUI Errors.
										//
	iNetErr_GUI = 30,					//	error related to graphical user interface
				
										//	----------------------------------------
										//	iNet Bus error codes
	
	iNetErr_QSPI_Busy = 31,				//	iNet Bus is busy running
	iNetErr_QSPI_Halted = 32,			//	iNet Bus hit HALT error
	iNetErr_QSPI_ArgOutOfRange = 33,	//	iNet Bus argument out of range
	iNetErr_QSPI_TimeOutErr = 34,		//	iNet Bus hit time out error
	iNetErr_FlakyNetwork = 35,			//	iNet Bus is acting flaky (need terminator?)
	
										//	----------------------------------------
										//	Driver Errors
										//
	iNetErr_CouldNotLocateDriverFile = 36,	//	could not find the DRIVER code resource
										//	file.
	iNetErr_netNumOutOfRange = 37,		//	netNum is out of range
	iNetErr_SettingGroupNumOutOfRange = 38,	//	settingGroupNum is out of range
	iNetErr_UnitTypeOutOfRange = 39,	//	deviceType is out of range
	iNetErr_DriverDidNotSetErrCode =40,	//	Driver did not get a chance to set the error code;
										//		therefore Driver is in trouble.
	iNetErr_SettingGroupTypeOutOfRange = 41, //	settingGroupType is out of range

										//	----------------------------------------
										//	Etc Codes

	iNetErr_ModuleNumOutOfRange = 42,	//	Module number is out of range
	iNetErr_IntentionNumOutOfRange =43,	//	Intention number is out of range
	iNetErr_ReadOnlyField = 44,			//	Cannot write to this field, read only
	iNetErr_WriteOnlyField = 45,		//	Cannot read from this field, write only
	iNetErr_FieldValueOutOfRange = 46,	//	Tried to set a field with a value that is too high or low					gsw 5/2/95
	iNetErr_ArgTypeOutOfRange = 47,		//	ArgType parameter is out of range
	iNetErr_BadKeyInFieldHierarchy =48,	//	A BAD key was found in the field hierarchy data
	iNetErr_Max_LT_MinInFieldHierarchy = 49,
										//	A maximum value is less than a minium value in the field hierarchy
	iNetErr_HierarchyFieldDataInTrouble = 50,
										//	Hierarchial field data is in trouble
	iNetErr_ChannelNameInvalid = 51,	//	The channel name is in trouble
	
	iNetErr_tempUnits_outOfRange = 52,	//	temperature scale {C,K,F} out of range
	iNetErr_sensorType_outOfRange = 53,	//	sensor type out of range


										//	----------------------------------------
										//	Digitize Errors.
										
	iNetErr_CircBufErr = 54,			//	circular data buffer error
	iNetErr_CtlrDataBufferOverflow = 55,//	controller circular data buffer overwrote data before it was read
	iNetErr_PulledTooMuchOnLastPull=56,	//	controller circular data buffer error where pulled too much on last pull, gsw 10/4/95

										//	----------------------------------------
										//	Filter Error Codes

	ERequired_fbx_DCIIR = 57,			/* "At least one cutoff frequency (passband or stopband) is needed for each transition band of bandpass and bandstop filters" */
	EFreqTooLarge_fx_DCIIR = 58,		/* "Cutoff frequency must be less than half the sampling rate" */
	EFreqsNotAscending_DCIIR = 59,		/* "Cutoff frequency negative or frequencies not in ascending order" */
	ERequired_fx_DCIIR = 60,			/* "Missing one or more cutoff frequencies" */
	ERequired_adelx_DCIIR = 61,			/* "Missing passband ripple and/or stopband attenuation" */
	EInvalidArg_DCIIR = 62,				/* "Invalid argument" */
	EOrderTooHigh_DCIIR = 63,			/* "Necessary or specified filter order is too high -- maximum order is %d" */
	EEven_ndeg_DCIIR = 64,				/* "Filter order must be even for bandpass and bandstop filters -- order being increased by 1" */
	EOrderTooLow_DCIIR = 65,			/* "Specified filter order is too low -- order being automatically increased" */
	EActualOrder_DCIIR = 66,			/* "Required filter order = %d  (%s biquadratic section%s)" */
	
										//	----------------------------------------
										//	New Error Codes
	
	iNetErr_InterfaceCompiledBadly =67,	//	a variable type in interface file (e.g. "ionC_INT.c") is bad
	iNetErr_BadInterfaceKey = 68,		//	the 'key' field passed to driver is bad
	iNetErr_BadAddrPassedToDriver = 69,	//	bad address passed to driver
	iNetErr_BadStaticVarInDriver = 70,	//	bad static variable in driver
	iNetErr_BadIntegerMathInDriver =71,	//	bad integer math in driver

	iNetErr_BadChannelType = 72,		//	bad channel Type		
	iNetErr_CppCompilerDidBad = 73,		//	Cpp compiler failed		
	iNetErr_MemMngr_Failed = 74,		//	Memory Manager failed	
	iNetErr_Toolbox_Failed = 75,		//	Toolbox failed			
	iNetErr_CrtRect_Failed = 76,		//	CrtRect failed			
	iNetErr_DlogCode_Failed = 77,		//	Dialog Code failed		
	iNetErr_DrvrNeedsFpu_Failed = 78,	//	Driver file needs FPU	
	iNetErr_iirCode_Failed = 79,		//	iir code failed			
	iNetErr_sprintf_Failed = 80,		//	sprintf failed				

	iNetErr_DigitizeInit = 81,			//	initialization of digitizer failed	
	iNetErr_SPE_off = 82,				//	SPE off while digitize error
	iNetErr_Halt_on = 83,				//	HALT while digitize error
	iNetErr_CPTQP_failed_to_clr = 84,	//	CPTQP_failed_to_clr error
	iNetErr_qspiBusyBeforeDigitize=85,	//	qsp busy before digitize error
	iNetErr_weAbortedEarly=86,			//	controller was told to abort digitize
	iNetErr_CtlrIsBusyDoingSomething=87,//	controller is busy doing something		
										//		and cannot be interrupted now
	iNetErr_CtlrDidNotFinishCmd=88,		//	controller did not finish the command
	iNetErr_CodeGenSegmentErr=89,		//	code generation segment error
	iNetErr_CPTQP_is_Bad=90,			//	CPTQP is bad
	iNetErr_CompilerErr=91,				//	Compiler error
	iNetErr_DrvrOrUserBufferOverflow = 92,//User or Driver data buffer overwrote data before it was read
	iNetErr_NonCompatible_OS = 93,		//	Operating System (version) is not compatible with driver
	iNetErr_badChanPtsPerScan=94,		//	ptsPerChannel = %sampleRate * numPtsPerScan needs to be integer
	iNetErr_DestBufferNotFound=95,		//	destination buffer not found

	iNetErr_CtlrDataBufferUnderflow = 96,//	did not keep up with writing data to ctlr (e.g. d/a)

	iNetErr_AbortDueToBusyCtlr = 97,	//	the host tried to do an i/o operation, yet
										//	aborted since the controller was busy
										//	(e.g. with digitize). This was ok, since
										//	the host had set gDontWaitIfControllerIsBusy
										//	TRUE, indicating it did not want to wait if ctlr was busy

										//	----------------------------------------

	iNetErr_ctlrRemovedOrOff = 100,		//	Controller removed or powered off (e.g. pcmcia)

										//	----------------------------------------
										//	STATUS register error codes.

	iNetErr_StatusRegBase = 10000,		//	this is an error code from the iNet stats
										//	register that is (10000+status)
	iNetErr_StatusRegEnd  = 10255,		//	last status register location

										//	----------------------------------------
										//	Operating System Error (Macintosh or Windows Error)
										//
										//		iNetError = (OSErr + iNetErr_OsBase) 
										//
	iNetErr_OsRegMin = -32000,			//	min Operating System Error
	iNetErr_OsBase   = -16000,			//	max Operating System Error
	iNetErr_OsRegMax  = -1				//	max Operating System Error


} iNetErrorCode;

										/*	convert iNetError to Operating System Error */
#define iNetError_TO_OSErr(iNetErr)		(iNetErr - ((iNetError) iNetErr_OsBase))

										/*	convert Operating System Error to iNetError */
#define OSErr_TO_iNetError(osErr_)		((iNetError) (((iNetINT32) osErr_ != 0L) ? \
										((iNetError) ((iNetINT32) osErr_ + (iNetINT32) iNetErr_OsBase)) : \
										((iNetError) iNetErr_None)))


										/*	------------------------------------ */
typedef enum iNetSubError {				//	iNet sub error codes (used internally)
										//	iNetINT16 -32K to +32K values

										/*	#### these #'s must not change */

	ioSubNetErr_None = 0,				//	no error 
	ioSubNetErr_BadLastRAMAddr = 1,		//	failed to find last RAM address 
	ioSubNetErr_BadBaseAddr = 2,		//	failed to calc board base addresss	
	ioSubNetErr_FirstRamAddrBad = 3,	//	1st RAM address fails RAM test
	ioSubNetErr_FailedFloatTest = 4,	//	failed floating point test
	ioSubNetErr_DataLinesBad = 5,		//	data line is bad
	ioSubNetErr_AddrLinesBad = 6,		//	addr line is bad
	ioSubNetErr_QuickIOtestFailed = 7	//	quick i/o test failed with RAM
	
} iNetSubError;

/*	================================== beep signal ==================================== */

										/*	------------------------------------ */
typedef enum BeepSignal	{				//	signals something with a 'BeepSignal' number
										//	of beeps without showing a dialog.
										
										/*	#### these #'s must not change */
										
	beepSignal_OS_Version_too_old = 3,	//	says that your operating system version
										//	# is too old.
									
										//	could not locate driver file (file "ionC_INT.c")
	beepSignal_NUM_BEEPS_IF_NO_DRIVER_FILE = 4,
										
	beepSignal_CouldNotShowAn_Alert = 5,//	could not show an alert, since that would have
										//	caused an infinite loop
										
	beepSignal_PopupTrouble = 6,		//	hit trouble with popups, 

	beepSignal_CouldNotLoad_Rsrc = 7	//	could not load a resource used in a dialog
	
} BeepSignal;

/* ============================= Types of Controllers ============================= */

										/*	----------------------- */
typedef enum ControllerType	{			//	specifies type of controller

										/*	#### these #'s must not change */

	ctlr_NotIdentified = 0x0000,		//	Not yet identified
	ctlr_Nubus = 0x1234 /* 4660 */,		//	Nubus board (Macintosh only)
	ctlr_PCI /* 4661 */,				//	PCI board (Macintosh or PC)
	ctlr_Ext_ISA /* 4662 */,			//	Extended ISA board (PC only)
	ctlr_PCMCIA /* 4663 */				//	PCMCIA card
	
} ControllerType;
											
										/*	returns TRUE if this controller
										 *	boots off of rom; FALSE if it boots
										 *	off of downloaded ram */
#define THIS_CONTROLLER_HAS_A_BOOT_ROM(controllerType)	 (controllerType == ctlr_Nubus)


/* ============================= Field Hierarchy Limits ============================= */

										/*	max # of settinggroups per CHANNEL */
										/*	32 -> 40, gsw 4/10/03 */
#define  MAX_NUM_settinggroup_PER_CHANNEL 40	

										/*	min # of settinggroups per CHANNEL */
#define  MIN_NUM_settinggroup_PER_CHANNEL 1		

#define  MAX_NUM_CHANNELS_PER_MODULE 64	/*	max # of CHANNELS per MODULE;
										 *	changed 32->64 for user defined channels 
										 *	(pop/editF/btn/pg), gsw 3/3/3 */

#define  MIN_NUM_CHANNELS_PER_MODULE 1	/*	min # of CHANNELS per MODULE */

#define  MAX_NUM_MODULES_PER_DEVICE 5	/*	max # of MODULES per hardware DEVICE,
										 *	changed 16 -> 5, gsw 3/3/3 */ 

#define  MIN_NUM_MODULES_PER_DEVICE 1	/*	min # of MODULES per hardware DEVICE */

#define  MAX_NUM_DEVICES_PER_NETWORK 32	/* 	max # of hardware DEVICES per NETWORK 
										 * (doesn't include CONTROLLER)
										 *	### this # is hardcoded into controller download code
										 *  ### if you change it, you need to recompile that code. */ 

#define  MIN_NUM_DEVICES_PER_NETWORK 1	/* 	min # of hardware DEVICES per NETWORK */

										/*	max # of dio bits per module */
#define  MAX_DIO_BITS_PER_MODULE  (bitNum_i100_QUA /* 8 */)	

#define  cltrNum_DRIVER	 		0		/* 	'cltrNum' = driver */		
#define  cltrNum_NONE			-1		/* 	'cltrNum' = no controller, or driver */		
#define  FIRST_NETWORK			1		/* 	'netNum' of first network */		

#define  MAX_NUM_NETWORKS  		4		/*	maximum # of hardware controllers/networks (does not include DRIVER) */
										/*	digitizeCode in NetorkGlobals struct takes up much space; so
										 *	changed 8->4, gsw 3/3/3 */
										
#define  netNum_DRIVER  		0		/*	'netNum' of 0 means "driver" */
#define  netNum_1stController  	1		/*	'netNum' of the 1st controller */
#define  netNum_AllControllers -1		/*	-1 means all hardware controllers */

#define  deviceNum_CONTROLLER 	0		/*	'devNum' of 0 means iNet Controller" */
#define  deviceNum_DRIVER 		0		/*	'devNum' of 0 means iNet driver if netNum = 0 (driver), gsw 1/28/97 */
#define  deviceNum_1stDevice   	1		/*	'devNum' of the 1st DEVICE on network */

#define  moduleNum_1stModule   	1		/*	'modNum' of the 1st MODULE in DEVICE */

#define  chanNum_1stChannel    	1		/*	'channelNum' of the 1st CHANNEL in MODULE */

#define  settingNum_1stSetting  1		/*	'settingNum' of the 1st SETTING Group in CHANNEL */

#define  fieldNum_1stField  	1		/*	'fieldNum' of the 1st FIELD in SETTING Group */
#define  MAX_NUM_FIELDS  		8		/*	max num of fields */
#define  fgNums_NONE_FOUND 		0		/* 	no fieldNum found */

#define  pChoice_NONE_FOUND 	0		/* 	no popupChoice found, for base1 popChoice values  */
#define  itemNum_NONE_FOUND 	-1L		/* 	no itemNum found, for base0 itemNum values */

/*	====================== MODULE NUMBERS WITHIN DRIVER DEVICE =============================== */

										/*	------------------------------------ */
										//	Module #' within the Driver Device

										/*	#### these #'s must not change */

typedef enum DriverModuleNumber {	

	Driver_moduleNum_NOT_RECOGNIZED =0,	//	not recognized

	Driver_moduleNum_1_Driver = 1,		//	list of user created buttons

	Driver_moduleNum_2_user_buttons = 2,//	list of user created buttons
										//	Addr = { Driver, Driver, User Buttons, Ch ... }

	Driver_moduleNum_3_user_pages = 3,	//	list of user created pages
										//	Addr = { Driver, Driver, User Pages, Ch ... }

	Driver_moduleNum_4_user_textFs = 4,	//	list of user created edit fields / dynamic text
										//	Addr = { Driver, Driver, User Text Fields, Ch ... }

	Driver_moduleNum_5_user_popups = 5	//	list of user created popups
										//	Addr = { Driver, Driver, User popups, Ch ... }

} DriverModuleNumber;

#define Driver_moduleNum_MIN	Driver_moduleNum_1_Driver
#define Driver_moduleNum_MAX	Driver_moduleNum_5_user_popups


/*	============================ little/big Endian ================================== */

										/*	#### these #'s must not change */

#define bigEndian_ion		0			/*	big endian, e.g. Motorola 68K, 68332 */
#define littleEndian_ion	1			/*	ittle endian, e.g. Intel x86 */

										/*	calculate endian mode for this compiler */
#if (MACHINE_TYPE_ == MACINTOSH_iNet || MACHINE_TYPE_ == CONTROLLER_iNet)

	#define  THIS_COMPILERS_ENDIAN_MODE  bigEndian_ion		/* Mac, Moto68K, PPC, 68332 */

#elif (MACHINE_TYPE_ == WINTEL_iNet)

	#define  THIS_COMPILERS_ENDIAN_MODE  littleEndian_ion	/* Intel x86 */

#else

	### error

#endif
	
/*	========================= Open Window Commands =================================== */

										/*	------------------------------------ */
										//	These are fieldValues for the OpenWindow
										//	Channel within the DRIVER.
typedef enum iNet_OpenWindow_Command_FieldValues {	
										
										/*	#### these #'s must not change */
										
	iNetCM_OpenWindow_Record = 1,		//	open the RECORD page
	iNetCM_OpenWindow_Network = 2,		//	open the NETWORK page
	iNetCM_OpenWindow_Test = 3,			//	open the TEST page
	
	iNetCM_OpenWindow_FullProbe = 4,	//	open the full Probe dialog
	iNetCM_OpenWindow_ChanSelection = 5,//	open channel selection dialog
	iNetCM_OpenWindow_FieldSelection =6,//	open field selection dialog
	iNetCM_OpenWindow_OneFieldSet = 7,	//	open Probe dialog with fixed channel address & setting group
	iNetCM_OpenWindow_AllFieldSets = 8,	//	open Probe dialog with fixed channel address
	
	iNetCM_OpenWindow_RecTiming = 9, 	//	open Timing dialog
	iNetCM_OpenWindow_RecTrigger = 10,	//	open Trigger dialog
	iNetCM_OpenWindow_RecOptions = 11, 	//	open the Record Options dialog
	iNetCM_OpenWindow_RecFile = 12,		//	open the Record File dialog
	iNetCM_OpenWindow_SimpleTiming = 13,//	open the SimpleTiming dlog
										//	(pts-per-scan and sample-rate)
	iNetCM_OpenWindow_CalOptions = 14	//	open the Calibration Options dlog

} iNet_OpenWindow_Command_FieldValues;

#define  iNet_OpenWindow_Command_FieldValues_MIN  iNetCM_OpenWindow_Record
#define  iNet_OpenWindow_Command_FieldValues_MAX  iNetCM_OpenWindow_SimpleTiming
#define  iNet_OpenWindow_Command_FieldValues_DEF  iNet_OpenWindow_Command_FieldValues_MIN


/*	=================================== buttonID's ================================ */

										/*	------------------------------------ */
										//	These are field numbers for commands that
										//	press buttons in the instruNet World window.

//	"iNet_OpenWindow_Command_FieldValues" is now called "iNet_Standard_ButtonID"

typedef enum iNet_Standard_ButtonID {			

										/*	#### these #'s must not change */
										/*	#### these #'s must not change */
										/*	#### these #'s must not change */

										//	THIS CORRESPONDS 1:1 w/ gBtnPress_CommandPop enum.
										//	THIS CORRESPONDS 1:1 w/ gBtnPress_CommandPop enum.

	iNet_ButtonID_NOT_DEFINED = 0,		//	undefined button

										//	-----------------------------
										//	RECORD page
										
	iNet_ButtonID_Record_Start = 1,		//	press 'Start' button in RECORD page
	iNet_ButtonID_Record_Stop = 2,		//	press 'Stop' button in RECORD page
	iNet_ButtonID_Record_Open = 3,		//	press 'Open' button in RECORD page
	iNet_ButtonID_Record_Save = 4,		//	press 'Save' button in RECORD page
	iNet_ButtonID_Record_Options = 5,	//	press 'Options' button in RECORD page
	iNet_ButtonID_Record_Timing = 6,	//	press 'Timing' button in RECORD page
	iNet_ButtonID_Record_Trigger = 7,	//	press 'Trigger' button in RECORD page
	iNet_ButtonID_Record_Probe = 8,		//	press 'Probe' button in RECORD page

										//	-----------------------------
										//	NETWORK page
										
	iNet_ButtonID_Network_Restore = 9,	//	press 'Restore' button in NETWORK page
	iNet_ButtonID_Network_Store = 10,	//	press 'Store' button in NETWORK page
	iNet_ButtonID_Network_Open = 11,	//	press 'Open' button in NETWORK page
	iNet_ButtonID_Network_Save = 12,	//	press 'Start' button in NETWORK page
	iNet_ButtonID_Network_Clear = 13,	//	press 'Clear' button in NETWORK page
	iNet_ButtonID_Network_Reset = 14,	//	press 'Reset' button in NETWORK page
	
										//	-----------------------------
										//	TEST page
										
	iNet_ButtonID_Test_Search = 15,		//	press 'Search' button in TEST page
	iNet_ButtonID_Test_Test = 16,		//	press 'Test' button in TEST page
	iNet_ButtonID_Test_BigTest = 17,	//	press 'Big Test' button in TEST page
	iNet_ButtonID_Test_Open = 18,		//	press 'Open' button in TEST page
	iNet_ButtonID_Test_SaveAs = 19,		//	press 'Save As' button in TEST page
	iNet_ButtonID_Test_Clear = 20,		//	press 'Clear' button in TEST page

										//	-----------------------------
										//	SCRIPT page
										
	iNet_ButtonID_Script_Execute = 24,	//	press 'Execute' button in SCRIPT page
	iNet_ButtonID_Script_Stop = 25,		//	press 'Stop' button in SCRIPT page
	iNet_ButtonID_Script_Open = 26,		//	press 'Open' button in SCRIPT page
	iNet_ButtonID_Script_Save = 27,		//	press 'Save' button in SCRIPT page
	iNet_ButtonID_Script_SaveAs = 28,	//	press 'Save As' button in SCRIPT page
	iNet_ButtonID_Script_Clear = 29,	//	press 'Clear' button in SCRIPT page

										//	-----------------------------
										//	RECENT ADDITIONS

	iNet_ButtonID_Record_CalOptions=30,	//	press 'Calibrate Options' button in RECORD page
	iNet_ButtonID_Test_Report = 31, 	//	press 'Report' button in TEST page
	iNet_ButtonID_Record_Directory=21,	//	press 'Directory' button in RECORD page
	iNet_ButtonID_Network_Recal = 22,	//	press 'Recal' button in NETWORK page, 4/21/97
	iNet_ButtonID_Record_Setup = 23,	//	press 'Setup' button in RECORD page
	iNet_ButtonID_Record_Print = 32,	//	press 'Print' button in RECORD page, gsw 8/22/98
	iNet_ButtonID_Test_Print = 33,		//	press 'Print' button in TEST page, gsw 8/22/98
	iNet_ButtonID_Script_Print = 34,	//	press 'Print' button in SCRIPT page, gsw 8/22/98
	iNet_ButtonID_Network_Create = 35,	//	press 'Create' button in NETWORK page, 1/20/03

										//	-----------------------------
										//	SERVICE

	iNet_ButtonID_Service_Probe,		
	iNet_ButtonID_Service_68332,	
	iNet_ButtonID_Service_ReadWrite,
	iNet_ButtonID_Service_QSPI,
	iNet_ButtonID_Service_Open,
	iNet_ButtonID_Service_SaveAs,
	iNet_ButtonID_Service_Clear,
	iNet_ButtonID_Service_Print,

} iNet_Standard_ButtonID;
										/*	THIS CORRESPONDS 1:1 w/ gBtnPress_CommandPop enum.
										//	THIS CORRESPONDS 1:1 w/ gBtnPress_CommandPop enum. */
#define  iNet_Standard_ButtonID_MIN   iNet_ButtonID_Record_Start
#define  iNet_Standard_ButtonID_MAX   iNet_ButtonID_Service_Print
#define  iNet_Standard_ButtonID_DEF   iNet_Standard_ButtonID_MIN

										//	min/max buttonID's for standard buttons
#define	 STANDARD_BUTTON_ID_MIN			iNet_Standard_ButtonID_MIN /* 1 */
#define	 STANDARD_BUTTON_ID_MAX			iNet_Standard_ButtonID_MAX
#define  STANDARD_BUTTON_MAX_QUA		(1 + iNet_Standard_ButtonID_MAX - iNet_Standard_ButtonID_MIN)

										//	min/max buttonID's for user defined buttons
#define  USERDEFINED_BUTTON_MAX_QUA		128 /* max # of user defined buttons */
#define	 USERDEFINED_BUTTON_ID_MIN		(iNet_Standard_ButtonID_MAX + 1)
#define	 USERDEFINED_BUTTON_ID_MAX		(USERDEFINED_BUTTON_ID_MIN + USERDEFINED_BUTTON_MAX_QUA - 1)

										//	min/max buttonID's for both std & defined buttons
#define  ALL_BUTTON_MAX_QUA				(STANDARD_BUTTON_MAX_QUA + USERDEFINED_BUTTON_MAX_QUA)
#define  ALL_BUTTON_ID_MIN				STANDARD_BUTTON_ID_MIN
#define  ALL_BUTTON_ID_MAX				USERDEFINED_BUTTON_ID_MAX

										//	identify button types
#define  THIS_IS_A_STANDARD_BUTTON(buttonID)	\
	((buttonID) >= STANDARD_BUTTON_ID_MIN      iNetAnd   (buttonID) <= STANDARD_BUTTON_ID_MAX)

#define  THIS_IS_A_USERDEFINED_BUTTON(buttonID)	\
	((buttonID) >= USERDEFINED_BUTTON_ID_MIN   iNetAnd   (buttonID) <= USERDEFINED_BUTTON_ID_MAX)

										//	min/max index into ButtonDesc[] for std buttons
										//	(i.e. ones that are not defined by user and are
										//	included when one first runs instruNet World)
#define	 STANDARD_BUTTON_INDEX_MIN		STANDARD_BUTTON_ID_MIN /* 1 */
#define	 STANDARD_BUTTON_INDEX_MAX		STANDARD_BUTTON_ID_MAX

										//	min/max index into ButtonDesc[] for user defined buttons
										//	(i.e. User selects CREATE BUTTON in menubar)
#define	 USERDEFINED_BUTTON_INDEX_MIN	(STANDARD_BUTTON_ID_MAX + 1)
//	 USERDEFINED_BUTTON_INDEX_MAX		use  gP->ButtonDescArray_indexOfLastAllocation
#define	 NUM_OF_USERDEFINED_BUTTONS		(1 + gP->ButtonDescArray_indexOfLastAllocation - USERDEFINED_BUTTON_INDEX_MIN) 

										//	min/max index into ButtonDesc[] for both user & std btns
#define  ALL_BUTTON_INDEX_MIN			STANDARD_BUTTON_INDEX_MIN
//	 ALL_BUTTON_INDEX_MAX				use  gP->ButtonDescArray_indexOfLastAllocation

/* =========================== DRIVER CHANNEL NUMBERS ============================== */
										
										/*	------------------------------------ */
typedef enum driver_Channels_Numbers {	//	Channels numbers for the DRIVER 

	driver_ChanNum_OpenWindow = 1,		//	Open Window Command (DRIVER channel type)
	driver_ChanNum_PushButton = 2,		//	Push Button Command (DRIVER channel type)
	driver_ChanNum_RecordOptions = 3	//	RECORD OPTIONS = {hScale, hPosition, maxPtsPerPix, gridOnOff, plotLinesDots}

} driver_Channels_Numbers;

#define  driver_Channels_Numbers_MIN  driver_ChanNum_OpenWindow
#define  driver_Channels_Numbers_MAX  driver_ChanNum_RecordOptions

//	-------------------------------- tabs at bottom of window --------------------------------

									//	------------------------------------
typedef enum iNet_Tabs {			//	Tabs at bottom of instruNet World window
									//	'gP->world_GUI.currentTab' is currently
									//	selected tab.

	iNetTab_AllTabs = -3,			//	refers to all tabs
	iNetTab_NoTabFound = -2,		//	refers to a tab that wasn't found
	iNetTab_CurrentTab = -1,		//	refers to currently showing page

	iNetTab_Network = 0,			//	NETWORK page
	iNetTab_Record = 1,				//	RECORD page
	iNetTab_Test = 2,				//	USER test page, uses TE
	iNetTab_Script = 3,				//	Script page, uses TE 
	
	iNetTab_User0_ = 4,				//	User0 page, uses TE (allows scriptBtns)
	iNetTab_User1_ = 5,				//	User1 page, uses TE (allows scriptBtns)
	iNetTab_User2_ = 6,				//	User2 page, uses TE (allows scriptBtns)
	iNetTab_User3_ = 7,				//	User3 page, uses TE (allows scriptBtns)
	iNetTab_User4_ = 8,				//	User4 page, uses TE (allows scriptBtns)
	iNetTab_User5_ = 9,				//	User5 page, uses TE (allows scriptBtns)
	iNetTab_User6_ = 10,			//	User6 page, uses TE (allows scriptBtns)
	iNetTab_User7_ = 11,			//	User7 page, uses TE (allows scriptBtns)
	
	iNetTab_Service	/* anyValue */	//	Service page (hidden from end user), uses TE

}  iNet_Tabs;

#define  iNetTab_MIN  				iNetTab_Network /* network = 0, base 0 */
#define  iNetTab_MAX  				iNetTab_Service
#define  iNetTab_MAX_VIEWED_BY_USER iNetTab_User7_

#define  iNetTab_NUM_OF_TABS		(1 + iNetTab_MAX - iNetTab_MIN /* tabNum */)
#define	 tabIndex_MAX				(iNetTab_NUM_OF_TABS-1)	/* max base0 index */

#define  iNetTab_User_MIN  			iNetTab_User0_ 
#define  iNetTab_User_MAX  			iNetTab_User7_ 

#define  iNetTab_Std_MIN  			iNetTab_Network /* = 0, base 0 */
#define  iNetTab_Std_MAX  			iNetTab_Script  /* = 3, base 0 */

#define  iNetTab_with_TE_MIN  		iNetTab_Test
#define  iNetTab_with_TE_MAX  		iNetTab_Service

#define	 NOT_RUNNING_VISIBLE_TEXT  -1			/*	the page is not showing */

									/*	------------------------------------ */
									//	PageList Popup = { Network, Record, User1 ... lastVisibleTab }, gsw 1/1/3

									//	convert tabNum (base 0) to popup number (base 1)
#define  PAGE_tabNum_TO_popNum( tabNum )	((tabNum) + 1)
#define  pagePopNum_TO_tabNum( popNum )		((popNum) - 1)

#define  ion_PageList_popNum_MIN /* 1  = Network, base1 */		PAGE_tabNum_TO_popNum( iNetTab_MIN ) 
#define  ion_PageList_popNum_MAX /* 11 = User7, base1 */		PAGE_tabNum_TO_popNum( iNetTab_MAX_VIEWED_BY_USER )
#define  ion_PageList_popNum_DEF /* 2  = Record, base1 */		PAGE_tabNum_TO_popNum( iNetTab_Record )

/* ================================ CHANNEL DIRECTION enum =============================== */

typedef enum iNetDemoMode {
									/*	#### these #'s must not change */
	iNet_NoDemo = 0,				//	real mode (no demo)
	iNet_FullSimulation = 1,		//	we fully simulate iNet hardware w/ triangle waves
									//	feeding a fake iNet-100 & iNet-200.
	iNet_CorruptData = 2			//	we read real instruNet hardware, yet we alter 
									//	the data randomly, to make it unuseable.
} iNetDemoMode;

/* ================================ CHANNEL DIRECTION enum =============================== */

typedef enum direction_TYPE {		//	native digitize i/o direction = { dir_hdwr_input_circBuf,
									//	dir_hdwr_output_circBuf, dir_hdwr_output_Blank }
	
									/*	#### these #'s must not change */
									/*	#### these #'s must not change */
									
	dir_hdwr_input_circBuf = 1,		//	hardware input channel that supports digitizing (e.g. a/d)

	dir_hdwr_output_circBuf = 2,	//	hardware output channel (e.g. d/a), where data comes
									//	from circBuffer

	dir_hdwr_output_Blank = 3,		//	hardware output channel (e.g. blanking word) where
									//	data is a constant

	dir_hdwr_inAndOut_circBuf = 4,	//	both input and output hardware channel, yet digitized
									//	as in input (e.g. iNet 100 digital i/o)

	dir_hdwr_inAndOut_NoCircBuf=6,	//	both input and output hardware channel, this channel
									//	does Not go into the digitizeList (e.g. controller
									//	digital/timer i/o, i100 dio bit channel)

									//	both input and output (i.e. Rd & Ww) Non-Hardware channel 
									//	(not tied to i2xx or i1xx hdwr) and is never placed in
									//	the digitizeList (e.g. user defined button/page/textf/popup)
	dir_NoHdwr_inAndOut_NoCircBuf = 5	

} direction_TYPE;
									/*	True if we digitize this Hardware channel as a input
									//	(e.g. a/d, iNet dig i/o, ctlr dig i/o) */
#define DIGITIZE_THIS_HDWR_CHANNEL_AS_AN_INPUT(direction_)  \
	((direction_ == dir_hdwr_input_circBuf)			iNetOr  \
	 (direction_ == dir_hdwr_inAndOut_circBuf))

									/*	TRUE if this an Hardware output channel 
									 *	that can be placed in the digitizeList (e.g. d/a) */
#define DIGITIZE_THIS_HDWR_CHANNEL_AS_AN_OUTPUT(direction_) \
	(((direction_) == dir_hdwr_output_circBuf)		iNetOr	\
	 ((direction_) == dir_hdwr_output_Blank))

									/*	TRUE if this an Hardware in or out
									 *	channel that can be placed in
									 * digitizeList (e.g. d/a, a/d, dio group din port) */
#define THIS_CHANNEL_CAN_DIGITIZE(direction_)					 \
	(DIGITIZE_THIS_HDWR_CHANNEL_AS_AN_INPUT(direction_)	 iNetOr	 \
	 DIGITIZE_THIS_HDWR_CHANNEL_AS_AN_OUTPUT(direction_))


									/*	TRUE if this hardware channel can ONLY do
									 *	output (e.g. d/a) */
#define THIS_IS_AN_OUTPUT_ONLY_HDWR_CHANNEL(direction_)	\
	(DIGITIZE_THIS_HDWR_CHANNEL_AS_AN_OUTPUT(direction_))

									/*	TRUE if is a Non-Hdwr channel,
									 *	e.g. user defined btn/page/textf/pop */
#define THIS_IS_A_NON_HDWR_CHANNEL(direction_)			\
	((direction_) == dir_NoHdwr_inAndOut_NoCircBuf)

									/*	TRUE if is a hdwr channel (anything
									 *	on i1xx/i2xx hardware) */
#define THIS_IS_A_HDWR_CHANNEL(direction_)				\
	( ! THIS_IS_A_NON_HDWR_CHANNEL(direction_))

									//	TRUE if this hdwr or non-hardware channel can do
									//	output (e.g. d/a, iNet dig i/o, ctlr dig i/o, 
									//	user defined btn/page/textf/pop)
#define THIS_CHANNEL_CAN_DO_OUTPUT(direction_) \
	(((direction_) == dir_hdwr_output_circBuf)			iNetOr	\
	 ((direction_) == dir_hdwr_output_Blank)			iNetOr	\
	 ((direction_) == dir_hdwr_inAndOut_circBuf)		iNetOr	\
	 ((direction_) == dir_hdwr_inAndOut_NoCircBuf)		iNetOr	\
	 ((direction_) == dir_NoHdwr_inAndOut_NoCircBuf))

									//	TRUE if this hdwr or non-hardware channel can do
									//	input (e.g. a/d, iNet dig i/o, ctlr dig i/o, 
									//	user defined btn/page/textf/pop)
#define THIS_CHANNEL_CAN_DO_INPUT(direction_)				\
	(((direction_) == dir_hdwr_input_circBuf)			iNetOr	\
	 ((direction_) == dir_hdwr_inAndOut_circBuf)		iNetOr	\
	 ((direction_) == dir_hdwr_inAndOut_NoCircBuf)		iNetOr	\
	 ((direction_) == dir_NoHdwr_inAndOut_NoCircBuf))

									//	If the instruNet World window is open, and
									//	Display fld #1 "digitize" is ON, it means
									//	we are turning ON the Display, yet we are
									//	not doing high speed digitizing via the vout
									//	channel (vout is not put into digitizeList),
									//	yet are instead using the CONTROL feature to drive
									//	the output via scalar i/o at the cRate. Here, 
									//	we still want to plot the output channel, yet
									//	driven by the CONTROL thing, not digitizeList buffers.	eeeeeeee
#define THIS_IS_AN_OUTPUT_CHANNEL_DRIVEN_BY_CONTROL_LOOP_AND_PLOTTED_IN_INETWORLD( chP )	\
	((giNetWindowIsUpAndOperating)	iNetAnd						\
	 (iNetWorldWindowIsOpen())				iNetAnd						\
	 (THIS_CHANNEL_CAN_DO_OUTPUT(chP->direction) /* d/a, iNet dig i/o, ctlr dig i/o) */))


/* ================================ CHANNEL TYPE enum =============================== */

typedef enum ion_channelType {			//	CHANNEL types

										/*	#### these #'s must not change */
										/*	#### these #'s must not change */

										//	----------------------------------------
										//	BAD
										
	ct_NotKnownAtThisTime = -1,			//	type is not known at this time

	ct_noneFound = 0,					//	nothing found

	ct_UnRecognizedType = 1,			//	unrecognized (user probably needs a
										//	newer driver that works with this hardware ??)		

										//	----------------------------------------
										//	MODEL 100 HARDWARE
										
	ct_i100_VinP = 2,					//	iNet Model 100 hardware device, Vin+
	ct_i100_VinM = 3,					//	iNet Model 100 hardware device, Vin-
	ct_i100_Vout = 4,					//	iNet Model 100 hardware device, 8bit Vout
	ct_i100_DioGroup = 5,				//	iNet Model 100 hardware device, Digital I/O

	ct_one_dio_bit = 6,					//	one digital i/o bit, gsw 4/10/03

										//	----------------------------------------
										//	DRIVER

	ct_Driver_OpenWindow = 7,			//	Open Window Command (DRIVER channel type)
	ct_Driver_PushButton = 8,			//	Push Button Command (DRIVER channel type)
	ct_Driver_Driver = 9,				//	Record Options, Master Directory settinggroups

										//	----------------------------------------
										//	68332 CONTROLLER

	ct_Controller_Tpu = 10,				//	Controller TPU (Timer/Counter/Din/Dout) Channel
	ct_Controller_Time = 11,			//	Controller TPU GetTime() function (get time since
										//	reset accurate to 250ns).
	ct_Controller_Digitizer = 12,		//	Digitizer {DigitizeOnOff, PtsPerScan, NoOfScans, ScanMode, SampleRate}

										//	----------------------------------------
										//	USER ITEMS

	ct_user_button = 13,				//	user created button
										//	Addr = { Driver, Driver, User Buttons, Ch ... }

	ct_user_page = 14,					//	user created page (i.e. new tab)
										//	Addr = { Driver, Driver, User Pages, Ch ... }

	ct_user_textF = 16,					//	user created front panel edit field / dynamic text
										//	Addr = { Driver, Driver, User Text Fields, Ch ... }

	ct_user_popup = 17					//	user created front panel popup menu
										//	Addr = { Driver, Driver, User Popup Menus, Ch ... }

} ion_channelType;

#define ion_channelType_MIN				ct_noneFound
#define ion_channelType_valid_MIN		ct_i100_VinP
#define ion_channelType_valid_MAX		ct_user_popup

										//	True if this channel is a Front panel user item
										//	(e.g. user defined btn/page/meter/etc)
#define THIS_CHANNEL_IS_A_FRONT_PANEL_USER_ITEM(chP_)	\
   ((chP_ != 0L)	iNetAnd								\
	((chP_->chanType == ct_user_button)		iNetOr		\
	 (chP_->chanType == ct_user_page)		iNetOr		\
	 (chP_->chanType == ct_user_textF)		iNetOr		\
	 (chP_->chanType == ct_user_popup)))

										//	True if this channel is a d/a
#define THIS_IS_A_DIGITAL_TO_ANALOG_CONVERTER(chP_)		\
   ( (chP_ != 0L)							iNetAnd		\
	 (chP_->chanType == ct_i100_Vout) )


/* ================================= HARDWARE Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_Vin {				//	FIELD NUMBERS for HARDWARE settingGroup

										/*	#### these #'s must not change */

	fldNum_Vin_sensorType 		= 1,	//	sensorType. This is in units of 'ion_SensorType' 
										//	(not 'ion_VinPos_SensorPopup' and not 'ion_VinNeg_SensorPopup')

	fldNum_Vin_wiring 			= 2,	//	wiring options

	fldNum_Vin_AnaLpFltr_Hz 	= 3,	//	analog lp filter hz value (e.g. 0, 40, 16000 for Model 100)
										//	fldNum_Vin_ad_MeasMethod 	= 4,	//	ad_MeasMethod

	fldNum_Vin_ad_IntegrateSecs = 4,	//	# of seconds that a/d integrates via multiple readings. 1/19/96

	fldNum_Vin_ad_VmaxRange		= 5		//	voltage range (max voltage) (i.e. a/d gain) {e.g. 5, .626, 0.078, 0.01}
										//	This field is in VOLTS units, not popup selection choice number
	
}  fgNums_Vin;

#define  fldNum_Vin_MIN  		fldNum_Vin_sensorType
#define  fldNum_Vin_MAX  		fldNum_Vin_ad_VmaxRange
#define  fldNum_Vin_ViewedMAX  	fldNum_Vin_ad_VmaxRange

										/*	------------------------------------ */
typedef enum ion_SensorType {			//	ALL SENSOR TYPES

										/*	#### these #'s must not change */
										
										//	See "SENSOR APPLICATION NOTES" section in file "ionC_100.c" for
										//	info on how to use these sensors.
										
										//	Sensor		Screws Used			Wiring				Units		Constants Used		
										//	---------	---------------		--------------		--------	---------------
										//	
	ion_SensorType_Voltage = 1,			//	Voltage 	(V+ - V-)			DIFFERENTIAL		Volts		(none)
										//				(V - GND)			SINGLE-ENDED		Volts		(none)
										//				(V+ - V-) / Vout	BRIDGE				Vmeas/Vexc	(none)		gsw 9/7/97
										//														Vr = Vmeas/Vexc = (V+ - V- - Vinit) / Vexc

	ion_SensorType_Current = 2,			//	Current 	(V+ - V-)			SHUNT RESISTOR		Amps		Rshunt

	ion_SensorType_Resistance = 3,		//	Resistance 	(V+,V-,Vout,Gnd)	VOLTAGE DIVIDER		Ohms		Rshunt, Vexcit					
										//	Resistance	(V+,V-,Vout,Gnd)	BRIDGE							Ro, Vexcit, Vinit

	ion_SensorType_StrainGauge = 4,		//	StrainGauge (V+,V-,Vout,Gnd)	VOLTAGE DIVIDER		Strain(E)	Ro,Shunt,Vexcit,Vinit,GF
										//	StrainGauge (V+,V-,Vout,Gnd)	Q Bridge Bend					Ro,Vexcit,Vinit,GF,Rlead
										//	StrainGauge (V+,V-,Vout,Gnd)	H Bridge Bend					Ro,Vexcit,Vinit,GF,Rlead
										//	StrainGauge (V+,V-,Vout,Gnd)	H Bridge Axial					Ro,Vexcit,Vinit,GF,Rlead,v_Poisson
										//	StrainGauge (V+,V-,Vout,Gnd)	F Bridge Bend I					Vexcit,Vinit,GF
										//	StrainGauge (V+,V-,Vout,Gnd)	F Bridge Axial I				Vexcit,Vinit,GF,v_Poisson
										//	StrainGauge (V+,V-,Vout,Gnd)	F Bridge Axial II				Vexcit,Vinit,GF,v_Poisson
										//
	ion_SensorType_RTD = 5,				//	RTD			(V+,V-,Vout,Gnd)	VOLTAGE DIVIDER		Celsius		alpha,delta,Ro,Shunt,Vexcit

	ion_SensorType_TC_J = 6, 			//	THERMOCOUPLE J		(V+ - V-)	DIFF or SE			Celsius		(none)		Calc with polynomial
	ion_SensorType_TC_K = 7, 			//	THERMOCOUPLE K		(V+ - V-)	DIFF or SE						(none)		Calc with polynomial
	ion_SensorType_TC_T = 8, 			//	THERMOCOUPLE T		(V+ - V-)	DIFF or SE						(none)		Calc with polynomial
	ion_SensorType_TC_E = 9, 			//	THERMOCOUPLE E		(V+ - V-)	DIFF or SE						(none)		Calc with polynomial
	ion_SensorType_TC_R = 10, 			//	THERMOCOUPLE R		(V+ - V-)	DIFF or SE						(none)		Calc with polynomial
	ion_SensorType_TC_S = 11,			//	THERMOCOUPLE S		(V+ - V-)	DIFF or SE						(none)		Calc with polynomial
	ion_SensorType_TC_B = 12,			//	THERMOCOUPLE B		(V+ - V-)	DIFF or SE						(none)		Calc with polynomial
	ion_SensorType_TC_N = 13,			//	THERMOCOUPLE N		(V+ - V-)	DIFF or SE						(none)		Calc with polynomial

	ion_SensorType_Thermistor = 14,		//	Thermistor	(V+,V-,Vout,Gnd)	VOLTAGE DIVIDER		Celsius		(not yet supported)

	ion_SensorType_Digital = 15,		//	Digital 	INT16 Digital word						(none

	ion_SensorType_LoadCell = 16,		//	Load Cell	similar to strain gage w/ voltage		Kg = Vr  /  (Vmeas per Vexc per Kg)			
										//				ratio, returns Kg Force, 12/10/02 gsw	Vr = Vmeas/Vexc = (V+ - V- - Vinit) / Vexc
										//
										//				(V+ - V-) / Vout	BRIDGE ratio		Ro, Vexcit, Vinit, GF (Vmeas/Vexc/Kg), alpha (max force Kg)

	ion_SensorType_POT = 17,			//	POT			returns 0 to 1, voltage ratio 			0 to 1 position = Vr
										//				added 12/10/02 (gsw)					Vr = Vmeas/Vexc = (V+ - V- - Vinit) / Vexc
										//
										//				(V+ - V-) / Vout	BRIDGE ratio		Ro (pot ohms), Vexcit, Vinit		

	ion_SensorType_Accel = 18			//	Accelerometer - these have their own constant current excitation and they put 
										//				out a signal w/ a high source impedance that feeds a high Z
										//				input (w/o mux pumping), where you get so may mV per G, 12/10/02 gsw
										//														
										//														G = (Vmeas - Vinit) / (GF = V per G)
										//														Vmeas = (Vin+ - Vin-) or Vin+ or Vin-
										//
										//				V+ or V-			SE or DI			Vinit, GF (V/G), alpha (max G)
}  ion_SensorType;

										/* All Sensor Types */
#define  ion_SensorType_MIN  	ion_SensorType_Voltage
#define  ion_SensorType_MAX  	ion_SensorType_Accel
#define  ion_SensorType_DEF  	ion_SensorType_Voltage

										/*	------------------------------------ */
										/*	thermocouple sensor types */

#define  ion_SensorType_TC_MIN  ion_SensorType_TC_J
#define  ion_SensorType_TC_MAX	ion_SensorType_TC_N	
#define  NUM_TC_TYPES  (1 + ion_SensorType_TC_MAX - ion_SensorType_TC_MIN)

										/*	true if sensor type is a thermocouple */
#define  THIS_IS_A_THERMOCOUPLE(sensorType_ /* ion_SensorType */)	\
  (((sensorType_) >= ion_SensorType_TC_MIN) iNetAnd ((sensorType_) <= ion_SensorType_TC_MAX))

										/*	------------------------------------ */
										/*	Vin+ channel sensor types */

										/*	returns TRUE if this sensorType
										 *	is supported by Vin+ channels, gsw 12/10/02 */
#define  VinPos_COMPATIBLE_SENSORTYPE(sensorType_ /* ion_SensorType */)	((Boolean) \
  (	((sensorType_) >= ion_SensorType_MIN)		iNetAnd		\
	((sensorType_) <= ion_SensorType_MAX)		iNetAnd		\
	((sensorType_) != ion_SensorType_Digital)))

										/*	------------------------------------ */
										/*	Vin- channel sensor types */

										/*	returns TRUE if this sensorType
										 *	is supported by Vin- channels, gsw 12/10/02 */
#define  VinNeg_COMPATIBLE_SENSORTYPE(sensorType_ /* ion_SensorType */)	((Boolean) \
	(((sensorType_) == ion_SensorType_Voltage)	iNetOr		\
	 ((sensorType_) == ion_SensorType_Accel)	iNetOr		\
	  THIS_IS_A_THERMOCOUPLE(sensorType_)))


										/*	------------------------------------ */
										//	Vin+ CHANNEL SENSOR POPUP CHOICES
										//	
										//	Measurements from Vin+ channels support
										//	all sensor types except 'Digital' sensorType

typedef enum ion_VinPos_SensorPopup {	//	### these gui numbers may change in the future

	ion_VinPos_SensorPopup_Voltage = 1,	ion_VinPos_SensorPopup_Current,	ion_VinPos_SensorPopup_Resistance,
	ion_VinPos_SensorPopup_StrainGauge,	ion_VinPos_SensorPopup_RTD,		ion_VinPos_SensorPopup_TC_J,
	ion_VinPos_SensorPopup_TC_K,		ion_VinPos_SensorPopup_TC_T,	ion_VinPos_SensorPopup_TC_E, ion_VinPos_SensorPopup_TC_R, 
	ion_VinPos_SensorPopup_TC_S,		ion_VinPos_SensorPopup_TC_B,	ion_VinPos_SensorPopup_TC_N,
	ion_VinPos_SensorPopup_Thermistor,	ion_VinPos_SensorPopup_LoadCell,
	ion_VinPos_SensorPopup_POT,			ion_VinPos_SensorPopup_Accel

}  ion_VinPos_SensorPopup;

#define  ion_VinPos_SensorPopup_MIN	 ion_VinPos_SensorPopup_Voltage 
#define  ion_VinPos_SensorPopup_MAX	 ion_VinPos_SensorPopup_Accel

										/*	------------------------------------ */
										//	Vin- CHANNEL SENSOR POPUP CHOICES
										//	
										//	Measurements from Vin- channels support only
										//	'Voltage', 'TC', and 'Accelerometer' sensor types

typedef enum ion_VinNeg_SensorPopup {	//	### these gui numbers may change in the future

	ion_VinNeg_SensorPopup_Voltage = 1,	ion_VinNeg_SensorPopup_TC_J,
	ion_VinNeg_SensorPopup_TC_K,		ion_VinNeg_SensorPopup_TC_T,	ion_VinNeg_SensorPopup_TC_E, ion_VinNeg_SensorPopup_TC_R, 
	ion_VinNeg_SensorPopup_TC_S,		ion_VinNeg_SensorPopup_TC_B,	ion_VinNeg_SensorPopup_TC_N,
	ion_VinNeg_SensorPopup_Accel

}  ion_VinNeg_SensorPopup;

#define  ion_VinNeg_SensorPopup_MIN	 ion_VinNeg_SensorPopup_Voltage 
#define  ion_VinNeg_SensorPopup_MAX	 ion_VinNeg_SensorPopup_Accel

										#if 0	//	 gsw 12/10/02
										#define  ion_SensorTy pe_Pos_MAX	 ion_SensorType_Thermistor 
										#define  ion_SensorTy pe_Neg_MAX	 ion_SensorType_TC_N
										#endif

										/*	------------------------------------ */
typedef enum ion_WiringOptions {		//	WIRING OPTIONS

										/*	#### these #'s must not change */

										//	See "SENSOR APPLICATION NOTES" section in file "ionC_100.c" for
										//	info on how to use these sensors.

	ion_Wiring_Differential = 1,		//	DIFFERENTIAL
	ion_Wiring_SingleEnded = 2,			//	SINGLE-ENDED POS
	
	ion_Wiring_Shunt_Resistor = 3,		//	SHUNT RESISTOR

	ion_Wiring_Voltage_Divider = 4,		//	VOLTAGE DIVIDER
	
	ion_Wiring_Bridge = 5,				//	BRIDGE

	ion_Wiring_Q_Bridge_Bend = 6, 		//	Q Bridge Bend
	ion_Wiring_H_Bridge_Bend = 7, 		//	H Bridge Bend
	ion_Wiring_H_Bridge_Axial = 8, 		//	H Bridge Axial
	ion_Wiring_F_Bridge_Bend_I = 9, 	//	F Bridge Bend I
	ion_Wiring_F_Bridge_Axial_I = 10, 	//	F Bridge Axial I
	ion_Wiring_F_Bridge_Axial_II = 11 	//	F Bridge Axial II
		
}  ion_WiringOptions;

#define  ion_Wiring_MIN 	 ion_Wiring_Differential

#define  ion_Wiring_Pos_MAX  ion_Wiring_F_Bridge_Axial_II	/* Positive channel, e.g. Ch1 Vin+, Ch4 Vin+ */
#define  ion_Wiring_Neg_MAX  ion_Wiring_SingleEnded			/* Negative channel, e.g. Ch2 Vin-, Ch5 Vin- */

										/*	TRUE if this is a bridge */
#define THIS_IS_A_BRIDGE(wiring_) (wiring_ >= ion_Wiring_Bridge iNetAnd wiring_ <= ion_Wiring_F_Bridge_Axial_II)					

										/*	TRUE if this is a StrainGage bridge */
#define THIS_IS_A_STRAINGAGE_BRIDGE(wiring_) (wiring_ >= ion_Wiring_Q_Bridge_Bend iNetAnd wiring_ <= ion_Wiring_F_Bridge_Axial_II)					

										/*	------------------------------------ */
typedef enum ion_AD_AnaLpFltr_Pop {		//	Analog Low Pass Filter Options (e.g. Model 100)

										/*	#### these #'s must not change */

	ion_AD_AnaLpFltr_Pop_Off = 1,		//	off
	ion_AD_AnaLpFltr_Pop_40Hz = 2,		//	40Hz
	ion_AD_AnaLpFltr_Pop_4KHz = 3		//	4KHz
	
}  ion_AD_AnaLpFltr_Pop;

#define  ion_AD_AnaLpFltr_Pop_MIN  ion_AD_AnaLpFltr_Pop_Off
#define  ion_AD_AnaLpFltr_Pop_MAX  ion_AD_AnaLpFltr_Pop_4KHz
#define  ion_AD_AnaLpFltr_Pop_DEF  ion_AD_AnaLpFltr_Pop_Off

										/*	------------------------------------ */
typedef enum ion_AD_RangePop {			//	A/D Range Options (e.g. popup)

										/*	#### these #'s must not change */

	ion_AD_RangePop_5V = 1,				//	+/- 5.0V
	ion_AD_RangePop_0_625V = 2,			//	+/- .625V
	ion_AD_RangePop_0_078V = 3,			//	+/- 0.078V
	ion_AD_RangePop_0_010V = 4			//	+/- 0.010V
	
}  ion_AD_RangePop;

#define  ion_AD_RangePop_MIN  ion_AD_RangePop_5V
#define  ion_AD_RangePop_MAX  ion_AD_RangePop_0_010V
#define  ion_AD_RangePop_DEF  ion_AD_RangePop_5V
 
/* ============================== Vin CONSTANTS Settings ============================= */
 
										/*	------------------------------------ */
typedef enum fgNums_VinCon {			//	FIELD NUMBERS for Vin CONSTANTS settingGroup

										/*	#### these #'s must not change */

	fldNum_VinCon_Ro 			= 1,	//	Ro constant
	fldNum_VinCon_Rshunt 		= 2,	//	Rshunt constant
	fldNum_VinCon_Vexcitation 	= 3,	//	Vexcitation constant
	fldNum_VinCon_Vinit			= 4,	//	Vinit constant
	fldNum_VinCon_alpha 		= 5,	//	alpha constant
	fldNum_VinCon_delta 		= 6,	//	delta constant
	fldNum_VinCon_GF 			= 7,	//	GF constant
	fldNum_VinCon_v_Poisson 	= 8		//	v_Poisson constant
	
}  fgNums_VinCon;

#define  fldNum_VinConstants_MIN  		fldNum_VinCon_Ro
#define  fldNum_VinConstants_MAX  		fldNum_VinCon_v_Poisson
#define  fldNum_VinConstants_ViewedMAX 	fldNum_VinCon_v_Poisson

/* ========================= CONTROLLER CHANNEL NUMBERS ============================ */

										/*	------------------------------------ */
										//	Channels numbers for the NETWORK's
										//	Controller. 
typedef enum controller_Channels_Numbers	{

										/*	#### these #'s must not change */

	controller_ChanNum_Ch1_Dio = 1,		//	Ch1 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch2_Dio = 2,		//	Ch2 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch3_Dio = 3,		//	Ch3 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch4_Dio = 4,		//	Ch4 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch5_Dio = 5,		//	Ch5 Dio		(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch6_Dio = 6,		//	Ch6 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch7_Dio = 7,		//	Ch7 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch8_Dio = 8,		//	Ch8 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_Ch9_Dio = 9,		//	Ch9 Dio 	(counter/timer/digital in/digitial out)
	controller_ChanNum_C10_Dio = 10,	//	Ch10 Dio 	(counter/timer/digital in/digitial out)	
	controller_ChanNum_C11_Time = 11,	//	Ch11 Time (get time in seconds since reset, accurate to .25us)
 controller_ChanNum_C12_Digitizer = 12	//	Ch12 Digitizer {control timebase and trigger while digitizing on network}

} controller_Channels_Numbers;

#define  controller_Channels_Numbers_MIN  controller_ChanNum_Ch1_Dio
#define  controller_Channels_Numbers_MAX  controller_ChanNum_C12_Digitizer

/* ================================ GENERAL Settings ================================= */

										/*	------------------------------------ */
typedef enum fgNums_General {			//	FIELD NUMBERS for GENERAL settingGroup

										/*	#### these #'s must not change */

	fldNum_General_valueEu = 1,			//	inputValue (engineering units)
	fldNum_General_unitsLabel = 2,		//	units label (editable); e.g. "Volts", "C", "F", "mmHg".
	fldNum_General_userName = 3,		//	user name (editable)
	fldNum_General_ad_sampleRateMult=4,	//	sampleRateMult (0.001% to 100% of master sample rate)
	fldNum_General_chanName = 5			//	channel name (non-editable)
	
}  fgNums_General;

#define  fgNums_General_MIN  		fldNum_General_valueEU
#define  fgNums_General_MAX  		fldNum_General_chanName
#define  fgNums_General_ViewedMAX  	fldNum_General_ad_sampleRateMult

										//	maximum field viewed when we have a
										//	user item channel (e.g. user btn/tab/etc)
#define  fgNums_General_ViewedMAX_WithUserItems  fldNum_General_userName

/* ================================ DISPLAY Settings ================================= */

										/*	------------------------------------ */
typedef enum fgNums_Display {			//	FIELD NUMBERS for DISPLAY settingGroup (1 for each channel)
										//	DISPLAY settingGroup = {dispOnOff, dispMaxEU, dispMinEU, dispShowHidePop}
										
										/*	#### these #'s must not change */

	fldNum_Display_dispOnOff = 1,		//	"Digitize" On (1) / Off (2)
										//
										//							    "Digitize" Field Meaning
										//								---------------------
										//	INPUT CHAN	iNet World:		"Digitize & Plot"		Put in Digitize List, and Plot == Call this "Digitize"
										//				Programming:	"Digitize to Buffer"	Put in Digitize List, and send data to buffers
										//								
										//	OUTPUT CH	iNet World:		"Plot"					Does NOT put in digitize list, use cRate/Control to set output, plot data
										//														(if this "Digitize" Fld is off, we don't plot. "Digitize" Fld controls Plotting here)
										//				Programming		"Digitize out buffers"	ON: Place in digitize list and feed outputs from buffers
										//														OFF: one can use cRate/control to run the outputs, not in digitize List
										//
										//	This was called "Display" and now it is called "Digitize", gsw 5/10/03

	fldNum_Display_dispMaxEU = 2,		//	EU value of top line of display (RECORD window, and PROBE dialog)
										//	This was called "Disp Max EU" and now it is called "Display Max", gsw 5/10/03

	fldNum_Display_dispMinEU = 3,		//	EU value of bottom line of display (RECORD window, and PROBE dialog)
										//	This was called "Disp Min EU" and now it is called "Display Min", gsw 5/10/03

	fldNum_Display_dispShowHidePop = 4	//	Show/Hide Display on Record page = { ion_ShowHidePop_show (1), ion_ShowHidePop_hide(2) }
										//	Use this field to save space on screen, yet keep digitizing ON
										//	This field was created 1/10/03

}  fgNums_Display;

#define  fgNums_Display_MIN  		fldNum_Display_dispOnOff
#define  fgNums_Display_MAX  		fldNum_Display_dispShowHidePop
#define  fgNums_Display_ViewedMAX  	fldNum_Display_dispShowHidePop

/* ================================ MAPPING Settings ================================= */

										/*	------------------------------------ */
typedef enum fgNums_Mapping {			//	FIELD NUMBERS for MAPPING settingGroup (1 for each channel)
										//	MAPPING settingGroup = {Internal1,External1,Internal2,External2}, gsw 11/13/96
										
										/*	#### these #'s must not change */

	fldNum_Mapping_internal1 = 1,		//	Mapping point #1, coordinate system inside driver
	fldNum_Mapping_external1 = 2,		//	Mapping point #1, coordinate system outside driver
	fldNum_Mapping_internal2 = 3,		//	Mapping point #2, coordinate system inside driver
	fldNum_Mapping_external2 = 4,		//	Mapping point #2, coordinate system outside driver
	
	fldNum_Mapping_scale = 5,			//	'scale' constant in the "y = (scale * x) + offset"
										//	format, gsw 2/22/97
	fldNum_Mapping_offset = 6			//	'offset' constant in the "y = (scale * x) + offset"
										//	format, gsw 2/22/97
	
} fgNums_Mapping;

#define  fgNums_Mapping_MIN  		fldNum_Mapping_internal1
#define  fgNums_Mapping_MAX  		fldNum_Mapping_offset
#define  fgNums_Mapping_ViewedMAX  	fldNum_Mapping_offset

/* ================================ CONTROL Settings ================================= */

										/*	------------------------------------ */
typedef enum fgNums_Control {			//	FIELD NUMBERS for CONTROL settingGroup (1 for each Vout and DoutBit
										//	channel) = {outputValueScript}, gsw 1/1/03
										
										/*	#### these #'s must not change */

	fldNum_Control_outputValueScript =1 //	if == "", we do nothing; otherwise this iNet script 
										//	is interpreted and output at the control rate
	
} fgNums_Control;

#define  fgNums_Control_MIN  		fldNum_Control_outputValueScript
#define  fgNums_Control_MAX  		fldNum_Control_outputValueScript
#define  fgNums_Control_ViewedMAX  	fldNum_Control_outputValueScript

										/*	----------------------- */
typedef enum DigitizeState	{			//	specifies state of digitization

										/*	#### these #'s must not change */

	ds_NotDigitizing = 0,				//	controller is not digitizing
	ds_WaitingForTrigger = 1,			//	controller is waiting for a trigger
	ds_WaitingForTheNextScanToBegin = 2,//	waiting for the next scan to start digitizing
	ds_DigitizingAScan = 3				//	inside a scan
	
} DigitizeState;

/* ============================== Digital I/O Bit options  ================================= */

										/*	------------------------------------ */
typedef enum fgNums_DioBitOptions {		//	Digital I/O Bit options = { io_direction }
										
										/*	#### these #'s must not change */

	fldNum_DioBitOptions_ioDirection= 1	//	I/O Direction = { ioDirectionPop_input (1) , ioDirectionPop_output (2) }

} fgNums_DioBitOptions;

#define  fgNums_DioBitOptions_MIN  		fldNum_DioBitOptions_ioDirection
#define  fgNums_DioBitOptions_MAX  		fldNum_DioBitOptions_ioDirection
#define  fgNums_DioBitOptions_ViewedMAX fldNum_DioBitOptions_ioDirection

										/*	------------------------------------ */
typedef enum ioDirectionPop	{			//	I/O Direction Popup = { ioDirectionPop_input (1), 
										//		ioDirectionPop_output (2) }

										/*	#### these #'s must not change */

	ioDirectionPop_input = 1,			//	input into iNet hardware (i.e. measure voltage)
	ioDirectionPop_output = 2			//	output out of iNet hardware (i.e. put out a voltage)
	
}  ioDirectionPop;

#define  ioDirectionPop_MIN	 ioDirectionPop_input
#define  ioDirectionPop_MAX	 ioDirectionPop_output
#define  ioDirectionPop_DEF	 ((directionMod100_DEF == directionMod100_ALL_INPUTS) ? ioDirectionPop_input : ioDirectionPop_output)

										/*	------------------------------------ */
typedef enum BitValuePop	{			//	Bit Value Popup = { BitValuePop_0, BitValuePop_1 } 
										//	( internally stored as 0/1 values )

										/*	#### these #'s must not change */

	BitValuePop_0 = 1,					//	bit value 0 (popup = 1, bit value = 0)
	BitValuePop_1 = 2					//	bit value 1 (popup = 2, bit value = 1)
	
}  BitValuePop;

#define  BitValuePop_MAX	BitValuePop_1
#define  BitValuePop_MIN	BitValuePop_0
#define  BitValuePop_DEF	((BitValue_DEF == BitValue_0) ? BitValuePop_0 : BitValuePop_1)

#define  BitValue_1			1L			/* 1 */
#define  BitValue_0			0L			/* 0 */
#define  BitValue_MAX		BitValue_1	/* max value of one bit */
#define  BitValue_MIN		BitValue_0	/* min value of one bit */
#define  BitValue_DEF		((iNetINT16) ((doutMod100_DEF == 0) ? 0 : 1))

#define  BitValuePop_TO_BitValue( bitValuePop_ )	(((iNetINT32) (bitValuePop_) == BitValuePop_0) ? 0L : 1L)
#define  Int32_TO_BitValuePop( bitValueInt32_ )		(((iNetINT32) (bitValueInt32_) == 0L) ? BitValuePop_0 : BitValuePop_1)
#define  Double_TO_BitValue( bitValueDouble_ )		((DOUBLE_TO_BOOL((bitValueDouble_)))? 1 : 0)
#define  Double_TO_BitValuePop( bitValueDouble_ )	(Double_TO_BitValue(bitValueDouble_) ? BitValuePop_1 : BitValuePop_0)



/* ================================ PANEL METER Settings ================================= */

										/*	------------------------------------ */
typedef enum fgNums_PanelItem {			//	FIELD NUMBERS for PANEL METER / POPUP / TEXT FIELD
										//	= {position, pageName, displayOrder, unitsLabel_ShowHide,
										//		optional calculatedValue}, gsw 1/1/03
										//	Used with All digital and analog and timer i/o channels
										
										/*	#### these #'s must not change */

										//	quadrant = { Hide, Top, Right, Bottom, Left }
	fldNum_PanelItem_position_quadrant = 1,
	
										//	pageNum base 1 (e.g. Network(1), Record(2), etc)
										//	enum:  PAGE_tabNum_TO_popNum( iNetTab_... )
	fldNum_PanelItem_pagePopNum = 2,
	
	fldNum_PanelItem_displayOrder = 3,	//	display order, lowest # is displayed 1st
	
										//	unitsLabel { viewShow (1), viewHide (2) }
	fldNum_PanelItem_unitsLabel_ShowHide = 4,		

										//	PANEL METER: Script text that is used to calculate
										//	the value of a PanelItem at the Control Rate.
										//	We Only do this in the case of an INDEPENDENT
										//	PanelItem (i.e. one not connected to a channel).
										//	if the text == "", then we do nothing at the 
										//	control rate and we let instruNet Script code
										//	read and write the Indendent Panel meter's text
										//	
										//	POPUP MENU: List of options in popup menu, 
										//	separated w/ commas
										//
										//	TEXT FIELD: Editable popup = {on / off}
	fldNum_PanelItem_Calculate_or_Editable_or_Options = 5			

} fgNums_PanelItem;

#define  fgNums_PanelItem_MIN  		fldNum_PanelItem_position_quadrant
#define  fgNums_PanelItem_MAX  		fldNum_PanelItem_Calculate_or_Editable_or_Options
#define  fgNums_PanelItem_ViewedMAX fldNum_PanelItem_Calculate_or_Editable_or_Options

										/*	------------------------------------ */
typedef enum ion_PositionQuadrant_Pop {	//	Panel Meter position Options (e.g. popup)

										/*	#### these #'s must not change */

	ion_PositionQuadrant_Pop_NotSet = 0,		//	unrecognized position
	ion_PositionQuadrant_Pop_Hide = 1,			//	Hide
	ion_PositionQuadrant_Pop_Left = 2,			//	Left
	ion_PositionQuadrant_Pop_Right = 3,			//	Right
	ion_PositionQuadrant_Pop_Top = 4,			//	Top
	ion_PositionQuadrant_Pop_Bottom = 5			//	Bottom
	
}  ion_PositionQuadrant_Pop;

#define  ion_PositionQuadrant_Pop_MIN   ion_PositionQuadrant_Pop_Hide
#define  ion_PositionQuadrant_Pop_MAX   ion_PositionQuadrant_Pop_Bottom
#define  ion_PositionQuadrant_Pop_DEF   ion_PositionQuadrant_Pop_Hide

										//	true if this item is shown
#define THIS_ITEM_IS_SHOWN(posPop)	(((posPop) >= ion_PositionQuadrant_Pop_Left) iNetAnd	\
									 ((posPop) <= ion_PositionQuadrant_Pop_Bottom))

										/*	------------------------------------ */
typedef enum ion_ShowHidePop	{		//	Show/Hide Options (e.g. popup)

										/*	#### these #'s must not change */

	ion_ShowHidePop_show = 1,			//	Show
	ion_ShowHidePop_hide = 2			//	Hide
	
}  ion_ShowHidePop;

#define  ion_ShowHidePop_MIN	ion_ShowHidePop_show
#define  ion_ShowHidePop_MAX	ion_ShowHidePop_hide
#define  ion_ShowHidePop_DEF	ion_ShowHidePop_show

/* =========================== DIGITAL FILTER Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_DigitalFilter {		//	FIELD NUMBERS for DIGITAL FILTER settingGroup (1 for each 
										//	filter in each channel) = {passband1_Hz, passBand_Ripple_dB,...}
										
										/*	#### these #'s must not change */

	fldNum_DigitalFilter_filterMethod = 1,		//	ATYPE_DCIIR = {FILTEROFF_DCIIR, BUTTERWORTH_DCIIR,	
												//		CHEBYSHEV_P_DCIIR, CHEBYSHEV_S_DCIIR, ELLIPTIC_DCIIR}
	fldNum_DigitalFilter_passBand_Ripple_dB = 2,//	passband ripple (dB)
	fldNum_DigitalFilter_stopBand_Attn_dB = 3,	//	stopband attenuation (dB)
	
	fldNum_DigitalFilter_filterOrder = 4,

	fldNum_DigitalFilter_passband1_Hz = 5,		//	(lower) passband cutoff frequency
	fldNum_DigitalFilter_stopband1_Hz = 6,		//	(lower) stopband cutoff frequency
	fldNum_DigitalFilter_passband2_Hz = 7,		//	upper passband cutoff (BANDPASS_DCIIR/BANDSTOP_DCIIR only)
	fldNum_DigitalFilter_stopband2_Hz = 8 		//	upper stopband cutoff (BANDPASS_DCIIR/BANDSTOP_DCIIR only)
	
} fgNums_DigitalFilter;

#define  fgNums_DigitalFilter_MIN  		fldNum_DigitalFilter_filterMethod
#define  fgNums_DigitalFilter_MAX  		fldNum_DigitalFilter_stopband2_Hz
#define  fgNums_DigitalFilter_ViewedMAX	fldNum_DigitalFilter_stopband2_Hz

										/*	------------------------------------ */
typedef enum ATYPE_DCIIR {				//	Filter Method (this is a popup menu)

										/*	#### these #'s must not change */

	FILTEROFF_DCIIR = 1,				//	filter is turned off (i.e. not running)
	ELLIPTIC_DCIIR = 2,					//	ELLIPTIC -- The magnitude response of an elliptic filter
	   									//	is equiripple in both passband and stopband.  For given
	   									//	filter specifications, the elliptic filter requires the
	   									//	lowest order of the four available types.
	CHEBYSHEV_P_DCIIR = 3,  			//	CHEBYSHEV_P -- The magnitude response of a Chebyshev filter
										//	with an equiripple passband exhibits monotonically
										//	increasing stopband attenuation.
	CHEBYSHEV_S_DCIIR = 4,  			//	CHEBYSHEV_S -- The magnitude response of a Chebyshev filter
										//	with an equiripple stopband exhibits a monotonically
										//	decreasing passband.
	BUTTERWORTH_DCIIR = 5				//	BUTTERWORTH -- The magnitude response of a Butterworth
										//	filter exhibits maximal passband flatness and monotonic
										//	stopband attenuation.  For given filter specifications,
										//	the Butterworth filter requires the highest order of
										//	the four approx. types.
} ATYPE_DCIIR;

#define filterMethod_MIN		FILTEROFF_DCIIR
#define filterMethod_MAX		BUTTERWORTH_DCIIR
#define filterMethod_DEF		FILTEROFF_DCIIR

/* =========================== RECORD OPTIONS Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_RecordOptions {		//	FIELD NUMBERS for RECORD OPTIONS settingGroup (1 for each driver)
										//	= {hScale, hPosition, maxPtsPerPix, gridOnOff, plotLinesDots}
										
										/*	#### these #'s must not change */

  fldNum_RecordOptions_hScale = 1,		//	horiz scale (e.g. 0.1 Seconds per horiz division)
										//	if == 0, we do an auto-scale and set ~5 digitized points per pixel
  fldNum_RecordOptions_hPosition = 2,	//	horiz position (i.e time of left edge, e.g. 0 Seconds)
  fldNum_RecordOptions_plotLinesDots =3,//	plot dots or connect dots with lines
  fldNum_RecordOptions_gridOnOff = 4,	//	grid is on or off (1 is on, 2 is off)
  fldNum_RecordOptions_maxPtsPerPix = 5,//	maximum points per vertical pixel column when plotting
  fldNum_RecordOptions_digitizeInto = 6,//	Digitize Into {off / To Ram Buffer / To Disk / User Control}
  fldNum_RecordOptions_overflowAlert =7,//	show alert on buffer overflow ON/OFF
  fldNum_RecordOptions_DispHeight = 8	//	min display height in pixels, gsw 11/18/97

}  fgNums_RecordOptions;

#define  fgNums_RecordOptions_MIN  		fldNum_RecordOptions_hScale
#define  fgNums_RecordOptions_MAX  		fldNum_RecordOptions_DispHeight	/* 11/18/97 */
#define  fgNums_RecordOptions_ViewedMAX	fldNum_RecordOptions_DispHeight	/* 11/18/97 */

										/*	------------------------------------ */
typedef enum ion_gSaveDataPopup {		//	Off/To Ram Buffer/To Disk Popup

										/*	#### these #'s must not change */

	ion_gSaveDataPopup_Off = 1,			//	off (the DIGITIZE fields in the FILE and DRIVER RAM BUFFER
										//		settings groups are turned OFF)

	ion_gSaveDataPopup_ToRamBuffer = 2,	//	to ram buffer (the DIGITIZE field in the DRIVER RAM BUFFER field
										//		group will automatically follow the DIGITIZE field
										//		in the DISPLAY fielgroup).

	ion_gSaveDataPopup_ToDisk = 3,		//	to disk (the DIGITIZE field in the FILE field
										//		group will automatically follow the DIGITIZE field
										//		in the DISPLAY settinggroup).

	ion_gSaveDataPopup_UserControl = 4	//	user control (the FILE and DRIVER RAM BUFFER settinggroups
										//		are left alone)
	
}  ion_gSaveDataPopup;

#define  ion_gSaveDataPopup_MIN  ion_gSaveDataPopup_Off
#define  ion_gSaveDataPopup_MAX  ion_gSaveDataPopup_UserControl
#define  ion_gSaveDataPopup_DEF  ion_gSaveDataPopup_ToRamBuffer

/* ============================== CALIBRATION Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_CalOptions {		//	FIELD NUMBERS for WINDOW settingGroup (1 for each driver)
										//	= {CalBtn, CalOnStart, CalOnWarm, AutoCalRate}
										/*	#### these #'s must not change */
  fldNum_CalOptions_CalBtn = 1,			//	Cal Btn = { measure, bal gages }
  fldNum_CalOptions_CalOnStart = 2,		//	Cal On Start = on/off
  fldNum_CalOptions_CalOnWarm = 3,		//	Cal On Warm (10min,25min after launch) = on/off
  fldNum_CalOptions_AutoCalRate = 4,	//	Auto Cal Rate (minutes), 0=never
  fldNum_CalOptions_CjcCalRate = 5		//	CJC Cal Rate (minutes),  0=never, 3min default, 1sec min, gsw 11/25/98

}  fgNums_CalOptions;

#define  fgNums_CalOptions_MIN  		fldNum_CalOptions_CalBtn
#define  fgNums_CalOptions_MAX  		fldNum_CalOptions_CjcCalRate
#define  fgNums_CalOptions_ViewedMAX	fldNum_CalOptions_CjcCalRate
										
										/*	------------------------------------ */
typedef enum ion_gCalBtnPopup {			//	CalBtn = {Measure/Bal Gages}
										//	This determines what happens when the Calibrate
										//	button is pressed.

										/*	#### these #'s must not change */

	ion_gCalBtnPop_Measure = 1,			//	calibrate the instruNet hardware for measurement

	ion_gCalBtnPop_BalGages = 2, 		//	Calibrate instruNet hardware &
										//	Balance all strain gages & load cells.  This entails: switch gage
										//	to volts, read gage unstrained voltage, put this in
										//	Vinit field, switch back to strain. Switch back
										//	the mapping settings as well.

	ion_gCalBtnPop_BalBridges = 3, 		//	Calibrate instruNet hardware &
										//	Balance all bridges (strain gages, load cells, pots)
	
	ion_gCalBtnPop_BalVdividers = 4 	//	Calibrate instruNet hardware &
										//	Balance all Voltage dividers.
	
}  ion_gCalBtnPopup;

#define  ion_gCalBtnPopup_MIN  ion_gCalBtnPop_Measure
#define  ion_gCalBtnPopup_MAX  ion_gCalBtnPop_BalVdividers
#define  ion_gCalBtnPopup_DEF  ion_gCalBtnPop_Measure

/* ============================== SCRIPT Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_Script {			//	FIELD NUMBERS for SCRIPT settingGroup (1 for each driver)
										//	Fields: debug, controlRateHz, userRateHz
										//	Address = { DRIVER, DRIVER, DRIVER, DRIVER }	

										/*	#### these #'s must not change */

  fldNum_Script_controlRateHz = 1,		//	Speed at which we execute the Control Event
										//	loop in # of times per sec (e.g. 10Hz). The Control 
										//	Event loop Only runs when digitizing

  fldNum_Script_userRateHz = 2,			//	Speed at which we execute the User Event
										//	loop in # of times per sec (e.g. 2Hz). This runs
										//	at All times and run the panel meters,
										//	front panel edit fields, front panel popups, etc.

  fldNum_Script_debugOnOff = 3				//	debug on/off (prints stuff to script window)

} fgNums_Script;

#define  fgNums_Script_MIN  		fldNum_Script_controlRateHz
#define  fgNums_Script_MAX  		fldNum_Script_debugOnOff
#define  fgNums_Script_ViewedMAX	fldNum_Script_debugOnOff

/* =========================== END USER PAGE Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_UserPage {			//	FIELD NUMBERS for USER PAGE settingGroup (1 for each user page)
										//	Fields: Show/Hide, Tab Char Spacing
										//	Address = { DRIVER, DRIVER, USER PAGE, Ch... }			

										/*	#### these #'s must not change */

	fldNum_UserPage_name = 1,			//	page name, this text appears on tab.
										//	This field is the same as the "userName" field
										//	in the general settings area

	fldNum_UserPage_showHide = 2,		//	view = show/hide

	fldNum_UserPage_tabCharSpace = 3,	//	tab spacing, in # of characters

	fldNum_UserPage_wordWrapPop = 4,	//	hScrollOnAndWordwrapOff or hScrollOffAndWordwrapOn
										//	= { ion_gOnOffPopup_Off, ion_gOnOffPopup_On }

										//	save text w/ .prf (and when saving data in record page)
										//	= { ion_gOnOffPopup_Off, ion_gOnOffPopup_On }
	fldNum_UserPage_saveTextInPrfFile = 5	


			#if 0	//	future stuff

			fldNum_UserPage_Type = 3,		//	UserPageType = { upt_TextEditor, upt_Spreadsheet }
					
			before script button (to text editor)	

			after script button (to text editor)

			#endif

} fgNums_UserPage;

#define  fgNums_UserPage_MIN  		fldNum_UserBtn_name
#define  fgNums_UserPage_MAX  		fldNum_UserPage_saveTextInPrfFile
#define  fgNums_UserPage_ViewedMAX	fldNum_UserPage_saveTextInPrfFile

#define  wordWrap_MIN				ion_gOnOffPopup_MIN
#define  wordWrap_MAX				ion_gOnOffPopup_MAX
#define  wordWrap_DEF				ion_gOnOffPopup_Off

#define  saveTextInPrfFile_MIN		ion_gOnOffPopup_MIN
#define  saveTextInPrfFile_MAX		ion_gOnOffPopup_MAX
#define  saveTextInPrfFile_DEF		ion_gOnOffPopup_Off

/*	these are defined elsewhere:

	#define  ion_ShowHidePop_MIN		show 
	#define  ion_ShowHidePop_MAX		hide
	#define  ion_ShowHidePop_DEF		show

	ion_PageList_popNum_MIN  ( 1  = Network, base1 )
	ion_PageList_popNum_MAX  ( 11 = User7, base1 )
	ion_PageList_popNum_DEF  ( 2  = Record, base1 )

*/

/* =========================== END USER BUTTON Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_UserBtn {			//	FIELD NUMBERS for USER BUTTON settingGroup (1 for each user btn)
										//	Fields: Page, Show/Hide, etc
										//	Address = { DRIVER, DRIVER, USER BUTTON, Ch... }		

										/*	#### these #'s must not change */

	fldNum_UserBtn_name = 1,			//	button name, this text appears on button.
										//	This field is the same as the "userName" field
										//	in the general settings area

	fldNum_UserBtn_pagePopNum = 2,		//	pageNum base 1 (e.g. Network(1), Record(2), etc)
										//	enum:  PAGE_tabNum_TO_popNum( iNetTab_... )

	fldNum_UserBtn_showHide = 3,		//	view = show/hide

	fldNum_UserBtn_fKey = 4				//	Win32 F1...F10 function key Attached
										//	to button (i.e. F key invokes btn's script).
										//	functionKey = key number (e.g. = 5 for F5, 
										//	0 for no key connected)

		#if 0	//	future stuff
				
		before script button (to text editor)	

		after script button (to text editor)

		#endif

} fgNums_UserBtn;

#define  fgNums_UserBtn_MIN  		fldNum_UserBtn_name
#define  fgNums_UserBtn_MAX  		fldNum_UserBtn_fKey
#define  fgNums_UserBtn_ViewedMAX	fldNum_UserBtn_fKey

#define functionKey_NO_KEY			0	/* no F key assigned to this button */
#define functionKey_MIN_KEY			1	/* F1  */
#define functionKey_MAX_KEY			10	/* F10 */

#define functionKey_DEF				functionKey_NO_KEY  /*  0 */
#define functionKey_MIN				functionKey_NO_KEY  /*  0 */
#define functionKey_MAX				functionKey_MAX_KEY /* 10 */

/*	these are defined elsewhere:

	#define  ion_ShowHidePop_MIN		show 
	#define  ion_ShowHidePop_MAX		hide
	#define  ion_ShowHidePop_DEF		show

	ion_PageList_popNum_MIN  ( 1  = Network, base1 )
	ion_PageList_popNum_MAX  ( 11 = User7, base1 )
	ion_PageList_popNum_DEF  ( 2  = Record, base1 )

*/

/* ============================== WINDWO Settings =============================== */

typedef enum fgNums_Window		{		//	struct for WINDOW OPTIONS settingGroup (1 for each driver)
										//	Address = { DRIVER, DRIVER, DRIVER, DRIVER }
	
										/*	#### these #'s must not change */
										/*	#### these #'s must not change */

	fldNum_Wnd_menubar_showHidePop = 1,	//	menubar = { ion_ShowHidePop_show (1), ion_ShowHidePop_hide(2) }
	
	fldNum_Wnd_btnBar_showHidePop = 2,	//	button bar = { ion_ShowHidePop_show (1), ion_ShowHidePop_hide(2) }

	fldNum_Wnd_tabBar_showHidePop = 3,	//	tab bar = { ion_ShowHidePop_show (1), ion_ShowHidePop_hide(2) }
			
	fldNum_Wnd_wndPos_SaveWSetupPop = 4,//	Window Position "Save w. Setup On" = { ion_SaveWSetupPop_On, ...Off }
										
	fldNum_Wnd_pageSel_SaveWSetupPop=5,	//	Page Selection "Save w. Setup On" = { ion_SaveWSetupPop_On, ...Off }

	fldNum_Wnd_horizLabelPop = 6		//	"Horiz Label" = {  ion_hLabel_TimeSinceStart, ion_hLabel_TimeOfDay }

} fgNums_Window;


#define  fgNums_Window_MIN  		fldNum_Wnd_menubar_showHidePop
#define  fgNums_Window_MAX  		fldNum_Wnd_horizLabelPop
#define  fgNums_Window_ViewedMAX  	fldNum_Wnd_horizLabelPop

										/*	------------------------------------ */
typedef enum ion_SaveWSetupPop	{		//	"Save w. Setup On/Off" Popup
										//	= { ion_SaveWSetupPop_On, .ion_SaveWSetupPop_Off }

										/*	#### these #'s must not change */

	ion_SaveWSetupPop_On = 1,			//	Save w. Setup On
	ion_SaveWSetupPop_Off = 2			//	Save w. Setup Off
	
} ion_SaveWSetupPop;

#define  ion_SaveWSetupPop_MIN		ion_SaveWSetupPop_On
#define  ion_SaveWSetupPop_MAX		ion_SaveWSetupPop_Off
#define  ion_SaveWSetupPop_DEF		ion_SaveWSetupPop_On

										/*	------------------------------------ */
typedef enum ion_HorizLabelPop	{		//	"Horiz Label" popup = {  ion_hLabel_TimeSinceStart, ion_hLabel_TimeOfDay }

										/*	#### these #'s must not change */

	ion_hLabel_TimeSinceStart = 1,		//	"Time Since Start"
	ion_hLabel_TimeOfDay = 2			//	"Time of Day"
	
} ion_HorizLabelPop;

#define  ion_HorizLabelPop_MIN		ion_hLabel_TimeSinceStart
#define  ion_HorizLabelPop_MAX		ion_hLabel_TimeOfDay
#define  ion_HorizLabelPop_DEF		ion_hLabel_TimeSinceStart

/* ============================== USER ITEMS Settings =============================== */

										/*	------------------------------------ */
typedef enum fgNums_UserItems {			//	FIELD NUMBERS for USER ITEMS settingGroup (1 for each driver)
										//	Fields: # of user tabs/btns/editFields/Popups/panelitems
										//	Address = { DRIVER, DRIVER, DRIVER, DRIVER }	

										/*	#### these #'s must not change */

  fldNum_UserItems_numOfUserTabs= 1,	//	# of end user front panel tabs
  fldNum_UserItems_numOfUserBtns = 2,	//	# of end user front panel buttons
  fldNum_UserItems_numOfUserTextFs = 3,	//	# of end user front panel Edit Fields
  fldNum_UserItems_numOfUserPopups = 4,	//	# of end user front panel tabs

} fgNums_UserItems;

#define  fgNums_UserItems_MIN  			fldNum_UserItems_numOfUserTabs
#define  fgNums_UserItems_MAX  			fldNum_UserItems_numOfUserPopups
#define  fgNums_UserItems_ViewedMAX		fldNum_UserItems_numOfUserPopups


										/*	------------------------------------ */
typedef enum ion_UserItemType_Popup {	//	User Item Type = {btn, tab, textF, popup},

										/*	#### these #'s must not change */

	uit_NotRecognized = -1,				//	not recognized user item

	uit_DontCreateUserItem = 0,			//	indicates no user item

	uit_button = 1,						//	user created button 
										//	valueEu = { pressed (1) / not pressed (0) }
										//	Addr = { Driver, Driver, User Buttons, Ch ... }

	uit_page = 2,						//	user created page (i.e. new tab)
										//	valueEu = { selected (1) / not selected (0) }
										//	Addr = { Driver, Driver, User Pages, Ch ... }

	uit_textF = 3,						//	user created front panel edit field
										//	Addr = { Driver, Driver, User Edit Fields, Ch ... }

	uit_popup = 4						//	user created front panel popup menu
										//	Addr = { Driver, Driver, User Popup Menus, Ch ... }
	
}  ion_UserItemType_Popup;

#define  ion_UserItemType_MIN	uit_button /* base1 */
#define  ion_UserItemType_MAX	uit_popup  /* base1 */
#define  ion_UserItemType_LEN	(1 + ion_UserItemType_MAX - ion_UserItemType_MIN)
#define  ion_UserItemType_DEF	uit_button

										/*	True if this panel item type stores it's
										 *	the panel item's label in the 'unitsLabel' field 
										 * (e.g. which is the case w/ Popups and TextFields) */
#define PANEL_ITEMLABEL_STORED_IN_UNITSLABEL_FIELD( userItemType )	\
	((userItemType == uit_textF)  iNetOr  (userItemType == uit_popup))

#define	 uit_Index_MIN /* base0 */		BASE1_TO_BASE0(ion_UserItemType_MIN)
#define	 uit_Index_MAX /* base0 */		BASE1_TO_BASE0(ion_UserItemType_MAX)

#define	 BUTTON_NOT_PRESSED		0 
#define	 BUTTON_IS_PRESSED		1

#define	 user_button_VALUE_MIN	BUTTON_NOT_PRESSED	/* 0 */
#define	 user_button_VALUE_MAX	BUTTON_IS_PRESSED	/* 1 */
#define	 user_button_VALUE_DEF	BUTTON_NOT_PRESSED	/* 0 */

#define	 PAGE_NOT_SELECTED		0 
#define	 PAGE_IS_SELECTED		1

#define	 user_page_VALUE_MIN	PAGE_NOT_SELECTED	/* 0 */
#define	 user_page_VALUE_MAX	PAGE_IS_SELECTED	/* 1 */
#define	 user_page_VALUE_DEF	PAGE_NOT_SELECTED	/* 0 */

#define	 user_textF_VALUE_MIN	((iNetFLT32) FLT32_MIN)
#define	 user_textF_VALUE_MAX	((iNetFLT32) FLT32_MAX)
#define	 user_textF_VALUE_DEF	((iNetFLT32) 0.0)

#define	 user_textF_DEF			""

										/*	max # of user defined popup options */
#define MAX_NUM_USERDEFINED_POPUP_OPTIONS	32

										/* each option can be a max of 15 chars long */
#define MAX_USERDEFINED_POPUP_OPTION_SIZE	15 

#define	 user_popup_VALUE_MIN	1		/* 1 item in list */
#define	 user_popup_VALUE_MAX	MAX_NUM_USERDEFINED_POPUP_OPTIONS
#define	 user_popup_VALUE_DEF	1		/* 1st item in list */


/* ================================ FILE Settings =================================== */

										/*	------------------------------------ */
typedef enum fgNums_File {				//	FIELD NUMBERS for FILE settingGroup 
										//	(1 for each filter in each channel)
										
										/*	#### these #'s must not change */
		
										//	----------------------------------
										//	CONTROL
										
	fldNum_File_FileOnOff = 1,			//	on/off for FILE turned ON & Linked to a Display (scroll bar will load from file)
	fldNum_File_DigitizeOnOff = 2,		//	on/off for Moving Digitized Data to FILE at Digitize Time

										//	----------------------------------
										//	FILE

	fldNum_File_FileName = 3,			//	Name of File (pathname is stored in MasterDirectory SettingGroup)
								
										//	----------------------------------
										//	PROGRAMMING
										//
	fldNum_File_fileCmd = 4,			//	command = {	fileCmd_Off
										//				fileCmd_FileToRamBuffer (ScanNum),
										//			   	fileCmd_RamBufferToFile (ScanNum),
										//			   	fileCmd_FileToUserBuffer (ScanNum)
	fldNum_File_ScanNum = 5,			//				fileCmd_UserBufferToFile (ScanNum)
	fldNum_File_PointNum = 6,			//				fileCmd_Get_File_Info (ScanNum, lastPtNum, ptsPerScan)
	fldNum_File_NumPts = 7				//		
										//		If programmer needs more control, they should go directly
										//		to the file.	
} fgNums_File;

#define  fgNums_File_MIN  		fldNum_File_FileOnOff
#define  fgNums_File_MAX  		fldNum_File_NumPts
#define  fgNums_File_ViewedMAX	fldNum_File_NumPts

										/*	------------------------------------ */
typedef enum ion_FileCmdPopup {			//	File Command Options (e.g. popup). gsw 1/28/97

										/*	#### these #'s must not change */

	fileCmd_Off = 1,					//	No command (off), gsw 1/28/97
	
	fileCmd_FileToRamBuffer = 2,		//	Transfer data from FILE to DRIVER RAM BUFFER 
	fileCmd_FileToUserBuffer = 4,		//	Transfer data from FILE to USER RAM BUFFER
										//
										//		ScanNum = Scan # of 1st point pulled out of buffer = {1...numScans}
										//		PointNum = Point # of 1st point pulled out of buffer = {1...PtsPerScan}
										//		NumPts = # of points to load in
										//
										//		destBuffer.firstPtSecs_BufferData = In BINARYMERGE case, we put
										//			data into ram buffer such that pt#1 corresponds to this time.
										//
										//			BINARY (1ch/file)
										//	
										//				We pull data out of file at {destBuffer.scanNumOut,
										//				destBuffer.ptNumOut, destBuffer.numPtsToAppend}
										//				and put it into destBuffer.bufferAddr at ram
										//				position destBuffer.ptNumOut. 
										//	
										//			BINARYMERGE (all channels interlaced into 1 file)
										//	
										//				For all channels, we pull data out of file
										//				at Channel[destBuffer.scanNumOut, destBuffer.ptNumOut
										//				destBuffer.numPtsToAppend] and put it into
										//				destBuffer.bufferAddr at ram position indicated
										//	 			by destBuffer.firstPtSecs_BufferData (this means
										//				that the ram destBuffer ptNum#1 will not always
										//				correspond to the file ptNum#1).

	fileCmd_RamBufferToFile = 3,		//	Transfer data from DRIVER RAM BUFFER to FILE 
	fileCmd_UserBufferToFile = 5,		//	Transfer data from USER RAM BUFFER to File
										//
										//		Saves entire buffer to disk (i.e. 1 scan).
										
	fileCmd_Get_File_Info = 6			//	Get info on FILE (ScanNum = # of scans; NumPts = pts per scan)
										//
										//		ScanNum = scan # of last point pushed into buffer = {1...numScans}
										//		PointNum = point # of last point pushed into buffer = {1...PtsPerScan}
										//		NumPts = pts per scan stored in the file for this channel
}  ion_FileCmdPopup;

#define  ion_FileCmdPopup_MIN  fileCmd_Off
#define  ion_FileCmdPopup_MAX  fileCmd_Get_File_Info
#define  ion_FileCmdPopup_DEF  fileCmd_Off

/*	================================== file types ==================================== */

										/*	pack 4 chars into an UINT32 */
#define PACK_UINT32(c0_, c1_, c2_, c3_) 	\
	(((iNetUINT32) (c0_ & 0xff) << 24) +	\
	 ((iNetUINT32) (c1_ & 0xff) << 16) +	\
	 ((iNetUINT32) (c2_ & 0xff) << 8)  +	\
	 ((iNetUINT32) (c3_ & 0xff) << 0)  )

//	==============================================================================
//	FILES
//							MACINTOSH	MACINTOSH	MACINTOSH	WIN32
//		TYPE				FILETYPE    CREATOR		EXTENSION	EXTENSION
//		-----------------------------------------------------------------
//		binary wave data	ioWa		ioNe		(none)		.ioW
//		text wave data		TEXT		ioNe		(none)		.TXT
//		merged text data	TEXT		ioNe		.TXT		.TXT
//		network state		TEXT		ioNe		.prf		.Prf
//		text edit Script	TEXT		ioNe		.iBs		.iBs
//		text edit nonScript TEXT		ioNe		.txt		.iBs
	
										/*	common extensions packed into a iNetUINT32 */
#define SCRIPT_EXTENSION 		PACK_UINT32('.', 'i', 'B', 's')		
#define NETWORKSTATE_EXTENSION 	PACK_UINT32('.', 'p', 'r', 'f')
#define TEXT_EXTENSION 			PACK_UINT32('.', 't', 'x', 't')
#define NO_EXTENSION 			PACK_UINT32(' ', ' ', ' ', ' ')

#if (MACHINE_TYPE_ == MACINTOSH_iNet)	/*	============= Macintosh ============= */

										//	------------------------------------
										//	FILETYPES

	#define iNetWAVE_DATA_FILETYPE 'ioWa'/*	fileType: 'ioWa' fType on Mac, .ioW ext on Win32  */
										/*	Uses: binary data  */

	#define NETWORKSTATE_FILETYPE 'TEXT'/*	fileType: 'TEXT' fType on Mac, .prf ext on Win32 */
										/*	Uses: network state, "iNetCom.prf".  */

	#define TEXT_DATA_FILETYPE  'TEXT'	/*  fileType: 'TEXT' fType on Mac, ".TXT" ext on Win32 */
										/*	Uses: TEXTEDIT Save/Open, Text Data  */

	#define SCRIPT_FILETYPE  'TEXT'		/*  fileType: 'TEXT' fType on Mac, ".iBs" ext on Win32 */
										/*	Uses: instruNet Script Files  */

										//	------------------------------------
										//	CREATORS

	#define NETWORK_DATA_CREATOR 'ioNe'	/*	Creator type - Macintosh */
										/*	(files are said to be created by instruNet) */
										
#elif (MACHINE_TYPE_ == WINTEL_iNet)	/*	=========== Windows/Intel =========== */

										// Windows CAVEAT:  Unlike the MAC, Windows is
										// "little-endian" , so if we want to store a short string
										// as a UINT32, but have it interpreted as a C-String,
										// we need to write it backwards. (Hence "ioW" is written here
										// as '\0Woi'  
										// Also, file types in Windows are indicated by the extension
										// on the file name.  This extension is limited to 3 characters,
										// hence the three character file types used here.  The \0 (NULL)
										// is used to make it a null terminated string.

										//	------------------------------------
										//	FILETYPES
										
										/*	fileType: 'ioWa' fType on Mac, .ioW ext on Win32  */
										/*	Uses: binary data  */
	#define  iNetWAVE_DATA_FILETYPE		CHARS_TO_FILE_TYPE( 'i', 'o', 'W' )
		
										/*  fileType: 'TEXT' fType on Mac, .TXT ext on Win32 */
										/*	Uses: TEXTEDIT Save/Open, Text Data  */
	#define  TEXT_DATA_FILETYPE			CHARS_TO_FILE_TYPE('T','X','T')	

										/*	fileType: 'TEXT' fType on Mac, .prf ext on Win32 */
										/*	Uses: network state, "iNetCom.prf", MotorolaScanFile.  */
	#define  NETWORKSTATE_FILETYPE		CHARS_TO_FILE_TYPE('P','r','f')	

										/*  fileType: 'TEXT' fType on Mac, ".iBs" ext on Win32 */
										/*	Uses: instruNet Script Files  */
	#define  SCRIPT_FILETYPE			CHARS_TO_FILE_TYPE('i','B','s')	

										/*	FileType for 68332 driver that is placed in the
										 *	win32 pc_src.rsrc folder, that is used by the
										 *	rsrc compiler to build the win32 apl/dll. */
	#define  _68332_DVR_CODE_FILETYPE	CHARS_TO_FILE_TYPE('M','O','T')

										//	------------------------------------
										//	CREATORS

										/*	Creator type for iNet NETWORK FIELD data - Win32 */
										/*	and iNet Wave files */
	#define  NETWORK_DATA_CREATOR		CHARS_TO_FILE_TYPE('i','o','N')

#endif

#if (MACHINE_TYPE_ == MACINTOSH_iNet)	/*	============= Macintosh ============= */
	#define MAX_TE_LENGTH  32760		/*	32K = max # of chars in TextEdit record */
#elif (MACHINE_TYPE_ == WINTEL_iNet)	/*	=========== Windows/Intel =========== */
	#define MAX_TE_LENGTH  32000		/*	Win32 TE is limited to 30K chars (according */
										/*	to debugger). For details, see:
										 *	ms-help://MS.VSCC/MS.MSDNVS/dnctrl/html/msdn_editctls.htm 
										 *	32K -> 2G -> 30K, gsw 3/23/03 */
#endif

/* ============================= MASTER DIRECTORY Settings ============================ */

										/*	------------------------------------ */
typedef enum fgNums_Directory {			//	FIELD NUMBERS for MASTER DIRECTORY settingGroup 
										//	(1 for each filter in each channel)
										
										/*	#### these #'s must not change */
		
										//	----------------------------------
										//	CONTROL
										
	fldNum_Directory_PathName = 1,		//	Path Name (for directory that contains a file)

										//	New Directory Name = { ndn_PromptUser, ndn_AutoGenerate }
										//	When we create a new directory we can save network 
										//	settings into the new directory with file name
										//	"instruNet.prf" if ON = {On/Off}
	fldNum_Directory_NewDirectoryName = 2,

										//	save network settings into the new directory = {on/off}
	fldNum_Directory_SaveSettingsOnOff = 3,	

										//	When we are asked to redirect our directory, then if
										//	LOAD SETTINGS is ON, and a "instrNet.prf" exists in the
										//	new Directory, then we will load those settings.
	fldNum_Directory_LoadSettingsOnOff = 4,	

	fldNum_Directory_FileType = 5,		//	FileType = {ft_Text, ft_TextMerge, ft_Binary, ft_BinaryMerge}

										//	----------------------------------
										//	PROGRAMMING

	fldNum_Directory_dirCmd = 6			//	dirCmd = {dirCmd_Off, dirCmd_CreateNewDirectory, dirCmd_ShowDirectoryDlog}

} fgNums_Directory;

#define  fgNums_Directory_MIN  		fldNum_Directory_PathName
#define  fgNums_Directory_MAX  		fldNum_Directory_dirCmd
#define  fgNums_Directory_ViewedMAX	fldNum_Directory_dirCmd

										/*	------------------------------------ */
typedef enum ion_NewDirNamePopup {		//	New Name = {Prompt User/Auto Generate}
										//	options (e.g. popup)

										/*	#### these #'s must not change */
	ndn_PromptUser = 1,					//	Prompt User 
	ndn_AutoGenerate = 2				//	Auto Generate  
	
}  ion_NewDirNamePopup;

#define  ion_NewDirNamePopup_MIN  ndn_PromptUser
#define  ion_NewDirNamePopup_MAX  ndn_AutoGenerate
#define  ion_NewDirNamePopup_DEF  ndn_PromptUser

										/*	------------------------------------ */
typedef enum ion_FileTypePopup {		//	FileType Options.

										/*	#### these #'s must not change */
	ft_netYetDefined = 0,				//	not yet assigned
	ft_Binary = 1,						//	iNet Binary, 1 channel per file.
	ft_Text = 2,						//	Text, 1 channel per file.
	ft_TextMerge = 3,					//	Text, 1 channel per file; except for 1 extra 
										//		file "Excel Waveform Data.txt" (was "Merged.txt")
										//		that contains all channels.
	ft_BinaryMerge = 4					//	Binary Merged, with all channels in each network
										//		merged into one file (i.e. interlaced).  This
										//		is good for spooling to disk. gsw 1/29/97
}  ion_FileTypePopup;

#define  ion_FileTypePopup_MIN  ft_Binary
#define  ion_FileTypePopup_MAX  ft_BinaryMerge
#define  ion_FileTypePopup_DEF  ft_Binary

										/*	------------------------------------ */
typedef enum ion_DirCmdPopup {			//	MASTER DIRECTORY Command Options

										/*	#### these #'s must not change */

	dirCmd_Off = 1,						//	off (no command), gsw 1/28/97
	dirCmd_CreateNewDirectory = 2,		//	Create a new directory
	dirCmd_ShowDirectoryDlog = 3		//	Show the Directory dlog & let user redirect directory  
	
}  ion_DirCmdPopup;

#define  ion_DirCmdPopup_MIN  dirCmd_Off
#define  ion_DirCmdPopup_MAX  dirCmd_ShowDirectoryDlog
#define  ion_DirCmdPopup_DEF  dirCmd_Off

/* ============================= USER RAM BUFFER Settings ============================ */

										/*	------------------------------------ */
typedef enum fgNums_UserRamBuffer {		//	FIELD NUMBERS for USER RAM BUFFER settingGroup 
										//	(1 for each filter in each channel)
										
										/*	#### these #'s must not change */
		
										//	----------------------------------
										//	CONTROL
										
	fldNum_UserBuffer_DigitizeOnOff =1,	//	on/off for Moving Digitized Data to buffer at Digitize Time
								
										//	----------------------------------
										//	USER BUFFER

	fldNum_UserBuffer_UserBufferAddr = 2,		
										//	user's addr to a buffer in RAM; 0 if not used (off)
										//	The Buffer MUST be able to hold one scan; therefore, it
										//	must be >= ptsPerScan. 
fldNum_UserBuffer_UserPtrSizeInBytes=3,	//	This is the size of the user's buffer in Bytes.
										//	It must be >= ptsPerScan.  Each point consumes 4 bytes.
								
										//	----------------------------------
										//	BUFFER COUNTERS
										
										//	User sees base 1
										
	fldNum_UserBuffer_ScanNumIn = 4,	//	Scan # of last point pushed into buffer = {1...numScans}
	fldNum_UserBuffer_PtNumIn = 5,		//	Point # of last point pushed into buffer = {1...PtsPerScan}
	fldNum_UserBuffer_ScanNumOut = 6,	//	Scan # of last point pulled out of buffer = {1...umScans}
	fldNum_UserBuffer_PtNumOut = 7		//	Point # of last point pulled out of buffer = {1...PtsPerScan}

} fgNums_UserRamBuffer;

#define  fgNums_UserBuffer_MIN  		fldNum_UserBuffer_DigitizeOnOff
#define  fgNums_UserBuffer_MAX  		fldNum_UserBuffer_PtNumOut
#define  fgNums_UserBuffer_ViewedMAX	fldNum_UserBuffer_PtNumOut

/* =========================== DRIVER RAM BUFFER Settings ============================ */

										/*	------------------------------------ */
typedef enum fgNums_DriverRamBuffer {	//	FIELD NUMBERS for DRIVER RAM BUFFER settingGroup 
										//	(1 for each filter in each channel)
										
										/*	#### these #'s must not change */
		
										//	----------------------------------
										//	CONTROL
										
	fldNum_DvrBuffer_DigitizeOnOff = 1,	//	on/off for Moving Digitized Data to buffer at Digitize Time
								
										//	----------------------------------
										//	DRIVER BUFFER

	fldNum_DvrBuffer_BufferAddr = 2,	//	driver's addr to a buffer in RAM; 0 if not used (off)
										//	The Buffer MUST be able to hold one scan; therefore, it
										//	must be >= ptsPerScan.
	fldNum_DvrBuffer_BufferAddrSizeInBytes = 3,	
										//	This is the size of the drivers's addr in Bytes.
										//	It must be >= ptsPerScan.  Each point consumes 4 bytes.
								
										//	----------------------------------
										//	BUFFER COUNTERS
										
										//	User sees base 1
										
	fldNum_DvrBuffer_ScanNumIn = 4,		//	Scan # of last point pushed into buffer = {1...numScans}
	fldNum_DvrBuffer_PtNumIn = 5,		//	Point # of last point pushed into buffer = {1...PtsPerScan}
	fldNum_DvrBuffer_ScanNumOut = 6,	//	Scan # of last point pulled out of buffer = {1...numScans}
	fldNum_DvrBuffer_PtNumOut = 7		//	Point # of last point pulled out of buffer = {1...PtsPerScan}

} fgNums_DriverRamBuffer;

#define  fgNums_DvrBuffer_MIN  		fldNum_DvrBuffer_DigitizeOnOff
#define  fgNums_DvrBuffer_MAX  		fldNum_DvrBuffer_PtNumOut
#define  fgNums_DvrBuffer_ViewedMAX	fldNum_DvrBuffer_PtNumOut

/* =============================== TIMING Settings =================================== */

										/*	------------------------------------ */
typedef enum fgNums_Timing {			//	FIELD NUMBERS for TIMING settingGroup
										//	TIMING settingGroup = {DigitizeOnOff, ptsPerScan, noOfScans, scanMode, sampleRate}
										
										/*	#### these #'s must not change */

	fldNum_Timing_digitizeOnOff = 1,	//	1 = digitizer turned on; 2 = off
	fldNum_Timing_ptsPerScan = 2,		//	points per scan (i.e. pts/trace)
	fldNum_Timing_noOfScans = 3,		//	# of scans
	fldNum_Timing_scanMode = 4,			//	space between scans = {ion_gScanModePopup_StripChart,	
										//	ion_gScanModePopup_OscilloQueued, ion_gScanModePopup_Oscilloscope}
	fldNum_Timing_sampleRate = 5,		//	master sample rate (pts/second)
	fldNum_Timing_minSecsBetweenTsfrs=6,//	minimum secs between 16bit tsfrs.  
										//	(It gives the analog electronics time to adjust from
										//	1 channel to the other. gsw 2/22/96)
	fldNum_Timing_network_bps = 7,		//	network data clock rate (bits per second)

	fldNum_Timing_switching = 8			//	switch channels quickly or with more accuracy and slower
										//	= {ion_gSwitchingPopup_Fast}
} fgNums_Timing;

#define  fgNums_Timing_MIN  		fldNum_Timing_digitizeOnOff
#define  fgNums_Timing_MAX  		fldNum_Timing_switching
#define  fgNums_Timing_ViewedMAX  	fldNum_Timing_switching

										/*	------------------------------------ */
typedef enum ion_gOnOffPopup {			//	ON/OFF Options (e.g. popup)

										/*	#### these #'s must not change */
										
	ion_gOnOffPopup_On = 1,				//	on
	ion_gOnOffPopup_Off = 2				//	off
	
}  ion_gOnOffPopup;

#define  ion_gOnOffPopup_MIN  ion_gOnOffPopup_On
#define  ion_gOnOffPopup_MAX  ion_gOnOffPopup_Off
#define  ion_gOnOffPopup_DEF  ion_gOnOffPopup_Off

										/*	------------------------------------ */
typedef enum ion_gLinesDotsPopup {		//	Lines/Dots Options (e.g. popup)

										/*	#### these #'s must not change */

	ion_gLinesDots_Lines = 1,			//	Lines
	ion_gLinesDots_Dots = 2				//	Dots
	
}  ion_gLinesDotsPopup;

#define  ion_gLinesDotsPopup_MIN  ion_gLinesDots_Lines
#define  ion_gLinesDotsPopup_MAX  ion_gLinesDots_Dots
#define  ion_gLinesDotsPopup_DEF  ion_gLinesDots_Dots

										/*	------------------------------------ */
typedef enum ion_gScanModePopup{		//	ON/OFF/OFF_WITH_SKIP Options (e.g. popup)

										/*	#### these #'s must not change */

	ion_gScanModePopup_StripChart = 1,	//	STRIP CHART 	continuous scans
	ion_gScanModePopup_Oscilloscope=2,	//	OSCILLOSCOPE	non-continuous scans pulled out
										//					of controller's buffer in a filo
										//					manner (first in, last out).
	ion_gScanModePopup_OscilloQueued =3 //	OSCILLO QUEUED	non-continuous scans pulled out
										//					of controller's buffer in a fifo
										//					manner (first in first out)
	
}  ion_gScanModePopup;

#define  ion_gScanModePopup_MIN  ion_gScanModePopup_StripChart
#define  ion_gScanModePopup_MAX  ion_gScanModePopup_OscilloQueued
#define  ion_gScanModePopup_DEF  ion_gScanModePopup_Oscilloscope

										/*	------------------------------------ */
typedef enum ion_gSwitchingPopup{		//	switch channels quickly or with more accuracy and slower
										//	= {ion_gSwitchingPopup_Accurate, ion_gSwitchingPopup_Fast}

										/*	#### these #'s must not change */
										
	ion_gSwitchingPopup_Accurate = 1,	//	switch slower, yet more accurate
	ion_gSwitchingPopup_Fast = 2		//	switch faster, yet less accurate
	
} ion_gSwitchingPopup;

#define  ion_gSwitchingPopup_MIN  ion_gSwitchingPopup_Accurate
#define  ion_gSwitchingPopup_MAX  ion_gSwitchingPopup_Fast
#define  ion_gSwitchingPopup_DEF  ion_gSwitchingPopup_Fast

/* ============================= SCRIPT fields  ================================= */

										/*	------------------------------------ */
typedef enum ScriptStorageType {		//	Different places that we store script text

										/*	these #'s CANNOT change - they are stored w/ the prf file */

	ScriptStorageType_UnRecognized = 0,	//	 we don't recognize this location

	ScriptStorageType_Control = 1,		//	ChGlobals control struct calculate field, cStr255
	ScriptStorageType_PanelItem = 2,	//	ChGlobals panelitem struct calculate field, cStr255

	ScriptStorageType_Btn = 3,			//	ButtonDesc.btn_Script_TextH[] array
	ScriptStorageType_Tab = 4,			//	gP->tab_Script_TextH[][]   array
	ScriptStorageType_Gen = 5			//	gP->gen_Script_TextH[][]   array

}  ScriptStorageType;

#define  ScriptStorageType_MIN  ScriptStorageType_Control
#define  ScriptStorageType_MAX  ScriptStorageType_Gen

										/*	------------------------------------ */
typedef enum ObjSaveType {				/*	Types of stringH objects saved to a .prf file */

										//	THESE #'s MUST NOT MOVE (they are saved to .prf files)
										//	THESE #'s MUST NOT MOVE (they are saved to .prf files)

	ObjSaveType_ScriptHandle = 1,		//	handle to a script

	ObjSaveType_PageText = 2,			//	text from a page (e.g. user defined page 
										//	w/ SaveText option On)
 
	ObjSaveType_WindowSettings = 3		//	Window options

} ObjSaveType;


										/*	------------------------------------ */
typedef enum ion_gWhenPopup {			//	After(1)/Before(2) Popup

										/*	#### these #'s must not change */

	ion_gWhenPopup_After = 1,			//	After
	ion_gWhenPopup_Before = 2			//	Before
	
}  ion_gWhenPopup;

#define  ion_gWhenPopup_MIN		ion_gWhenPopup_After
#define  ion_gWhenPopup_MAX		ion_gWhenPopup_Before /* base1 */
#define  ion_gWhenPopup_DEF		ion_gWhenPopup_After

#define  when_base0_MIN			BASE1_TO_BASE0(ion_gWhenPopup_MIN)
#define  when_base0_MAX			BASE1_TO_BASE0(ion_gWhenPopup_MAX)

#define  whenIndex_MAX	(ion_gWhenPopup_MAX-1)	/* max base0 index */

										/*	------------------------------------ */
typedef enum ion_gEventPopup {			//	Script Event Popup = { button, tab, cRate, uRate, etc }

										//	These #'s CAN CHANGE !!! since they are NOT (NOT !) 
										//	stored w/ the .prf file.
										//
										//	If you change these, please also change
										//	SCRIPTGENINDEX_TO_EVENTPOPUP() and
										//	EVENTPOPUP_TO_SCRIPTGENINDEX()

	ion_gEventPopup_StringScript = -4,	//	refers to a script that exists inside 
										//	a string$ that is created & executed via script code

	ion_gEventPopup_FileScript = -3,	//	refers to a script that exists inside 
										//	a file that is opened & executed via script code
											
	ion_gEventPopup_ChPanelMeter = -2,	//	refers to the str255 channel panel meter
										//	calculate field script (accessed from the
										//	control settings group in an output channel)

	ion_gEventPopup_ChOutControl = -1,	//	refers to the str255 output channel CONTROL
										//	calculate field script (accessed from the
										//	control settings group in an output channel)

	ion_gEventPopup_UnRecognized = 0,	//	unrecognized setting
										
	ion_gEventPopup_testScript = 1,		//	testing of scripts (press execute to run them)
	ion_gEventPopup_cRate = 2,			//	at control rate (e.g. 10Hz), while digitizing
	ion_gEventPopup_uRate = 3,			//	at user rate (e.g. 1Hz), at all times
	ion_gEventPopup_eachScan = 4,		//	each scan
	ion_gEventPopup_eachDigitization =5,//	each digitization (i.e. set of scans)
	ion_gEventPopup_LoadSettings = 6,	//	load .prf settings file (network restore/load)
	ion_gEventPopup_ScriptEngine = 7,	//	runs right after we initialize the script
										//	engine (BEFORE SCRIPT ENGINE) or when
										//	we dispose of the engine and all the 
										//	variables (AFTER SCRIPT ENGINE)
	ion_gEventPopup_exitProgram = 8, 	//	exit program (i.e. exit iNet World)
	ion_gEventPopup_ButtonPress = 9,	//	button press
	ion_gEventPopup_TabPress = 10		//	tab press
	
}  ion_gEventPopup;

#define  ion_gEventPopup_MIN  ion_gEventPopup_testScript
#define  ion_gEventPopup_MAX  ion_gEventPopup_TabPress
#define  ion_gEventPopup_DEF  ion_gEventPopup_testScript

										/*	------------------------------------ */
typedef enum ScriptGenStorage {			//	"genIndex" = indices into gen_Script_TextH[][] array

										/*	these #'s CANNOT change - they are stored w/ the prf file */

	ScriptGenStorage_testScript = 0,	//	testing of scripts (press execute to run them)
	ScriptGenStorage_cRate = 1,			//	at control rate (e.g. 10Hz), while digitizing
	ScriptGenStorage_uRate = 2,			//	at user rate (e.g. 1Hz), at all times
	ScriptGenStorage_eachScan = 3,		//	each scan
	ScriptGenStorage_eachDigitization=4,//	each digitization (i.e. set of scans)
	ScriptGenStorage_loadSettings = 5,	//	load .prf settings file
	ScriptGenStorage_ScriptEngine = 6,	//	runs right after we initialize the script
										//	engine (BEFORE SCRIPT ENGINE) or when
										//	we dispose of the engine and all the 
										//	variables (AFTER SCRIPT ENGINE)
	ScriptGenStorage_exitProgram = 7 	//	exit program (i.e. exit iNet World)
	
}  ScriptGenStorage;

#define  ScriptGenStorage_MIN    ScriptGenStorage_testScript
#define  ScriptGenStorage_MAX    ScriptGenStorage_exitProgram /* base1 */
#define  ScriptGenStorage_LEN   (1L + ScriptGenStorage_MAX - ScriptGenStorage_MIN)
#define	 genIndex_MAX			(ScriptGenStorage_LEN-1) /* base 0 */

										//	convert scriptStorageIndex to EventPopup
										//	
										//	if we change EventPopup and it gets complicated,
										//	this is the macro that we need to make a bit
										//	complicated as well
#define  SCRIPTGENINDEX_TO_EVENTPOPUP(scriptStorageIndex /* base0 */)  ((scriptStorageIndex) + 1)

										//	convert scriptStorageIndex to EventPopup
										//	
										//	if we change EventPopup and it gets complicated,
										//	this is the macro that we need to make a bit
										//	complicated as well
#define  EVENTPOPUP_TO_SCRIPTGENINDEX(eventPopup /* base 1 */)  ((eventPopup) - 1)

										//	true if this Script Event requires the
										//	tab popup (e.g. button press and 
										//	tab press scripts needs tab popup choice)
#define THIS_SCRIPTEVENT_REQUIRES_TAB_POPUP(eventChoice /* base1 */)			\
	(((eventChoice) == ion_gEventPopup_ButtonPress) iNetOr						\
	 ((eventChoice) == ion_gEventPopup_TabPress))

										//	true if this Script Event requires the
										//	button popup (e.g. button press 
										//	scripts needs button popup choice)
#define THIS_SCRIPTEVENT_REQUIRES_BUTTON_POPUP(eventChoice /* base1 */)			\
	((eventChoice) == ion_gEventPopup_ButtonPress)

										//	true if this Script Event stores
										//	it's textH in ButtonDesc.btn_Script_TextH[]
#define THIS_SCRIPTEVENT_STORES_TEXT_IN_BTN_ARRAY(eventChoice /* base1 */)		\
	((eventChoice) == ion_gEventPopup_ButtonPress)

										//	true if this Script Event stores
										//	it's textH in tab_Script_TextH[]
#define THIS_SCRIPTEVENT_STORES_TEXT_IN_TAB_ARRAY(eventChoice /* base1 */)		\
	((eventChoice) == ion_gEventPopup_TabPress)

										//	true if this Script Event stores
										//	it's textH in gen_Script_TextH[]
#define THIS_SCRIPTEVENT_STORES_TEXT_IN_GEN_ARRAY(eventChoice /* base1 */)		\
	(((eventChoice) >= ion_gEventPopup_testScript)	 iNetAnd					\
	 ((eventChoice) <= ion_gEventPopup_exitProgram))

										//	convert Event_PopupChoice_base1 to 
										//	ScriptStorageType enum
#define EVENTPOPUP_TO_SCRIPTSTORAGETYPE( Event_PopupChoice_base1 )						\
		(THIS_SCRIPTEVENT_STORES_TEXT_IN_BTN_ARRAY( Event_PopupChoice_base1 )			\
			? ScriptStorageType_Btn														\
			: (THIS_SCRIPTEVENT_STORES_TEXT_IN_TAB_ARRAY( Event_PopupChoice_base1 )		\
				? ScriptStorageType_Tab													\
				: (THIS_SCRIPTEVENT_STORES_TEXT_IN_GEN_ARRAY( Event_PopupChoice_base1)	\
					? ScriptStorageType_Gen												\
					: ScriptStorageType_UnRecognized /* bad error */)))


										//	converts base0 value to base1
#define BASE0_TO_BASE1(base0)  ((base0) + 1L)

										//	converts base1 value to base0
#define BASE1_TO_BASE0(base1)  ((base1) - 1L)

										/*	------------------------------------ */
										//	Dynamic Button Popup
										//
										//	This is generated dynamically for the
										//	gDynButtonPop_TabNum_base0 page

										//	tab num, base0 = (Network(0), Record(1), User1..lastVisibleTab}
										//	for which we generate a list of button between
										//	the 1st button and the lastVisibleBtn (which may be a user button)
extern iNet_Tabs gDynButtonPop_TabNum_base0;	

#define	 MAX_NUM_BTNS_PER_PAGE  32		/* max # of btns in one page */

#define  ion_gButtonPop_MIN   1
#define  ion_gButtonPop_MAX   MAX_NUM_BTNS_PER_PAGE /* 32 */
#define  ion_gButtonPop_DEF   1

/* ============================= TRIGGER Settings  ================================= */

										/*	------------------------------------ */
typedef enum fgNums_Trigger {			//	FIELD NUMBERS for TRIGGER settingGroup
										//	TRIGGER settingGroup = {triggerMode, thresholdEu, slopeRisFal,
										//	hysteresis, srcNet, srcModule, srcDevice, srcChannel}
										
										/*	#### these #'s must not change */

	fldNum_Trigger_triggerModePop = 1,	//	trigger mode popup {1=off, 2=auto, 3=normal}
	fldNum_Trigger_thresholdEu = 2,		//	trigger threshold engineering units
	fldNum_Trigger_slopeRisFalPop = 3,	//	slope {1=rising edge, 2=falling edge}
	fldNum_Trigger_hysteresis = 4,		//	hyteresis in engineering units
	fldNum_Trigger_srcNet = 5,			//	trigger source netNum
	fldNum_Trigger_srcDevice = 6,		//	trigger source devNum
	fldNum_Trigger_srcModule = 7,		//	trigger source modNum
	fldNum_Trigger_srcChannel = 8		//	trigger source channeNum
		
}  fgNums_Trigger;

#define  fgNums_Trigger_MIN  		fldNum_Trigger_triggerModePop
#define  fgNums_Trigger_MAX  		fldNum_Trigger_srcChannel
#define  fgNums_Trigger_ViewedMAX  	fldNum_Trigger_srcChannel

										/*	------------------------------------ */
typedef enum ion_TriggerModePopup {		//	MODE options in TRIGGER Settings Group

										/*	#### these #'s must not change */

	ion_TriggerMode_Off = 1,			//	trigger off (i.e. start when START button is pressed)
	ion_TriggerMode_Auto = 2,			//	auto trigger (wait for threshold, and if it does
										//	not arrive within several secs, trigger anyway)
	ion_TriggerMode_Norm = 3			//	Normal trigger (ONLY trigger when src crosses threshold)
	
}  ion_TriggerModePopup;

#define  ion_TriggerModePopup_MIN  ion_TriggerMode_Off
#define  ion_TriggerModePopup_MAX  ion_TriggerMode_Norm
#define  ion_TriggerModePopup_DEF  ion_TriggerMode_Off

										/*	------------------------------------ */
typedef enum ion_RiseFallPopup {		//	SLOPE options in TRIGGER Settings Group

										/*	#### these #'s must not change */

	ion_Rising = 1,						//	trigger on rising edge
	ion_Falling = 2						//	trigger on falling edge
	
}  ion_RiseFallPopup;

#define  ion_RiseFallPopup_MIN  ion_Rising
#define  ion_RiseFallPopup_MAX  ion_Falling
#define  ion_RiseFallPopup_DEF  ion_Rising

#define	 AUTO_HYSTERESIS  0.0			/*	automatically set the hystereisis */

/* =============================== TIMER Settings  ================================== */

										/*	------------------------------------ */
typedef enum fgNums_Timer {				//	FIELD NUMBERS for TIMER settingGroup
										//	TIMER settingGroup = {functionPop, clkTotalSecs, clkHiSecs,
										//	measHiOrCyclePop, measResolution, measNumPeriods}
										//	uController TPU Channel (Din, Dout, periodMeasure, clockOut)
										
										/*	#### these #'s must not change */

	fldNum_Timer_functionPop = 1,		//	function mode popup {1=digitalIn,
										//	2=digitalOut, 3=clkOut, 4=periodMeas,
										//	5=FreqMeas, 6=QuadMeas}

	fldNum_Timer_clkTotalSecs = 2,		//	clockOut total time (seconds)
	fldNum_Timer_clkHiSecs = 3,			//	clockOut high time (seconds)

	fldNum_Timer_measHiOrCyclePop = 4,	//	periodMeasureCyclePop {1=measureCycleTime, 2=measureHighTime}
	fldNum_Timer_measResolutionPop = 5,	//	periodMeasureResolutionPop {1 = 0.25us, 2 = 1ms}

	fldNum_Timer_measNumPeriods = 6,	//	periodMeasureNumPeriods {1...255...2e9}

	fldNum_Timer_Mode = 7				//	read mode = { ion_TimerMopePopup_WaitAndCont, _WaitAndReset,
										//	_NoWaitAndGo, _NoWaitAndReset }
		
} fgNums_Timer;

#define  fgNums_Timer_MIN  			fldNum_Timer_functionPop
#define  fgNums_Timer_MAX  			fldNum_Timer_Mode
#define  fgNums_Timer_ViewedMAX  	fldNum_Timer_Mode

#define  measNumPeriods_FOREVER 0L		/*	run clock out forever */

										/*	------------------------------------ */
typedef enum ion_TimerFuncPopup {		//	uController TPU Channel Timer/Din/Dout
										//	Function Options (e.g. popup)

										/*	#### these #'s must not change */

	ion_TimerFuncPopup_Din = 1,			//	digital input
	ion_TimerFuncPopup_Dout = 2,		//	digital output
	ion_TimerFuncPopup_ClkOut = 3,		//	clock output
	ion_TimerFuncPopup_PerMeas = 4,		//	period measurement
	ion_TimerFuncPopup_CountPulses = 5,	//	count pulses, gsw 4/10/98
	ion_TimerFuncPopup_FreqMeas = 6,	//	frequency measurement, gsw 6/23/98
	ion_TimerFuncPopup_QuadMeas = 7		//	quadrature measurement, gsw 6/23/98
	
}  ion_TimerFuncPopup;

#define  ion_TimerFuncPopup_MIN  ion_TimerFuncPopup_Din
#define  ion_TimerFuncPopup_MAX  ion_TimerFuncPopup_QuadMeas
#define  ion_TimerFuncPopup_DEF  ion_TimerFuncPopup_Din

										/*	------------------------------------ */
typedef enum ion_TimerModePopup {		//	uController TPU Channel r/w Modes

										/*	#### these #'s must not change */

	ion_TimerModePopup_WaitAndCont = 1,	//	Period/Frequency: Wait till measurement completes
										//		and restart a new one after reading result.
										//	EventCt/Quadrature: Read current value and then let
										//		it continue measuring.

	ion_TimerModePopup_WaitAndReset=2,	//	Period/Frequency: Wait till measurement completes
										//		and then halt timer after reading result.
										//		It will be started when you read again.
										//	EventCt/Quadrature: Read current value, and then 
										//		reset counter.
	
	ion_TimerModePopup_NoWaitAndCont=3,	//	Period/Frequency: Read 0 if measurement is not complete
										//		and restart a new one after reading result.
										//	EventCt/Quadrature: Read current value and then let
										//		it continue measuring.

	ion_TimerModePopup_NoWaitAndReset=4	//	Period/Frequency: Read 0 if measurement is not complete
										//		and then halt timer after reading result.
										//		It will be started when you read again.
										//	EventCt/Quadrature: Read current value, and then 
										//		reset counter.
}  ion_TimerModePopup;

#define  ion_TimerModePopup_MIN  ion_TimerModePopup_WaitAndCont
#define  ion_TimerModePopup_MAX  ion_TimerModePopup_NoWaitAndReset
#define  ion_TimerModePopup_DEF  ion_TimerModePopup_WaitAndCont

										/*	------------------------------------ */
typedef enum ion_measHiOrCyclePop {		//	uController TPU Channel measure CYCLE time
										//	or HIGH time.

										/*	#### these #'s must not change */

	ion_measHiOrCyclePop_CycleTime = 1,	//	measure cycle time (falling edge to falling edge)
	ion_measHiOrCyclePop_HighTime = 2	//	measure high time (rising edge to falling edge)
	
}  ion_measHiOrCyclePop;

#define  ion_measHiOrCyclePop_MIN  ion_measHiOrCyclePop_CycleTime
#define  ion_measHiOrCyclePop_MAX  ion_measHiOrCyclePop_HighTime
#define  ion_measHiOrCyclePop_DEF  ion_measHiOrCyclePop_CycleTime

										/*	------------------------------------ */
typedef enum ion_timeResolutionPop {	//	25us/8ms Resolution Popup

										/*	#### these #'s must not change */

	ion_timeResolutionPop_quarterMicroSec = 1,	//	.25us resolution
	ion_timeResolutionPop_eightMilliSec = 2		//	1ms resolution
	
}  ion_timeResolutionPop;

#define  ion_timeResolutionPop_MIN  ion_timeResolutionPop_quarterMicroSec
#define  ion_timeResolutionPop_MAX  ion_timeResolutionPop_eightMilliSec
#define  ion_timeResolutionPop_DEF  ion_timeResolutionPop_eightMilliSec

/* ====================== DIGITAL I/O Settings Field Numbers  ========================= */

										/*	------------------------------------ */
typedef enum fgNums_Mod100DinDout {		//	FIELD NUMBERS for 8bit Mod 100 Digital
										//	I/O settingGroup {din, dout, direction}
										
										/*	#### these #'s must not change */

	fldNum_Mod100DinDout_dout = 1,		//	digital output, {0..255}

	fldNum_Mod100DinDout_direction = 2  //	direction, {0..255}
		
}  fgNums_Mod100DinDout;

#define  fgNums_Mod100DinDout_MIN  		fldNum_Mod100DinDout_dout
#define  fgNums_Mod100DinDout_MAX  		fldNum_Mod100DinDout_direction
#define  fgNums_Mod100DinDout_ViewedMAX fldNum_Mod100DinDout_direction

/* ========================= User Interface Types For Fields ========================== */

typedef enum fieldUserInterfaceType	{	//	types of user interfaces for fields

										/*	#### these #'s must not change */

	fuit_unknown = 0,
	
	fuit_editField_flt32 = 1,			//	Edit Field with FLT32 data
	fuit_editField_double = 2,			//	Edit Field with double data
	fuit_editField_int16 = 3,			//	Edit Field with INT16 data
	fuit_editField_int32 = 4,			//	Edit Field with INT32 data
	fuit_editField_uint32 = 5,			//	Edit Field with UINT32 data
	fuit_editField_str15 = 6,			//	Edit Field with STR15 data
	fuit_editField_str255 = 7,			//	Edit Field with STR255 data

	fuit_staticText_double = 45,		//	Static Text with Double data
	fuit_staticText_flt32 = 10,			//	Static Text with FLT32 data
	fuit_staticText_int16 = 11,			//	Static Text with INT16 data
	fuit_staticText_int32 = 12,			//	Static Text with INT32 data
	fuit_staticText_uint32 = 13,		//	Static Text with UINT32 data
	fuit_staticText_str15 = 14,			//	Static Text with STR15 data
	
	fuit_popup_Mod100analogLpFltrPop=20,//	Model 100 Analog Low Pass Filter Popup {off, 40Hz, 4KHz}
	fuit_popup_Mod100rangePop = 21,		//	Model 100 Range Popup {+/-5V, +/-1.25V, +/-.37V, +/-.08V}

	fuit_popup_VinPos_SensorPopup = 22,	//	Vin+ Sensor Popup {Volts, Tc, Rtd, Thm, Ohms, Amps, Accel, LoadCell, Pot}
	fuit_popup_VinNeg_SensorPopup = 23,	//	Vin- Sensor Popup {Volts, Tc's, Accelerometers)

	fuit_popup_VinPos_WiringPopup = 24,	//	Vin+ Wiring Popup = {diff, se, bridge, R shunt, V divider}
	fuit_popup_VinNeg_WiringPopup = 25,	//	Vin- Wiring Popup = {diff, se}
	
	fuit_popup_scanMode = 26,			//	Strip Chart, Oscilloscope, Oscillo Queued
	fuit_popup_digitizeInfo = 27,		//	save data {off / To Ram Buffer / To Disk / User Control}
	fuit_popup_OnOff = 28,				//	On/Off Popup {1=on 0=off}
	fuit_popup_LinesDots = 29,			//	Lines/Dots Popup {1=lines 2=dots}
	fuit_popup_triggerMode = 30,		//	trigger mode popup {1=off, 2=auto, 3=normal}
	fuit_popup_riseFall = 31,			//	slope {1=rising edge, 2=falling edge}
	fuit_popup_timerFunction = 32,		//	function mode popup {1=digitalIn, 2=digitalOut, 3=clkOut, 4=periodMeas}
	fuit_popup_measHiOrCycle = 33,		//	periodMeasureCyclePop {1=measureCycleTime, 2=measureHighTime}
	fuit_popup_measResolution = 34,		//	periodMeasureResolutionPop {1 = 0.25us, 2 = 1ms}
	fuit_popup_filterMethod = 35,		//	filter method = {FILTEROFF_DCIIR, BUTTERWORTH_DCIIR, etc}
	fuit_popup_DirCmd = 36,				//	text to the DirCmd popup
	fuit_popup_FileType = 37,			//	text to the FileType popup
	fuit_popup_NewDirName = 38,			//	text to the NewDirName popup
	fuit_popup_FileCmd = 39,			//	text to the FileCmd popup
	fuit_popup_PushButton = 40,			//	DRIVER Push Button Command (select a page to open)
	fuit_popup_OpenWindow = 41,			//	DRIVER Open Window Command (select a btn to press)
	fuit_popup_switching = 42,			//	channel switching = {Accurate, Fast}
	fuit_popup_calBtn = 43,				//	calibration button = {Measure, Bal Gages}
	fuit_popup_horizScale = 44,			//	horiz scale popup = secs/div
	fuit_popup_timerMode = 46,			//	read mode = { ion_TimerMopePopup_WaitAndCont, _WaitAndReset, _NoWaitAndGo, _NoWaitAndStop }
	fuit_popup_ShowHide = 47,			//	Show/Hide Popup = {1=show, 2=hide}, gsw 1/1/03
	fuit_popup_PositionQuadrant = 48,	//	Position Quadrant = { hide, top, right, bottom, left}, gsw 1/1/03
	fuit_popup_PageList = 49,			//	PageList Popup = { Network, Record, User1 ... lastVisibleTab }, gsw 1/1/3
	fuit_popup_When = 50,				//	After(1)/Before(2) Popup, gsw 1/8/3
	fuit_popup_Event = 51,				//	Script Event Popup = { button, tab, cRate, uRate, etc }, gsw 1/8/3
	fuit_popup_DynButton = 52,			//	List of Buttons generated dynamically for the gDynButtonPop_TabNum_base0 page, gsw 1/8/3
	fuit_popup_UserItemType = 53,		//	User Item Type = {btn, tab, textF, popup}, gsw 1/20/03
	fuit_popup_SaveWSetupPop = 54,		//	popup = "Save w. Setup On/Off" = { ion_SaveWSetupPop_On, ...Off }
	fuit_popup_fKey = 55,				//	list of AVAILABLE function key = {e.g. none, F1, F3, F5, F10 }
	fuit_popup_ioDirection = 56,		//	I/O Direction = { ioDirectionPop_input (1) , ioDirectionPop_output (2) }
	fuit_popup_BitValuePop = 57,		//	Bit Value Popup = { BitValuePop_0, BitValuePop_1 } -- internally stored as 0/1 values
	fuit_popup_HorizLabelPop = 58		//	"Horiz Label" popup = {  ion_hLabel_TimeSinceStart, ion_hLabel_TimeOfDay }

} fieldUserInterfaceType;

/*	=========================== user interface catagory ============================= */

										//	------------------------------------
typedef enum itemType_iNet{				//	Types of items to add to a dialog.
									
										/*	#### these #'s must not change */
										
	i_notDefined = 0,					//	not defined
	i_Btn = 1,							//	button		
	i_cBox = 2,							//	checkbox	
	i_rBtn = 3,							//	radio button		
	i_sText = 4,						//	static text
	i_eText = 5,						//	edit text
	i_uItem = 6,						//	user item
	i_icon = 7,							//	icon item
	i_pict = 8,							//	picture item
	i_ctrl = 9							//	control item
	
} itemType_iNet;

										/*	true, if this field is a popup menu */
#define THIS_FIELD_IS_A_POPUP(itemType_) (itemType_ == i_uItem /* popup */)

//	----------------------------------------------------------
//	types of windows

typedef enum {
	jHamm = 0,						//	hamming window
	jHann = 1,						//	Von Hann
	jBlackman = 2,					//	Blackman
	jKaiser = 3						//	Kaiser
} iNetWindowType;								

/*	=========================== request struct interface ============================= */

/*	These macros are the offset's from the beginning of the iNet_Request struct
 *	to the specified field. A pointer to the iNet_Request struct is passed to
 *	the driver. */
										/*	#### these #'s must not change */
										
#define  netNum_OFFSET  			0x00	/*	offset to 'netNum' parameter */
#define  deviceNum_OFFSET  			0x01
#define  moduleNum_OFFSET  			0x02
#define  chanNum_OFFSET  			0x03

#define  settingGroupNum_OFFSET		0x04
#define  fieldNum_OFFSET  			0x06
#define  intention_OFFSET  			0x08
#define  argType_OFFSET  			0x0a
#define  error_OFFSET  				0x0e
#define  ptrToArg_OFFSET  			0x10

#define  A_OFFSET  					0x14
#define  B_OFFSET  					0x18
#define  C_OFFSET  					0x1c
#define  D_OFFSET  					0x20
#define  E_OFFSET  					0x24
#define  F_OFFSET  					0x28

#define  netP_OFFSET  				0x2c
#define  interfaceBlockP_OFFSET 	0x30
#define  deviceGlobalsP_OFFSET 		0x34
#define  moduleGlobalsP_OFFSET 		0x38
#define  channelGlobalsP_OFFSET 	0x3c
#define  settingGroup__P_OFFSET 	0x40
#define  settingGroupType_OFFSET 	0x44
#define  key_OFFSET 				0x46

										/*	size of the iNet_Request struct */
#define  SIZE_OF_iNet_Request	(key_OFFSET + sizeof(iNetINT16))

										/*	calculate address of a parameter */
#define	 paramPtr(requestP, offset)	(((unsigned char *) (requestP)) + offset)
									
/*	The following macros are used to access parameters within a request struct */
									 
#define  netNum_PARAM(requestP)			*((iNetUINT8 *) paramPtr(requestP, netNum_OFFSET))
#define  deviceNum_PARAM(requestP)		*((iNetUINT8 *) paramPtr(requestP, deviceNum_OFFSET))
#define  moduleNum_PARAM(requestP)		*((iNetUINT8 *) paramPtr(requestP, moduleNum_OFFSET))
#define  chanNum_PARAM(requestP)		*((iNetUINT8 *) paramPtr(requestP, chanNum_OFFSET))

#define  settingGroupNum_PARAM(requestP) *((iNetINT16 *) paramPtr(requestP, settingGroupNum_OFFSET))
#define  fieldNum_PARAM(requestP)		*((iNetINT16 *) paramPtr(requestP, fieldNum_OFFSET))
#define  intention_PARAM(requestP)		*((iNetINT16 *) paramPtr(requestP, intention_OFFSET))
#define  argType_PARAM(requestP)		*((iNetUINT8 *) paramPtr(requestP, argType_OFFSET))
#define  error_PARAM(requestP)			*((iNetINT16 *) paramPtr(requestP, error_OFFSET))
#define  ptrToArg_PARAM(requestP)		*((void * *) paramPtr(requestP, ptrToArg_OFFSET))

#define  A_PARAM(requestP)				*((iNetUINT32 *) paramPtr(requestP, A_OFFSET))
#define  B_PARAM(requestP)				*((iNetUINT32 *) paramPtr(requestP, B_OFFSET))
#define  C_PARAM(requestP)				*((iNetUINT32 *) paramPtr(requestP, C_OFFSET))
#define  D_PARAM(requestP)				*((iNetUINT32 *) paramPtr(requestP, D_OFFSET))
#define  E_PARAM(requestP)				*((iNetUINT32 *) paramPtr(requestP, E_OFFSET))
#define  F_PARAM(requestP)				*((iNetUINT32 *) paramPtr(requestP, F_OFFSET))

#define  netP_PARAM(requestP)			*((void * *) paramPtr(requestP, netP_OFFSET))
#define interfaceBlockP_PARAM(requestP)	*((void * *) paramPtr(requestP, interfaceBlockP_OFFSET))
#define  deviceGlobalsP_PARAM(requestP)	*((void * *) paramPtr(requestP, deviceGlobalsP_OFFSET))
#define  moduleGlobalsP_PARAM(requestP)	*((void * *) paramPtr(requestP, moduleGlobalsP_OFFSET))
#define channelGlobalsP_PARAM(requestP)	*((void * *) paramPtr(requestP, channelGlobalsP_OFFSET))
#define  settingGroup__P_PARAM(requestP)	*((void * *) paramPtr(requestP, settingGroup__P_OFFSET))
#define  settingGroupType_PARAM(requestP)	*((iNetINT16 *) paramPtr(requestP, settingGroupType_OFFSET))
#define  key_PARAM(requestP)			*((iNetINT16 *) paramPtr(requestP, key_OFFSET))


/* =========================== for internal use only ====================================== */

#if (MACHINE_TYPE_ != CONTROLLER_iNet)	/*	if we are NOT compiling for uController... */

	#if defined(DRIVER_IS_COMPILED_INTO_AN_APP)
										/*	if we are compiling driver into application... */

		#if (MACHINE_TYPE_ == MACINTOSH_iNet)	
										/*	============= Macintosh ============= */
	
			pascal void iNet_Main_Entry(iNetUINT8 *request_structP);

		#elif (MACHINE_TYPE_ == WINTEL_iNet)
										/*	=========== Windows/Intel =========== */
	
			void pascal iNet_Main_Entry(iNetUINT8 *request_structP);
	
		#endif

	#else
										/*	if we are compiling driver into a DLL...*/
		#if (MACHINE_TYPE_ == MACINTOSH_iNet)	
										/*	============= Macintosh ============= */
	
		#elif (MACHINE_TYPE_ == WINTEL_iNet)
										/*	=========== Windows/Intel =========== */
	
			void pascal iNet_Main_Entry(iNetUINT8 *request_structP);
	
		#endif

	#endif

#endif

/* ========================= iNet() Prototype & Support =================================== */
										
#if (MACHINE_TYPE_ != CONTROLLER_iNet)	/*	if we are NOT compiling for uController... */

	iNetINT16 iNet(iNetUINT8 netNum, iNetUINT8 devNum, iNetUINT8 modNum,
		iNetUINT8 chNum, iNetINT16 settingGroupNumOrType, iNetINT16 fieldNum,
		iNetINT16 intention, iNetUINT8 argType, void *ptrToArg);
		 
	extern iNetUINT8 *gRequestP;		/*	points to the request struct passed to iNet() */
	
	void Initialize_OperatingSystem_If_Necessary_main(void);

										/*	TRUE if the ansi console window has been opened */
	extern Boolean gConsoleWindowHasBeenOpened;

#endif	/* #if (MACHINE_TYPE_ != CONTROLLER_iNet) */

/* ================================ BINARY file header ===================================== */

//	BINARY fileType
//
//		Waves stored in iNet BINARY file format are stored with 1 wave per file, where
//		wave data and header are both stored in the data section of the file, where the
//		header (shown below) is at the beginning of the file's data, and the actual points
//		are a 1 dimensional array after the header.  The 0th byte of the file corresponds
//		to 'headerSizeInBytes', and the 1st waveform point begins at 'data[0]'.
//
//	BINARYMERGE fileType
//
//		This is similar to BINARY, yet all digitize ON channels (from one controller)
//		are stored in ONE interlaced file.  An array of 'GWI_file_header_struct' headers
//		are stored at the beginning of the file for digitize channels {0... numDigChannels-1}.
//		Read the 'channelsPerFile' field to see how many headers are there.  The data
//		is then saved in an interlaced form, where points are stored in the order
//		that they are acquired in time.  For example, data from 3 channels (A, B and C) at
//		the same sample rate would be stored as:
//
//			A[0], B[0], C[0], A[1], B[1], C[1], A[2], B[2], C[2]......
//
//		If Channel B was stored at 1/N of the sample rate where N is 2 (N is ALWAYS and 
//		integer, and is defined in the 'sampleRate_Divider' field), the data would be packed 
//		in the following way:
//
//			A[0], B[0], C[0], A[1], C[1], A[2], B[1], C[2], A[3], C[3], A[4], B[2], C[4] ......
//
//	NOTES
//
//		1)	The binary data is stored in intel little endian or 68k big endian format,
//			as noted by the 'file_endian' field.  Use the 'int32key', 'int32key_StructTest'
//			'int16key' and 'flt32key' fields to make sure you are reading things correctly.
//			If you save the file on a MS-Windows computer, and load it on an MS-Windows
//			computer, things should be ok.  Byteswapping is necessay when saving on 
//			a bigEndian computer (e.g. Macintosh) and then loading on a littleEndian
//			computer (e.g. Windows95).
//		2)	99% of instruNet data is stored as 32bit floating point numbers (this is the
//			native instruNet dataType).

#if COMPILING_FOR_PPC_MAC
	#pragma options align=mac68k
#elif (MACHINE_TYPE_ == WINTEL_iNet)
	#pragma pack(1)
#endif
										//	----------------------------------
typedef struct GWI_file_header_struct{	//	This struct is at the beginning of
										//	GWI iNet BINARY files that
										//	contain waves.
										//
										//	Macintosh:
										//
										//		file type:		'GWID'
										//		creator type:	'ioNe'		NETWORK_DATA_CREATOR   
		
										//	----------------------------------
										//	HEADER INFORMATION
		
	iNetINT32 headerSizeInBytes;		//	contains length, in bytes, of this 
										//	header (this does not include 1 byte of data)
										//	{ bytes 0..3, base 0 }

										//	----------------------------------
										//	FILE INFORMATION
		
	iNetINT32 int32key;					//	32bit key that should contain 0x12345678
										//	(this will help you make sure your byte
										//	lanes are ok). 
										//	{ bytes 4..7, base 0 }
	
	iNetINT32 file_endian; 				//	endian mode of stored data on disk = 
										//	
										//	0	bigEndian_ion
										//	1	littleEndian_ion
										//	{ bytes 8..11, base 0 }
	
	iNetINT16 int16key;					//	16bit key that should contain 0x55b4;
										//	(this field should consume 2 bytes
										//	 in the struct -- no padding)
										//	(i.e. INET_INT16_KEY = 0x55b4)
										//	{ bytes 12..13, base 0 }

	iNetINT16 zero;						//	set to 0
										//	(this field should consume 2 bytes 
										//	in the struct -- no padding)
										//	{ bytes 14..15, base 0 }

										//	# of seconds since Jan 1, Midnight, 1904 that the 
										//	acquisition started (this is used to compute the
										//	date of acquisition)
										//	Strip Chart: 1st digitized point in entire stream (i.e. 1st pt of 1st scan)
										//	Osc Mode:    1st point in current scan, secsSince1904 units 
										//	{ bytes 16..19, base 0 }
	iNetUINT32 acquisition_secsSince1904;
										

										//	----------------------------------
										//	# OF POINTS STORED
										//
										//	This file contains a set of scans.  Each
										//	scan is 1 to .5billion points long.  For example,
										//	we might have 100 scans, each 1000 points long.
										//	In this example:
										//
										//		pointsPerScanThisChannel_LSB = 1000
										//		pointsPerScanThisChannel_MSB = 0
										//
										//		numScansStoredBeforeLastScan = 99
										//
										//		numPointsInLastPartialScan_LSW = 1000
										//		numPointsInLastPartialScan_MSW = 0
										//
										//	Each channel can have a different number of 
										//	points per scan due to the sampleRateMultiplier
												
	iNetUINT32 pointsPerScanThisChannel_LSB;	
	iNetUINT32 pointsPerScanThisChannel_MSB;	
										//	# points per scan = 
										//		(pointsPerScanThisChannel_MSB * 2^32) + pointsPerScanThisChannel_LSB
										//	{ bytes 20..23, base 0 }
										//	{ bytes 24..27, base 0 }

	iNetUINT32 numScansStoredBeforeLastScan;	
										//	# of complete scans stored in file 
										//	{ bytes 28..31, base 0 }
	
	iNetUINT32 numPointsInLastPartialScan_LSW;	
	iNetUINT32 numPointsInLastPartialScan_MSW;	
										//	# points stored in last scan if it is partially complete =	
										//		(numPointsInLastPartialScan_MSW * 2^32) + numPointsInLastPartialScan_LSW
										//	{ bytes 32..35, base 0 }
										//	{ bytes 36..39, base 0 }

										//	----------------------------------
										//	TIME INFORMATION

	iNetFLT32 firstPoint_Time_Secs;		//	time of 1st point, units are seconds
										//	{ bytes 40..43, base 0 }

	iNetFLT32 samplePeriod_Secs;		//	time between points for this channel,
										//	units are seconds.  Notice that channels
										//	can have different sample rates, which
										//	is the masterSampleRate / sampleRate_Divider,
										//	where 'sampleRate_Divider' is an integer.
										//	{ bytes 44..47, base 0 }

										//	----------------------------------
										//	TYPE OF DATA STORED

	iNetINT32 arrayDataType;			//	Type of src array data. iNetDataType:
										//
										//	0	iNetDT_INT16:	16bit integer, signed
										//	2	iNetDT_UINT16:	16bit integer, unsigned
										//	3	iNetDT_INT32: 	32bit integer, signed
										//	4	iNetDT_UINT32: 	32bit integer, unsigned
										//	5	iNetDT_FLT32: 	32bit float (IEEE flt32 format)
										//	6	iNetDT_Double: 	'double', as determined by the compiler
										//						(e.g. flt64, flt80, flt96, flt128)
										//						see 'bytesPerDataPoint' field to see
										//						how many bytes
										//	{ bytes 48..51, base 0 }
												
	iNetINT32 bytesPerDataPoint;		//	# of bytes for each datapoint (e.g. 4 for 32bit signed integer)
										//	{ bytes 52..55, base 0 }
	
	iNetStr31 verticalUnitsLabel;		//	pascal string of vertical units
										//	label (e.g. "Volts")
										//	{ bytes 56..87, base 0 }

	iNetStr31 horizontalUnitsLabel;		//	horizontal units label, e.g. "Secs" 
										//	pascal string (0th char is the # of valid chars)   
										//	{ bytes 88..119, base 0 }
	
	iNetStr31 userName;					//	user named set by user, e.g. "Pressure 1"
										//	pascal string (0th char is the # of valid chars)   
										//	{ bytes 120..151, base 0 }
	
	iNetStr31 chanName;					//	name of channel, e.g. "Ch1 Vin+"
										//	pascal string (0th char is the # of valid chars)   
										//	{ bytes 152..183, base 0 }
	
										//	----------------------------------
										//	DATA MAPPING
										//
	iNetINT32 minCode;					//	if data is stored in integer format,
	iNetINT32 maxCode;					//	this contains the mapping from integer
	iNetFLT32 minEU;					//	to engineering units (e.g. +/-2048 A/D
	iNetFLT32 maxEU;					//	data is mapped to +/- 10V, minCode = -2048,
										//	maxCode = +2047, minEU = -10.000, 
										//	maxEU = +9.995.
										//	{ bytes 184..187, base 0 }
										//	{ bytes 188..191, base 0 }
										//	{ bytes 192..195, base 0 }
										//	{ bytes 196..199, base 0 }

										//	----------------------------------
										//	iNet NETWORK ADDRESS (this does not need
										//	to be filled in, 0L's are ok)

	iNetINT32 netNum;					//	channel network # (this pertains to 
										//	iNet only; use 0 otherwise)
										//	{ bytes 200..203, base 0 }

	iNetINT32 devNum;				//	channel device # (this pertains to 
										//	iNet only; use 0 otherwise)
										//	{ bytes 204..207, base 0 }

	iNetINT32 modNum;				//	channel module # (this pertains to 
										//	iNet only; use 0 otherwise)
										//	{ bytes 208..211, base 0 }

	iNetINT32 chNum;					//	channel channel # (this pertains to 
										//	iNet only; use 0 otherwise)
										//	{ bytes 212..215, base 0 }
			
										//	----------------------------------
										//	END USER NOTES

	iNetStr255 notes;					//	pascal string that contains notes 
										//	about the data stored.
										//	{ bytes 216..471, base 0 }
	
										//	----------------------------------
										//	MAPPING

	iNetFLT32 internal1;				//	Mapping from internal engineering units						 
	iNetFLT32 external1;				//	(e.g. Volts) to external engineering	
	iNetFLT32 internal2;				//	units (e.g. mmHg).  This is used for
	iNetFLT32 external2;				//	2 point linear mapping/calibration to
										//	a new, user defined, coordinate system.
										//	instruNet World does not read these values
										//	from the wave files, yet instead reads
										//	them from the instrNet.prf file -- they
										//	are only stored for the benefit of other
										//	software that might read this file. gsw 12/1/96
										//	{ bytes 472..475, base 0 }
										//	{ bytes 476..479, base 0 }
										//	{ bytes 480..483, base 0 }
										//	{ bytes 484..487, base 0 }

	iNetFLT32 flt32key;					//	flt32 key set to 1234.56 (i.e. INET_FLT32_KEY)
										//	Used to test floating point code. gsw 12/1/96
										//	{ bytes 488..491, base 0 }

	iNetINT32 sampleRate_Divider;		//	this channel is digitized at the masterSampleRate divided
										//	this 'sampleRate_Divider' (i.e. sampleRateMult_recip_uint32)
										//	(helpful with FileType Binary Merge), gsw 1/29/97
										//	Note: This field was introduced 1/29/97 and
										//	files saved before that time set it to 0.
										//	{ bytes 492..495, base 0 }
										
	iNetINT32 channelsPerFile;			//	# of channels per file (i.e. interlaced after array of headers)
										//	(helpful with FileType Binary Merge), gsw 1/29/97
										//	Note: This field was introduced 1/29/97 and
										//	files saved before that time set it to 0.
										//	{ bytes 496..499, base 0 }
										
										//	----------------------------------
										//	EXPANSION FIELDS
	
	iNetINT32 expansion8;				//	expansion fields that are preset to 
	iNetINT32 expansion9;				//	0 and then ignored
	iNetINT32 expansion10;				//	{ bytes 500..503, base 0 }
										//	{ bytes 504..507, base 0 }
										//	{ bytes 508..511, base 0 }

										//	----------------------------------
										//	KEY TO TEST STRUCT PACKING

	iNetINT32 int32key_StructTest;		//	32bit key that should contain 0x12345678;
										//	(i.e. INET_INT32_KEY)
										//	{ bytes 512..515, base 0 }
										
										//	----------------------------------
										//	ACTUAL DATA
	
	/* iNetFLT32 *data[1]; */			//	contains array of data of type 'arrayDataType'
	
} GWI_file_header_struct;

#if COMPILING_FOR_PPC_MAC
	#pragma options align=reset
#elif (MACHINE_TYPE_ == WINTEL_iNet)
	#pragma pack()
#endif

/* ========================================================================================= */

#ifdef __cplusplus						/*	if running C++ */
	}									/* make this a C function */
#endif

#endif	/* __iNetCInterface__ */

